<?php 

# check if script by this name is already running

$sc = shell_exec('ps ax | grep areminder-manager.php | grep -v grep | grep -v /bin/sh | grep -v vim | grep -v nano | wc -l');
if($sc > 1){ 
  exit; 
}

if (zend_loader_file_encoded()) {
	$lic_info	= zend_loader_file_licensed();
	$lic_exp        = isset($lic_info['areminder_exp'])?preg_replace('/-/','',$lic_info['areminder_exp']):'00000000';
	if ($lic_exp > date('Ymd')) {
		$areminder_licensed = true;
	} else {
		$areminder_licensed = false;
		exit;
	}
} else {
	$areminder_licensed = true;
}

//Parse manager/db credentials and such
$gsASMUser = $amp_conf['AMPMGRUSER'];
$gsASMPass = $amp_conf['AMPMGRPASS'];
$gsASMServer = "localhost";

// Use bootstrap AMI connection 
$gtAMI = $astman;

if ($arDebug == TRUE) {
	dbug('areminder', $amp_conf);
}

$keeplooping = true;

// Start a daemon loop that will continue until no calls need to be placed
while($keeplooping) {

	// Grab max number of calls 
	$sSQL = "SELECT `value` as maxcalls FROM areminder_settings WHERE `key` = 'maxcalls'";
	$hSQL = mysql_query($sSQL);
	$aRow = mysql_fetch_assoc($hSQL);
	$iMaxCalls = (integer) ($aRow['maxcalls'] > 0 ? $aRow['maxcalls'] : 1);

	// Calculate the previous cycle start and stop times in seconds from midnight 
	$iPreviousStart = (integer) (date('H',(time() - 900)) * 3600) + (floor(date('i',(time() - 900)) / 15) * 900);
	$iPreviousStop  = (integer) $iPreviousStart + 900;

	// Grab number of active reminder calls from AMI
	$result = $gtAMI->command('core show channels concise');
	preg_match_all('/(!areminder-main!)/',$result['data'],$matches);
	$iCallCount = (integer) (count($matches[1]));

	// Update calls that have exceeded their retry count
	$sSQL = "
UPDATE 
  areminder_calls c
  LEFT JOIN areminder a
  on c.arid = a.id 
SET 
  status = 9
WHERE 
  retry > retrycount AND 
  status = 0
";
	$db->query($sSQL);

	// Update calls that are in the past
	$sSQL = "
UPDATE 
  areminder_calls  
SET 
  status = 10
WHERE 
  appointment < UNIX_TIMESTAMP(NOW()) AND
  status = 0
";
	$db->query($sSQL);


	// Select list of calls to place and exit if no calls to place
$sSQL = "
SELECT 
  a.id AS arid,
  a.outcid,
  a.outcidname,
  a.cidtype,
  a.retrydelay,
  c.id AS callid,
  c.number,
  c.calltime
FROM 
  areminder AS a LEFT JOIN 
  areminder_calls AS c
ON a.id = c.arid 
WHERE
  enabled > 0 AND
  `start" . date('N') ."` >= 0 AND
  `start" . date('N') ."`  < ((HOUR(NOW()) * 3600) + (MINUTE(NOW()) * 60)) AND
  `stop" . date('N') ."`  > ((HOUR(NOW()) * 3600) + (MINUTE(NOW()) * 60)) AND
  CAST((appointment) - UNIX_TIMESTAMP(NOW()) AS SIGNED) < (maxnotice * 86400) AND
  retry <= retrycount AND
  status < 1 AND
  LENGTH(c.number) > 0
ORDER BY appointment ASC
";

	$hSQL = $db->query($sSQL);
	
	$bTerminate = ($hSQL->numRows() < 1 ? true : false); 
	
	// Generate call files for each and create entries in areminder_events 
	$iCallsPlaced = 0;
	$iCallsToPlace = $iMaxCalls - $iCallCount;
	
	while ($bTest = $hSQL->fetchInto($aRow,DB_FETCHMODE_ASSOC))
	{
		// Break if we have placed enough calls
		if ($iCallsPlaced >= $iCallsToPlace) break;
		
		$iReminderID = $aRow['arid'];
		$iCallID = $aRow['callid'];
		$sCallNumber = $aRow['number'];
		$sOutCID = (strlen($aRow['outcidname'])>0?'"'.$aRow['outcidname'].'" <'.$aRow['outcid'].'>':'"'.$aRow['outcid'].'" <'.$aRow['outcid'].'>');
		$sCIDType = $aRow['cidtype'];
		$iRetryDelay = $aRow['retrydelay'];
		$iCallTime = $aRow['calltime'];
		
		if(($iCallTime + $iRetryDelay) < time())
		{
			// Set CID channel variables to properly provide outbound trunk CID
			if ($sCIDType=='fixed'||$sCIDType=='forcemb') {
				$sCID = "__TRUNKCIDOVERRIDE=$sOutCID";
			}else{
				$sCID = "__REALCALLERIDNUM=$sOutCID";
			}

			// Build call file variables array
			$aCallVars = Array($sCID,"__arid=$iReminderID","__callid=$iCallID");

			// Place call file for this call in outgoing directory 
			fsPlaceCallFile("Local/$sCallNumber@areminder-out", 'areminder-main', "$iReminderID*$iCallID", 1, $aCallVars, 0, 0);
			$iCallsPlaced++;
			
			// Update DB with date of call being placed
			mysql_query("UPDATE `areminder_calls` SET `calltime` = UNIX_TIMESTAMP(NOW()), retry = (retry+1) WHERE id = $iCallID");
		}
	}


# Find any campaigns that ran today (had calls) and ended in the past, 
# which have not been notified, and generate emails
	
	$aEmails = Array();
	$gEmailSQL = "
SELECT 
  s.*,
  a.name AS arname,
  c.name AS callname,
  c.number,
  c.status,
  c.retry,
  c.appointment,
  c.calltime,
  a.emailcomplete,
  a.emailfrom,
  a.attachas
FROM 
  areminder_calls AS c  
LEFT JOIN areminder AS a    
  ON c.arid = a.id  
LEFT JOIN (SELECT `id`, `stop1`, `stop2`, `stop3`, `stop4`, `stop5`, `stop6`, `stop7` FROM areminder) s 
  ON a.id = s.id
WHERE 
  `status` > 0  AND  
  `calltime` > `lastemail` AND
  LENGTH(emailcomplete) > 0  
ORDER BY 
  a.name,
  c.status,
  c.name";

	$hSQL = $db->query($gEmailSQL);

	while ($bTest = $hSQL->fetchInto($aRow,DB_FETCHMODE_ASSOC)) 
	{
		$endtime = (integer) ($aRow['stop'.date('N',$aRow['calltime'])] > 0 ? $aRow['stop'.date('N',$aRow['calltime'])] : 86340);
		$calldate = strtotime(date('Y-m-d 00:00:00',$aRow['calltime']));
		$calldateendtime = $endtime + $calldate;
		
		if (time() > ($calldateendtime + 300))
		{
			switch($aRow['status'])
			{
				case '1':
					$sStatus = 'CONFIRM';
					break;
				case '2':
					$sStatus = 'CANCEL';
					break;
				case '3':
					$sStatus = 'RESCHEDULE';
					break;
				case '4':
					$sStatus = 'OPERATOR';
					break;
				case '9':
					$sStatus = 'NOANSWER';
					break;
				default:
					$sStatus = 'PENDING';
					break;
			}

			$aEmails[$aRow['arname']]['id']          = $aRow['id'];
			$aEmails[$aRow['arname']]['to']          = $aRow['emailcomplete'];
			$aEmails[$aRow['arname']]['from']        = $aRow['emailfrom'];
			$aEmails[$aRow['arname']]['subject']     = 'Appointment Reminder Report for ' . $aRow['arname'] . ' - ' . date('Y-m-d');
			$aEmails[$aRow['arname']]['body']        = "Appointment Reminder " . $aRow['arname'] . " completed for " . date('Y-m-d') . ".";
			$aEmails[$aRow['arname']]['attachmentname'] = ($aRow['attachas'] == 'none' ? '' : preg_replace('/[^a-zA-Z0-9]/', '', $aRow['arname']) . '_' . date('Y-m-d') . '.' . $aRow['attachas']);
			if(strlen($aEmails[$aRow['arname']]['attachmentname']) > 0)
			{
				$aEmails[$aRow['arname']]['attachment'] .= '"' . $aRow['callname'] . '","' . $aRow['number'] . '","' . date('Y-m-d H:i:s', $aRow['appointment']) . '","' . date('Y-m-d H:i:s', $aRow['calltime']) . '","' . $sStatus . '"' . "\n";
			}
			else
			{
				$aEmails[$aRow['arname']]['attachment']  = '';
			}
		}
	}
	
	$csvHeader = "Name,Phone Number,Appointment Date,Called Date,Status\n";
	
	foreach($aEmails as $aEmail)
	{
		$tMailer = New TSMTP;
		$bEmailed = $tMailer->fbSendMessage($aEmail['to'], $aEmail['from'], $aEmail['subject'], $aEmail['body'], $aEmail['attachmentname'], ($csvHeader.$aEmail['attachment']));

		$gEmailSQL = 'UPDATE areminder SET lastemail = UNIX_TIMESTAMP(NOW()) WHERE id = ' . $aEmail['id'];
		$db->query($gEmailSQL);

	}

	if ($bTerminate) die("No calls to place\n");
	
	// Sleep 30 seconds and loop
	if($keeplooping) {
		sleep(30);
	}

} // end while($keeplooping)







# functions

//Returns a 9 digit string, which has a random ID for this call
function fsPlaceCallFile($p_sChannel, $p_sContext, $p_sExtension = 's', $p_iPriority, $p_aSet = Array(), $p_iRetries = 0, $p_iExecutionSecondsFromNow = 0)
{
	$sID = (integer) rand(100,999).substr(microtime(), 2,6);
	
	$sContents = "
Channel: $p_sChannel
Context: $p_sContext
Extension: $p_sExtension
Priority: $p_iPriority
MaxRetries: $p_iRetries
";

	foreach($p_aSet as $sSet) 
	{
		$sContents .= "Set: $sSet\n";
	}

	$sFile = '/tmp/' . $sID . '.call';
	file_put_contents($sFile, $sContents);
	touch($sFile, (time() + $p_iExecutionSecondsFromNow), (time() + $p_iExecutionSecondsFromNow));
	rename($sFile, '/var/spool/asterisk/outgoing/' . $sID . '.call');
	
	return $sID;
}


?>
