<?php if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}

if (zend_loader_file_encoded()) {
	$areminder_lic_info	= zend_loader_file_licensed();
	$areminder_lic_exp	= isset($areminder_lic_info['areminder_exp'])?preg_replace('/-/','',$areminder_lic_info['areminder_exp']):00000000;
	if ($areminder_lic_exp > date('Ymd')) {
		$areminder_licensed = true;
	} else {
		$areminder_licensed = false;
	}
} else {
	$areminder_licensed = true;
}

function areminder_fsrnav()
{
	return areminder_fsGetrnav();
}

function areminder_fsGetrnav()
{
	if ($GLOBALS['areminder_licensed'])
	{
		return '
<div class="rnav">
<ul>
<li> <a href="' . areminder_fsLink()            . '">Overview</a></li></li>
<li> <a href="' . areminder_fsLink('add')       . '">Add a reminder</a></li>
<li> <a href="' . areminder_fsLink('edit')      . '">Edit reminders</a></li>
<li> <a href="' . areminder_fsLink('manage')    . '">Manage recipients</a></li>
<li> <a href="' . areminder_fsLink('reporting') . '">Reporting</a></li>
</ul>
</div>
		';
	}
	else
	{
		return '';
	}

}

function areminder_fsRenderHoursList($p_sName)
{
	$sBody = '<select name="' . $p_sName . '">';

	for($nX=0;$nX<24;$nX++)
	{
		$sBody .= '<option value="' . areminder_fvQuickFormatNumber00($nX) . '">' . areminder_fvQuickFormatNumber00($nX);
	}

	$sBody .= '</select>';

	return $sBody;
}

function areminder_fsRenderMinutesList($p_sName)
{
	$sBody = '<select name="' . $p_sName . '">';

	for($nX=0;$nX<60;$nX++)
	{
		$sBody .= '<option value="' . areminder_fvQuickFormatNumber00($nX) . '">' . areminder_fvQuickFormatNumber00($nX);
	}

	$sBody .= '</select>';

	return $sBody;
}

function areminder_fsLink($p_sAction = '')
{
	if($p_sAction == '')
		return '/admin/config.php?type=tool&display=areminder';
	else
		return '/admin/config.php?type=tool&display=areminder&action=' . $p_sAction;
}

function areminder_fvOpenAction($p_sAction)
{
	return areminder_fvGetOpenAction($p_sAction);
}

function areminder_fvGetOpenAction($p_sAction)
{
	if ($GLOBALS['areminder_licensed']) {
		require('./modules/areminder/views/page.areminder.' . $p_sAction . '.php');
	} else {
		echo sysadmin_get_sales_html('areminder');
	}
}

function areminder_fvQuickFormatNumber00($p_sNumber)
{
	if(strlen($p_sNumber) == 1)
		return "0" . $p_sNumber;
	else
		return $p_sNumber;
}

function areminder_fsGetTimeFromTimestamp($p_sTimeStamp)
{
	$nHours = round((($p_sTimeStamp / 60) / 60), 0, PHP_ROUND_HALF_DOWN);
	$nMinutes = (($p_sTimeStamp / 60) % 60);

	$sHours = areminder_fvQuickFormatNumber00($nHours);
	$sMinutes = areminder_fvQuickFormatNumber00($nMinutes);

	return $sHours . ':' . $sMinutes;
}

function areminder_fsGetMinsOrHrsFromTimestamp($p_sTimeStamp)
{
	$nHours = round((($p_sTimeStamp / 60) / 60), 0, PHP_ROUND_HALF_DOWN);
	$nMinutes = (($p_sTimeStamp / 60) % 60);

	if($nMinutes == 0)
		return $nHours . ' hours';
	else
		return $nMinutes . ' minutes';
}

function areminder_faGetFiles($p_sDir)
{
	$aDir = scandir($p_sDir);
	$aFiles = array();

	foreach($aDir as $nX)
	{
		if(is_file($p_sDir . $nX))
		{
			if($nX != '.' && $nX != '..')
			{
				$nF++;
				$aFiles[$nF] = $nX;
			}
		}
	}


	return $aFiles;
}

function areminder_faGetRecordings()
{
	$aData = sql('SELECT * FROM `recordings`',"getAll",DB_FETCHMODE_ASSOC);

	return $aData;
}

function areminder_faGetReportingData($p_nReminder,$p_sDStart,$p_sDEnd,$p_sFilter,$p_sSort)
{
	$aData = sql("SELECT * FROM `areminder_calls` WHERE `arid` = '$p_nReminder' AND (`$p_sFilter` >= $p_sDStart AND `$p_sFilter` <= $p_sDEnd) ORDER BY `$p_sSort`",'getAll',DB_FETCHMODE_ASSOC);
	return $aData;
}

function areminder_faGetCoreExtensions()
{
	$aExt = framework_check_extension_usage(true);
	$aCoreExt = $aExt['core'];

	return $aCoreExt;
}

function areminder_fvSaveKey($p_sKey, $p_sValue)
{
	sql('DELETE FROM `areminder_settings` WHERE `key` = "' . $p_sKey . '"');

	//Insert back
	sql('INSERT INTO `areminder_settings` (`id`, `key`,`value`) VALUES ("", "' . $p_sKey . '", "' . $p_sValue . '");');
}

function areminder_fsGetKey($p_sKey)
{
	$aData = sql('SELECT * FROM `areminder_settings` WHERE `key` = "' . $p_sKey . '";',"getAll",DB_FETCHMODE_ASSOC);

	return $aData[0][value];
}

function areminder_faParseCSVFile($p_sFile)
{
	if (($handle = fopen($p_sFile, "r")) !== false)
	{
		$aCSV = array();
		while (($aRow = fgetcsv($handle,1000,",")) !== false)
		{
			$aCSV[] = $aRow;
		}
		return $aCSV;
	} else {
		return false;
	}
}

function areminder_fvSendMail($p_sFrom, $p_sRecipients, $p_sBody, $p_sSubject, $p_sAttachment, $p_sFileName)
{
	$email = new CI_Email();

	$email->from($p_sFrom, 'Appointment Reminder');
	$email->to($p_sRecipients);

	$email->subject($p_sSubject);
	$email->message($p_sBody);

	if((strlen($p_sAttachment) > 0) && (strlen($p_sFileName) > 0))
	{
		$email->attach($p_sAttachment);
	}

	$email->send();
}


function areminder_fbIsNotBlank($p_sValue)
{
	if($p_sValue != '')
		return true;
	else
		return false;
}

function areminder_fsVerifyForm($p_aForm)
{
	$sError = '';

	foreach($p_aForm as $nX => $nY)
	{
		$aField = explode(":", $nX);

		$bRes = eval('
		if(' . $nY . '($_POST["' . $aField[0] . '"]) )
		{
			return TRUE;
		}
		else
		{
			return FALSE;
		}');

		if($bRes == false)
			$sError .= '- Please enter a valid value for "' . $aField[1] . '"<br>';
	}

	return $sError;
}

function areminder_sCleanNumeric($input)
{
	return (string) preg_replace('/[^0-9]/','',$input);
}

function areminder_sStatusText($p_iStatus)
{
	$sStatus = '';
	switch((string) $p_iStatus)
	{
		case '0':
			$sStatus = 'PENDING';
			break;
		case '1':
			$sStatus = 'CONFIRM';
			break;
		case '2':
			$sStatus = 'CANCEL';
			break;
		case '3':
			$sStatus = 'RESCHEDULE';
			break;
		case '4':
			$sStatus = 'OPERATOR';
			break;
		case '9':
			$sStatus = 'NOANSWER';
			break;
		case '10':
			$sStatus = 'EXPIRED';
			break;
		default:
			$sStatus = 'UNKNOWN';
	}
	return $sStatus;
}


function areminder_get_config() {
	global $ext, $amp_conf, $areminder_licensed;

	//if we aren't licensed return out, as we don't want dialplan to be generated
	if ($areminder_licensed !== true) {
		return;
	}

	//create main context for placed calls to land in and spawn AGI
	$ext->add('areminder-main', '_X.', '', new ext_answer());
	$ext->add('areminder-main', '_X.', '', new ext_nocdr());
	$ext->add('areminder-main', '_X.', '', new ext_agi('areminder-main.php'));
	$ext->add('areminder-main', '_X.', '', new ext_gotoif('$["${TXCONTEXT}"!=""]','${TXCONTEXT},${TXEXTENSION},${TXPRIORITY}'));
	$ext->add('areminder-main', '_X.', '', new ext_hangup());

	// create outbound dialplan to handle setting caller id
	$ext->add('areminder-out', '_X.', '', new ext_macro('blkvm-set'));
  $ext->add('areminder-out', '_X.', '', new ext_dial('Local/${EXTEN}@from-internal','45,M(auto-blkvm)'));
	$ext->add('areminder-out', '_X.', '', new ext_hangup());

	// Install Cron on apply config as we will only do this if licensed
	$sReminderCron['minute']  = '*/5';
	$sReminderCron['hour']    = '*';
	$sReminderCron['dom']     = '*';
	$sReminderCron['month']   = '*';
	$sReminderCron['dow']     = '*';
	$sReminderCron['command'] = $amp_conf['ASTAGIDIR'] . '/areminder-manager.php 2>&1 >/dev/null';

	edit_crontab('areminder-manager.php',$sReminderCron);
}

function areminder_sysadmin_getinfo() {
    return array(
        "name" => "Appointment Reminder", // Required. Descriptive name.
        "expires" => true,         // Optional. Defaults to false (never expires)
        "keyname" => "areminder_exp", // Optional. Only checked if 'expires' is true
    );
}
