<?php

$restrict_mods = true;
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) { 
	  include_once('/etc/asterisk/freepbx.conf'); 
}

$sql = "SELECT concurrent_calls,maximum_retry,from_email from broadcast_settings";
$result = $db->query($sql);
list($concurrent_calls,$maximum_retry,$from_email) = $result->fetchRow(DB_FETCHMODE_ORDERED);
if(!$from_email)  {
	$from_email = "broadcast@schmoozecom.com";
}
$sql = "SELECT * from broadcast_campaigns WHERE active='1' AND completed='0'";
$result = $db->getAll($sql,DB_FETCHMODE_ASSOC);

$width = sizeof($result);
$depth = 0;
$campaigns = array();
foreach($result as $campaign)  {
	$campaigns[$campaign['id']] = array($campaign);
	$sql = "SELECT g.campaign_id, c.id, c.name, c.phonenum, l.callid
			FROM broadcast_campaign_groups g 
			LEFT JOIN broadcast_callees c ON c.group_id=g.group_id 
			LEFT JOIN broadcast_log l ON l.campaign_id='$campaign[id]' AND l.callee=c.id 
			WHERE g.campaign_id='$campaign[id]' AND (l.answer IS NULL OR (l.answer='0' AND l.delivered_to='' AND l.initiated_dial != '1'))";
	$r_callees = $db->getAll($sql,DB_FETCHMODE_ASSOC);

	if(sizeof($r_callees) > $depth)  {
		$depth = sizeof($r_callees);
	}
	$callees[] = $r_callees;
}

// Now we loop through the results and generate an array that alternates calls between each campaign
// The reason for this is we want to make sure each campaign gets an equal amount of attention, so
// we don't have the full attention of the broadcast going to campaign A until it is complete, then
// moving on to campaign B. 
$call_list = array();
for($i = 0; $i < $depth; $i ++)  {
	for($j = 0; $j < $width; $j++)  {
		if(isset($callees[$j][$i]))  {
			$call_list[] = $callees[$j][$i];
		}
	}
}

$tmpdir = "/tmp";
$outgoing = "/var/spool/asterisk/outgoing";

$local_context = "from-internal";
$maxretries = $maximum_retry; // from global settings
$time_between_call = "30";
$waittime = 30;
$callerid = "Test";
$exten = "s";
$pri = "1";
$initiated = array(); // keep track of the calls we initiated
while(sizeof($initiated) != sizeof($call_list))  {
	reset($call_list);

	// index keeps track of the main $call_list array so we can set an "initited" state on an element so the loop keeps going until 
	// all attempts have been made (due to excluded periods of time that will occur because of the constraints that may have been
	// configured

	$index = 0;
	foreach($call_list as $call)  {
		$campaign_id = $call['campaign_id'];
		$call_prefix = $campaigns[$campaign_id][0]['prefix'];
		$date_start = strtotime($campaigns[$campaign_id][0]['date_start']);
		$date_finish = strtotime($campaigns[$campaign_id][0]['date_finish']);
		$time_start = $campaigns[$campaign_id][0]['time_start'];
		$time_finish =$campaigns[$campaign_id][0]['time_finish'];
		$weekday_start = $campaigns[$campaign_id][0]['weekday_start'];
		$weekday_finish = $campaigns[$campaign_id][0]['weekday_finish'];
		$now = strtotime(date('Y-m-d'));//old way of doing this which is problematic -> mktime();
		if(!isset($call_list[$index]['initiated']) && ($now >= $date_start && $now <= $date_finish))  { // Is date in range or equal to the range?

			// Is the campaign only setup to run during a certain span of weekdays (Monday, Tuesday, Wednesday, etc) and
			// if so is the current date within that span?
			if(($weekday_start == 0 || $weekday_finish == 0) 
				|| (date("N") >= $weekday_start && date("N") <= $weekday_finish)
			)  {

				$currtime = date("H:i:s");
				$started = array();
				if($currtime > $time_start && $currtime < $time_finish)  { // Check to make sure time is in range
					$started[$campaign_id] = true;
					// we only want one record per campaign:callee pair
					$callid = $call['callid'];
					if(!$callid)  {
						$callid = md5(uniqid(rand(), true));
						$sql = "INSERT INTO broadcast_log (id,last_updated,callid,campaign_id,callee,initiated_dial) 
							VALUES ('',NOW(),'$callid','$campaign_id','$call[id]','1')";
						$db->query($sql);
					}
					
					if(!empty($campaigns[$campaign_id][0]['callerid']))
					{
						$callerid = $campaigns[$campaign_id][0]['callerid'];
					}
					
					$phonenum = $call_prefix . $call['phonenum'];
					$phonenam = $call['name'];

					$contextname = "broadcast-campaign-$campaign_id";		

					$fn = "$tmpdir/$campaign_id-$phonenum.call" ;
					$fptmp = fopen($fn, "w");

					$e = "channel: Local/$phonenum@$local_context/n\n" ;
					$e .= "maxretries: ". $maxretries . "\n" ;
					$e .= "retrytime: ". $time_between_call . "\n" ;
					$e .= "waittime: ". $waittime . "\n" ;
					//If we have a callerid, why not use it
					if (!empty($callerid))
					{
						$e .= "callerid: $callerid\n" ;
					} else {
						//The old way we used to do it just in case we don't have 
						$e .= "callerid: $phonenam " . $phonenum . "\n" ;
					}
					$e .= "context: $contextname\n" ;
					$e .= "extension: $exten\n" ;
					$e .= "priority: $pri\n" ;
					$e .= "Set: CALLEENAME=" . $phonenam . "\n" ; 
					$e .= "Set: CALLEENUM=" . $phonenum . "\n" ;
					$e .= "Set: DIAL=" . $phonenum . "\n" ;
					$e .= "Set: CALLID=" . $callid . "\n" ;
					if (!empty($callerid))
					{
						$e .= "Set: TRUNKCIDOVERRIDE=$callerid \n" ;
					}
					fwrite($fptmp,$e) ;	
					fclose($fptmp);
					chown($fn, 'asterisk');
					rename("$fn", "$outgoing/$campaign_id-$phonenum.call");
					$initiated[] = $call;
					// the array was initialized without this entry, now that a successful attempt has been made we need to flag it
					// so we don't try this entry again over the long period of time this application may be running (days/weeks?)
					$call_list[$index]['initiated'] = true;
				
				}
				else  { // we are not in the defined timeframe
					if(isset($campaign_id, $started[$campaign_id]) && $started[$campaign_id])  { // The campaign was running today, so now that the day is over, email a report
						$email = $campaign['email'];
						$email_settings = $campaign['email_settings'];
						if($email && $email_settings == "daily")  {	

							$subject = "Daily Broadcast Report - ".$campaign['name']." - ".date("m/d/Y");
							$body = "The ".$campaign['name']." broadcast campaign has reached the time limit for the day.  See attachment for full results.";	
							email_report($campaign['email'],$subject,$body,$data,$from_email);
						}
					}
				} // end time frame check
			} // end week day timeframe check
		} // end date timeframe check

		$openslot = false;
		while (!$openslot)  {
			echo "waiting for maximum channels\n";
			usleep(100000); // don't consume processor
			$files = sizeof(scandir($outgoing))-2; // list the outgoing directory and count.  Subtract 2 for "." (cwd) and ".." (parent dir)
			if ($files < $concurrent_calls) { // Don't exceed your total concurrant calls allowance 
				$openslot = true; 
			}
		}
		// index keeps track of the main $call_list array so we can set an "initited" state on an element so the loop keeps going until 
		// all attempts have been made (due to excluded periods of time that will occur because of the constraints that may have been
		// configured
		$index++; 
	}

}
// If we get here, all of the campaigns completed


if(sizeof($campaigns))  {
	// Now wait for the calls to complete
	$empty = false;
	while (!$empty)  {
		usleep(100000);
		$files = sizeof(scandir($outgoing))-2; // list the outgoing directory and count.  Subtract 2 for "." (cwd) and ".." (parent dir)
		if ($files == 0) { 
			$empty = true; 
		}
	}

	foreach($campaigns as $campaign)  {
		$campaign_ids[] = "id='".$campaign[0]['id']."'";
		$data = broadcast_reportcsv($db,$campaign[0]['id']);
		$email = $campaign[0]['email'];
		$email_settings = $campaign[0]['email_settings'];
		if($email && $email_settings)  {
			$subject = "Broadcast Report - ".$campaign[0]['name']." - ".date("m/d/Y");
			$body = "The ".$campaign[0]['name']." broadcast campaign has completed.  See attachment for full results.";	
			email_report($email,$subject,$body,$data,$from_email);
		}
	}
	$update_campaigns = implode(" OR ",$campaign_ids);
//	$db->query("UPDATE broadcast_campaigns SET completed='1' WHERE $update_campaigns");
}
?>
