<?php /* $Id */
//Copyright (C) 2010 Schmooze Com, Inc.
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
if (zend_loader_file_encoded()) {
	$broadcast_lic_info	= zend_loader_file_licensed();
	$broadcast_lic_exp        = isset($broadcast_lic_info['xdialer_exp'])?preg_replace('/-/','',$broadcast_lic_info['xdialer_exp']):'00000000';
	if ($broadcast_lic_exp > date('Ymd') || $broadcast_lic_info['Broadcast'] == 1 ) {
		$broadcast_licensed = true;
	} else {
		$broadcast_licensed = false;
	}
} else {
	$broadcast_licensed = true;
}

if($broadcast_licensed != FALSE) {

require_once "broadcast_report.inc.php";

//Below is to ensure on FreePBX 2.9 or greater that we don't try extending the class until the class is loaded
if (!function_exists('broadcast_backgrounddetect')) {
	function broadcast_backgrounddetect() {
		if(class_exists("extension") && !class_exists("ext_backgrounddetect"))  {
			class ext_backgrounddetect extends extension {
				var $filename;
				var $silence;
				var $min;
				var $max;
				function ext_backgrounddetect($filename,$silence=null,$min=null,$max=null)  {
					$this->filename = $filename;
					$this->silence = $silence;
					$this->min = $min;
					$this->max = $max;
				}

				function output() {
					return 'BackgroundDetect(' .$this->filename.($this->silence ? ',' .$this->silence : '' ).($this->min ? ',' .$this->min : '' ).($this->max ? ',' .$this->max : '' ). ')' ;
				}
			}
		}
	}
}

function broadcast_get_config($engine) {
	global $db, $ext;
	switch($engine) {
		case "asterisk":
		//Generate dialplan to simply play system recordings.  This is the simplest form of a broadcast application
		$tresults = recordings_list();
		if (isset($tresults[0])) {
			foreach ($tresults as $tresult) {
				$ext->add('play-system-recording',$tresult['id'],'',new ext_answer());
				$ext->add('play-system-recording',$tresult['id'],'',new ext_playback($tresult['filename']));
				$ext->add('play-system-recording',$tresult['id'],'',new ext_hangup());
			}
		}
		broadcast_backgrounddetect();
		$campaigns = broadcast_campaignList();
		if(isset($campaigns[0]))  {
			foreach($campaigns as $campaign)  {
				$c = "broadcast-campaign-".$campaign['id'];
				$ext->add($c,'s','',new ext_setvar("CALLERID(name)", '${CALLEENAME}'));
				$ext->add($c,'s','',new ext_setvar("CALLERID(num)", '${CALLEENUM}'));
				$ext->add($c,'s','',new ext_setvar("MACHINE",'0'));
				$ext->add($c,'s','',new ext_answer());
				$ext->add($c,'s','',new ext_setvar("_STATE","answered"));
				$ext->add($c,'s','',new ext_agi("broadcast_log.php"));
				$ext->add($c,'s','',new ext_backgrounddetect("silence-5","1000","50"));
				$ext->add($c,'s','',new ext_noop("answering machine detected"));
				$ext->add($c,'s','',new ext_setvar("MACHINE",'1'));
				$ext->add($c,'s','',new ext_backgrounddetect("silence-30","1000","50","30050"));
				$ext->add($c,'s','',new ext_noop("too long of a message"));
				$ext->add($c,'s','',new ext_hangup());
				$ext->add($c,'talk','',new ext_gotoif('$[ ${MACHINE} = 1]','2','5'));
				$ext->add($c,'talk','',new ext_setvar("_STATE","machine"));
				$ext->add($c,'talk','',new ext_agi("broadcast_log.php"));
				$ext->add($c,'talk','',new ext_goto($campaign['destination_machine']));
				$ext->add($c,'talk','',new ext_setvar("_STATE","person"));
				$ext->add($c,'talk','',new ext_agi("broadcast_log.php"));
				$ext->add($c,'talk','',new ext_goto($campaign['destination_person']));
				$ext->add($c,'h','',new ext_noop("this is where we will put do-not-call"));
			}
		}
		break;
	}
}

function broadcast_destinations() {  // Add a destination for the playback of audio files
	global $db;
	$dests = array();
	$tresults = recordings_list();
	if (isset($tresults[0])) {
		foreach ($tresults as $tresult) {
				$dests[] = array('destination' => "play-system-recording,".$tresult['id'].",1", 'description' => $tresult['displayname'], 'category' => "Play Recording");
		}
	}

		// return an associative array with destination and description
	return $dests;
}

function broadcast_settings() { // retrieves broadcast application settings from the database
	global $db;

	$sql = "SELECT * FROM broadcast_settings";
	$results = $db->getAll($sql,DB_FETCHMODE_ASSOC);
	if($db->IsError($results)) {
		$results = null;
	} else {
	}
	return $results;

}
function broadcast_calleeList($group) { // retrieves the callees of a particular group
	global $db;

	$sql = "SELECT * FROM broadcast_callees WHERE group_id='$group'";
	$results = $db->getAll($sql,DB_FETCHMODE_ASSOC);
	if($db->IsError($results)) {
		$results = null;
	} else {
	}
	return $results;

}
function broadcast_groupList() { // Retrieve all callee groups
	global $db;

	$sql = "SELECT * FROM broadcast_groups";
	$results = $db->getAll($sql,DB_FETCHMODE_ASSOC);
	if($db->IsError($results)) {
		$results = null;
	} else {
	}
	return $results;

}
function broadcast_campaignList($id = null) { // Retrieve all campaigns
	global $db;

	$sql = "SELECT * FROM broadcast_campaigns";
	if($id)  {
		$sql .= " WHERE id='$id'";
	}
	$results = $db->getAll($sql,DB_FETCHMODE_ASSOC);
	if($db->IsError($results)) {
		$results = null;
	} else {
	}
	return $results;

}

function broadcast_savesettings($concurrent_calls,$maximum_retry,$active_campaigns,$from_email)  { // save general settings
	sql("DELETE FROM broadcast_settings");
	sql("INSERT INTO broadcast_settings (concurrent_calls,maximum_retry,from_email) VALUES ('$concurrent_calls','$maximum_retry','$from_email')");
	// Deactivate all campaigns
	sql("UPDATE broadcast_campaigns SET active='0'");
	// Activate checked campaigns
	if(is_array($active_campaigns) && sizeof($active_campaigns) > 0)  {
		foreach($active_campaigns as $campaign)  {
			sql("UPDATE broadcast_campaigns SET active='1' WHERE id='$campaign'");
		}
	}

}

function broadcast_editGroup($id,$name)  { // Update a group
	global $db;
	$sql = "UPDATE broadcast_groups SET name='$name' WHERE id='$id'";
	$result = $db->query($sql);
	if($db->IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}

}
function broadcast_addGroup($name)  {  // Add a group
	global $db;
	$sql = "INSERT INTO broadcast_groups (id,name) VALUES ('','$name')";
	$result = $db->query($sql);
	if($db->IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}
	else  {
		$id = $db->getOne("SELECT id FROM broadcast_groups WHERE name='$name' ORDER BY id DESC LIMIT 1");
		return $id;
	}

}
function broadcast_addCallee($group_id,$name,$number)  { // Add a callee to a group
	global $db;
	$name = $db->escapeSimple($name);
	$number = $db->escapeSimple($number);

	// Only add callee if the number does not exist in the group
	$sql = "SELECT * FROM broadcast_callees WHERE phonenum='$number' AND group_id='$group_id'";
	$result = $db->query($sql);
	if($db->IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}
	if($result->numRows() == 0)  {
		$sql = "INSERT INTO broadcast_callees (id,group_id,name,phonenum) VALUES ('','$group_id','$name','$number')";
		$result = $db->query($sql);
		if($db->IsError($result)) {
			die_freepbx($result->getMessage().$sql);
		}
	}


}
function broadcast_editCallee($id,$name,$number)  {  // Edit an individual callee in a group

	sql("UPDATE broadcast_callees SET name='$name',phonenum='$number' WHERE id='$id'");
}
function broadcast_deleteCallee($id)  { // Delete an individual callee in a group
	sql("DELETE FROM broadcast_callees WHERE id='$id'");
}
function broadcast_getgroup($id)  { // retrieve a single callee group from database
	global $db;
	$sql = "SELECT * FROM broadcast_groups WHERE id='$id'";
	$results = $db->getAll($sql,DB_FETCHMODE_ASSOC);
	if($db->IsError($results)) {
		$results = null;
	} else {
	}
	return $results;

}
function broadcast_isgroupincampaign($group,$campaign)  { // determines if a callee group is associated with a particiular campaign
	global $db;
	$sql = "SELECT * FROM broadcast_campaign_groups WHERE campaign_id='$campaign' AND group_id='$group'";
	$results = $db->query($sql);

	if($db->IsError($results)) {
		$results = null;
	} else {
		if($results->numRows() > 0)  {
			return true;
		}
		else  {
			return false;
		}
	}
	return false;
}

function broadcast_deleteCampaign($campaign)  {  // Delete an individual campaign
	global $db;
	$sql = "DELETE FROM broadcast_campaigns WHERE id='$campaign'";
	$results = $db->query($sql);

	if($db->IsError($results)) {
		die_freepbx($result->getMessage().$sql);
	}
	$sql = "DELETE FROM broadcast_campaign_groups WHERE campaign_id='$campaign'";
	$results = $db->query($sql);

	if($db->IsError($results)) {
		die_freepbx($result->getMessage().$sql);
	}
	$sql = "DELETE FROM broadcast_log WHERE campaign_id='$campaign'";
	$results = $db->query($sql);

	if($db->IsError($results)) {
		die_freepbx($result->getMessage().$sql);
	}
}

function broadcast_deleteGroup($group)  {  // Delete an individual group
	global $db;
	$sql = "DELETE FROM broadcast_groups WHERE id='$group'";
	$results = $db->query($sql);

	if($db->IsError($results)) {
		die_freepbx($result->getMessage().$sql);
	}
	$sql = "SELECT id FROM broadcast_callees WHERE group_id='$group'";
	$results = $db->getAll($sql,DB_FETCHMODE_ASSOC);
	$delete_callees = array();
	foreach($results as $callee)  {
		$delete_callees[] = "callee='".$callee['id']."'";

	}

	if($db->IsError($results)) {
		die_freepbx($result->getMessage().$sql);
	}
	if(sizeof($delete_callees))  {
		$or = implode(" OR ",$delete_callees);
		$sql = "DELETE FROM broadcast_log WHERE $or";
		$results = $db->query($sql);
		if(DB::IsError($results)) {
			die_freepbx($result->getMessage().$sql);
		}
	}

	$sql = "DELETE FROM broadcast_callees WHERE group_id='$group'";
	$results = $db->query($sql);

	if(DB::IsError($results)) {
		die_freepbx($result->getMessage().$sql);
	}
	$sql = "DELETE FROM broadcast_campaign_groups WHERE group_id='$group'";
	$results = $db->query($sql);

	if($db->IsError($results)) {
		die_freepbx($result->getMessage().$sql);
	}

}

// Edit an individual campaign
function broadcast_editCampaign($campaign_id,$campaign)  {
	extract($campaign);
	global $db;
	$sql = "UPDATE broadcast_campaigns SET name='$name',email='$email',email_settings='$email_settings',active='$active',
						time_start='$time_start',time_finish='$time_finish',
						weekday_start='$weekday_start',weekday_finish='$weekday_finish',date_start='$date_start',
						date_finish='$date_finish',destination_person='$destination_person',
						destination_machine='$destination_machine', callerid='$callerid', prefix='$prefix' WHERE id='$campaign_id'";

	$result = $db->query($sql);
	if($db->IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}

}
function broadcast_addCampaign($campaign)  {
	extract($campaign);
	global $db;
	$sql = "INSERT INTO broadcast_campaigns(id,name,email,email_settings,active,time_start,time_finish,weekday_start,weekday_finish,date_start,date_finish,
						destination_person,destination_machine, callerid)
		VALUES ('','$name','$email','$email_settings','$active','$time_start','$time_finish','$weekday_start','$weekday_finish','$date_start','$date_finish',
			'$destination_person','$destination_machine', '$callerid')";
	$result = $db->query($sql);
	if($db->IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}
	else  {
		$id = $db->getOne("SELECT id FROM broadcast_campaigns WHERE name='$name' ORDER BY id DESC LIMIT 1");
		return $id;

	}

}
function hma_to_sql($hour,$minute,$ampm)  { // converts hour, minute, am/pm to sql time
	$hour = str_pad($hour, 2, "0", STR_PAD_LEFT);
	$minute = str_pad($minute, 2, "0", STR_PAD_LEFT);
	$time = strtotime("$hour:$minute $ampm");
	return date("H:i:s",$time);
}
function sql_to_hma($sql)  { // converts sql time to hour, minute am/pm
	$sql_time = strtotime($sql);
	$time = array(date("h",$sql_time),date("i",$sql_time),date("A",$sql_time));
	return $time;
}
function date_to_sql($month,$day,$year)  {
	$date = strtotime("$month/$day/$year");
	return date("Y-m-d",$date);
}
function sql_to_date($sql)  {
	$sql_date = strtotime($sql);
	$date = array(date("n",$sql_date),date("j",$sql_date),date("Y",$sql_date));
	return $date;
}

function broadcast_deletecallgroups($campaign_id)  {
	global $db;
	$sql = "DELETE FROM broadcast_campaign_groups WHERE campaign_id='$campaign_id'";
	$result = $db->query($sql);
	if($db->IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}

}
function broadcast_addcallgroups($campaign_id,$active_groups)  {
	global $db;

	foreach($active_groups as $group)  {
		$sql = "INSERT INTO broadcast_campaign_groups (id,campaign_id,group_id) VALUES ('','$campaign_id','$group')";
		$result = $db->query($sql);
		if($db->IsError($result)) {
			die_freepbx($result->getMessage().$sql);
		}

	}
}
function broadcast_csv_download ($data, $name, $mimetype="", $filesize=false) {
	// File size not set?
	if ($filesize == false OR !is_numeric($filesize)) {
		$filesize = strlen($data);
	}
	// Mimetype not set?
	if (empty($mimetype)) {
		$mimetype = "application/octet-stream";
	}
	// Make sure there's not anything else left
	$ob_active = ob_get_length() !== false;
	while($ob_active) {
		ob_end_clean();
		$ob_active = ob_get_length() !== false;
	}

	// Start sending headers
	header("Pragma: public"); // required
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Cache-Control: private",false); // required for certain browsers
	header("Content-Transfer-Encoding: binary");
	header("Content-Type: " . $mimetype);
	header("Content-Length: " . $filesize);
	header("Content-Disposition: attachment; filename=\"" . $name . "\";" );
	// Send data
	echo $data;
	die();
}
function broadcast_calls_uncompleted($campaign) {
	global $db;
	$sql = "SELECT COUNT(*)
                        FROM broadcast_campaign_groups g
                        LEFT JOIN broadcast_callees c ON c.group_id=g.group_id
                        LEFT JOIN broadcast_log l ON l.campaign_id='$campaign' AND l.callee=c.id
                        WHERE g.campaign_id='$campaign' AND (l.answer IS NULL OR (l.answer='0' AND l.delivered_to='' AND l.initiated_dial != '1'))";
    	$callees = $db->getOne($sql);
	return $callees;
}
function broadcast_completion_percentage($campaign)  {
	global $db;
	$done = $db->getOne("SELECT completed FROM broadcast_campaigns WHERE id='$campaign'");
	if($done)  {
		return "100";
	}
	$complete = $db->getOne("SELECT COUNT(*) FROM broadcast_log WHERE campaign_id='$campaign' AND (answer='1' OR delivered_to != '' OR initiated_dial = '1')");
	$total = $db->getOne("SELECT COUNT(*) FROM broadcast_campaign_groups g LEFT JOIN broadcast_callees c ON g.group_id=c.group_id WHERE g.campaign_id='$campaign'");
	if($total != 0)  {
		$percent_complete = round($complete/$total*100);
	}
	else  {
		$percent_complete = 0;
	}
	return $percent_complete;
}
function broadcast_duplicate_campaign($campaign)  {
	global $db;
	// Insert a new campaign, appending the date to the name, with the same values as the campaign we are duplicating
	$sql = "INSERT INTO broadcast_campaigns (id,name,email,email_settings,active,time_start,time_finish,weekday_start,weekday_finish,
						 date_start,date_finish,destination_person,destination_machine, callerid)
			SELECT '', CONCAT(name,'-',DATE_FORMAT(NOW(),'%Y%m%d')), email, email_settings, active, time_start, time_finish, weekday_start,weekday_finish,date_start,date_finish, destination_person,destination_machine, callerid
			FROM broadcast_campaigns
			WHERE id='$campaign'";
	$result = $db->query($sql);
	if($db->IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}
	else  {
		$id = $db->getOne("SELECT id FROM broadcast_campaigns WHERE name=(SELECT CONCAT(name,'-',DATE_FORMAT(NOW(),'%Y%m%d')) FROM broadcast_campaigns WHERE id='$campaign') ORDER BY id DESC LIMIT 1");
	}
	// insert rows into broadcast_campaign_groups for each group active with the campaign we are duplicating
	$sql = "INSERT INTO broadcast_campaign_groups (id,campaign_id,group_id) SELECT '','$id',group_id FROM broadcast_campaign_groups WHERE campaign_id='$campaign'";

	$result = $db->query($sql);
	if($db->IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}
	return $id;

	}
}

function broadcast_sysadmin_getinfo() {
    return array(
        "name" => "XactDialer", // Required. Descriptive name.
        "expires" => true,         // Optional. Defaults to false (never expires)
        "keyname" => "xdialer_exp", // Optional. Only checked if 'expires' is true
    );
}
