<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
/*
 * Copyright 2011 by Schmooze Com., Inc.
 *
 * These materials may not be duplicated, distributed or used
 * in whole or in part, except as permitted by Schmooze Com., Inc.
 * via a valid license agreement
 *
 * By installing, copying or using the materials provided herewith,
 * or by inspecting the source code or reverse engineering or decompiling
 * any or part of the work, you agree to all of the
 * terms of use as determined by Schmoozec Com., Inc.
 *
 * Schmooze Com., Inc reserves the right to unilaterally change the terms of
 * this agreement at any time
 *
 */
if (zend_loader_file_encoded()) {
        $callerid_lic_info       = zend_loader_file_licensed();
	$callerid_lic_exp        = isset($callerid_lic_info['callerid_man_exp'])?preg_replace('/-/','',$callerid_lic_info['callerid_man_exp']):'00000000';
        if ($callerid_lic_exp > date('Ymd')) {
                $callerid_licensed = true;
        } else {
                $callerid_licensed = false;
        }
} else {
        $callerid_licensed = true;
}

//get all callerid's
function callerid_get() {
	global $db;
	$res = $db->getAll('SELECT * FROM callerid_entries', DB_FETCHMODE_ASSOC);
	if($db->IsError($res)) {
		die_freepbx($res->getMessage() . $db->last_query);
	}

	/*foreach ($res as $my => $r) {
		$fc = new featurecode('callerid', 'entry-' . $r['id']);
		$res[$my]['prefix'] = $fc->getCode();
	}*/

	return $res;
}


//generate dialplan
function callerid_get_config($engine) {
	global $ext, $callerid_licensed;

	if ($callerid_licensed) {
		switch($engine) {
			case "asterisk":
				$callerid = callerid_get();
				if (!$callerid) {
					break; //no callerid's? no dialplan!
				}

				$c = 'callerid-management';

				//generate per-callerid dialplan
				foreach ($callerid as $cid) {
					//parse the callerid for dynamic random callerid's
					if (substr($cid['cidnum'], 0, 1) == '_') {
						$cid['cidnum'] = substr($cid['cidnum'], 1);
						$rcid = '';
						preg_match_all("/x|n|z|(?<=\[)[^]]+(?=\])/", $cid['cidnum'], $split);

						foreach ($split[0] as $s) {
							switch (true) {
								case (is_string($s) && strtolower($s) == 'n'):
									$rcid .= '${RAND(2,9)}';
									break;
								case (is_string($s) && strtolower($s) == 'x'):
									$rcid .= '${RAND(0,9)}';
									break;
								case (is_string($s) && strtolower($s) == 'z'):
									$rcid .= '${RAND(1,9)}';
									break;
								case (ctype_digit($s)):
									$rcid .= '${CUT(' . implode('-', str_split($s)) . ',,${RAND(1,' . count(str_split($s)).')})}';
									break;
								default:
									$rcid .= $char;
									break;
							}
						}

						$cid['cidnum'] = $rcid;
					}
					//dbug('generating')
					//dialplan to perminanatly change the callerid
					if ($cid['cidnum'] == '*') {
						$ext->add($c, '_' . $cid['prefix'] . '.', '', new ext_set('CM_CIDNAME', $cid['cidname']));
						$cid['cidnum'] = '${CM_CIDNUM}';
						$cid['cidname'] = '${CM_CIDNAME}';
						$ext->add($c, '_' . $cid['prefix'] . '.', '', new ext_gosub('1','dyn',false,'${EXTEN:' . strlen($cid['prefix']) . '}'));
					} else {
						$ext->add($c, '_' . $cid['prefix'] . '.', '', new ext_set('TEXTEN', '${EXTEN:' . strlen($cid['prefix']) . '}'));
					}
					if ($cid['perm'] == 'true') {
						$ext->add($c, '_' . $cid['prefix'] . '.', '', new ext_macro('user-callerid'));
						$ext->add($c, '_' . $cid['prefix'] . '.', '',
										new ext_execif('$["${AMPUSER}" != ""]',
												'System',
												'${ASTVARLIBDIR}/bin/callerid_updater.php'
												. ' -u${AMPUSER}'
												. ' -n"' . $cid['cidname'] . '"'
												. ' -m' . $cid['cidnum']
												));
						$ext->add($c, '_' . $cid['prefix'] . '.', '', new ext_gosubif('$["${AMPUSER}" != ""]', 'clear,1'));

					} else {//dialplan to change the callerid temporaraly
						$ext->add($c,  '_' . $cid['prefix'] . '.', '', new ext_set('CALLERID_OVERIDE',
												'"' . $cid['cidname'] . '" '
												. '<' . $cid['cidnum']  . '>'
								));
					}

					//with either state, go to from-internal when done
					$ext->add($c, '_' . $cid['prefix'] . '.', '', new ext_goto('from-internal,${TEXTEN},1'));
				}

				// clear ampuser dialplan
				// TODO: I'm wondering if this is a problem for certain scenarios, consider removing
				//
				$ext->add($c, 'clear', '', new ext_set('AMPUSER', ''));
				$ext->add($c, 'clear', '', new ext_set('AMPUSERCID', ''));
				$ext->add($c, 'clear', '', new ext_set('AMPUSERCIDNAME', ''));
				$ext->add($c, 'clear', '', new ext_return());

				//       ARG1 has the full number so need to extract the other part
				//
				$ext->add($c, 'dyn', '', new ext_set('CM_CIDNUM', '${CUT(ARG1,#,1)}'));
				$ext->add($c, 'dyn', '', new ext_set('TEXTEN', '${CUT(ARG1,#,2)}'));
				$ext->add($c, 'dyn', '', new ext_execif('$[${LEN(${CM_CIDNUM})} & ${LEN(${TEXTEN})}]', 'Return'));

				$ext->add($c, 'dyn', '', new ext_resetcdr(''));
				$ext->add($c, 'dyn', '', new ext_nocdr(''));
				$ext->add($c, 'dyn', '', new ext_progress(''));
				$ext->add($c, 'dyn', '', new ext_wait('1'));
				$ext->add($c, 'dyn', '', new ext_playback('you-dialed-wrong-number'));
				$ext->add($c, 'dyn', '', new ext_wait('1'));
				$ext->add($c, 'dyn', '', new ext_saydigits('${ARG1}'));
				$ext->add($c, 'dyn', '', new ext_wait('1'));
				$ext->add($c, 'dyn', '', new ext_congestion('10'));
				$ext->add($c, 'dyn', '', new ext_hangup(''));

				$ext->addInclude('from-internal-additional', $c);
				needreload();
			break;
		}
	}
}

//generate hookd dial plan
function callerid_hookGet_config($engine) {
	global $ext, $callerid_licensed;

	if ($callerid_licensed) {
		switch($engine) {
			case 'asterisk':
				$callerid = callerid_get();
				if (!$callerid) {
					break; //no callerid's? no dialplan!
				}

				$ext->splice('macro-outbound-callerid', 's', 'hidecid',
					new ext_execif('$[${LEN(${CALLERID_OVERIDE})}]', 'Set', 'CALLERID(all)=${CALLERID_OVERIDE}'));
			break;
		}
	}
}


//save callerid's
function callerid_put($items, $entries) {
	global $db;
	$errors = array();

	/*$stale = callerid_get();
	if ($stale) {
		foreach ($stale as $s) {
			$fc = new featurecode('callerid-entires', 'entry-' . $s['prefix']);
			$fc->delete();
		}
	}*/
	//remove old entrys
	sql('DELETE FROM callerid_entries');

	if (is_array($items)) {
		$id = 0;
		foreach ($items as $i) {

			//check for dup's before saving
			$dup = framework_check_extension_usage($entries['prefix'][$i]);

			//format the error msg array
			if (is_array($dup) && $dup) {
				foreach ($dup as $my => $d) {
					$dup['mod'] = $my;
					$dup['ext'] = $entries['prefix'][$i];
					$dup = array_merge($dup, $entries['prefix'][$i]);
				}
				//dbug('dup', $dup);
				$errors[] = $dup;
				break;//dont save a dup!
			}

			$sql = 'INSERT INTO callerid_entries (id, name, prefix, cidname, cidnum, perm) VALUES (?, ?, ?, ?, ?, ?)';
			$q = $db->query($sql,
					array($id++,
						$entries['name'][$i],
						$entries['prefix'][$i],
						$entries['cidname'][$i],
						$entries['cidnum'][$i],
						(isset($entries['perm'][$i]) ? $entries['perm'][$i] : ''))
					);
			if($db->IsError($q)) {
				die_freepbx($q->getMessage() . $db->last_query);
			}
	}

		//update fc
		//$fc = new featurecode('callerid', 'entry-' . $i);
		//$fc->setDefault($entries['prefix'][$i]);
		//$fc->setDescription('CallerID Management: ' . $i);
		//$fc->update();
	}

	needreload();

	return $errors;
}

//report which extensions were using to prevent dup's
function callerid_check_extensions($exten = true) {
	$extenlist = array();
	if (is_array($exten) && empty($exten)) {
		return $extenlist;
	}
	$sql = "SELECT name, prefix FROM callerid_entries ";
	if (is_array($exten)) {
		$sql .= "WHERE prefix in ('".implode("','",$exten)."')";
	}

	$results = sql($sql,"getAll",DB_FETCHMODE_ASSOC);

	foreach ($results as $result) {
		$thisexten = $result['prefix'];
		$extenlist[$thisexten]['description'] = sprintf(_("CallerID Management: %s %s"), $result['name'], $result['prefix']);
		$extenlist[$thisexten]['status'] = _('INUSE');
		$extenlist[$thisexten]['edit_url'] = 'config.php?display=callerid';
	}
	return $extenlist;
}

function callerid_set_cid($extension, $outboundcid) {
    global $db, $astman;

    if(!get_magic_quotes_gpc()) {
	$extension = isset($extension) ? $db->escapeSimple($extension) : '';
        $outboundcid = isset($outboundcid) ? $db->escapeSimple($outboundcid) : '';
    }

    $sql = "UPDATE users set outboundcid=\"";
    $sql .= isset($outboundcid)?$outboundcid:'';
    $sql .= "\" where extension = " . $extension;

    sql($sql);

    if ($astman) {
        $astman->database_put("AMPUSER",$extension."/outboundcid",isset($outboundcid)?"\"".$outboundcid."\"":'');
    }
}

function callerid_sysadmin_getinfo() {
    return array(
        "name" => "Caller ID Management", // Required. Descriptive name.
        "expires" => true,         // Optional. Defaults to false (never expires)
        "keyname" => "callerid_man_exp", // Optional. Only checked if 'expires' is true
    );
}
