<?php
$html = '';
$html .= heading('CallerID Management', 3) . '<hr/>';

if (!$callerid_licensed) {
	echo sysadmin_get_sales_html('callerid');	
}

$html .= _('The CallerID Management module allows you to change '
		. 'the outbound Caller ID on an extension basis by utilizing a call prefix code.')
		. br(2);
//$html .= form_open($_SERVER['REQUEST_URI'], 'id=""'); doesnt work in fpbx 2.9
$html .= '<form name="prompt" action="' . $_SERVER['REQUEST_URI'] . '" method="post" id="cidform">';
$html .= form_hidden('action', 'save');

//send error if a duplicate extension is detected
if ($errors) {
	foreach ($errors as $error) {
			$html .= '<div class="ui-state-error ui-corner-all">'
					. _('Attention: Extension') . ' ' . $error['ext'] . ' ' 
					. _('conflicts with') 
					. ': <a href="' . $error['edit_url'] . '">'
					. $error['description']
					. '</a>. '
					. _('Extension discarded!')
					. '</div>';
		}
	}

$num_hint = _('If you put a single "*" as the CallerID Number, you can dynamically set '
			.	'the CallerID Number as part of the dialstring. You must dial as follows:') . br() . br()
			. htmlspecialchars(_('<prefix><caller-id-number>#<number-to-dial>.')) . br() . br()
			.	_('You can also generate a random callerid by using dialplan matching. '
			. 'Prefix your string with a _ and then use any of the following') . br()
			. _('N: any digit from 2-9') . br()
			. _('Z: any digit from 1-9') . br()
			. _('X: any digit from 0-9') . br()
			. _('[xzy]: the digits specified in the brackets. Note: unlike regular ')
			. _(' dialplan matching, you cannot use an automatic range (i.e. [2-6])')
			. _(' instead, you must list all of the possible digits (i.e. [23456])');

$perm = _('Make CallerID changes persistant. If unchecked, will only change the CallerID for one call.');
$table = new CI_Table;
$table->set_template(array('table_open' => '<table class="alt_table" id="entry_table">'));			
$table->set_heading(_('Name'), _('Prefix'), 
					_('CallerID Name'), fpbx_label(_('CallerID Num'), $num_hint), 
					 fpbx_label(_('Persistent'), $perm), _('Delete'));

//trash icon
$trash = '<img src="images/trash.png" style="cursor:pointer;" alt="'
		. _('remove') 
		. '" title="'
		. _('Click here to remove this entry')
		. '" class="delete_entry">';
//counter
$c = 0;		
foreach ($entries as $id => $e) {

	//use PLACEHOLD when were on the last item, otherwise just increment $c
	$name = array(
			'name' 			=> 'entries[name][' . $id . ']',
			'placeholder'	=> 'descriptive name',
			'value'			=> $e['name']
	);

	$prefix = array(
			'name' 			=> 'entries[prefix][' . $id . ']',
			//'placeholder'	=>	'descriptive name'
			'value'			=> $e['prefix']
	);

	$cidname = array(
			'name' 			=> 'entries[cidname][' . $id . ']',
			'placeholder'	=> _('CallerID name'),
			'value'			=> $e['cidname']
	);

	$cidnum = array(
			'name' 			=> 'entries[cidnum][' . $id . ']',
			'placeholder'	=> _('CallerID num'),
			'value'			=> $e['cidnum']
	);

	$perm = array(
			'name' 			=> 'entries[perm][' . $id . ']',
			'value'			=> 'true'
	);
	$e['perm'] ? $perm['checked'] = 'checked' : '';
	
	$table->add_row(form_hidden('items[]', $id) . form_input($name), 
					form_input($prefix), 
					form_input($cidname), 
					form_input($cidnum), 
					form_checkbox($perm),
					$trash);
	
}
$html .= $table->generate();

$html .= br() . '<img src="modules/callerid/assets/images/add.png" style="cursor:pointer" title="Add Entry" id="add_entry" />';

$html .= br(2) . form_submit('submit', _('Submit'));

echo $html;
?>
