<?php /* $Id */
// vim: set filetype=php expandtab tabstop=4 shiftwidth=4 autoindent smartindent:

if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

$action = (isset($_REQUEST['action']))?$_REQUEST['action']:'';
if (isset($_REQUEST['delete'])) $action = 'delete';
$itemid = (isset($_REQUEST['itemid']))?$_REQUEST['itemid']:'';
$dispnum = 'calllimit';

if (isset($_POST['action'])) {
    switch($action) {
    case 'add':
        calllimit_put($_POST);
        needreload();
        break;
    case 'delete':
        calllimit_del($itemid);
        needreload();
        break;
    case 'edit':
        calllimit_put($_POST);
        needreload();
        break;
    default:
        break;
    }
}

$calllimit_all = calllimit_get_all();

if (!$calllimit_licensed) {
	echo sysadmin_get_sales_html('calllimit');
}
?>
<!-- right side menu -->
<div class="rnav"><ul>
    <li><a id="<?php echo ($itemid=='' ? 'current':'') ?>" href="config.php?display=<?php echo urlencode($dispnum)?>"><?php echo _("Add Call Limit")?></a></li>
<?php
    if (isset($calllimit_all)) {
        foreach ($calllimit_all as $calllimits) {
            echo "<li><a id=\"".($itemid==$calllimits['id'] ? 'current':'')."\" href=\"config.php?display=".urlencode($dispnum)."&itemid=".urlencode($calllimits['id'])."\">{$calllimits['name']}</a></li>";
        }
    }
?>
</ul></div>

<?php 

    if ($itemid) {
        $calllimit = calllimit_get($itemid);

        echo "<h2>"._("Edit: ").$calllimit['name']."</h2>";

        $usage_list = framework_display_destination_usage(calllimit_getdest($itemid));
        if (!empty($usage_list)) {
?>
            <tr><td colspan="2">
                    <a href="#" class="info"><?php echo $usage_list['text']?>:<span><?php echo $usage_list['tooltip']?></span></a>
                </td></tr><br /><br />
<?php
        }

    } else {
        echo "<h2>"._("Add Outbound Call Limit")."</h2>";
    }

    $helptext = _("An Outbound Call limit allows you to restrict the number of calls people make that match particular outbound routes.");
    echo $helptext;
    echo $row['dest'];

?>

<form name="editCalllimit" action="<?php echo $_SERVER['REQUEST_URI'] ?>" method=POST>
    <input type="hidden" name="itemid" value="<?php echo $itemid; ?>">
        <input type="hidden" name="id" value="<?php echo $itemid; ?>">
    <input type="hidden" name="action" value="<?php echo ($itemid ? 'edit' : 'add'); ?>">
    <table id="calllimitoptionstable">
        <tr>
            <td colspan="2"><h5><?php  echo ($itemid ? _("Edit Call Limit") : _("Add Call Limit")) ?><hr></h5></td>
        </tr>
                <tr>
                        <td><a href="#" class="info"><?php echo _("Name")?>:<span><?php echo _("Enter the name of your outbound call limit rule to make it easier to select in your outbound route.")?></span></a></td>
                        <td><input size="30" type="text" name="name" value="<?php  echo $calllimit['name']; ?>" tabindex="<?php echo ++$tabindex;?>"></td>
                </tr>                   
        <tr><td colspan="2"><h3>Call Limits<hr></h3></tr></td>
        <tr><td colspan="2">
    <p>Select the maximum number of calls that can be made in a single period.</p>
    <p>Note that this will match against <strong>all fields</strong>.</p>
    <p>This means, for example, if you have a maximum of '10' in a 5 hour period, but a maximum of '5' per day, it will block calls after 5, because it will match on the 'per day' field.</p>
        </td></tr>
<?php 
    foreach (array(1,2,3) as $query) {
        $qty = isset($calllimit['qty_'.$query])?$calllimit['qty_'.$query]:'1';
        $len = isset($calllimit['periodlength_'.$query])?$calllimit['periodlength_'.$query]:'1';
        echo "<tr><td colspan=2>A Maximum of ";
        echo "<input size='2' type='text' name='qty_$query' value='$qty' tabindex=".++$tabindex." /> calls per \n";
        echo "<input size='2' type='text' name='periodlength_$query' value='$len' tabindex=".++$tabindex." />\n";
        echo '<select name="periodtype_'.$query."\">\n";
        foreach (array('Unused', 'Hours', 'Days', 'Months') as $period) {
            $thisperiodtype = isset($calllimit['periodtype_'.$query])?$calllimit['periodtype_'.$query]:'Unused';
            echo '<option value="'.$period.'" '.($period == $thisperiodtype ? ' SELECTED' : '').' tabindex='.++$tabindex.'>'.$period."</option>\n";
        }
        echo "</select>\n";
        if ($query != 3) 
            echo "<br />&nbsp;&nbsp;<strong>or</strong>\n";

    }
?>
        <?php if (function_exists('recordings_list')) { ?>
        <tr>
            <td><a href="#" class="info"><?php echo _("Recording")?>:<span><?php echo _("Select the recording to be played to the caller when they have hit this limit and are unable to complete their outbound call.")?></span></a></td>
            <td>
                <select name="recording" tabindex="<?php echo ++$tabindex;?>">
<?php
    $tresults = recordings_list();
    $default = (isset($calllimit['recording_id']) ? $calllimit['recording_id']: '');
    echo '<option value="None">'._("Default");
    if (isset($tresults[0])) {
        foreach ($tresults as $tresult) {
            echo '<option value="'.$tresult['id'].'"'.($tresult['id'] == $default ? ' SELECTED' : '').'>'.$tresult['displayname']."</option>\n";
        }
    }
?>
                </select>
            </td>
        </tr>
        <?php } else { ?>
        <tr>
                    <td><a href="#" class="info"><?php echo _("Recording")?>:<span><?php echo _("Select the recording to be played to the caller when they have hit this limit and are unable to complete their outbound call.")?></span></a></td>
        </tr>
        <?php } ?>
        <tr>
            <td colspan="2"><br><h6><input name="submit" type="submit" value="<?php echo _("Submit")?>" tabindex="<?php echo ++$tabindex;?>"></h6>
            <?php if (isset($itemid)) { ?>
                    <br><h6><input name="delete" type="submit" value="<?php echo _("Delete")?>" tabindex="<?php echo ++$tabindex;?>"></h6>
            <?php } ?>
            </td>
        </tr>
    </table>
</form>
<?php
    //add hooks
    echo $module_hook->hookHtml;

