<?php // vim: set ai ts=4 sw=4 ft=phtml:

// Check to see if we're licenced
if (!cos_islicenced()) {
	// We're not.
	echo sysadmin_get_sales_html('cos');
	return;
}

$cos = new Cos();
?>
<div class='rnav'>
  <ul>
    <li><a href='?display=cos&action=add'>Add new COS</a></li>
<?php

$allCOS = $cos->getAllCOS();
if ($allCOS) {
	print "    <li><hr></li>\n";
	foreach ($allCOS as $c) {
		print "    <li><a href=\"?display=cos&action=edit&cos=".urlencode($c)."\">$c</a></li>\n";
	}
}
?>
  </ul>
</div>


<h3>Class of Service</h3>

<form method='post' action='?display=cos'>

<?php
if (!function_exists('core_users_list')) {
	print "<h3>Core Module Disabled</h3>\n<p>Please re-enable core through module admin</p>\n";
	return;
}

// Setup
$ringgroups = false;
$queues = false;
$conferences = false;
$paging = false;
$vmblast = false;

if (function_exists('ringgroups_destinations') && ringgroups_list()) {
	// Ringgroups returns an almost-dialplan entry. So we need to fix that
	$ringgroups = ringgroups_list();
}
if (function_exists('queues_list') && queues_list()) {
	$queues = queues_list();
}
if (function_exists('conferences_list') && conferences_list()) {
	$conferences = conferences_list();
}
if (function_exists('paging_list') && paging_list()) {
	$paging = paging_list();
}
if (function_exists('vmblast_list') && vmblast_list()) {
	$vmblast = vmblast_list();
}

// Start to process things.
if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'edit') {
  $edit = true;
  if (!isset($_REQUEST['cos'])) {
	  $cosname = 'Unnamed';
  } else {
	  $cosname = htmlentities($_REQUEST['cos'],ENT_COMPAT|ENT_HTML401,"UTF-8",false);
  }
  print "<p>Edit Class of Service</p>\n";
  print "<input type='hidden' name='action' value='change'>\n";
  print "<input type='hidden' name='cos' value=\"$cosname\">\n";
  print "<p>CoS Name: <input type='text' name='cosname' value=\"$cosname\"/></p>\n";
} else {
  $edit = false;
  print "<p>Add new Class of Service</p>\n";
  print "<input type='hidden' name='action' value='addnew'>\n";
  print "<p>CoS Name: <input type='text' name='cosname' /></p>\n";
}

// We keep the tabs hidden until we've finished loading it. Looks crappy, otherwise.
?>
<div id='tabs' style='display: none'>
  <ul>
    <li><a href='#users'>Members</a></li>
	<li><a href='#routes'>Routes</a></li>
    <li><a href='#featurecodes'>Feature Codes</a></li>
<?php
if ($ringgroups) {
	print "<li><a href='#rg'>Ring Groups</a></li>\n";
}
if ($queues) {
	print "<li><a href='#queues'>Queues</a></li>\n";
}
if ($conferences) {
	print "<li><a href='#conf'>Conferences</a></li>\n";
}
if ($paging) {
	print "<li><a href='#paging'>Paging</a></li>\n";
}
if ($vmblast) {
	print "<li><a href='#vmblast'>VoiceMail Blasts</a></li>\n";
}

print "</ul>\n";

$fcs = $cos->getAllFCs();

if ($edit) {
	// Grab all our codes.
	$all = $cos->getAll($_REQUEST['cos']);
} else {
	$all = array();
}

// Assign them to the correct side.
$fcdeny = array();
$fcallow = array();
foreach ($fcs as $f) {
	if (isset($all['fcallow'][$f['name']]) || !$edit) {
		$fcallow[] = $f;
	} else {
		$fcdeny[] = $f;
	}
}

// Users.
$allusers = core_users_list();
$usermember = array();
$usernotmember = array();
foreach ($allusers as $user) {
	if (isset($all['members'][$user[0]])) {
		$usermember[] = $user;
	} else {
		$usernotmember[] = $user;
	}
}

// Prepare sections..
$sections = array();

if ($cos->hasExtensionroutes()) {
	$sections[] = "routes";
	// Routes
	$routesallow = array();
	$routesdeny = array();
	foreach (core_routing_list() as $r) {
		$id = $r['route_id'];
		$name = $r['name'];

		if (isset($all['routesallow'][$id]) || !$edit) {
			$routesallow[$id] = array('ident' => $id, 'desc' => $name);
		} else {
			$routesdeny[$id] = array('ident' => $id, 'desc' => $name);
		}
	}
} else {
	print "<div id='routes'><p>Outbound Routes integrates with the free Extension Routes Module.</p><p>The Extension Route module is not loaded</p>\n";
	print "<p>This may be because of any of the following reasons:<ul>\n";
	print "  <li> The module is not installed</li>\n";
	print "  <li> The module is not registered</li>\n";
	print "  <li> The module has expired.</li>\n";
	print "  <li> The module is out of date</li>\n";
	print "</ul></p></div>\n";
}

// Ring Groups
if ($ringgroups) {
	$rgallow = array();
	$rgdeny = array();
	foreach ($ringgroups as $rg) {
		if (isset($all['rgallow'][$rg['grpnum']]) || !$edit) {
			$rgallow[$rg['grpnum']] = array('ident' => $rg['grpnum'], 'desc' => $rg['description']);
		} else {
			$rgdeny[$rg['grpnum']] = array('ident' => $rg['grpnum'], 'desc' => $rg['description']);
		}
	}
	$sections[] = "rg";
}

// Conferences
if ($conferences) {
	$confallow = array();
	$confdeny = array();
	foreach ($conferences as $c) {
		if (isset($all['confallow'][$c[0]]) || !$edit) {
			$confallow[$c[0]] = array('ident' => $c[0], 'desc' => $c[1]);
		} else {
			$confdeny[$c[0]] = array('ident' => $c[0], 'desc' => $c[1]);
		}
	}
	$sections[] = "conf";
}

// Queues
if ($queues) {
	$queuesallow = array();
	$queuesdeny = array();
	foreach ($queues as $q) {
		if (isset($all['queuesallow'][$q[0]]) || !$edit) {
			$queuesallow[$q[0]] = array('ident' => $q[0], 'desc' => $q[1]);
		} else {
			$queuesdeny[$q[0]] = array('ident' => $q[0], 'desc' => $q[1]);
		}
	}
	$sections[] = "queues";
}

// Paging
if ($paging) {
	$pagingallow = array();
	$pagingdeny = array();
	foreach ($paging as $p) {
		if (isset($all['pagingallow'][$p[0]]) || !$edit) {
			$pagingallow[$p[0]] = array('ident' => $p[0], 'desc' => $p['description']);
		} else {
			$pagingdeny[$p[0]] = array('ident' => $p[0], 'desc' => $p['description']);
		}
	}
	$sections[] = "paging";
}

// VMBlast
if ($vmblast) {
	$vmballow = array();
	$vmbdeny = array();
	foreach ($vmblast as $v) {
		if (isset($all['vmblastallow'][$v[0]]) || !$edit) {
			$vmblastallow[$v[0]] = array('ident' => $v[0], 'desc' => $v[1]);
		} else {
			$vmblastdeny[$v[0]] = array('ident' => $v[0], 'desc' => $v[1]);
		}
	}
	$sections[] = "vmblast";
}

// Featurecodes
?>
<div id='featurecodes' class='tab'>
  <fieldset class="featurecodes_list ui-sortable left" id='fc_allow' data-otherid='fc_deny'>
    <legend>Allow</legend>
<?php
foreach ($fcallow as $a) {
	print "    <span data-fcname='".$a['name']."'>".$a['desc']." (".$a['code'].")</span>\n";
}
?>
  </fieldset>
<?php showMiddle(); ?>
  <fieldset class="featurecodes_list ui-sortable right" id='fc_deny' data-otherid='fc_allow'>
    <legend>Deny</legend>
<?php
foreach ($fcdeny as $a) {
	print "    <span data-fcname='".$a['name']."'>".$a['desc']." (".$a['code'].")</span>\n";
}
?>
  </fieldset>
</div> <!-- featurecodes -->

<div id='users' class='tab'>
  <fieldset class='users_list ui-sortable left' id='users_allow' data-otherid='users_deny'>
    <legend>Include</legend>
<?php
foreach ($usermember as $u) {
	print "    <span data-extnum='".$u[0]."'>".$u[0]." (".$u[1].")</span>\n";
}
?>
  </fieldset>
<?php showMiddle(); ?>
  <fieldset class='users_list ui-sortable right' id='users_deny' data-otherid='users_allow'>
    <legend>Exclude</legend>
<?php
foreach ($usernotmember as $u) {
	print "    <span data-extnum='".$u[0]."'>".$u[0]." (".$u[1].")</span>\n";
}
?>
  </fieldset>
</div>

<?php
// End Featurecodes

foreach ($sections as $s) {
	$allowname = "{$s}allow";
	$denyname = "{$s}deny";
	print "  <div id='$s' class='tab'>\n";
	print "    <fieldset class='{$s}_list ui-sortable left' id='{$s}_allow' data-otherid='${s}_deny'>\n";
	print "      <legend>Allow</legend>\n";
	foreach ($$allowname as $p) {
		print "    <span data-ident='".$p['ident']."'>".$p['desc']." (".$p['ident'].")</span>\n";
	}
	print "    </fieldset>\n";
	showMiddle();
    print "    <fieldset class='{$s}_list ui-sortable right' id='{$s}_deny' data-otherid='${s}_allow'>\n";
    print "      <legend>Deny</legend>\n";
	foreach ($$denyname as $p) {
		print "      <span data-ident='".$p['ident']."'>".$p['desc']." (".$p['ident'].")</span>\n";
	}
	print "    </fieldset>\n";
	print "  </div>\n";
}

print "</ul>\n";

if ($edit) {
	print "<input class='submit' type='submit' name='Save' value='Save'/>";
	print "<input class='submit' type='submit' name='Delete' value='Delete'/>";
} else {
	print "<input class='submit' type='submit' name='Create' value='Create'/>";
}
?>
</form>

</div>

<script type='text/javascript'>

$(document).ready(function() {
  // Tabs
  $("#tabs").tabs({
    show: function() { set_height(); },
  });

  // Buttonize the options.
  $('fieldset>span').button();

  // Make everything draggable.
  var tabs = [ '.featurecodes_list', '.users_list', '.routes_list', '.rg_list', '.conf_list', '.queues_list', '.paging_list', '.vmblast_list' ];
  $.each(tabs, function(i, tab) {
    $(tab).sortable({
      connectWith: tab,
      items: '>span',
      deactivate: function(){ set_height();},
	}).disableSelection();
  });

  // When you double click on a thing, it should move.
  $('fieldset>span').dblclick(function(e){
    var to = $(this).parent().data('otherid');
    $(this).appendTo($('#' + to));
    set_height();
  });

  $(window).resize(function() { set_height(); });

  // Enable 'Move All' buttons
  $('.button').button();
  $('.button').click(function() {
	  var cmd=$(this).data('cmd');
	  var thistab = $("#tabs>.tab:visible");
	  var left = thistab.children('.left');
	  var right = thistab.children('.right');
	  if (cmd == 'allleft') {
		  right.children('span').each(function() { $(this).appendTo(left); });
	  } else if (cmd == 'allright') {
		  left.children('span').each(function() { $(this).appendTo(right); });
	  } else {
		  oldleft = left.children('span');
		  right.children('span').each(function() { $(this).appendTo(left); });
		  oldleft.each(function() { $(this).appendTo(right); });
	  }
  });

  // Show the tabs, we're ready to go.
  $("#tabs").show();
  set_height();
});

function set_height() {
  var height = 0;
  $("#tabs>.tab:visible").height('auto').each(function(){
       height = $(this).height() > height ? $(this).height() : height;
     }).height(height);
}


// When 'Submit' is clicked, return a useful list of things.
$('form').submit(function() {
  var form=$(this);
  $('#fc_allow>span').each(function() {
    form.append('<input type="hidden" name="fc_allow[]" value="'+$(this).attr('data-fcname')+'">');
  });
  $('#users_allow>span').each(function() {
    form.append('<input type="hidden" name="users_allow[]" value="'+$(this).attr('data-extnum')+'">');
  });
  $('#routes_allow>span').each(function() {
    form.append('<input type="hidden" name="routes_allow[]" value="'+$(this).attr('data-ident')+'">');
  });
  $('#rg_allow>span').each(function() {
    form.append('<input type="hidden" name="rg_allow[]" value="'+$(this).attr('data-ident')+'">');
  });
  $('#conf_allow>span').each(function() {
    form.append('<input type="hidden" name="conf_allow[]" value="'+$(this).attr('data-ident')+'">');
  });
  $('#queues_allow>span').each(function() {
    form.append('<input type="hidden" name="queues_allow[]" value="'+$(this).attr('data-ident')+'">');
  });
  $('#paging_allow>span').each(function() {
    form.append('<input type="hidden" name="paging_allow[]" value="'+$(this).attr('data-ident')+'">');
  });
  $('#vmblast_allow>span').each(function() {
    form.append('<input type="hidden" name="vmblast_allow[]" value="'+$(this).attr('data-ident')+'">');
  });
});


</script>

<?php
function showMiddle() {
	print "<span class='middle'>\n";
    print "<span class='button allleft' data-cmd='allleft'>&lt;--</span>\n";
	print "<span class='button swap' data-cmd='swap'>&lt;--&gt;</span>\n";
	print "<span class='button allright' data-cmd='allright'>--&gt;</span>\n";
	print "</span>\n";
}
