<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
function endpoint_write_cisco_ext($extEdit){
    global $db;
    $ext = endpoint_getExtensionAssignments();
    $model = endpoint_get_brand_models('cisco');
    foreach($model as $k=>$v){
        $type[$v['model']] = $v['type'];
        $linekeys[$v['model']] = $v['linekeys'];
    }
	foreach($ext as $key=>$value){
        if($value['ext'] == $extEdit){
            if($value['brand'] == 'Cisco' && $type[$value['model']] == 'phone'){
                switch($value['model']){
//Enterprise version
                    case 'CP7975G':
                    case 'CP7961G':
                    case 'CP7962G':
                    case 'CP7965G':
                    case 'CP9951':
                    case 'CP9971':
                    case 'CP7941G':
                    case 'CP7942G':
                    case 'CP7945G':
                    case 'CP7911G':
                    case 'CP7912G':
                    case 'CP7931G':
                    case 'CP8941':
                    case 'CP8945':
                    case 'CP8961':
                    case 'CP6921':
                        $extInfo = endpoint_getSipInfo($value['ext']);
                        $values = endpoint_configVariables($value, 'cisco', $model);
//set buttons
                        $b = endpoint_get_brand_buttons($value['template'], 'cisco');
                        foreach($b as $k=>$v){
                            $buttons[$v['key']] = $v['value'];
                        }
                        $temp = endpoint_Replace_Buttons($buttons, $value);
                        
                        unset($buttons);
                        foreach($temp as $k=>$v){
                            $but = explode('_', $k);
                            if($but[0] == $value['model']){
                                $buttons[$but[1]][$but[2]] = $v;
                            }
                        }
                        //hack to make sure at least 1 button is set for line otherwise it won't provision
                        $lines = 'no';
                        foreach($buttons as $number=>$vals){
                            if($vals['type'] == 'Line'){$lines = 'yes';}
                            $nums[$number] = $number;
                            if(empty($vals['acct'])){$vals['acct'] = '1';} else {$vals['acct'] = substr($vals['acct'], 7);}
                            //deal with line 1 first
                            switch($vals['type']){
                                case 'Line':
                                    $values['b' . $number . 'Type'] = '9';
                                    $values['b' . $number . 'Label'] = $values['line' . $vals['acct'] . 'Name'];
                                    $values['b' . $number . 'Proxy'] = 'USECALLMANAGER';
                                    $values['b' . $number . 'sipPort'] = $values['line' . $vals['acct'] . 'sipPort'];
                                    $values['b' . $number . 'Ext'] = $values['line' . $vals['acct'] . 'Ext'];
                                    $values['b' . $number . 'Auth'] = $values['line' . $vals['acct'] . 'Ext'];
                                    $values['b' . $number . 'Pass'] = $values['line' . $vals['acct'] . 'Pass'];
                                    break;
                                case 'Speeddial':
                                    $values['b' . $number . 'Type'] = '21';
                                    $values['b' . $number . 'Label'] = $vals['label'];
                                    $values['b' . $number . 'Value'] = $vals['value'];
                                    break;
                                case 'URI':
                                    $values['b' . $number . 'Type'] = '20';
                                    $values['b' . $number . 'Label'] = $vals['label'];
                                    $values['b' . $number . 'Value'] = $vals['value'];
                                    break;
                                }
                        }
                        if($lines == 'no'){
                            //no lines set, need to set one
                            $b = '1';
                            $set = '0';
                            while($set === '0'){
                                if(!isset($nums[$b])){
                                    $values['b' . $b . 'Type'] = '9';
                                    $values['b' . $b . 'Label'] = $values['line1Name'];
                                    $values['b' . $b . 'Proxy'] = 'USECALLMANAGER';
                                    $values['b' . $b . 'sipPort'] = $values['line1sipPort'];
                                    $values['b' . $b . 'Ext'] = $values['line1Ext'];
                                    $values['b' . $b . 'Auth'] = $values['line1Ext'];
                                    $values['b' . $b . 'Pass'] = $values['line1Pass'];
                                    $set = '1';
                                }
                                $b++;
                                if($b > $linekeys[$value['model']]){exit('Error, no line key set for Cisco Enterprise phone');}
                            }
                        }
                        
//get basefile
                        $basefile = endpoint_generate_cisco_xml_config('cisco', 'phone', $value['model'], $value['template'], 'enterprise');
                        
                        $basefile = preg_replace('/\<1line\>/', '<line button="1">', $basefile);
                        $basefile = preg_replace('/\<\/1line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<2line\>/', '<line button="2">', $basefile);
                        $basefile = preg_replace('/\<\/2line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<3line\>/', '<line button="3">', $basefile);
                        $basefile = preg_replace('/\<\/3line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<4line\>/', '<line button="4">', $basefile);
                        $basefile = preg_replace('/\<\/4line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<5line\>/', '<line button="5">', $basefile);
                        $basefile = preg_replace('/\<\/5line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<6line\>/', '<line button="6">', $basefile);
                        $basefile = preg_replace('/\<\/6line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<7line\>/', '<line button="7">', $basefile);
                        $basefile = preg_replace('/\<\/7line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<8line\>/', '<line button="8">', $basefile);
                        $basefile = preg_replace('/\<\/8line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<9line\>/', '<line button="9">', $basefile);
                        $basefile = preg_replace('/\<\/9line\>/', '</line>', $basefile);
                        $basefile = preg_replace('/\<10line\>/', '<line button="10">', $basefile);
                        $basefile = preg_replace('/\<\/10line\>/', '</line>', $basefile);                                   
                        
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }
                        
                        $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                        $basefile = preg_replace('/\\\%/', '', $basefile);
                        
                        $value['mac'] = strtoupper($value['mac']);                
                        $fileloc = '/tftpboot/SEP' . $value['mac'] . '.cnf.xml';
                        file_put_contents($fileloc, $basefile);
                        $chmods = system("/bin/chmod 755 " . $fileloc, $retval);
                        
//write out dialplan
                        $basefile = endpoint_generate_cisco_dialplanxml_config('cisco', 'phone', $value['model'], $value['template'], 'dialplan');
                        //dbug($basefile);
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }
                        
                        $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                        $basefile = preg_replace('/\\\%/', '', $basefile);
                        //dbug($basefile);
                        $value['mac'] = strtoupper($value['mac']);                
                        $fileloc = '/tftpboot/dialplan-' . $value['mac'] . '.xml';
                        file_put_contents($fileloc, $basefile);
                        $chmods = system("/bin/chmod 755 " . $fileloc, $retval);
                        
                        break;
 
//Legacy Enterprise Version 
                    case 'CP7940':
                    case 'CP7960':
                        $extInfo = endpoint_getSipInfo($value['ext']);
                        $values = endpoint_configVariables($value, 'cisco', $model);
//set buttons
                        $b = endpoint_get_brand_buttons($value['template'], 'cisco');
                        foreach($b as $k=>$v){
                            $buttons[$v['key']] = $v['value'];
                        }
                        $temp = endpoint_Replace_Buttons($buttons, $value);
                        
                        unset($buttons);
                        foreach($temp as $k=>$v){
                            $but = explode('_', $k);
                            if($but[0] == $value['model']){
                                $buttons[$but[1]][$but[2]] = $v;
                            }
                        }

                        foreach($buttons as $number=>$vals){
                            $nums[$number] = $number;
                            if(empty($vals['acct'])){$vals['acct'] = '1';} else {$vals['acct'] = substr($vals['acct'], 7);}
                            //deal with line 1 first
                            switch($vals['type']){
                                case 'Line':
                                    $values['line' . $number . 'Ext'] = $values['line' . $vals['acct'] . 'Ext'];
                                    $values['line' . $number . 'Name'] = $values['line' . $vals['acct'] . 'Name'];
                                    $values['line' . $number . 'Pass'] = $values['line' . $vals['acct'] . 'Pass'];
                                    break;
                                }
                        }
                        
//get basefile
                        $basefile = endpoint_generate_cisco_cnf_config('cisco', 'phone', $value['model'], $value['template'], 'lenterprise');
                        
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }
                        
                        $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                        $basefile = preg_replace('/\\\%/', '', $basefile);
                        
                        $value['mac'] = strtoupper($value['mac']);                
                        $fileloc = '/tftpboot/SIP' . $value['mac'] . '.cnf';
                        file_put_contents($fileloc, $basefile);
                        $chmods = system("/bin/chmod 755 " . $fileloc, $retval);

                        //write out generic SIPDefault.cnf to avoid provision errors
                        $basefile = 'http_proxy_addr: "" 
http_proxy_port: 80 
remote_party_id: 0';
                        $fileloc = '/tftpboot/SIPDefault.cnf';
                        file_put_contents($fileloc, $basefile);
                        $chmods = system("/bin/chmod 755 " . $fileloc, $retval);
                        break;
// Non-Enterprise version
                default:
                        $extInfo = endpoint_getSipInfo($value['ext']);
                        $values = endpoint_configVariables($value, 'cisco', $model);
//set buttons
                        $b = endpoint_get_brand_buttons($value['template'], 'cisco');
                        foreach($b as $k=>$v){
                            $buttons[$v['key']] = $v['value'];
                        }
                        $buttons = endpoint_Replace_Buttons($buttons, $value);
                        foreach($buttons as $k=>$v){
                            $h = strlen($value['model']);
                            if($value['model'] == substr($k, 0, $h) && substr($k, -5) == 'label' && substr($k, -8, 1) != 's'){
                                if(empty($values['line' . substr($k, -7, 1) . 'label'])){
                                    $values['line' . substr($k, -7, 1) . 'label'] = $v;
                                }
                            }
                            if($value['model'] == substr($k, 0, $h) && substr($k, -4) == 'type' && $v == 'Line'){
                                $lines[] = substr($k, 0, -5);
                            }
                            if($value['model'] == substr($k, 0, $h) && substr($k, -4) == 'type' && $v == 'BLF'){
                                $lines[] = substr($k, 0, -5);
                            }
                            if($value['model'] == substr($k, 0, $h) && substr($k, -4) == 'type' && $v == 'Speeddial'){
                                $speed[] = substr($k, 0, -5);
                            }
                        }

                        foreach($speed as $k=>$v){
                            $values['speeddial' . substr($v, -1)] = $buttons[$v . '_value'];
                        }
                        foreach($lines as $k=>$v){
                            if(!empty($buttons[$v . '_acct'])){
                                $buttons[$v . '_acct'] = substr($buttons[$v . '_acct'], 7);
                            } else {
                                $buttons[$v . '_acct'] = '1';
                            }
                            $mTemp = explode('_', $v);
                            $modelTemp = $mTemp[0] . '_';
                            if($buttons[$v . '_type'] == 'Line'){
                                $values['line' . $mTemp[1] . 'acct'] = $buttons[$v . '_acct'];

                                if(empty($buttons[$v . '_label'])){
                                    $values['line' . $mTemp[1] . 'label'] = $values['line' . $buttons[$v . '_acct'] . 'Name'];
                                } else {
                                    $values['line' . $mTemp[1] . 'label'] = $buttons[$v . '_label'];
                                }
                                $values['line' . $mTemp[1] . 'value'] = '';
                                $values['line' . $mTemp[1] . 'sharedcall'] = 'shared';                    }
                            if($buttons[$v . '_type'] == 'BLF'){$values['line' . $mTemp[1] . 'acct'] = 'Disabled';}
                            if($buttons[$v . '_type'] == 'BLF'){$values['line' . $mTemp[1] . 'label'] = $buttons[$v . '_label'];}
                            if($buttons[$v . '_type'] == 'BLF'){$values['line' . $mTemp[1] . 'sharedcall'] = 'private';}
                            if($buttons[$v . '_type'] == 'BLF'){
                                if(preg_match('/@/', $buttons[$v . '_value'])){
                                    $values['line' . $mTemp[1] . 'value'] = 'fnc=blf+sd+cp;sub=' . $buttons[$v . '_value'] . ';nme=' . $buttons[$v . '_label'];   
                                } else {
                                    $values['line' . $mTemp[1] . 'value'] = 'fnc=blf+sd+cp;sub=' . $buttons[$v . '_value'] . '@' . $values['line' . $buttons[$v . '_acct'] . 'Dest'] . ';nme=' . $buttons[$v . '_label'];     
                                }  
                            }
                        }
//get basefile
                        $bf = endpoint_GetBasefile('cisco', 'phone', $value['model'], 'spa');	
                        $custom = endpoint_BasefileTemplate($bf, $value['template']);

//write out mac.cfg
        $basefile = '<!--Configuration automatically generated via the Schmooze Com EndPoint Module
#DO NOT HAND MODIFY THIS FILE!
#generated: ' . date('r') . '
#################################################################-->
<flat-profile>  
';	
                        foreach($bf as $k=>$v){
                            if($v['template'] == 'default' || $v['template'] == $value['template']){
                                if($v['model'] == '' || strpos($v['model'],$value['model']) !== false){
                                    if(array_key_exists($v['define'], $custom)&& $v['template'] == 'default'){
                                        //do nothing
                                    } else {
                                        if($v['attrib'] == ''){$attrib = '';} else {$attrib = ' ua="' . $v['attrib'] . '"';}
                                        $basefile .= "  <" . $v['param'] . $attrib . '>' . $v['value'] . '</' . $v['param'] . '>
';
                                    }
                                }
                            }
                        }
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }

                        $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                        $basefile = preg_replace('/\\\%/', '', $basefile);

//write out expansion module if needed
                        foreach($model as $kM=>$vM){
                            if($value['exp0'] == $vM['model']){$b = $vM['linekeys'];}
                        }
                        if(!empty($value['exp0'])){
                            $c = 1;
                            while($c <= $b){
                                if($buttons[$value['exp0'] . '_' . $c . '_type'] == 'Speed'){
                                $basefile .= "\n  <Unit_1_Key_" . $c . ' ua="na">fnc=sd;ext=' . $buttons[$value['exp0'] . '_' . $c . '_value'] . '@' . $values['destination'] . ';nme=' . $buttons[$value['exp0'] . '_' . $c . '_label'] . '</Unit_1_Key_' . $c . '>';
                                }
                                if($buttons[$value['exp0'] . '_' . $c . '_type'] == 'BLF'){
                                $basefile .= "\n  <Unit_1_Key_" . $c . ' ua="na">fnc=blf+sd+cp;sub=' . $buttons[$value['exp0'] . '_' . $c . '_value'] . '@' . $values['destination'] . ';nme=' . $buttons[$value['exp0'] . '_' . $c . '_label'] . '</Unit_1_Key_' . $c . '>';
                                }
                                $c++;
                            }
                        }
						
						foreach($model as $kM=>$vM){
                            if($value['exp1'] == $vM['model']){$b = $vM['linekeys'];}
                        }
						if(!empty($value['exp1'])){
							$c = 1;
                            while($c <= $b){
                                if($buttons[$value['exp1'] . '_' . $c . '_type'] == 'Speed'){
                                $basefile .= "\n  <Unit_2_Key_" . $c . ' ua="na">fnc=sd;ext=' . $buttons[$value['exp1'] . '_' . $c . '_value'] . '@' . $values['destination'] . ';nme=' . $buttons[$value['exp1'] . '_' . $c . '_label'] . '</Unit_2_Key_' . $c . '>';
                                }
                                if($buttons[$value['exp1'] . '_' . $c . '_type'] == 'BLF'){
                                $basefile .= "\n  <Unit_2_Key_" . $c . ' ua="na">fnc=blf+sd+cp;sub=' . $buttons[$value['exp1'] . '_' . $c . '_value'] . '@' . $values['destination'] . ';nme=' . $buttons[$value['exp1'] . '_' . $c . '_label'] . '</Unit_2_Key_' . $c . '>';
                                }
                                $c++;
                            }
                        }

                        $basefile .= '
</flat-profile>';

                        $value['mac'] = strtolower($value['mac']);              
                        $fileloc = '/tftpboot/spa' . $value['mac'] . '.xml';
                        file_put_contents($fileloc, $basefile);
                        $chmods = system("/bin/chmod 755 " . $fileloc, $retval);       
                        if(!isset($values['provisionAddress'])){$values['provisionAddress'] = '/spa$MA.xml';}
                        $cfg = '';       
                        $cfg .= "<!--Configuration automatically generated via the EndPoint Module \n";
                        $cfg .= "#DO NOT HAND MODIFY THIS FILE! \n";
                        $cfg .= '#generated: ' . date('r') . "\n-->";
                        $cfg .= "\n";
                        $cfg .= '<flat-profile>
    <!-- The Phone will load up this file first -->
    <!-- Don\'t put anything else into this file except the two lines below! It will never be referenced again! -->
    <!-- Trick the Phone into loading a specific file for JUST that phone -->
    <!-- Set the resync to 3 seconds so it reboots automatically, we set this to 86400 seconds in the other file -->
    <Resync_Periodic>3</Resync_Periodic>
    <Profile_Rule>' . $values['provisionAddress'] . '/spa$MA.xml</Profile_Rule>
</flat-profile>';
                        $value['mac'] = strtolower($value['mac']);
                        $configModel = preg_replace('/SPA/', 'spa', $value['model']);
                        $fileloc = '/tftpboot/' . $configModel . '.cfg';
                        file_put_contents($fileloc, $cfg);
                        $chmods = system("/bin/chmod 755 " . $fileloc, $retval);  

                    }
                    break;
            }
                    
                    
                    
                    
                    
//for fxs devices
            if($value['brand'] == 'Cisco' && $type[$value['model']] == 'fxs'){
                $values = endpoint_configVariables($value, 'cisco', $model);
//get basefile
                $bf = endpoint_GetBasefile('cisco', 'fxs', $value['model'], 'spa');
                $custom = endpoint_BasefileTemplate($bf, $value['template']);
//get all accounts together
                $acct = endpoint_getSameExt($value['mac']);
                foreach($acct as $k=>$v){
                    $extInfo = endpoint_getSipInfo($v['ext']);
                    $acct[$k]['pass'] = $extInfo['secret'];
                }
                $i=1;
                foreach($acct as $k=>$v){
                    if($acct['account' . $i]['accessory'] == 'fax'){
                        $values['line' . $i . 'echoCanc'] = 'Yes';
                        $values['line' . $i . 'cedDetect'] = 'Yes';
                        $values['line' . $i . 'cngDetect'] = 'Yes';
                        $values['line' . $i . 'passthruCodec'] = 'G711u';
                        $values['line' . $i . 'codecSymmetric'] = 'Yes';
                        $values['line' . $i . 'passthruMethod'] = 'ReINVITE';
                        $values['line' . $i . 'processNse'] = 'Yes';
                        $values['line' . $i . 'enableT38'] = 'Yes';
                        $values['line' . $i . 'toneDetectMode'] = 'caller or callee';
                        $values['line' . $i . 't38Redundancy'] = '2';
                        $values['line' . $i . 't38V29'] = 'Yes';
                    }
                    if($acct['account' . $i]['ext'] != ''){
                        $values['line' . $i . 'Enable'] = 'Yes';
                        $values['line' . $i . 'Ext'] = $acct['account' . $i]['ext'];
                        $values['line' . $i . 'Pass'] = $acct['account' . $i]['pass'];
                    }
                    $i++;
                }
//write out mac.cfg
                $basefile = '<!--Configuration automatically generated via the Schmooze Com EndPoint Module
#DO NOT HAND MODIFY THIS FILE!
#generated: ' . date('r') . '
#################################################################-->
<flat-profile>  
';
                foreach($bf as $k=>$v){
                    if($v['template'] == 'default' || $v['template'] == $value['template']){
			if($v['model'] == '' || strpos($v['model'],$value['model']) !== false){
                            if(array_key_exists($v['define'], $custom)&& $v['template'] == 'default'){
                                //do nothing
                            } else {
                                if($v['attrib'] == ''){$attrib = '';} else {$attrib = ' ua="' . $v['attrib'] . '"';}
                                $basefile .= "  <" . $v['param'] . $attrib . '>' . $v['value'] . '</' . $v['param'] . '>
';
                            }
			}
                    }
                }             
                $basefile .= '  <router-configuration>
';
                foreach($file['router-configuration'] as $v){
                    $basefile .= '    <' . $v['param'] . '>' . $v['value'] . '</' . $v['param'] . '>
';
                }
                $basefile .= '    <Web_Management>
';
                foreach($file['Web_Management'] as $v){
                    $basefile .= '      <' . $v['param'] . '>' . $v['value'] . '</' . $v['param'] . '>
';
                }
                $basefile .= '    </Web_Management>
';
                $basefile .= '  </router-configuration>';
                $basefile .= '
</flat-profile>';
				
                foreach($values as $k=>$v){
                    $basefile = str_replace('%' . $k . '%', $v, $basefile);
                }
                
                $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                $basefile = preg_replace('/\\\%/', '', $basefile);
                        
                $value['mac'] = strtolower($value['mac']);
                $fileloc = '/tftpboot/spa' . $value['mac'] . '.xml';
                file_put_contents($fileloc, $basefile);
                $chmods = system("/bin/chmod 755 " . $fileloc, $retval);       
                
                $cfg = '';       
                $cfg .= "<!--Configuration automatically generated via the EndPoint Module \n";
                $cfg .= "#DO NOT HAND MODIFY THIS FILE! \n";
                $cfg .= '#generated: ' . date('r') . "\n-->";
                $cfg .= "\n";
                $cfg .= '<flat-profile>
	<!-- The Phone will load up this file first -->
	<!-- Don\'t put anything else into this file except the two lines below! It will never be referenced again! -->
	<!-- Trick the Phone into loading a specific file for JUST that phone -->
	<!-- Set the resync to 3 seconds so it reboots automatically, we set this to 86400 seconds in the other file -->
	<Resync_Periodic>3</Resync_Periodic>
	<Profile_Rule>/spa$MA.xml</Profile_Rule>
</flat-profile>';
                unset($fileloc);
                switch($value['model']){
                    case 'SPA232D':
                        $fileloc = '/tftpboot/spa232D.cfg';
                        break;
                    case 'PAP2':
                        $fileloc = '/tftpboot/init.cfg';
                        break;
                    case 'SPA301':
                    case 'SPA303':
                    case 'SPA901':
                    case 'SPA921':
                    case 'SPA922':
                    case 'SPA941':
                    case 'SPA942':
                    case 'SPA962':
                    case 'SPA2102':
                    case 'SPA3102':
                    case 'SPA8000':
                        $fileloc = '/tftpboot/' . $value['model'] . '.cfg';
                        break;
                    case 'SPA112':
                    case 'SPA122':
                        $fileloc = '/tftpboot/' . strtolower($value['model']) . '.cfg';
                        break;
                    
                    default:
                        if(substr($v['model'], -1) == "G"){
                            $model = substr(strtolower($v['model']), 0, -1) . 'G';
                            $fileloc = '/tftpboot/' . $model . '.cfg';
                        }
                        break;
                }
                if(!empty($fileloc)){
                    file_put_contents($fileloc, $cfg);
                    $chmods = system("/bin/chmod 755 " . $fileloc, $retval);  
                }
            }
        }
    }
}

function endpoint_generate_cisco_xml_config($brand, $type, $model, $template_name, $file){
    $bf = endpoint_GetBasefile($brand, $type, $model);		
    $custom = endpoint_BasefileTemplate_polycom($bf, $template_name);
    foreach($bf as $k=>$v){
        if($v['file'] == $file){
            if($v['template'] == 'default' || $v['template'] == $template_name){
                if($v['model'] == '' || strpos($v['model'],$model) !== false){
// need to check if define exists in custom, but then need to verify everything else is same. 
                    if(array_key_exists($v['define'], $custom) && $v['template'] == 'default' && $v['value'] == $custom[$v['define']]['value']){
                        //skip it as it is in custom and we add it later
                    } else {
                        if($v['edited'] != '1' && !array_key_exists($v['define'], $custom)){
                            $basefiles[] = array('parent'=>$v['attrib'], 'param'=>$v['param'], 'value'=>$v['value']);
                        }
// removed to eliminate edited and original both showing
//                        if($v['edited'] == '1' && empty($v['define'])){
//                            $basefiles[] = array('parent'=>$v['attrib'], 'param'=>$v['param'], 'value'=>$v['value']);
//                        }
                    }
                }
            }
        }
    }
// now add in the custom entries that are not edits of existing basefiles
    foreach($custom as $k=>$v){
        if($v['file'] == $file){
            if($v['template'] == $template_name){
                if($v['model'] == '' || strpos($v['model'],$model) !== false){
                    $basefiles[] = array('parent'=>$custom[$v['define']]['attrib'], 'param'=>$custom[$v['define']]['param'], 'value'=>$custom[$v['define']]['value']);
                }
            }
        }
    }

//break it up into the parents and children
    foreach($basefiles as $k=>$v){
        if($v['value'] == 'PARENT'){
            $parent[$v['parent']][] = array('param'=>$v['param'], 'attrib'=>$v['parent'], 'value'=>$v['value']);
        }
    }
    foreach($basefiles as $k=>$v){
        if($v['value'] != 'PARENT'){
            $children[$v['parent']][] = array('param'=>$v['param'], 'attrib'=>$v['parent'], 'value'=>$v['value']);
        }
    }
//now lets build the xml
    $basefile = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
    ksort($parent['TOP']);
    //level1
    foreach($parent['TOP'] as $k=>$v){
        $base = $v['param'];
        $basefile .= "<" . $base . ">";
        foreach($children[$base] as $c1K=>$c1V){	
            if($c1V['attrib'] == $base){$basefile .= "\n <" . $c1V['param'] . '>' . $c1V['value'] . '</' . $c1V['param'] . ">";}
        }
    //level2
        ksort($parent[$v['param']]);
        foreach($parent[$base] as $p1K=>$p1V){
            $base1 = $p1V['param'];
            $basetemp1 = '';
            foreach($children[$base1] as $c2K=>$c2V){	
                if($c2V['param'] == 'NONE'){$basetemp1 .= "\n  <" . $base1 . " " . $c2V['value'] . ' />';}
            }
            if(empty($basetemp1)){$basefile .= "\n  <" . $base1 . ">";} else {$basefile .= $basetemp1;}
            foreach($children[$base1] as $c2K=>$c2V){	
                if($c2V['attrib'] == $base1 && $c2V['param'] != 'NONE'){$basefile .= "\n    <" . $c2V['param'] . '>' . $c2V['value'] . '</' . $c2V['param'] . ">";}
            }
            //level3
            ksort($parent[$base1]);
            if($parent[$base1]){
                foreach($parent[$base1] as $p2K=>$p2V){
                    $base2 = $p2V['param'];
                    $basetemp2 = '';
                    foreach($children[$base2] as $c3K=>$c3V){	
                        if($c3V['param'] == 'NONE'){$basetemp2 .= "\n    <" . $base2 . " " . $c3V['value'] . ' />';}
                    }
                    if(empty($basetemp2)){$basefile .= "\n    <" . $base2 . ">";} else {$basefile .= $basetemp2;}
                    foreach($children[$base2] as $c3K=>$c3V){
                        if($c3V['attrib'] == $base2 && $c3V['param'] != 'NONE'){$basefile .= "\n      <" . $c3V['param'] . '>' . $c3V['value'] . '</' . $c3V['param'] . ">";}
                    }
                    //level4
                    ksort($parent[$base2]);
                    if($parent[$base2]){
                        foreach($parent[$base2] as $p3K=>$p3V){
                            $base3 = $p3V['param'];
                            $basetemp3 = '';
                            foreach($children[$base3] as $c4K=>$c4V){	
                                if($c4V['param'] == 'NONE'){$basetemp3 .= "\n      <" . $base3 . " " . $c4V['value'] . ' />';}
                            }
                            if(empty($basetemp3)){$basefile .= "\n      <" . $base3 . ">";} else {$basefile .= $basetemp3;}
                            foreach($children[$base3] as $c4K=>$c4V){
                                if($c4V['attrib'] == $base3 && $c4V['param'] != 'NONE'){$basefile .= "\n        <" . $c4V['param'] . '>' . $c4V['value'] . '</' . $c4V['param'] . ">";}
                            }
                            //level5
                            ksort($parent[$base3]);
                            if($parent[$base3]){
                                foreach($parent[$base3] as $p4K=>$p4V){
                                    $base4 = $p4V['param'];
                                    $basetemp4 = '';
                                    foreach($children[$base4] as $c5K=>$c5V){	
                                        if($c5V['param'] == 'NONE'){$basetemp4 .= "\n        <" . $base4 . " " . $c5V['value'] . ' />';}
                                    }
                                    if(empty($basetemp4)){$basefile .= "\n        <" . $base4 . ">";} else {$basefile .= $basetemp4;}
                                    foreach($children[$base4] as $c5K=>$c5V){
                                        if($c5V['attrib'] == $base4 && $c5V['param'] != 'NONE'){$basefile .= "\n          <" . $c5V['param'] . '>' . $c5V['value'] . '</' . $c5V['param'] . ">";}
                                    }
                                    //level6
                                    ksort($parent[$base4]);
                                    if($parent[$base4]){
                                        foreach($parent[$base4] as $p5K=>$p5V){
                                            $base5 = $p5V['param'];
                                            $basetemp5 = '';
                                            foreach($children[$base5] as $c6K=>$c6V){	
                                                if($c6V['param'] == 'NONE'){$basetemp5 .= "\n          <" . $base5 . " " . $c6V['value'] . ' />';}
                                            }
                                            if(empty($basetemp5)){$basefile .= "\n          <" . $base5 . ">";} else {$basefile .= $basetemp5;}
                                            foreach($children[$base5] as $c6K=>$c6V){
                                                if($c6V['attrib'] == $base5 && $c6V['param'] != 'NONE'){$basefile .= "\n            <" . $c6V['param'] . '>' . $c6V['value'] . '</' . $c6V['param'] . ">";}
                                            }
                                            //level7
                                            ksort($parent[$base5]);
                                            if($parent[$base5]){
                                                foreach($parent[$base5] as $p6K=>$p6V){
                                                    $base6 = $p6V['param'];
                                                    $basetemp6 = '';
                                                    foreach($children[$base6] as $c7K=>$c7V){	
                                                        if($c7V['param'] == 'NONE'){$basetemp6 .= "\n            <" . $base6 . " " . $c7V['value'] . ' />';}
                                                    }
                                                    if(empty($basetemp6)){$basefile .= "\n            <" . $base6 . ">";} else {$basefile .= $basetemp6;}
                                                    foreach($children[$base6] as $c7K=>$c7V){
                                                        if($c7V['attrib'] == $base6 && $c7V['param'] != 'NONE'){$basefile .= "\n              <" . $c7V['param'] . '>' . $c7V['value'] . '</' . $c7V['param'] . ">";}
                                                    }
                                                    if(empty($basetemp6)){$basefile .=  "\n" . '            </' . $base6  . ">";}
                                                }
                                            }
                                            if(empty($basetemp5)){$basefile .=  "\n" . '          </' . $base5  . ">";}
                                        }
                                    }
                                    if(empty($basetemp4)){$basefile .=  "\n" . '        </' . $base4  . ">";}
                                }
                            }
                            if(empty($basetemp3)){$basefile .=  "\n" . '      </' . $base3  . ">";}
                        }
                    }
                    if(empty($basetemp2)){$basefile .=  "\n" . '    </' . $base2  . ">";}
                }
            }
            if(empty($basetemp1)){$basefile .=  "\n" . '  </' . $base1  . ">";}
        }
        $basefile .=  "\n" . '</' . $base  . ">\n";
    }
    return($basefile);
}

function endpoint_generate_cisco_dialplanxml_config($brand, $type, $model, $template_name, $file){
    $bf = endpoint_GetBasefile($brand, $type, $model);		
    $custom = endpoint_BasefileTemplate_ciscoDialplan($bf, $template_name);
    foreach($bf as $k=>$v){
        if($v['file'] == $file){
            if($v['template'] == 'default' || $v['template'] == $template_name){
                if($v['model'] == '' || strpos($v['model'],$model) !== false){
// need to check if define exists in custom, but then need to verify everything else is same. 
                    if(array_key_exists($v['define'], $custom) && $v['template'] == 'default' && isset($v['OID'])){
                        // parse through custom to see if we have the CI number
                        foreach($custom as $define=>$opts){
                            if($define == $v['define']){
                                unset($test);
                                foreach($opts as $c){
                                    if($v['OID'] == $c['OID']){
                                        $test = 'exists';
                                    }
                                }
                                if($test != 'exists'){
                                    $basefiles[] = array('parent'=>$v['attrib'], 'param'=>$v['param'], 'value'=>$v['value']);
                                }
                            }
                        }
                    } else {
                        if($v['edited'] != '1'){
                            $basefiles[] = array('parent'=>$v['attrib'], 'param'=>$v['param'], 'value'=>$v['value']);
                        }
                    }
                }
            }
        }
    }

// now add in the custom entries that are not edits of existing basefiles
    foreach($custom as $k=>$val){
        foreach($val as $define=>$v){
            if($v['file'] == $file){
                if($v['template'] == $template_name){
                    if($v['model'] == '' || strpos($v['model'],$model) !== false){
                        $basefiles[] = array('parent'=>$v['attrib'], 'param'=>$v['param'], 'value'=>$v['value']);
                    }
                }
            }
        }
    }
//break it up into the parents and children
    foreach($basefiles as $k=>$v){
        if($v['value'] == 'PARENT'){
            $parent[$v['parent']][] = array('param'=>$v['param'], 'attrib'=>$v['parent'], 'value'=>$v['value']);
        }
    }
    foreach($basefiles as $k=>$v){
        if($v['value'] != 'PARENT'){
            $children[$v['parent']][] = array('param'=>$v['param'], 'attrib'=>$v['parent'], 'value'=>$v['value']);
        }
    }
//now lets build the xml
    $basefile = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
    ksort($parent['TOP']);
    //level1
    foreach($parent['TOP'] as $k=>$v){
        $base = $v['param'];
        $basefile .= "<" . $base . ">";
        foreach($children[$base] as $c1K=>$c1V){	
            if($c1V['attrib'] == $base){$basefile .= "\n <" . $c1V['param'] . '>' . $c1V['value'] . '</' . $c1V['param'] . ">";}
        }
    //level2
        ksort($parent[$v['param']]);
        foreach($parent[$base] as $p1K=>$p1V){
            $base1 = $p1V['param'];
            $basetemp1 = '';
            foreach($children[$base1] as $c2K=>$c2V){	
                if($c2V['param'] == 'NONE'){$basetemp1 .= "\n  <" . $base1 . " " . $c2V['value'] . ' />';}
            }
            if(empty($basetemp1)){$basefile .= "\n  <" . $base1 . ">";} else {$basefile .= $basetemp1;}
            foreach($children[$base1] as $c2K=>$c2V){	
                if($c2V['attrib'] == $base1 && $c2V['param'] != 'NONE'){$basefile .= "\n    <" . $c2V['param'] . '>' . $c2V['value'] . '</' . $c2V['param'] . ">";}
            }
            //level3
            ksort($parent[$base1]);
            if($parent[$base1]){
                foreach($parent[$base1] as $p2K=>$p2V){
                    $base2 = $p2V['param'];
                    $basetemp2 = '';
                    foreach($children[$base2] as $c3K=>$c3V){	
                        if($c3V['param'] == 'NONE'){$basetemp2 .= "\n    <" . $base2 . " " . $c3V['value'] . ' />';}
                    }
                    if(empty($basetemp2)){$basefile .= "\n    <" . $base2 . ">";} else {$basefile .= $basetemp2;}
                    foreach($children[$base2] as $c3K=>$c3V){
                        if($c3V['attrib'] == $base2 && $c3V['param'] != 'NONE'){$basefile .= "\n      <" . $c3V['param'] . '>' . $c3V['value'] . '</' . $c3V['param'] . ">";}
                    }
                    //level4
                    ksort($parent[$base2]);
                    if($parent[$base2]){
                        foreach($parent[$base2] as $p3K=>$p3V){
                            $base3 = $p3V['param'];
                            $basetemp3 = '';
                            foreach($children[$base3] as $c4K=>$c4V){	
                                if($c4V['param'] == 'NONE'){$basetemp3 .= "\n      <" . $base3 . " " . $c4V['value'] . ' />';}
                            }
                            if(empty($basetemp3)){$basefile .= "\n      <" . $base3 . ">";} else {$basefile .= $basetemp3;}
                            foreach($children[$base3] as $c4K=>$c4V){
                                if($c4V['attrib'] == $base3 && $c4V['param'] != 'NONE'){$basefile .= "\n        <" . $c4V['param'] . '>' . $c4V['value'] . '</' . $c4V['param'] . ">";}
                            }
                            //level5
                            ksort($parent[$base3]);
                            if($parent[$base3]){
                                foreach($parent[$base3] as $p4K=>$p4V){
                                    $base4 = $p4V['param'];
                                    $basetemp4 = '';
                                    foreach($children[$base4] as $c5K=>$c5V){	
                                        if($c5V['param'] == 'NONE'){$basetemp4 .= "\n        <" . $base4 . " " . $c5V['value'] . ' />';}
                                    }
                                    if(empty($basetemp4)){$basefile .= "\n        <" . $base4 . ">";} else {$basefile .= $basetemp4;}
                                    foreach($children[$base4] as $c5K=>$c5V){
                                        if($c5V['attrib'] == $base4 && $c5V['param'] != 'NONE'){$basefile .= "\n          <" . $c5V['param'] . '>' . $c5V['value'] . '</' . $c5V['param'] . ">";}
                                    }
                                    //level6
                                    ksort($parent[$base4]);
                                    if($parent[$base4]){
                                        foreach($parent[$base4] as $p5K=>$p5V){
                                            $base5 = $p5V['param'];
                                            $basetemp5 = '';
                                            foreach($children[$base5] as $c6K=>$c6V){	
                                                if($c6V['param'] == 'NONE'){$basetemp5 .= "\n          <" . $base5 . " " . $c6V['value'] . ' />';}
                                            }
                                            if(empty($basetemp5)){$basefile .= "\n          <" . $base5 . ">";} else {$basefile .= $basetemp5;}
                                            foreach($children[$base5] as $c6K=>$c6V){
                                                if($c6V['attrib'] == $base5 && $c6V['param'] != 'NONE'){$basefile .= "\n            <" . $c6V['param'] . '>' . $c6V['value'] . '</' . $c6V['param'] . ">";}
                                            }
                                            //level7
                                            ksort($parent[$base5]);
                                            if($parent[$base5]){
                                                foreach($parent[$base5] as $p6K=>$p6V){
                                                    $base6 = $p6V['param'];
                                                    $basetemp6 = '';
                                                    foreach($children[$base6] as $c7K=>$c7V){	
                                                        if($c7V['param'] == 'NONE'){$basetemp6 .= "\n            <" . $base6 . " " . $c7V['value'] . ' />';}
                                                    }
                                                    if(empty($basetemp6)){$basefile .= "\n            <" . $base6 . ">";} else {$basefile .= $basetemp6;}
                                                    foreach($children[$base6] as $c7K=>$c7V){
                                                        if($c7V['attrib'] == $base6 && $c7V['param'] != 'NONE'){$basefile .= "\n              <" . $c7V['param'] . '>' . $c7V['value'] . '</' . $c7V['param'] . ">";}
                                                    }
                                                    if(empty($basetemp6)){$basefile .=  "\n" . '            </' . $base6  . ">";}
                                                }
                                            }
                                            if(empty($basetemp5)){$basefile .=  "\n" . '          </' . $base5  . ">";}
                                        }
                                    }
                                    if(empty($basetemp4)){$basefile .=  "\n" . '        </' . $base4  . ">";}
                                }
                            }
                            if(empty($basetemp3)){$basefile .=  "\n" . '      </' . $base3  . ">";}
                        }
                    }
                    if(empty($basetemp2)){$basefile .=  "\n" . '    </' . $base2  . ">";}
                }
            }
            if(empty($basetemp1)){$basefile .=  "\n" . '  </' . $base1  . ">";}
        }
        $basefile .=  "\n" . '</' . $base  . ">\n";
    }
    return($basefile);
}

function endpoint_generate_cisco_cnf_config($brand, $type, $model, $template_name, $file){
	$basefile = "";
	$bf = endpoint_GetBasefile($brand, $type, $model);		
    $custom = endpoint_BasefileTemplate_polycom($bf, $template_name);
    foreach($bf as $k=>$v){
        if($v['file'] == $file){
            if($v['template'] == 'default' || $v['template'] == $template_name){
                if($v['model'] == '' || strpos($v['model'],$model) !== false){
// need to check if define exists in custom, but then need to verify everything else is same.                 
                    if(array_key_exists($v['define'], $custom) && $v['template'] == 'default' && $v['value'] == $custom[$v['define']]['value']){
                        //skip it as it is in custom and we add it later
                    } else {
                        if($v['edited'] != '1'){
                            $basefile .= $v['param'] . ': "' . $v['value'] . '"' . "\n";
                        }
                        if($v['edited'] == '1' && empty($v['define'])){
                            $basefile .= $v['param'] . ': "' . $v['value'] . '"' . "\n";
                        }
                    }
                }
            }
        }
    }
// now add in the custom entries that are not edits of existing basefiles
    foreach($custom as $k=>$v){
        if($v['file'] == $file){
            if($v['template'] == $template_name){
                if($v['model'] == '' || strpos($v['model'],$model) !== false){
					$basefile .= $v['param'] . ': "' . $v['value'] . '"' . "\n";
                }
            }
        }
    }
    return($basefile);
}


?>