<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
/*
* Copyright 2011 by Schmooze Com., Inc.
* By installing, copying, downloading, distributing, inspecting or using the
* materials provided herewith, you agree to all of the terms of use as outlined
* in our End User Agreement which can be found and reviewed at
* http://www.schmoozecom.com/cmeula
*/


    include_once('functions_aastra.php');
    include_once('functions_algo.php');
    include_once('functions_and.php');
    include_once('functions_audiocodes.php');
    include_once('functions_asterisk_conf.php');
    include_once('functions_cisco.php');
    include_once('functions_cyberdata.php');
    include_once('functions_common.php');
    include_once('functions_cortelco.php');
    include_once('functions_digium.php');
    include_once('functions_grandstream.php');
    include_once('functions_mitel.php');
    include_once('functions_mocet.php');
    include_once('functions_obihai.php');
    include_once('functions_panasonic.php');
    include_once('functions_phoenix.php');
    include_once('functions_polycom.php');
    include_once('functions_sangoma.php');
    include_once('functions_snom.php');
    include_once('functions_uniden.php');
    include_once('functions_vtech.php');
    include_once('functions_yealink.php');
    include_once('functions_xorcom.php');
    include_once('functions_xml_api.php');
    include_once('functions_views.php');
    include_once('functions_license.php');
    include_once('grandstream_screens.php');

//XML-API function for what mac/ext
function endpoint_api($info){
    global $db;
    $exts = endpoint_getExtensionAssignments();
    foreach($exts as $ext=>$vals){
        $mac[strtolower($vals['mac'])][] = $vals;
    }
    if(isset($info['ext'])){
        //return Make, Model, Mac
        if(isset($exts[$info['ext']])){
            return($exts[$info['ext']]);
        } else {
            return('Extension not found');
        }
    }
    if(isset($info['mac'])){
        //return Make Model Ext
        if(isset($mac[strtolower($info['mac'])])){
            return($mac[strtolower($info['mac'])]);
        } else {
            return('MAC not found');
        }
    }
}

//XML-API function for what button is what
function endpoint_apiButtons($ext){
    global $db;
    $extList = endpoint_getExtensionAssignments();
    $ret = '';
    $sql = "SELECT * FROM endpoint_buttons WHERE `template_name` = '" . $extList[$ext]['template'] . "'";
    $res = $db->getAll($sql, DB_FETCHMODE_ASSOC);
    if($db->IsError($res)){
        die_freepbx($res->getDebugInfo());
    }
    foreach($res as $key=>$button){
        $list[$button['key']] = $button['value'];
    }
    foreach($res as $key=>$button){
        if(preg_match('/' . $extList[$ext]['model'] . '[-_]/', $button['key'])){
            if(preg_match('/type/', $button['key'])){
                if($button['value'] == 'XML-API'){
                    $b = explode('_', $button['key']);
                    $separator = '_';
                    if($extList[$ext]['brand'] == 'Aastra'){
                        // gotta fix layout for aastra
                        $t = explode('-', $b[0]);
                        $b[2] = $b[1];
                        $b[0] = $t[0];
                        $b[1] = $t[1];
                        $separator = '-';
                    }
                    $temp[$b[0]][] = array('button'=>$b[1], 'value'=>$list[$b[0] . $separator . $b[1] . '_value']);
                }
            }
        }
    }
    return($temp[$extList[$ext]['model']]);
}

//XML-API function for what extension/key has app
function endpoint_apiApp($app){
    global $db;
    //get what templates use the app
    $sql = "SELECT * FROM endpoint_buttons WHERE `value` = '$app'";
    $res = $db->getAll($sql, DB_FETCHMODE_ASSOC);
    if($db->IsError($res)){
        die_freepbx($res->getDebugInfo());
    }
    foreach($res as $templates){
        // add to the list
        $list[$templates['template_name']][$templates['key']]['button'] = $templates['key'];
        $sql2 = "SELECT * FROM endpoint_buttons WHERE `key` = '" . substr($templates['key'], 0, -5) . 'acct' . "'";
        $res2 = $db->getAll($sql2, DB_FETCHMODE_ASSOC);
        if($db->IsError($res2)){
            die_freepbx($res2->getDebugInfo());
        }

        foreach($res2 as $accts){
            if(isset($accts['value'])){$acct = $accts['value'];} else {$acct = 'all';}
            $list[$templates['template_name']][$templates['key']]['acct'] = $acct;
        }
    }

    //get extension and figure out what ones use the template
    $extList = endpoint_getExtensionAssignments();
    $ret = '';
    foreach($extList as $ext=>$data){
        if(isset($list[$data['template']])){
            foreach($list[$data['template']] as $name=>$val){
                if(preg_match('/' . $data['model'] . '[-_]/', $val['button'])){
                    $b = explode('_', $val['button']);
                    $separator = '_';
                    if($data['brand'] == 'Aastra'){
                        // gotta fix layout for aastra
                        $t = explode('-', $b[0]);
                        $b[2] = $b[1];
                        $b[0] = $t[0];
                        $b[1] = $t[1];
                        $separator = '-';
                    }
                    $val['button'] = $b[1];

                    $used[$ext] = $val;
                }
            }
        }
    }
    return($used);
}
