<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
function endpoint_write_panasonic_ext($extEdit){
    global $db;
    $ext = endpoint_getExtensionAssignments();
    $model = endpoint_get_brand_models('panasonic');
    foreach($ext as $key=>$value){
        if($value['ext'] == $extEdit){
            if($value['brand'] == 'Panasonic'){
                $values = endpoint_configVariables($value, 'panasonic', $model);
//set buttons
                if($value['model'] == 'TGP500' || $value['model'] == 'TGP550T04'){
                    $acct = endpoint_getSameExt($value['mac']);
                    foreach($acct as $k=>$v){
                        $extInfo = endpoint_getSipInfo($v['ext']);
                        $values['line' . substr($k, -1) . 'Ext'] = $v['ext'];
                        $values['line' . substr($k, -1) . 'Pass'] = $extInfo['secret'];
                        $values['line' . substr($k, -1) . 'Name'] = endpoint_getAcctName($v['ext']);
                    }
                }

                $b = endpoint_get_brand_buttons($value['template'], 'panasonic');
                foreach($b as $k=>$v){
                    $buttons[$v['key']] = $v['value'];
                }
                $buttons = endpoint_Replace_Buttons($buttons, $value);

                $lines = '';
                $softs = '';
                foreach($buttons as $k=>$v){
                    $tModel = explode('_', $k);
                    $h = strlen($value['model']);
                    if($value['model'] == substr($k, 0, $h) && substr($k, -4) == 'type'){
                        $temp = $tModel[0] . '_' . $tModel[1];
                        $lines[] = $temp;
                    }
                }

                if($ext[$extEdit]['model'] != 'UTG300B'){
                    foreach($lines as $k=>$v){
                        $tModel = explode('_', $v);
                        if(empty($buttons[$v . '_acct'])){$buttons[$v . '_acct'] = 'account1';}
                        switch($buttons[$v . '_type']){
                            case 'Line':
                                $values['b' . $tModel[1] . 'type'] = 'X_PANASONIC_IPTEL_DN';
                                $values['b' . $tModel[1] . 'value'] = '1,' . substr($buttons[$v . '_acct'], 7);
                                break;
                            case 'Speeddial':
                                $values['b' . $tModel[1] . 'type'] = 'X_PANASONIC_IPTEL_ONETOUCH';
                                $values['b' . $tModel[1] . 'value'] = $buttons[$v . '_value'];
                                break;
                            case 'BLF':
                                $values['b' . $tModel[1] . 'type'] = 'X_PANASONIC_IPTEL_CONTACT';
                                $values['b' . $tModel[1] . 'value'] = $buttons[$v . '_value'];
                                break;
                            default:
                                break;
                        }
                        $values['b' . $tModel[1] . 'label'] = $buttons[$v . '_label'];
                    }
                
//get basefile info
                    $bf = endpoint_GetBasefile('panasonic', 'phone', $value['model']);
                    $custom = endpoint_BasefileTemplate($bf, $value['template']);
//write out mac.cfg                
                    $basefile = "# PCC Standard Format File #\n";
                    $basefile .= "\n#Configuration automatically generated via the EndPoint Module# \n";
                    $basefile .= "#DO NOT HAND MODIFY THIS FILE!# \n";
                    $basefile .= '#generated: ' . date('r') . "#\n";
                    $basefile .= "\n";

                    foreach($bf as $k=>$v){
                        if($v['template'] == 'default' || $v['template'] == $value['template']){
                            if($v['model'] == '' || strpos($v['model'],$value['model']) !== false){
                                if(array_key_exists($v['define'], $custom)&& $v['template'] == 'default'){
                                    //do nothing
                                } else {
                                    $basefile .= $v['param'] . '="' . $v['value'] . '"' . "\n";
                                }
                            }
                        }
                    }
                    $basefile .= "\n" . $line . "\n";
                    
                    //remove sip entries as it will cause the config not to load if they are not set
                    $basefile = preg_replace('/\SIP_OUTPROXY_PORT_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_OUTPROXY_ADDR_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_RGSTR_PORT_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_RGSTR_ADDR_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_PRXY_PORT_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_PRXY_ADDR_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_[0-9]NDPROXY_PORT_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_[0-9]NDRGSTR_PORT_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_PRSNC_PORT_[0-9]=""/', '', $basefile);
                    $basefile = preg_replace('/\SIP_[0-9]NDPRSNC_PORT_[0-9]=""/', '', $basefile);
                    
                    foreach($values as $k=>$v){
                        $basefile = str_replace('%' . $k . '%', $v, $basefile);
                    }
                    $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                    $basefile = preg_replace('/\\\%/', '', $basefile);
                } else {
//new format
                    //set all buttons = 0 by default
                    $i = 1;
                    while($i < 25){
                        $values['b' . $i . 'Type'] = '0';
                        $i++;
                    }
                    foreach($lines as $k=>$v){
                        $tModel = explode('_', $v);
                        if(empty($buttons[$v . '_acct'])){$buttons[$v . '_acct'] = 'account1';}
                        switch($buttons[$v . '_type']){
                            case 'Line':
                                $values['b' . $tModel[1] . 'Acct'] = preg_replace('/account/', '', $buttons[$v . '_acct']);
                                $values['b' . $tModel[1] . 'Type'] = '0';
                                $values['b' . $tModel[1] . 'Value'] = '';
                                break;
                            case 'Speeddial':
                                $values['b' . $tModel[1] . 'Acct'] = preg_replace('/account/', '', $buttons[$v . '_acct']);
                                $values['b' . $tModel[1] . 'Type'] = '1';
                                $values['b' . $tModel[1] . 'Value'] = $buttons[$v . '_value'];
                                break;
                            case 'BLF':
                                $values['b' . $tModel[1] . 'Acct'] = preg_replace('/account/', '', $buttons[$v . '_acct']);
                                $values['b' . $tModel[1] . 'Type'] = '2';
                                $values['b' . $tModel[1] . 'Value'] = $buttons[$v . '_value'];
                                break;
                            default:
                                break;
                        }
                        $values['b' . $tModel[1] . 'Label'] = $buttons[$v . '_label'];
                    }

//set all expansion modules button types to 0 to avoid config errors
                    $i = "1";
                    while($i < 73){
                        $values['exp' . $i . 'Type'] = '0';
                        $i++;
                    }

//write out expansion module if needed
                    if(!empty($value['exp0'])){
                        $c = 1;
                        while($c <= 36){
                            if(empty($buttons[$value['exp0'] . _ . $c . '_acct'])){$buttons[$value['exp0'] . _ . $c . '_acct'] = 'account1';}
                            dbug($buttons[$value['exp0'] . _ . $c . '_type']);
                            switch($buttons[$value['exp0'] . _ . $c . '_type']){
                                case 'Line':
                                    $values['exp' . $c . 'Acct'] = preg_replace('/account/', '', $buttons[$value['exp0'] . _ . $c . '_acct']);
                                    $values['exp' . $c . 'Type'] = '0';
                                    $values['exp' . $c . 'Value'] = '';
                                    break;
                                case 'Speeddial':
                                    $values['exp' . $c . 'Acct'] = preg_replace('/account/', '', $buttons[$value['exp0'] . _ . $c . '_acct']);
                                    $values['exp' . $c . 'Type'] = '1';
                                    $values['exp' . $c . 'Value'] = $buttons[$value['exp0'] . _ . $c . '_value'];
                                    break;
                                case 'BLF':
                                    $values['exp' . $c . 'Acct'] = preg_replace('/account/', '', $buttons[$value['exp0'] . _ . $c . '_acct']);
                                    $values['exp' . $c . 'Type'] = '2';
                                    $values['exp' . $c . 'Value'] = $buttons[$value['exp0'] . _ . $c . '_value'];
                                    break;
                                default:
                                    break;
                            }
                            $values['exp' . $c . 'Label'] = $buttons[$value['exp0'] . _ . $c . '_label'];
                            $c++;
                        }
                    }
                    if(!empty($value['exp1'])){
                        $c = 1;
                        $d = $c+36;
                        while($c <= 36){
                            if(empty($buttons[$value['exp1'] . _ . $c . '_acct'])){$buttons[$value['exp1'] . _ . $c . '_acct'] = 'account1';}
                            switch($buttons[$value['exp1'] . _ . $c . '_type']){
                                case 'Line':
                                    $values['exp' . $d . 'Acct'] = preg_replace('/account/', '', $buttons[$value['exp1'] . _ . $c . '_acct']);
                                    $values['exp' . $d . 'Type'] = '0';
                                    $values['exp' . $d . 'Value'] = '';
                                    break;
                                case 'Speeddial':
                                    $values['exp' . $d . 'Acct'] = preg_replace('/account/', '', $buttons[$value['exp1'] . _ . $c . '_acct']);
                                    $values['exp' . $d . 'Type'] = '1';
                                    $values['exp' . $d . 'Value'] = $buttons[$value['exp1'] . _ . $c . '_value'];
                                    break;
                                case 'BLF':
                                    $values['exp' . $d . 'Acct'] = preg_replace('/account/', '', $buttons[$value['exp1'] . _ . $c . '_acct']);
                                    $values['exp' . $d . 'Type'] = '2';
                                    $values['exp' . $d . 'Value'] = $buttons[$value['exp1'] . _ . $c . '_value'];
                                    break;
                                default:
                                    break;
                            }
                            $values['exp' . $d . 'Label'] = $buttons[$value['exp1'] . _ . $c . '_label'];
                            $c++;
                            $d++;
                        }
                    }
                    //dbug($values);
                    $basefile = endpoint_panasonic_basefile($ext[$extEdit]['model'], $template_name);
                    foreach($values as $k=>$v){
                        $basefile = str_replace('%' . $k . '%', $v, $basefile);
                    }
                    $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                    $basefile = preg_replace('/\\\%/', '', $basefile);
                }
                                
                $value['mac'] = strtoupper($value['mac']);
                if($ext[$extEdit]['model'] != 'UTG300B'){
                    $fileloc = '/tftpboot/Config' . $value['mac'] . '.cfg';
                } else {
                    $fileloc = '/tftpboot/Config' . $value['mac'] . '.xml';
                }
                file_put_contents($fileloc, $basefile);
                $chmods = system("/bin/chmod 755 " . $fileloc, $retval);

//write out pointer file				
                if($ext[$extEdit]['model'] != 'UTG300B'){
                    $cfg = '';       

                    $cfg .= '# PCC Standard Format File #
				
OPTION66_ENABLE="Y"
OPTION66_REBOOT="Y"
PROVISION_ENABLE="Y"
CFG_STANDARD_FILE_PATH="' . $values['provisionAddress'] . '/Config{MAC}.cfg"
';
                    if($value['model'] == 'TGP500'){
                                            $value['model'] = $value['model'] . 'B04';
                    }
                    $fileloc = '/tftpboot/KX-' . $value['model'] . '.cfg';
                    file_put_contents($fileloc, $cfg);
                    $chmods = system("/bin/chmod 755 " . $fileloc, $retval);
                }
                
                if($ext[$extEdit]['model'] == 'UTG300B'){
                    $cfg = '';       

                    $cfg .= '<PANASIPPhoneConfig>
    <Initial>
        <Certs>
            <CLIENT_CERTIFICATE_PATH perm="RW"></CLIENT_CERTIFICATE_PATH>
            <CLIENT_KEY_PATH perm="RW"></CLIENT_KEY_PATH>
            <CFG_ROOT_CERTIFICATE_PATH1 perm="RW"></CFG_ROOT_CERTIFICATE_PATH1>
            <CFG_ROOT_CERTIFICATE_PATH2 perm="RW"></CFG_ROOT_CERTIFICATE_PATH2>
            <CFG_ROOT_CERTIFICATE_PATH3 perm="RW"></CFG_ROOT_CERTIFICATE_PATH3>
        </Certs>
        <CfgFiles>
            <CFG_STANDARD_FILE_PATH perm="RW">' . $values['provisionAddress'] . '/Config{MAC}.xml</CFG_STANDARD_FILE_PATH>
            <CFG_PRODUCT_FILE_PATH perm="RW"></CFG_PRODUCT_FILE_PATH>
            <CFG_MASTER_FILE_PATH perm="RW"></CFG_MASTER_FILE_PATH>
        </CfgFiles>
    </Initial>
  </PANASIPPhoneConfig>';
                    $fileloc = '/tftpboot/KX-' . $value['model'] . '.cfg';
                    file_put_contents($fileloc, $cfg);
                    $chmods = system("/bin/chmod 755 " . $fileloc, $retval);
                }
            }
        }
    }
}

function endpoint_panasonic_basefile($model, $template_name){
//Basefile time
    $bf = endpoint_GetBasefile('panasonic', 'phone', $model);		
    $custom = endpoint_BasefileTemplate_OID($bf, $template_name);
    foreach($bf as $id=>$vals){
        if(strpos($vals['model'],$model) === false){
            unset($bf[$id]);
        }
    }
    foreach($bf as $k=>$v){
        if($v['file'] == $file){
            if($v['template'] == 'default' || $v['template'] == $template_name){
                if($v['model'] == '' || strpos($v['model'],$model) !== false){
// need to check if define exists in custom, but then need to verify everything else is same.                 
                    if(array_key_exists($v['OID'], $custom) && $v['template'] == 'default'){
                        
                    } else {
                        if($v['edited'] != '1'){
                            $basefiles[] = array('parent'=>$v['attrib'], 'param'=>$v['param'], 'value'=>$v['value']);
                        }
                    }
                }
            }
        }
    }
// now add in the custom entries that are not edits of existing basefiles
    foreach($custom as $k=>$v){
        if($v['file'] == $file){
            if($v['template'] == $template_name){
                if($v['model'] == '' || strpos($v['model'],$model) !== false){
                    //fix to remove removed entries
                    if(empty($v['attrib']) && empty($v['value'])){
                        //skip it
                    } else {
                        $basefiles[] = array('parent'=>$v['attrib'], 'param'=>$v['param'], 'value'=>$v['value']);
                    }
                }
            }
        }
    }

    
    
    //break it up into the parents and children
    foreach($basefiles as $k=>$v){
        if($v['value'] == 'PARENT'){
            $parent[$v['parent']][] = array('param'=>$v['param'], 'attrib'=>$v['parent'], 'value'=>$v['value']);
        }
    }
    foreach($basefiles as $k=>$v){
        if($v['value'] != 'PARENT'){
            $children[$v['parent']][] = array('param'=>$v['param'], 'attrib'=>$v['parent'], 'value'=>$v['value']);
        }
    }
    $basefile = "<PANASIPPhoneConfig>\n";
    ksort($parent['TOP']);
    //level1
    foreach($parent['TOP'] as $k=>$v){
        $base = $v['param'];
        $basefile .= "    <" . $base . ">";
        foreach($children[$base] as $c1K=>$c1V){	
            if($c1V['attrib'] == $base){
                $close = explode(' ', $c1V['param']);
                $c1V['param'] = preg_replace('/_[0-9]/', '', $c1V['param']);
                $basefile .= "\n        <" . $c1V['param'] . '>' . $c1V['value'] . '</' . $close[0] . '>';
            }
        }
        //level2
        ksort($parent[$v['param']]);
        foreach($parent[$base] as $p1K=>$p1V){
            $base1 = preg_replace('/_[0-9]/', '', $p1V['param']);
            $base1Close = explode(' ', $p1V['param']);
            $basefile .= "\n        <" . $base1 . ">";
            foreach($children[$base1] as $c2K=>$c2V){	
                if($c2V['attrib'] == $base1){
                    $close = explode(' ', $c2V['param']);
                    $c2V['param'] = preg_replace('/_[0-9]/', '', $c2V['param']);
                    $basefile .= "\n            <" . $c2V['param'] . '>' . $c2V['value'] . '</' . $close[0] . '>';
                }
            }
            //level3
            ksort($parent[$base1]);
            if($parent[$base1]){
                foreach($parent[$base1] as $p2K=>$p2V){
                    $base2 = preg_replace('/_[0-9]/', '', $p2V['param']);
                    $base2Close = explode(' ', $p2V['param']);
                    $basefile .= "\n            <" . $base2 . ">";
                    foreach($children[$base2] as $c3K=>$c3V){	
                        if($c3V['attrib'] == $base2){
                            $close = explode(' ', $c3V['param']);
                            $c3V['param'] = preg_replace('/_[0-9]/', '', $c3V['param']);
                            $basefile .= "\n                <" . $c3V['param'] . '>' . $c3V['value'] . '</' . $close[0] . '>';
                        }
                    }
                    //level4
                    ksort($parent[$base2]);
                    if($parent[$base2]){
                        foreach($parent[$base2] as $p3K=>$p3V){
                            $base3 = preg_replace('/Voip_[0-9]/', 'Voip', $p3V['param']);
                            $base3 = preg_replace('/CallCtrl_[0-9]/', 'CallCtrl', $base3);
                            $base3 = preg_replace('/Sip_[0-9]/', 'Sip', $base3);
                            
                            //replacing kem# for expansion modules, should always be at this level
                            $base3C = preg_replace('/KEM[0-9].*Button/', 'Button', $base3);
                            $base3Close = explode(' ', $p3V['param']);
                            $base3Close[0] = preg_replace('/KEM[0-9].*Button/', 'Button', $base3Close[0]);
                            $basefile .= "\n                <" . $base3C . ">";
                            foreach($children[$p3V['param']] as $c4K=>$c4V){	
                                if($c4V['attrib'] == $p3V['param']){
                                    $close = explode(' ', $c4V['param']);
                                    $c4V['param'] = preg_replace('/Voip_[0-9]/', 'Voip', $c4V['param']);
                                    $c4V['param'] = preg_replace('/CallCtrl_[0-9]/', 'CallCtrl', $c4V['param']);
                                    $c4V['param'] = preg_replace('/Sip_[0-9]/', 'Sip', $c4V['param']);
                                    $basefile .= "\n                    <" . $c4V['param'] . '>' . $c4V['value'] . '</' . $close[0] . '>';}
                                }
                            $basefile .=  "\n" . '                </' . preg_replace('/_[0-9]/', '', $base3Close[0])  . ">";
                        }
                    }
                    $basefile .=  "\n" . '            </' . preg_replace('/_[0-9]/', '', $base2Close[0])  . ">";
                }
            }
            $basefile .=  "\n" . '        </' . preg_replace('/_[0-9]/', '', $base1Close[0])  . ">";
        }
        $basefile .=  "\n" . '    </' . $base  . ">\n";
    }
    $basefile .= "</PANASIPPhoneConfig>";

    return($basefile);	
}
?>