<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}

function endpoint_brandView($brand, $template, $new){
    if(!isset($template['template_name'])){
        $template['template_name'] = '';
        $template['destination'] = '';
        $template['time_server_1'] = '';
        $template['time_server_2'] = '';
        $template['timezone'] = '';
        $template['ftpserver'] = '';
        $buttons = '';
        $check = '';
        $checkboxes = '';
        $phones = '';
    }
	
// get global settings
	global $db;
	$q_g = 'SELECT * FROM endpoint_global';
	$g_set = $db->getAll($q_g, DB_FETCHMODE_ASSOC);
	foreach($g_set as $key=>$value){
		$g_settings[$value['key']] = $value['values'];
	}
	$use_temp = "no";

// get template common info if editing
	if($template != null) {
		$template = endpoint_GetTemplateByBrand($brand, $template);
		$use_temp = "yes";
	}

// modal box for duplicate template
?>
	<script>
	$(function() {
		$( "#dialog-form" ).dialog({
			autoOpen: false,
			height: 300,
			width: 350,
			modal: true
		});	
		$( "#duplicate" )
			.button()
			.click(function() {
				$( "#dialog-form" ).dialog( "open" );
			});
	});
	</script>

<div id="dialog-form" title="Duplicate Template">
	<?php
	echo '<form name="duplicate" method="post" action="' . $_SERVER['REQUEST_URI'] . '">';
	?>
	<fieldset>
		<label for="newTemplateName">Duplicate Template Name: </label><input type="text" size="30" name="newTemplateName" /><br />
		<input type="hidden" name="action" value="copyTemplate" />
		<input type="hidden" name="template" value="<?php echo $template['template_name']; ?>" />
		<br /><br /><center><input type="submit" /></center>
	</fieldset>
	</form>
</div>
<?php

	echo '<a href="/admin/config.php?display=endpoint&view=' . $brand . '&action=removeTemplate&template=' . $template['template_name'] . '&brand=' . $brand . '"><input type="button" style="width: 100px;" value="Remove" onclick="return confirm(\'Are you sure you want to delete this item?\');"/></a>';
	echo '<a href="/admin/config.php?display=endpoint&csv_type=output&template=' . $template['template_name'] . '&brand=' . $brand . '"><input type="button" style="width: 100px;" value="Export"/></a>';
	echo '<button id="duplicate">Duplicate</button>';
	
	echo '<form id="' . $brand . '" name="' . $brand . '" method="post" action="' . $_SERVER['REQUEST_URI'] . '">';
	echo '<input type="hidden" name="int_ip" id="int_ip" value="' . $g_settings['internal'] . '">';
	echo '<input type="hidden" name="ext_ip" id="ext_ip" value="' . $g_settings['external'] . '">';
	$table = new CI_Table();
//template name
	if(!empty($template['template_name'])){
            $table->add_row(array( 'data' => fpbx_label('Template Name:', 'Current Template Name.'), 'class' => 'template_name'),
                array( 'data' => $template['template_name'])
            );
            switch($brand){
                case 'aastra':
                case 'digium':
                case 'yealink':
                    if($template['default'] === '1'){$default = 'checked';} else {$default = '';}
                    $table->add_row(array( 'data' => fpbx_label('Default Template:', 'Default Template for XML-API Login/Logout Module.'), 'class' => 'default'),
                        array( 'data' => '<input type="checkbox" name="default" id="default" value="1" ' . $default . '>')
                    );
                    break;
                default:
                    break;
            }
            echo '<input type="hidden" name="template_name" id="template_name" value="' . $template['template_name'] . '">';
	
	} else {
            $table->add_row(array( 'data' => fpbx_label('Template Name:', 'Enter a name for this template.'), 'class' => 'template_name'),
                array( 'data' => '<input id="template_name" type="text" name="template_name" value="" placeholder="Template Name"/>')
            );
	}
//destination address
	$table->add_row(array( 'data' => fpbx_label('Destination Address:', 'Enter an IP or choose Internal or External for the destination of the phones.'), 'class' => 'template_name'),
            array( 'data' => '<input type="text" id="destination" name="destination" value="' . $template['destination'] . '" placeholder="Destination Address"/><span class="radioset">
            <input type="radio" name="dest_option" id="dest-internal" value="internal" ' . ($template['destination'] == $g_settings['internal'] ? 'checked' : '') . ' /> 
            <label for="dest-internal">Internal</label>

            <input type="radio" name="dest_option" id="dest-external" value="external" ' . ($template['destination'] == $g_settings['external'] ? 'checked' : '') . ' /> 
            <label for="dest-external">External</label>
            </span>')
	);

//Aastra Specific
	if($brand == 'aastra'){
		$table->add_row(fpbx_label('Switch Focus to Ringing Line:', 'Change UI Focus on Incoming Calls.'),
			'<span class="radioset">
			<input type="radio" name="focus" id="focus-enable" value="1" ' . ($template['focus'] == "1" ? 'checked' : '') . ' /> 
			<label for="focus-enable">Enable</label>			
			<input type="radio" name="focus" id="focus-disable" value="0" ' . ($template['focus'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="focus-disable">Disable</label>
			</span>'
			);

		$table->add_row(fpbx_label('Auto Answer:', 'Allow Auto Answer on Paging/Intercom.'),
			'<span class="radioset">
			<input type="radio" name="answer" id="answer-enable" value="1" ' . ($template['answer'] == "1" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' />  
			<label for="answer-enable">Enable</label>
			
			<input type="radio" name="answer" id="answer-disable" value="0" ' . ($template['answer'] == "0" ? 'checked' : '') . ' /> 
			<label for="answer-disable">Disable</label>
			</span>'
			);
					
		$table->add_row(fpbx_label('Mute Mic:', 'Enable mute when auto answering.'),
			'<span class="radioset">
			<input type="radio" name="mute" id="mute-enable" value="1" ' . ($template['mute'] == "1" ? 'checked' : '') . ' /> 
			<label for="mute-enable">Enable</label>
			
			<input type="radio" name="mute" id="mute-disable" value="0" ' . ($template['mute'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="mute-disable">Disable</label>
			</span>'
			);

		$table->add_row(fpbx_label('Allow Barge:', 'Allow Someone to Join an Existing Intercom.'),
			'<span class="radioset">
			<input type="radio" name="barge" id="barge-enable" value="1" ' . ($template['barge'] == "1" ? 'checked' : '') . ' /> 
			<label for="barge-enable">Enable</label>
			
			<input type="radio" name="barge" id="barge-disable" value="0" ' . ($template['barge'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="barge-disable">Disable</label>
			</span>'
			);

		$table->add_row(fpbx_label('Auto Off Hook:', 'For Visual Voice Mail.'),
			'<span class="radioset">
			<input type="radio" name="offhook" id="offhook-enable" value="1" ' . ($template['offhook'] == "1" ? 'checked' : '') . ' /> 
			<label for="offhook-enable">Enable</label>
			
			<input type="radio" name="offhook" id="offhook-disable" value="0" ' . ($template['offhook'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="offhook-disable">Disable</label>
			</span>'
			);

		$table->add_row(fpbx_label('Call Stutter:', 'Call Stutter for Voicemail Notifications.'),
			'<span class="radioset">
			<input type="radio" name="stutter" id="stutter-enable" value="0" ' . ($template['stutter'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="stutter-enable">Enable</label>
			
			<input type="radio" name="stutter" id="stutter-disable" value="1" ' . ($template['stutter'] == "1" ? 'checked' : '') . ' /> 
			<label for="stutter-disable">Disable</label>
			</span>'
			);
                
		$deploy_type = endpoint_systype();
                    $table->add_row(fpbx_label('6739i Voicemail Button:', 'Enable Visual Voicemail for 6739i Messages button. NOTE: REQUIRES RESTApps TO BE INSTALLED AND LICENSED!'),
			'<span class="radioset">
			<input type="radio" name="ext" id="ext-enable" value="1" ' . ($template['ext'] == "1" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="ext-enable">Visual VMail</label>
			
			<input type="radio" name="ext" id="ext-disable" value="0" ' . ($template['ext'] == "0" ? 'checked' : '') . ' /> 
			<label for="ext-disable">Standard VMail</label>
			</span>'
			);
                
		$audiomode = '<select name="volume" id="volume">';
		if($template['volume'] == null) {
			$audiomode .= '<option value="0" selected>Speaker Only</option>';
		}
		$am0 = '';
		$am1 = '';
		$am2 = '';
		$am3 = '';
		
		switch($template['volume']){
                    case NULL:
                    case '0':
                    default:
                        $am0 = "selected";
                        break;
                    case '1':
                        $am1 = 'selected';
                        break;
                    case '2':
                        $am2 = 'selected';
                        break;
                    case '3':
                        $am3 = 'selected';
                        break;
		}
		$audiomode .= '<option value="0" ' . $am0 . '>Speaker Only</option>';
		$audiomode .= '<option value="1" ' . $am1 . '>Headset Only</option>';
		$audiomode .= '<option value="2" ' . $am2 . '>Speaker Then Headset</option>';
		$audiomode .= '<option value="3" ' . $am3 . '>Headset Then Speaker</option>';
		
		$audiomode .= '</select>';

		$table->add_row(array( 'data' => fpbx_label('Audio Mode:', 'Configure how the "handsfree" key on the IP phone operates.')),
				array( 'data' => $audiomode)
		);
		
		$table->add_row(fpbx_label('DHSG Settings:', 'Enables and disables the DHSG headset support on the phone.'),
			'<span class="radioset">
			<input type="radio" name="missed" id="missed-enable" value="1" ' . ($template['missed'] == "1" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="missed-enable">Enable</label>
			
			<input type="radio" name="missed" id="missed-disable" value="0" ' . ($template['missed'] == "0" ? 'checked' : '') . ' /> 
			<label for="missed-disable">Disable</label>
			</span>'
			);	
			
			
			

		$timelist = '<select name="timeout" id="timeout">';
		if($template['timeout'] == null) {
			$timelist .= '<option value="4" selected>4 Seconds</option>';
		}
		$c = 1;
		while($c <= 10){
			if($template['timeout'] == $c){
				$timelist .= '<option value="' . $c . '" selected>' . $c . ' Seconds</option>';
			} else {
				$timelist .= '<option value="' . $c . '">' . $c . ' Seconds</option>';
			}
			$c++;
		}
		$timelist .= '</select>';

		$table->add_row(array( 'data' => fpbx_label('Timeout Length:', 'SIP Digit Mapping Timeout Length.')),
				array( 'data' => $timelist)
		);


		$tonesetlist = '<select name="toneset" id="toneset">';
		if($template['toneset'] == null) {
			$tonesetlist .= '<option value="0" selected>US/Canada</option>';
		}

		$tonesets = array("US"=>"US/Canada",
			"Europe"=>"Europe (generic tones)",
			"UK"=>"UK",
			"France"=>"France",
			"Germany"=>"Germany",
			"Italy"=>"Italy",
			"Mexico"=>"Mexico",
			"Brazil"=>"Brazil",
			"Austrailia"=>"Austrailia"
			);

		foreach($tonesets as $value=>$loc){
			if($template['toneset'] == $value){
				$tonesetlist .= '<option value="' . $value . '" selected>' . $loc . '</option>';
			} else {
				$tonesetlist .= '<option value="' . $value . '">' . $loc . '</option>';
			}
		}

		$tonesetlist .= '</select>';

		$table->add_row(array( 'data' => fpbx_label('Tone Set:', 'Tone Set Selection.')),
				array( 'data' => $tonesetlist)
		);         
	}
//Cisco Specific
        if($brand == 'cisco'){           
            $table->add_row(fpbx_label('User Password:', 'Enables and disables the user level password.'),
			'<span class="radioset">
			<input type="radio" name="focus" id="focus-enable" value="1" ' . ($template['focus'] == "1" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="focus-enable">Enable</label>
			
			<input type="radio" name="focus" id="focus-disable" value="0" ' . ($template['focus'] == "0" ? 'checked' : '') . ' /> 
			<label for="focus-disable">Disable</label>
			</span>'
			);  
            $table->add_row(fpbx_label('Audio Indication for Call Pickup:', 'Enables and disables audio notification when any BLF user is receiving a call.'),
			'<span class="radioset">
			<input type="radio" name="mute" id="mute-enable" value="1" ' . ($template['mute'] == "1" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="mute-enable">Enable</label>
			
			<input type="radio" name="mute" id="mute-disable" value="0" ' . ($template['mute'] == "0" ? 'checked' : '') . ' /> 
			<label for="mute-disable">Disable</label>
			</span>'
			);  

        }
//Polycom Specific
	if($brand == 'polycom'){
		$table->add_row(fpbx_label('Missed Calls:', 'Display missed calls.'),
			'<span class="radioset">
			<input type="radio" name="missed" id="missed-enable" value="1" ' . ($template['missed'] == "1" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' />  
			<label for="missed-enable">Enable</label>
			
			<input type="radio" name="missed" id="missed-disable" value="0" ' . ($template['missed'] == "0" ? 'checked' : '') . ' /> 
			<label for="missed-disable">Disable</label>
			</span>'
			);
					
		$table->add_row(fpbx_label('Persistent Volume:', 'Keep volume level after phone call.'),
			'<span class="radioset">
			<input type="radio" name="volume" id="volume-enable" value="1" ' . ($template['volume'] == "1" ? 'checked' : '') . ' /> 
			<label for="volume-enable">Enable</label>
			
			<input type="radio" name="volume" id="volume-disable" value="0" ' . ($template['volume'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="volume-disable">Disable</label>
			</span>'
			);

		$table->add_row(fpbx_label('Call Waiting Signal:', 'How call waiting alerts you.'),
			'<span class="radioset">
                        <input type="radio" name="callwaiting" id="callwaiting-beep" value="2" ' . ($template['callwaiting'] == "2" ? 'checked' : '') . ' /> 
			<label for="callwaiting-beep">Beep</label>
				
			<input type="radio" name="callwaiting" id="callwaiting-enable" value="1" ' . ($template['callwaiting'] == "1" ? 'checked' : '') . ' /> 
			<label for="callwaiting-enable">Ring</label>
			
			<input type="radio" name="callwaiting" id="callwaiting-disable" value="0" ' . ($template['callwaiting'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="callwaiting-disable">Silent</label>
			</span>'
			);
		
		$table->add_row(array( 'data' => fpbx_label('Time Server:', 'Enter a Time Server.')),
			array( 'data' => '<input type="text" name="time_server_1" value="' . ($template['time_server_1'] == null ? $g_settings['internal'] : $template['time_server_1']) . '" placeholder="Time Server"/>')
		);
		$table->add_row(fpbx_label('Daylight Savings:', 'Enable or disable daylight savings.'),
			'<span class="radioset">
			<input type="radio" name="daylight" id="daylight-enable" value="1" ' . ($template['daylight'] == "1" ? 'checked' : '') . ' /> 
			<label for="daylight-enable">Enable</label>
			
			<input type="radio" name="daylight" id="daylight-disable" value="0" ' . ($template['daylight'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="daylight-disable">Disable</label>
			</span>'
			);
	}

//Grandstream Specific
	if($brand == 'grandstream'){
		$table->add_row(fpbx_label('Auto Answer:', 'Allow Auto Answer on Paging/Intercom.'),
			'<span class="radioset">
			<input type="radio" name="answer" id="answer-enable" value="1" ' . ($template['answer'] == "1" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' />  
			<label for="answer-enable">Enable</label>
			
			<input type="radio" name="answer" id="answer-disable" value="0" ' . ($template['answer'] == "0" ? 'checked' : '') . ' /> 
			<label for="answer-disable">Disable</label>
			</span>'
			);
		$table->add_row(fpbx_label('Mute Mic:', 'Enable mute when auto answering.'),
			'<span class="radioset">
			<input type="radio" name="mute" id="mute-enable" value="1" ' . ($template['mute'] == "1" ? 'checked' : '') . ' /> 
			<label for="mute-enable">Enable</label>
			
			<input type="radio" name="mute" id="mute-disable" value="0" ' . ($template['mute'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="mute-disable">Disable</label>
			</span>'
			);
		$table->add_row(fpbx_label('Auto Off Hook:', 'For Visual Voice Mail.'),
			'<span class="radioset">
			<input type="radio" name="offhook" id="offhook-enable" value="1" ' . ($template['offhook'] == "1" ? 'checked' : '') . ' /> 
			<label for="offhook-enable">Enable</label>
			
			<input type="radio" name="offhook" id="offhook-disable" value="0" ' . ($template['offhook'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="offhook-disable">Disable</label>
			</span>'
			);
	}
        //yealink Specific
	if($brand == 'yealink'){
            if(!isset($template['focus'])){$template['focus'] = '1';}
		$table->add_row(fpbx_label('Config Style:', 'Enable v70 config style.  Requires all phones using this template to be at firmware version 70 or greater.'),
			'<span class="radioset">
			<input type="radio" name="focus" id="focus-enable" value="1" ' . ($template['focus'] === "1" ? 'checked' : '') . ' />  
			<label for="focus-enable">v70 Style</label>
			
			<input type="radio" name="focus" id="focus-disable" value="0" ' . ($template['focus'] === "0" ? 'checked' : '') . ' /> 
			<label for="focus-disable">Legacy Style</label>
			</span>'
			);
        }

	//obihai Specific
        if($brand == 'obihai'){
            if(!isset($template['focus'])){$template['focus'] = '1';}
                $table->add_row(fpbx_label('Config Style:', 'Enable Current config style.  Requires all phones using this template to be at newer firmware.'),
                        '<span class="radioset">
                        <input type="radio" name="focus" id="focus-enable" value="1" ' . ($template['focus'] === "1" ? 'checked' : '') . ' />
                        <label for="focus-enable">Current Style</label>

                        <input type="radio" name="focus" id="focus-disable" value="0" ' . ($template['focus'] === "0" ? 'checked' : '') . ' />
                        <label for="focus-disable">Legacy Style</label>
                        </span>'
                        );
        }

//Time Zone	
	switch($brand){
		case 'aastra':
		case 'algo':
		case 'and':
		case 'audiocodes':
		case 'cisco':
                case 'cortelco':
		case 'cyberdata':
		case 'digium':
		case 'grandstream':
		case 'mitel':
                case 'mocet':
                case 'obihai':
		case 'panasonic':
                case 'phoenix':
		case 'polycom':
		case 'sangoma':
		case 'snom':
                case 'uniden':
                case 'vtech':
		case 'yealink':
                case 'xorcom':
			$tz = endpoint_getTimeZones();
			$tzlist = '<select name="timezone" id="timezone">';
			if($template['timezone'] == null) {
				$tzlist .= '<option value="" selected>Select</option>';
			}
			foreach($tz as $key=>$value){
				if($template['timezone'] == $key){
					$tzlist .= '<option value="' . $key . '" selected>' . $value . '</option>';
				} else {
					$tzlist .= '<option value="' . $key . '">' . $value . '</option>';
				}
			}
			$tzlist .= '</select>';
	
			$table->add_row(fpbx_label('Time Zone:', 'Time Zone for Phone.'),
					array( 'data' => $tzlist)
			);
			break;
		
		default:
			break;
	}
	
//Time Server 1			
	switch($brand){
		case 'aastra':
		case 'algo':
		case 'and':
		case 'audiocodes':
		case 'cisco':
                case 'cortelco':
		case 'cyberdata':
		case 'digium':
		case 'grandstream':	
		case 'mitel':
                case 'mocet':
		case 'obihai':
                case 'panasonic':
                case 'phoenix':
		case 'sangoma':
		case 'snom':
                case 'uniden':
                case 'vtech':
		case 'yealink':
                case 'xorcom':
			$table->add_row(array( 'data' => fpbx_label('Primary Time Server:', 'Enter a Time Server.')),
				array( 'data' => '<input type="text" name="time_server_1" value="' . ($template['time_server_1'] == null ? '0.us.pool.ntp.org' : $template['time_server_1']) . '" placeholder="Time Server"/>')
			);
			break;
		
		default:
			break;
	}
	
//Time Server 2
	switch($brand){
		case 'aastra':
		case 'audiocodes':
		case 'cisco':
                case 'cortelco':
		case 'obihai':
                case 'yealink':
                case 'xorcom':
			$table->add_row(array( 'data' => fpbx_label('Time Server 2:', 'Enter a Time Server.')),
				array( 'data' => '<input type="text" name="time_server_2" value="' . ($template['time_server_2'] == null ? $g_settings['internal'] : $template['time_server_2']) . '" placeholder="Time Server 2"/>')
			);
			break;
		
		default:
			break;
	}

//Time Server 3
	switch($brand){
		case 'aastra':
			$table->add_row(array( 'data' => fpbx_label('Time Server 3:', 'Enter a Time Server.')),
				array( 'data' => '<input type="text" name="time_server_3" value="' . ($template['time_server_3'] == null ? $g_settings['external'] : $template['time_server_3']) . '" placeholder="Time Server 3"/>')
			);
			break;
		
		default:
			break;
	}

// daylight savings
        switch($brand){
            case 'audiocodes':
            case 'cortelco':
            case 'mocet':
            case 'obihai':
            case 'phoenix':
            case 'panasonic':
            case 'uniden':
            case 'vtech':
            case 'yealink':
                $table->add_row(fpbx_label('Daylight Savings:', 'Enable or disable daylight savings.'),
                    '<span class="radioset">
                    <input type="radio" name="daylight" id="daylight-enable" value="1" ' . ($template['daylight'] == "1" ? 'checked' : '') . ' /> 
                    <label for="daylight-enable">Enable</label>

                    <input type="radio" name="daylight" id="daylight-disable" value="0" ' . ($template['daylight'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
                    <label for="daylight-disable">Disable</label>
                    </span>'
                    );
                break;
            default:
                break;
        }
	
//images
	switch($brand){
            case 'aastra':
            case 'cisco':
            case 'digium':
            case 'grandstream':
            //case 'mocet':
            case 'panasonic':
            case 'polycom':
            case 'snom':
                $availImages = endpoint_get_images($template['background']);
                $table->add_row(array( 'data' => fpbx_label('Background Image:', 'Background image to display.')),
                    array( 'data' => $availImages)
                );
                break;
	}
	
//Provision Server			
	switch($brand){
		case 'aastra':
		case 'algo':
		case 'audiocodes':
		case 'cisco':
                case 'cortelco':
		case 'cyberdata':
		case 'digium':
		case 'grandstream':
		case 'mitel':
                case 'mocet':
		case 'obihai':
                case 'panasonic':
		case 'polycom':
                case 'phoenix':
		case 'sangoma':
		case 'snom':
                case 'uniden':
                case 'vtech':
		case 'yealink':
                case 'xorcom':
			$table->add_row(fpbx_label('Provision Server Address:', 'IP or FQDN for Provisioning Server.'),
				'Server Address: <input name="ftpserver" id="ftpserver" value="' . $template['ftpserver'] . '" /><br />'
				);
			break;
		
		default:
			break;
	}	
	
//provision protocol
	switch($brand){
		// ftp and tftp
		case 'cyberdata':
                case 'polycom':
                case 'xorcom':
			$table->add_row(fpbx_label('Provision Server Protocol:', 'Protocol PBX uses to tranfer configs to phones.'),
				'<span class="radioset">
				<input type="radio" name="protocol" id="protocol-enable" value="1" ' . ($template['protocol'] == "1" ? 'checked' : '') . ' /> 
				<label for="protocol-enable">TFTP</label>
				
				<input type="radio" name="protocol" id="protocol-disable" value="0" ' . ($template['protocol'] == "0" ? 'checked' : '') . ' /> 
				<label for="protocol-disable">FTP</label>
				</span>'
				);
			break;
		//ftp tftp and http
                case 'aastra':
                case 'audiocodes':
                case 'mocet':
                case 'obihai':
                case 'panasonic':
                case 'phoenix':
                case 'snom':
                case 'uniden':
                case 'vtech':
		case 'yealink':
                    $table->add_row(fpbx_label('Provision Server Protocol:', 'Protocol PBX uses to tranfer configs to phones.'),
                    '<span class="radioset">
                    
                    <input type="radio" name="protocol" id="protocol-tftp" value="1" ' . ($template['protocol'] == "1" ? 'checked' : '') . ' /> 
                    <label for="protocol-tftp">TFTP</label>

                    <input type="radio" name="protocol" id="protocol-ftp" value="0" ' . ($template['protocol'] == "0" ? 'checked' : '') . ' /> 
                    <label for="protocol-ftp">FTP</label>
                    
                    <input type="radio" name="protocol" id="protocol-http" value="2" ' . ($template['protocol'] == "2" ? 'checked' : '') . ' /> 
                    <label for="protocol-http">HTTP</label>
                    
                    </span>'
                    );
                    break;
                
                //ftp and http
                case 'digium':
                    $table->add_row(fpbx_label('Provision Server Protocol:', 'Protocol PBX uses to tranfer configs to phones.'),
                    '<span class="radioset">
                    
                    <input type="radio" name="protocol" id="protocol-ftp" value="0" ' . ($template['protocol'] == "0" ? 'checked' : '') . ' /> 
                    <label for="protocol-ftp">FTP</label>
                    
                    <input type="radio" name="protocol" id="protocol-http" value="2" ' . ($template['protocol'] == "2" ? 'checked' : '') . ' /> 
                    <label for="protocol-http">HTTP</label>
                    
                    </span>'
                    );
                    break;
                
                // tftp and http
                case 'cisco':
                case 'algo':
                case 'grandstream':
                    $table->add_row(fpbx_label('Provision Server Protocol:', 'Protocol PBX uses to tranfer configs to phones.'),
                    '<span class="radioset">
                    
                    <input type="radio" name="protocol" id="protocol-tftp" value="1" ' . ($template['protocol'] == "1" ? 'checked' : '') . ' /> 
                    <label for="protocol-tftp">TFTP</label>

                    <input type="radio" name="protocol" id="protocol-http" value="2" ' . ($template['protocol'] == "2" ? 'checked' : '') . ' /> 
                    <label for="protocol-http">HTTP</label>
                    
                    </span>'
                    );
                    break;
                			
                default:
			break;
	}

//Line Labels
        switch($brand){
            case 'aastra':
            case 'cisco':
            case 'cortelco':
            case 'digium':
            case 'grandstream':
            case 'mitel':
            case 'mocet':
            case 'panasonic':
            case 'polycom':
            case 'snom':
            case 'uniden':
            case 'vtech':
            case 'xorcom':
            case 'yealink':
                $table->add_row(fpbx_label('Line Label:', 'Label for line key on supported models.'),
			'<span class="radioset">
			<input type="radio" name="lineLabel" id="lineLabel-name" value="0" ' . ($template['lineLabel'] == "0" ? 'checked' : '') . ($use_temp == "no" ? 'checked' : '') . ' /> 
			<label for="lineLabel-name">Name</label>
			
			<input type="radio" name="lineLabel" id="lineLabel-ext" value="1" ' . ($template['lineLabel'] == "1" ? 'checked' : '') . ' /> 
			<label for="lineLabel-ext">Extension</label>
			
			<input type="radio" name="lineLabel" id="lineLabel-both" value="2" ' . ($template['lineLabel'] == "2" ? 'checked' : '') . ' />
                        <label for="lineLabel-both">Name-Extension</label>
			</span>'
                );
                break;
            
            default:
                break;        
        }
//Multicast Settings			
	switch($brand){
		case 'aastra':
		case 'algo':
		//case 'and':
		//case 'audiocodes':
		//case 'cisco':
		case 'cyberdata':
		//case 'digium':
		//case 'mitel':
                case 'mocet':
		case 'panasonic':
		//case 'sangoma':
		case 'snom':
                case 'yealink':
                    $table->add_row(array( 'data' => fpbx_label('Multicast Enable:', 'Enable or disable multicast.'), 'class' => 'multicastEnable'),
                    array( 'data' => '<span class="radioset">
                        <input type="radio" name="multicastEnable" id="multicast-enable" value="1" ' . ($template['multicastEnable'] == '1' ? 'checked' : '') . ' /> 
                        <label for="multicast-enable">Enable</label>

                        <input type="radio" name="multicastEnable" id="multicast-disable" value="0" ' . ($template['multicastEnable'] === '0' ? 'checked' : '') . ' /> 
                        <label for="multicast-disable">Disable</label>
                        </span>')
                    );

			$table->add_row(array( 'data' => fpbx_label('Multicast Address', 'Enter multicast addresses with port seperated by comma. ie:224.0.36.0:10000,224.0.36.1:10000')),
				array( 'data' => '<input type="text" width="200px" name="multicastAddress" value="' . ($template['multicastAddress'] == null ? '' : $template['multicastAddress']) . '" placeholder="Multicast Address"/>')
			);
                        break;
		
		default:
			break;
	}
	

//RSS Feed	
	switch($brand){
		case 'mitel':
			$table->add_row(fpbx_label('RSS Feed', 'Enter a web address for an RSS feed.(Optional)'),
				'RSS Feed (Optional): <input name="extra" size="40" id="extra" value="' . $template['extra'] . '" /><br />'
				);
			break;
		
		default:
			break;
	}
	
//add firmware        
        if(empty($template['firmware'])){
            $firmware = '<option value="0">Recommended</option>';
        } else {
            $firmware = '<option value="' . $template['firmware'] . '" >Firmware Slot ' . $template['firmware'] . '</option>';   
        }
	
        $check = "SELECT * FROM endpoint_firmware where `brand` = '$brand'";
	$result = $db->getAll($check, DB_FETCHMODE_ASSOC);
	$firmOptions = '';
        foreach($result as $key=>$value){
            if(!empty($value['slot1'])){$firmOptions .= '<option value="1">Firmware Slot 1</option>';}
            if(!empty($value['slot2'])){$firmOptions .= '<option value="2">Firmware Slot 2</option>';}
	}

        $table->add_row(fpbx_label('Firmware Version', 'Use Firmware at right to select versions.'),
            '<select name="firmware" id="firmware">' . $firmware . $firmOptions . '<option value="0">Recommended</option></select>');
	
	echo $table->generate();
	$table->clear();
	
	if($template['protocol'] == "0"){
		$divFtp = '<div id="ftp" style="display: inline;">';
	} else {
		$divFtp = '<div id="ftp">';
	}
	echo $divFtp;
	echo '<fieldset><legend>FTP Server</legend>';
	$table->add_row(fpbx_label('FTP User Name:', 'Enter user name for FTP Server.'), 
		'<input type="text" id="ftpuser" name="ftpuser" value="' . $template['ftpuser'] . '" placeholder="User Name"/>');
	$table->add_row(fpbx_label('FTP Password:', 'Enter password for FTP Server'),
		'<input type="text" id="ftppass" name="ftppass" value="' . $template['ftppass'] . '" placeholder="Password" />'); 
	echo $table->generate();
	$table->clear();
	echo '</fieldset>';
	echo '</div>';

}

function endpoint_templatesView($brand){
    $Brand = ucfirst($brand);
    echo '<div class="phones rnav">';
    echo '<ul class="ui-menu ui-widget ui-widget-content ui-corner-all" role="listbox" aria-activedescendant="ui-active-menuitem">';
// List Templates
    echo '<li class="rnavH3Top">Create</li>';
    echo '<li><a href="config.php?display=endpoint&new=1&view=' . $brand . '">' . _("New Template") . '</a></li>';
    echo '<li><a href="config.php?display=endpoint&view=import&brand=' . $brand . '">' . _("Import Template") . '</a></li>';
    $templates = endpoint_get_templates($brand);
    echo '<li class="rnavH3">Manage</li>';
    foreach ($templates as $key => $value) {
        echo '<li><a ' . (isset($_REQUEST['template']) && $_REQUEST['template'] == $value['template_name'] ? 'class="current ui-state-highlight"' : '') 
            . 'href="config.php?display=endpoint&view=' . $brand . '&template=' . $value['template_name'] . '">' . _($value['template_name']) . '</a></li>';
    }

    if($brand == 'and'){
        echo '<li class="rnavH3">Display</li>';
        echo '<li><a href="config.php?display=endpoint&view=and_text">' . _("Send Text") . '</a></li>';
    }

    if($brand == 'aastra'){
        $deploy_type = endpoint_systype();
        if($deploy_type != 'oss'){
            echo '<li class="rnavH3">Global Aastra Options</li>';
            echo '<li><a href="config.php?display=endpoint&view=asterisk_conf">' . ("Global Config") . '</a></li>';
        }
    }
    if($brand == 'aastra' || $brand == 'digium' || $brand == 'yealink'){
        global $db;
        $sql = "SELECT * FROM endpoint_templates where `brand` = '" . $brand . "' and `default` = '1'";
        $res = $db->getAll($sql, DB_FETCHMODE_ASSOC); 
        if($db->IsError($res)){ 
            die_freepbx($res->getDebugInfo()); 
        }

        $dflt = '';
        if(!empty($res)){
            foreach($res as $vals){
                $dflt = $vals['template_name'];
            }
            echo '<li class="rnavH3">Default Template</li>';
            echo '<li><a href="config.php?display=endpoint&view=' . $brand . '&template=' . $dflt . '">' . _($dflt) . '</a></li>';
        }
    }
    echo '</ul>';
echo '</div>';

echo heading('New ' . ucfirst($brand) . ' Template',3);
echo "On this page you can create templates for $Brand Phones<br /><br />";
echo '<hr />';
}

function endpoint_UploadImage($_FILES){
	global $db;
	$picture = trim($_FILES['picture1']['name']);
	$picture_type = $_FILES['picture1']['type'];
	$picture_size = $_FILES['picture1']['size'];
	$picture_tmp = $_FILES['picture1']['tmp_name'];

	// Validate and move the uploaded picture file
	if (!empty($picture)) {
		if ((($picture_type == 'image/gif') || ($picture_type == 'image/jpeg') || ($picture_type == 'image/pjpeg') || ($picture_type == 'image/png')) && ($picture_size > 0) && ($picture_size <= 256000)) {
			// Move the file to the target upload folder
			$target = '/tftpboot/images/originals/' . $picture;
			if (!file_exists($target)) {
				move_uploaded_file($picture_tmp, $target);
				//add to database
				$query = "REPLACE INTO endpoint_images (`key`) VALUES ('$picture')";
				$sql = $db->query($query);
			} else {
				echo 'Duplicate File Found';
			}
		} else {
			echo "Not a valid picture format or size.<br />Please try again.";
		}
	} else {
		echo 'No picture selected.';
	}
}

function endpoint_ConvertImage($filename, $brand, $model, $type){
	//Check if the file is there first.
    $errors=0;
    if(!file_exists('/tftpboot/images/formatted/' . $type . '-' . $brand . '-' . $model . '-' . $filename)){
        $filepath = '/tftpboot/images/originals/' . $filename;
        $extension = endpoint_getExtension($filepath);
        $extension = strtolower($extension);
        if (($extension != "jpg") && ($extension != "jpeg") && ($extension != "png") && ($extension != "gif")) {
            echo "Not a valid picture format or size.<br />Please try again.";
            $errors=1;
        } else {
            if($extension=="jpg" || $extension=="jpeg" ){
                $src = imagecreatefromjpeg($filepath);
            } else if($extension=="png") {
                $src = imagecreatefrompng($filepath);
            } else {
                $src = imagecreatefromgif($filepath);
            }
            list($width,$height)=getimagesize($filepath);
            // set convert to false to avoid creating bmp except for polycom
            $convertbmp = false;
            // 1bit bmp for cisco
            $convertbmpbw = false;
            // base64 encode
            $convertbmpb64 = false;
            //greyscale
            $convertbmpgrey = false;
            switch($brand){
                case 'aastra':
			if($model == '6739i'){
				$newwidth=694;
				$newheight=544;
				$convertedfilename = "/tftpboot/images/formatted/$type-$brand-$model-" . substr($filename, 0, -4);
			}
			if($model == '6867i'){
				$newwidth=240;
				$newheight=320;
			        $convertedfilename = "/tftpboot/images/formatted/$type-$brand-$model-" . substr($filename, 0, -4);
				$convertpng = true;
			}
                    break;
                case 'cisco':
                    $convertedfilename= "/tftpboot/images/formatted/$type-$brand-$model-" . substr($filename, 0, -4);
                    switch($model){
                        case 'SPA525G2':
                        case 'SPA525G':
                        case 'SPA962':
                            $newwidth=320;
                            $newheight=240;
                            $convertbmp = true;
                            break;
                        case 'SPA962':
                        case 'SPA501G':
                        case 'SPA303':
                        case 'SPA502G':
                        case 'SPA504G':
                        case 'SPA508G':
                        case 'SPA509G':
                        case 'SPA514G':
                            $newwidth=128;
                            $newheight=48;
                            $convertbmpbw = true;
                            break;
                            
                        default:
                            break;
                    }
                    break;
                case 'digium':
                    switch($model){
                        case 'D70':
                            $newwidth=205;
                            $newheight=85;
                            break;
                        default:
                            $newwidth=150;
                            $newheight=45;
                            break;
                    }
                    $convertedfilename= "/tftpboot/images/formatted/$type-$brand-$model-" . substr($filename, 0, -4);
                    break;
                case 'grandstream':
                   switch($model){
                        case 'GXP-1160':
                        case 'GXP-1165':
                            $newwidth=110;
                            $newheight=10;
                            $convertbmpbw = true;
                            $convertbmpb64 = true;
                            break;
                        case 'GXP-1450':
                            $newwidth=110;
                            $newheight=25;
                            $convertbmpbw = true;
                            $convertbmpb64 = true;
                            break;
                        case 'GXP-1405':
                            $newwidth=110;
                            $newheight=10;
                            $convertbmpbw = true;
                            $convertbmpb64 = true;
                            break;
                        
                        case 'GXP-2110':
                        case 'GXP-2124':
                            $newwidth=180;
                            $newheight=60;
                            $convertbmpgrey = true;
                            $convertbmpb64 = true;
                            break;
                        case 'GXP-2100':
                            $newwidth=180;
                            $newheight=50;
                            $convertbmpgrey = true;
                            $convertbmpb64 = true;
                            break;
                        case 'GXP-2120':
                            $newwidth=220;
                            $newheight=95;
                            $convertbmpgrey = true;
                            $convertbmpb64 = true;
                            break;
                        case 'GXP-2140':
                        case 'GXP-2160':
                            $newwidth=220;
                            $newheight=95;
                            $convertbmpgrey = true;
                            $convertbmpb64 = true;
                            break;
                        case 'GXP-2000':
                            $newwidth=130;
                            $newheight=64;
                            $convertbmpbw = true;
                            $convertbmpb64 = true;
                            break;
                        default:
                            $newwidth=10;
                            $newheight=10;
                            break;
                   }
                   $convertedfilename = "/tftpboot/images/formatted/$type-$brand-$model-" . substr($filename, 0, -4);
                   break;
               case 'panasonic':
                    $newwidth=160;
                    $newheight=240;
                    $convertedfilename = "/tftpboot/images/formatted/$type-$brand-$model-" . substr($filename, 0, -4);
                    break;
                case 'polycom':
                    switch($model){
                        case 'IP450':
                            $newwidth=170;
                            $newheight=79;
                            break;
                        case 'VVX400':
                        case 'VVX410':
                        case 'VVX500':
                            $newwidth=320;
                            $newheight=240;
                            break;
                        case 'VVX300':
                        case 'VVX310':
                            $newwidth=208;
                            $newheight=104;
                            break;
                        case 'VVX600':
                            $newwidth=480;
                            $newheight=272;
                            break;
                        case 'VVX1500':
                            $newwidth=800;
                            $newheight=480;
                            break;
                        case 'IP550':
                        case 'IP560':
                        case 'IP650':
                        case 'IP670':
                            $newwidth=200;
                            $newheight=100;
                            break;
                    }
                    $convertedfilename = "/tftpboot/images/formatted/$type-$brand-$model-" . substr($filename, 0, -4);
                    break;
                case 'snom':
                   switch($model){
                        case 'S-360':
                            $newwidth=128;
                            $newheight=64;
                            $convertbmpbw = true;
                            $convertbmpb64 = true;
                            break;
                        case 'S-370':
                            $newwidth=240;
                            $newheight=110;
                            $convertbmpbw = true;
                            $convertbmpb64 = true;
                            break;
                        case 'S-820':
                        case 'S-821':
                        case 'S-760':
                            $newwidth=320;
                            $newheight=240;
                            $convertbmp = true;
                            $convertbmpb64 = true;

                            break;
                        case 'S-870':
                            $newwidth=480;
                            $newheight=272;
                            $convertbmp = true;
                            $convertbmpb64 = true;

                            break;
                        default:
                            $newwidth=200;
                            $newheight=100;
                            break;
                   }
                   $convertedfilename = "/tftpboot/images/formatted/$type-$brand-$model-" . substr($filename, 0, -4);
                   break;
                
               
                default:
                    $newwidth=200;
                    $newheight=200;
                    break;
            }
            //stop here if yealink dob file
            if($convertnone == false){
                if($height/$newheight > $width/$newwidth){
                    $newwidth=($width/$height)*$newheight;
                } else {
                    $newheight=($height/$width)*$newwidth;
                }
                $newimg=imagecreatetruecolor($newwidth,$newheight);
                imagecopyresampled($newimg,$src,0,0,0,0,$newwidth,$newheight, $width,$height);
                imagejpeg($newimg,$convertedfilename . '.jpg',100);
		if($convertpng == true){
			imagepng($newimg,$convertedfilename . '.png',0);
		}
                if($convertbmp == true){
                    endpoint_imagebmp($newimg,$convertedfilename . ".bmp");
                }
                if($convertbmpbw == true){
                    endpoint_imagebmpbw($convertedfilename, $convertedfilename . ".bmp");
                }
                if($convertbmpgrey == true){
                    endpoint_imagebmpgrey($convertedfilename, $convertedfilename . ".bmp");
                }
                if($convertbmpb64 == true){
                    endpoint_imageb64($convertedfilename . ".bmp");
                }
                imagedestroy($newimg);
            }
        }
    }
}

function endpoint_get_images($background){
	global $db;
	$sql = 'SELECT * FROM endpoint_images'; 
	$res = $db->getAll($sql, DB_FETCHMODE_ASSOC); 
	if($db->IsError($res)){ 
		die_freepbx($res->getDebugInfo()); 
	} 
	$availImages = '<select name="background" id="background"><option value="" selected></option>';
	foreach($res as $key=>$value){
		if(file_exists('/tftpboot/images/originals/' . $value['key'])){
			if($background == $value['key']){
				$availImages .= '<option value="' . $value['key'] . '" selected>' . $value['key'] . '</option>';
			} else {
				$availImages .= '<option value="' . $value['key'] . '">' . $value['key'] . '</option>';
			}
		}
	}	
	$availImages .= '</select>';
	return($availImages);
}

function endpoint_imagebmp($im, $filename = ""){
	if (!$im) return false;
	$w = imagesx($im);
	$h = imagesy($im);
	$result = '';

	if (!imageistruecolor($im)) {
	$tmp = imagecreatetruecolor($w, $h);
	imagecopy($tmp, $im, 0, 0, 0, 0, $w, $h);
	imagedestroy($im);
	$im = & $tmp;
	}

	$biBPLine = $w * 3;
	$biStride = ($biBPLine + 3) & ~3;
	$biSizeImage = $biStride * $h;
	$bfOffBits = 54;
	$bfSize = $bfOffBits + $biSizeImage;

	$result .= substr('BM', 0, 2);
	$result .= pack ('VvvV', $bfSize, 0, 0, $bfOffBits);
	$result .= pack ('VVVvvVVVVVV', 40, $w, $h, 1, 24, 0, $biSizeImage, 0, 0, 0, 0);

	$numpad = $biStride - $biBPLine;
	for ($y = $h - 1; $y >= 0; --$y) {
	for ($x = 0; $x < $w; ++$x) {
	$col = imagecolorat ($im, $x, $y);
	$result .= substr(pack ('V', $col), 0, 3);
	}
	for ($i = 0; $i < $numpad; ++$i)
	$result .= pack ('C', 0);
	}

	if($filename==""){
	echo $result;
	}
	else
	{
	$file = fopen($filename, "wb");
	fwrite($file, $result);
	fclose($file);
	}
	return true;
}
function endpoint_imagebmpbw($im, $filename = ""){
    $convert = fpbx_which('convert');
    exec($convert . ' ' . $im . '.jpg -monochrome ' . $filename, $result);
    exec('/bin/rm -f ' . substr($filename, 0, -4) . '.jpg', $result);
    return true;
}
function endpoint_imagebmpgrey($im, $filename = ""){
    $convert = fpbx_which('convert');
    exec($convert . ' ' . $im . '.jpg -colorspace gray ' . $filename, $result);
    exec('/bin/rm -f ' . substr($filename, 0, -4) . '.jpg', $result);
    return true;
}
function endpoint_imageb64($filename = ""){
    $perl = fpbx_which('perl');
    exec($perl . " -MMIME::Base64 -0777 -ne 'print encode_base64(\$_)' < " . $filename . " > " . $filename . '.bmp', $result);
    exec('/bin/rm -f ' . $filename, $result);
    exec('/bin/rm -f ' . substr($filename, 0, -4) . '.jpg', $result);   
    return true;
}
function endpoint_getExtension($str) {
	$i = strrpos($str,".");
	if (!$i) { return ""; } 
	$l = strlen($str) - $i;
	$ext = substr($str,$i+1,$l);
	return $ext;
}

function endpoint_accounts($model, $models){
    foreach($models as $key=>$value){
        if($value['model'] == $model){
            $accts = $value['accounts'];
        }
    }
    $i = 1;
    $acct = '';
    while($i<=$accts){
        $acct .= '<option value="account' . $i . '">Account' . $i . '</option>';
        $i++;
    }
    return($acct);
}

function endpoint_xmlapi($type, $name, $value, $brand = ''){
    global $db;
    $deploy_type = endpoint_systype();
    $sql = "SELECT * FROM endpoint_xml where `api` = '1'"; 
    $res = $db->getAll($sql, DB_FETCHMODE_ASSOC); 
    if($db->IsError($res)){ 
            die_freepbx($res->getDebugInfo()); 
    }
    //figure out what to display
    if($type == 'XML-API') {
        $typex="";
        $typev="display:none;";
    } else {
        $typex="display:none;";
        $typev="";
    }
    if($type == 'xml' && $brand == 'aastra' && $deploy_type != 'oss'){
        $typex="display:none;";
        $typev="display:none;";
    }
    //output standard value box
    echo '&nbsp;&nbsp;&nbsp;<a href="#" class="info" tabindex="-1">Value:<span>Value for the button.</span></a>
        <input style="' . $typev . '" id="' . $name . '_value" name="' . $name . '_value" value="' . $value . '">';
    
    //output xml
    echo '<select style="' . $typex . ' width:140px;" id="' . $name . '_xml" name="' . $name . '_xml"><option value="" selected>Select</option>';
    foreach($res as $vals){
        if($value == $vals['app_name']){
            echo '<option value="' . $vals['app_name'] . '" selected>' . $vals['app_name'] . '</option>';
        } else {
            echo '<option value="' . $vals['app_name'] . '">' . $vals['app_name'] . '</option>';
        }
    }
    echo '</select>';
}
