<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
function endpoint_write_yealink_ext($extEdit){
    global $db;
    $ext = endpoint_getExtensionAssignments();
    $model = endpoint_get_brand_models('yealink');
    $xml = endpoint_xmlList();
    foreach($ext as $key=>$value){
        if($value['ext'] == $extEdit){
            if($value['brand'] == 'Yealink'){
                $template = endpoint_getTemplate($value['template'], 'yealink');
                if($value['model'] == 'VP-2009' || $template['0']['focus'] === '0'){
                    if($value['model'] != 'SIP-T41G' || $value['model'] != 'SIP-T42G' || $value['model'] != 'SIP-T46G' || $value['model'] != 'SIP-T48G' || $value['model'] != 'W52P'){
                        $values = endpoint_configVariables($value, 'yealink', $model);
//set buttons
                        $b = endpoint_get_brand_buttons($value['template'], 'yealink');
                        foreach($b as $k=>$v){
                            $buttons[$v['key']] = $v['value'];
                        }
                        $buttons = endpoint_Replace_Buttons($buttons, $value);		
                        $lines = '';
                        $softs = '';
                        foreach($buttons as $k=>$v){
                            $tModel = explode('_', $k);
                            $h = strlen($value['model']);
                            if($value['model'] == substr($k, 0, $h) && substr($k, -4) == 'type' && substr($tModel[1], 0, 1) != 's'){
                                $temp = $tModel[0] . '_' . $tModel[1];
                                $lines[] = $temp;
                            }
                            if($value['model'] == substr($k, 0, $h) && substr($k, -4) == 'type' && substr($tModel[1], 0, 1) == 's'){
                                $temp = $tModel[0] . '_' . $tModel[1];
                                $softs[] = $temp;
                            }
                        }
                        foreach($lines as $k=>$v){
                            $tModel = explode('_', $v);
                            switch($buttons[$v . '_type']){
                                case 'Line':
                                    $dktype='15';
                                    break;
                                case 'Speeddial':
                                    $dktype='13';
                                    break;
                                case 'BLF':
                                    $dktype='16';
                                    break;
                                case 'DTMF':
                                    $dktype='11';
                                    break;
                                case 'Multicast':
                                    $dktype='18';
                                    break;
                                case 'Park':
                                    $dktype='10';
                                    break;
                                default:
                                    $dktype='';
                            }
                            if(empty($buttons[$v . '_acct'])){
                                $values['line' . $tModel[1] . 'acct'] = '0';
                            } else {
                                if($dktype == '15'){
                                    $values['line' . $tModel[1] . 'acct'] = substr($buttons[$v . '_acct'], 7);
                                } else {
                                    $values['line' . $tModel[1] . 'acct'] = substr($buttons[$v . '_acct'], 7) - 1;
                                }
                            }
                            $values['line' . $tModel[1] . 'label'] = $buttons[$v . '_label'];
                            $values['line' . $tModel[1] . 'type'] = $buttons[$v . '_type'];
                            $values['line' . $tModel[1] . 'typeNum'] = $dktype;
                            if($buttons[$v . '_type'] == 'XML-API'){
                                $values['line' . $tModel[1] . 'value'] = $xml[$buttons[$v . '_value']];
                            } else {
                                $values['line' . $tModel[1] . 'value'] = $buttons[$v . '_value'];
                            }
                        }

                        foreach($softs as $k=>$v){
                            $tModel = explode('_', $v);
                            $tModel[1] = substr($tModel[1], 1);
                            switch($buttons[$v . '_type']){
                                case 'Line':
                                    $dktype='15';
                                    break;
                                case 'Speeddial':
                                    $dktype='13';
                                    break;
                                case 'BLF':
                                    $dktype='16';
                                    break;
                                case 'DTMF':
                                    $dktype='11';
                                    break;
                                case 'Multicast':
                                    $dktype='18';
                                    break;
                                case 'Park':
                                    $dktype='10';
                                    break;
                                default:
                                    $dktype='';
                            }
                            if(empty($buttons[$v . '_acct'])){
                                $values['b' . $tModel[1] . 'acct'] = '0';
                            } else {
                                if($dktype == '15'){
                                    $values['b' . $tModel[1] . 'acct'] = substr($buttons[$v . '_acct'], 7);
                                } else {
                                    $values['b' . $tModel[1] . 'acct'] = substr($buttons[$v . '_acct'], 7) -1;
                                }
                            }
                            $values['b' . $tModel[1] . 'label'] = $buttons[$v . '_label'];
                            $values['b' . $tModel[1] . 'type'] = $buttons[$v . '_type'];
                            $values['b' . $tModel[1] . 'typeNum'] = $dktype;
                            if($buttons[$v . '_type'] == 'XML-API'){
                                $values['b' . $tModel[1] . 'value'] = $xml[$buttons[$v . '_value']];
                            } else {
                                $values['b' . $tModel[1] . 'value'] = $buttons[$v . '_value'];
                            }
                            
                        }

//get basefile info
                        $bf = endpoint_GetBasefile('yealink', 'phone', $value['model'], 'legacy');
                        $custom = endpoint_BasefileTemplate($bf, $value['template']);


                        $basefile = '';
                        if($values['model'] == 'VP530'){
                            $basefile .= "#!version:1.0.0.1\n";
                        }
                        $basefile .= "#Configuration automatically generated via the EndPoint Module \n";
                        $basefile .= "#DO NOT HAND MODIFY THIS FILE! \n";
                        $basefile .= '#generated: ' . date('r') . "\n";
                        $basefile .= "\n";
                        foreach($bf as $k=>$v){
                            if($v['template'] == 'default' || $v['template'] == $value['template']){
                                if($v['model'] == '' || strpos($v['model'],$value['model']) !== false){
                                    if(array_key_exists($v['param'], $custom)&& $v['template'] == 'default'){
                                        //do nothing
                                    } else {
                                        $base[$v['attrib']][$v['param']] = $v['value'];
                                    }
                                }
                            }
                        }
                        foreach($base as $k=>$v){
                            if($values['model'] != 'VP530'){
                                if(substr($k, 0, 7) == 'account'){
                                    $basefile .= "[ " . substr($k, 0, -1) . " ]\n";
                                } else {
                                    $basefile .= "[ $k ]\n";
                                }
                                $basefile .= "path = " . $v['path'] . "\n";
                                unset($v['path']);
                            }
                            foreach($v as $param=>$val){
                                $basefile .= "$param = $val\n";
                            }
                            $basefile .= "\n";
                        }

//write out expansion module if needed
                        foreach($model as $kM=>$vM){
                            if($value['exp0'] == $vM['model']){$b = $vM['softkeys'];}
                        }
                        if(!empty($value['exp0'])){
                            $c = 0;
                            if(empty($b)){$b = 0;}
                            while($c <= $b){
                                if($c == 0 || $c == 21){

                                } else {
                                    $d = $c+1;
                                    if(!empty($buttons[$value['exp0'] . '_' . $c . '_value'])){	
                                        switch($buttons[$value['exp0'] . '_' . $c . '_type']){
                                            case 'Line':
                                                $dktype='15';
                                                break;
                                            case 'Speeddial':
                                                $dktype='13';
                                                break;
                                            case 'BLF':
                                                $dktype='16';
                                                break;
                                            case 'DTMF':
                                                $dktype='11';
                                                break;
                                            case 'Multicast':
                                                $dktype='18';
                                                break;
                                            case 'Park':
                                                $dktype='10';
                                                break;
                                            default:
                                                $dktype='';
                                        }
                                        if(empty($buttons[$value['exp0'] . '_' . $c . '_acct'])){
                                            $values['e1' . $c . 'acct'] = '0';
                                        } else {
                                            $values['e1' . $c . 'acct'] = substr($buttons[$value['exp0'] . '_' . $c . '_acct'], 7);
                                        }
                                        $values['e1' . $c . 'label'] = $buttons[$value['exp0'] . '_' . $c . '_label'];
                                        $values['e1' . $c . 'type'] = $buttons[$value['exp0'] . '_' . $c . '_type'];
                                        $values['e1' . $c . 'typeNum'] = $dktype;
                                    }      
                                }
                                $c++;
                            }
                        }
                        if(!empty($value['exp1'])){
                            $c = 0;
                            while($c <= $b){
                                if($c == 0 || $c == 21){
                                } else {
                                    $d = $c+1;
                                    if(!empty($buttons[$value['exp1'] . '_' . $c . '_value'])){
                                        switch($buttons[$value['exp1'] . '_' . $c . '_type']){
                                            case 'Line':
                                                $dktype='15';
                                                break;
                                            case 'Speeddial':
                                                $dktype='13';
                                                break;
                                            case 'BLF':
                                                $dktype='16';
                                                break;
                                            case 'DTMF':
                                                $dktype='11';
                                                break;
                                            case 'Multicast':
                                                $dktype='18';
                                                break;
                                            case 'Park':
                                                $dktype='10';
                                                break;
                                            default:
                                                $dktype='';
                                        }
                                        if(empty($buttons[$value['exp1'] . '_' . $c . '_acct'])){
                                            $values['e2' . $c . 'acct'] = '0';
                                        } else {
                                            $values['e2' . $c . 'acct'] = substr($buttons[$value['exp1'] . '_' . $c . '_acct'], 7);
                                        }
                                        $values['e2' . $c . 'label'] = $buttons[$value['exp1'] . '_' . $c . '_label'];
                                        $values['e2' . $c . 'type'] = $buttons[$value['exp1'] . '_' . $c . '_type'];
                                        $values['e2' . $c . 'typeNum'] = $dktype;
                                    }
                                }
                                $c++;
                            }
                        }			
                        foreach($values as $k=>$v){
                            $basefile = str_replace('%' . $k . '%', $v, $basefile);
                        }

                        $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                        $basefile = preg_replace('/\\\%/', '', $basefile);

                        $value['mac'] = strtolower($value['mac']);
                        $fileloc = '/tftpboot/' . $value['mac'] . '.cfg';
                        file_put_contents($fileloc, $basefile);
                        $chmods = system("/bin/chmod 755 " . $fileloc, $retval);
                    }
                }

// start v71 and greater
                if($value['model'] == 'SIP-T41G' || $value['model'] == 'SIP-T42G' || $value['model'] == 'SIP-T46G' || $value['model'] == 'SIP-T48G' || $value['model'] == 'W52P' || $template['0']['focus'] === '1' && $value['model'] != 'VP-2009'){
                    $values = endpoint_configVariables($value, 'yealink', $model);
                    // correct provision address to be full address
                    $values['firmware'] = $values['provisionAddress'] . $values['firmware'];
                    
                    $buttonTypes = endpoint_Get_Phone_Types('yealink', 'flat');
                    //set buttons
                    $b = endpoint_get_brand_buttons($value['template'], 'yealink');
                    foreach($b as $k=>$v){
                        $buttons[$v['key']] = $v['value'];
                    }
                    $buttons = endpoint_Replace_Buttons($buttons, $value);		
                    $lines = '';
                    $softs = '';
                    foreach($buttons as $k=>$v){
                        $tModel = explode('_', $k);
                        $h = strlen($value['model']);
                        if($value['model'] == substr($k, 0, $h) && substr($k, -4) == 'type' && substr($tModel[1], 0, 1) != 's'){
                            $temp = $tModel[0] . '_' . $tModel[1];
                            $lines[] = $temp;
                        }
                        if($value['model'] == substr($k, 0, $h) && substr($k, -4) == 'type' && substr($tModel[1], 0, 1) == 's'){
                            $temp = $tModel[0] . '_' . $tModel[1];
                            $softs[] = $temp;
                        }
                    }
                    foreach($lines as $k=>$v){
                        $tModel = explode('_', $v);
                        $dktype = $buttonTypes[$buttons[$v . '_type']];
                        if(empty($buttons[$v . '_acct'])){
                            $values['line' . $tModel[1] . 'acct'] = '0';
                        } else {
                            if($dktype == '15'){
                                $values['line' . $tModel[1] . 'acct'] = substr($buttons[$v . '_acct'], 7);
                            } else {
                                $values['line' . $tModel[1] . 'acct'] = substr($buttons[$v . '_acct'], 7) - 1;
                            }
                        }
                        if($buttons[$v . '_type'] == 'XML-API'){
                            $lineNumber = $values['line' . $tModel[1] . 'acct'] + 1;
                            $values['line' . $tModel[1] . 'value'] = $xml[$buttons[$v . '_value']] . $values['line' . $lineNumber . 'Ext'];
                        } else {
                            $values['line' . $tModel[1] . 'value'] = $buttons[$v . '_value'];
                        }
                        $values['line' . $tModel[1] . 'label'] = $buttons[$v . '_label'];
                        $values['line' . $tModel[1] . 'type'] = $dktype;
                        $values['line' . $tModel[1] . 'typeNum'] = $dktype;
                    }

                    foreach($softs as $k=>$v){
                        unset($values['buttonAcct']);
                        $tModel = explode('_', $v);
                        $tModel[1] = substr($tModel[1], 1);
                        $dktype = $buttonTypes[$buttons[$v . '_type']];
                        if(empty($buttons[$v . '_acct'])){
                            $values['b' . $tModel[1] . 'acct'] = '0';
                        } else {
                            if($dktype == '15'){
                                $values['b' . $tModel[1] . 'acct'] = substr($buttons[$v . '_acct'], 7);
                            } else {
                                $values['b' . $tModel[1] . 'acct'] = substr($buttons[$v . '_acct'], 7) -1;
                            }
                        }
                        if($buttons[$v . '_type'] == 'XML-API'){
                            $lineNumber = $values['b' . $tModel[1] . 'acct'] + 1;
                            $values['b' . $tModel[1] . 'value'] = $xml[$buttons[$v . '_value']] . $values['line' . $lineNumber . 'Ext'];
                        } else {
                            $values['b' . $tModel[1] . 'value'] = $buttons[$v . '_value'];
                        }
                        $values['b' . $tModel[1] . 'label'] = $buttons[$v . '_label'];
                        $values['b' . $tModel[1] . 'type'] = $dktype;
                        $values['b' . $tModel[1] . 'typeNum'] = $dktype;
                    }
    //get basefile info
                    $bf = endpoint_GetBasefile('yealink', 'phone', $value['model'], 'v70');
                    $custom = endpoint_BasefileTemplate($bf, $value['template']);

                    $basefile = '';
                    $basefile .= "#!version:1.0.0.1\n";
                    $basefile .= "#Configuration automatically generated via the EndPoint Module \n";
                    $basefile .= "#DO NOT HAND MODIFY THIS FILE! \n";
                    $basefile .= '#generated: ' . date('r') . "\n";
                    $basefile .= "\n";
                    foreach($bf as $k=>$v){
                        if($v['template'] == 'default' || $v['template'] == $value['template']){
                            if($v['model'] == '' || strpos($v['model'],$value['model']) !== false){
                                if(array_key_exists($v['param'], $custom)&& $v['template'] == 'default'){
                                    //do nothing
                                } else {
                                    $base[$v['attrib']][$v['param']] = $v['value'];
                                }
                            }
                        }
                    }
                    foreach($base as $k=>$v){
                        foreach($v as $param=>$val){
                            $basefile .= "$param = $val\n";
                        }
                        $basefile .= "\n";
                    }

    //write out expansion module if needed
                    foreach($model as $kM=>$vM){
                        if($value['exp0'] == $vM['model']){$b = $vM['softkeys'];}
                    }
                    if(!empty($value['exp0'])){
                        $c = 0;
                        if(empty($b)){$b = 0;}
                        while($c <= $b){
                        $d = $c+1;
                            if(!empty($buttons[$value['exp0'] . '_' . $c . '_value'])){	
                                $dktype = $buttonTypes[$buttons[$value['exp0'] . '_' . $c . '_type']];

                                if(empty($buttons[$value['exp0'] . '_' . $c . '_acct'])){
                                    $values['e1' . $c . 'acct'] = '0';
                                } else {
                                    $values['e1' . $c . 'acct'] = substr($buttons[$value['exp0'] . '_' . $c . '_acct'], 7);
                                }
                                $values['e1' . $c . 'value'] = $buttons[$value['exp0'] . '_' . $c . '_value'];
                                $values['e1' . $c . 'label'] = $buttons[$value['exp0'] . '_' . $c . '_label'];
                                $values['e1' . $c . 'type'] = $dktype;
                                $values['e1' . $c . 'typeNum'] = $dktype;
                                if($buttons[$value['exp0'] . '_' . $c . '_type'] == 'XML-API'){
                                    $values['e1' . $c . 'value'] = $xml[$buttons[$value['exp0'] . '_' . $c . '_value']];
                                } else {
                                    $values['e1' . $c . 'value'] = $buttons[$value['exp0'] . '_' . $c . '_value'];
                                }
                            }      
                            $c++;
                        }
                    }
                    if(!empty($value['exp1'])){
                        $c = 0;
                        while($c <= $b){
                            $d = $c+1;
                            if(!empty($buttons[$value['exp1'] . '_' . $c . '_value'])){
                                $dktype = $buttonTypes[$buttons[$value['exp1'] . '_' . $c . '_type']];
                                if(empty($buttons[$value['exp1'] . '_' . $c . '_acct'])){
                                    $values['e2' . $c . 'acct'] = '0';
                                } else {
                                    $values['e2' . $c . 'acct'] = substr($buttons[$value['exp1'] . '_' . $c . '_acct'], 7);
                                }
                                $values['e2' . $c . 'value'] = $buttons[$value['exp1'] . '_' . $c . '_value'];
                                $values['e2' . $c . 'label'] = $buttons[$value['exp1'] . '_' . $c . '_label'];
                                $values['e2' . $c . 'type'] = $dktype;
                                $values['e2' . $c . 'typeNum'] = $dktype;
                                if($buttons[$value['exp1'] . '_' . $c . '_type'] == 'XML-API'){
                                    $values['e2' . $c . 'value'] = $xml[$buttons[$value['exp1'] . '_' . $c . '_value']];
                                } else {
                                    $values['e2' . $c . 'value'] = $buttons[$value['exp1'] . '_' . $c . '_value'];
                                }
                            }
                            $c++;
                        }
                    }			
                    foreach($values as $k=>$v){
                        $basefile = str_replace('%' . $k . '%', $v, $basefile);
                    }
                    foreach($values as $k=>$v){
                        $basefile = str_replace('%' . $k . '%', $v, $basefile);
                    }
                    $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
                    $basefile = preg_replace('/\\\%/', '', $basefile);

                    //need to fix to get rid of blank lines.
                    //$basefile = preg_replace('/^[a-z].* = $/', '', $basefile);

                    $value['mac'] = strtolower($value['mac']);
                    $fileloc = '/tftpboot/' . $value['mac'] . '.cfg';
                    file_put_contents($fileloc, $basefile);
                    $chmods = system("/bin/chmod 755 " . $fileloc, $retval);

                }
            }
        }
    }
}

//used for writing blank configs for xml-api login/logout
function endpoint_write_yealink_blank($mac, $model, $template){
    global $db;
    $xml = endpoint_xmlList();
    $values = endpoint_blankConfigVariables('yealink', $model);
    $values['line1Dest'] = '127.0.0.1';
    $values['line1label'] = 'Login';
    $values['line1type'] = '27';
    $values['line1value'] = $xml['REST-Login'] . '0000';
    $values['line1acct'] = '0';
    
    $values['b1label'] = 'Login';
    $values['b1type'] = '27';
    $values['b1value'] = $xml['REST-Login'] . '0000';
    $values['b1acct'] = '0';

    //clear all keys -- just in case
    $i = 2;
    while($i < 200){
        $values['line' . $i . 'label'] = '';
        $values['line' . $i . 'type'] = '0';
        $values['b' . $i . 'label'] = '';
        $values['b' . $i . 'type'] = '0';    
        $i++;
    }
    
    
    //get basefile info
    $bf = endpoint_GetBasefile('yealink', 'phone', $model, 'v70');
    $custom = endpoint_BasefileTemplate($bf, $value['template']);
    $basefile = '';
    $basefile .= "#!version:1.0.0.1\n";
    $basefile .= "#Configuration automatically generated via the EndPoint Module \n";
    $basefile .= "#DO NOT HAND MODIFY THIS FILE! \n";
    $basefile .= '#generated: ' . date('r') . "\n";
    $basefile .= "\n";
    foreach($bf as $k=>$v){
        if($v['template'] == 'default'){
            if($v['model'] == '' || strpos($v['model'],$model) !== false){
                if(array_key_exists($v['param'], $custom)&& $v['template'] == 'default'){
                    //do nothing
                } else {
                    //hack to avoid fail2ban
                    //uses line1Dest for xml, but if account is set to line1Dest, phone gets banned
                    if($base[$v['attrib']][$v['param']] == 'account.1.sip_server_host'){$base[$v['attrib']][$v['param']] = '127.0.0.1';}
                    if($base[$v['attrib']][$v['param']] == 'account.1.outbound_host'){$base[$v['attrib']][$v['param']] = '127.0.0.1';}
                    $base[$v['attrib']][$v['param']] = $v['value'];
                }
            }
        }
    }
    foreach($base as $k=>$v){
        foreach($v as $param=>$val){
            $basefile .= "$param = $val\n";
        }
        $basefile .= "\n";
    }
    foreach($values as $k=>$v){
        $basefile = str_replace('%' . $k . '%', $v, $basefile);
    }
    foreach($values as $k=>$v){
        $basefile = str_replace('%' . $k . '%', $v, $basefile);
    }
    $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
    $basefile = preg_replace('/\\\%/', '', $basefile);

    $mac = strtolower($mac);
    $fileloc = '/tftpboot/' . $mac . '.cfg';
    file_put_contents($fileloc, $basefile);
    $chmods = system("/bin/chmod 755 " . $fileloc, $retval);
}

function endpoint_write_yealink_commons(){
    global $db;
    $gValues = endpoint_getGlobalSettings();
    if($gValues['xml-api'] == 'Y'){
        $xml = endpoint_xmlList();
        $values = endpoint_blankConfigVariables('yealink', $model);
        $values['line1Dest'] = $values['destination'];
        $values['line1label'] = 'Login';
        $values['line1type'] = '27';
        $values['line1value'] = $xml['REST-Login'];
        $values['line1acct'] = '0';
        $values['b1label'] = 'Login';
        $values['b1type'] = '27';
        $values['b1value'] = $xml['REST-Login'];
        $values['b1acct'] = '0';

        $values['line2Dest'] = $values['destination'];
        $values['line2label'] = 'Login';
        $values['line2type'] = '27';
        $values['line2value'] = $xml['REST-Login'];
        $values['line2acct'] = '0';
        $values['b2label'] = 'Login';
        $values['b2type'] = '27';
        $values['b2value'] = $xml['REST-Login'];
        $values['b2acct'] = '0';

        $basefile = '';
        $basefile .= "#!version:1.0.0.1\n";
        $basefile .= "#Configuration automatically generated via the EndPoint Module \n";
        $basefile .= "#DO NOT HAND MODIFY THIS FILE! \n";
        $basefile .= '#generated: ' . date('r') . "\n";
        $basefile .= "\n";
        $basefile .= "security.user_password  = admin:%adminPass%
security.user_password = user:%userPass%
action_url.log_on = " . $xml['REST-Login'] . "0000
";
        if(!empty($gValues['internal'])){
            $basefile .= "linekey.1.line = 0
linekey.1.value = http://%internal%:%restapps%/applications.php/endpoint/main?user=0000
linekey.1.extension = **
linekey.1.type = 27
linekey.1.label = Internal
memorykey.1.line = 0
memorykey.1.value = http://%internal%:%restapps%/applications.php/endpoint/main?user=0000
memorykey.1.pickup_value = **
memorykey.1.type = 27
memorykey.1.xml_phonebook = ";
        }
        if(!empty($gValues['external'])){
            $basefile .= "
linekey.2.line = 0
linekey.2.value = http://%external%:%restapps%/applications.php/endpoint/main?user=0000
linekey.2.extension = **
linekey.2.type = 27
linekey.2.label = External
memorykey.2.line = 0
memorykey.2.value = http://%external%:%restapps%/applications.php/endpoint/main?user=0000
memorykey.2.pickup_value = **
memorykey.2.type = 27
memorykey.2.xml_phonebook = ";
        }
        foreach($values as $k=>$v){
            $basefile = str_replace('%' . $k . '%', $v, $basefile);
        }
        foreach($values as $k=>$v){
            $basefile = str_replace('%' . $k . '%', $v, $basefile);
        }
        $basefile = preg_replace('/(?<!\\\)\%.*(?!\\\)%/', '', $basefile);
        $basefile = preg_replace('/\\\%/', '', $basefile);
		$commons = array(
			'y000000000028.cfg', 
			'y000000000029.cfg', 
			'y000000000036.cfg',
			'y000000000000.cfg',
			'y000000000004.cfg',
			'y000000000005.cfg',
			'y000000000007.cfg',
			'y000000000008.cfg',
			'y000000000009.cfg',
			'y000000000038.cfg',
			'y000000000032.cfg',
			'y000000000023.cfg',
			'y000000000035.cfg');

		foreach($commons as $file){
			$fileloc = '/tftpboot/' . $file;
			file_put_contents($fileloc, $basefile);
			$chmods = system("/bin/chmod 755 " . $fileloc, $retval);
		}
	}
}