<?php
// file used display extension and their links to templates
echo '<div class="content">';
echo '<script type="text/javascript" src="modules/endpoint/assets/js/views/extensions.js"></script>';
echo heading('Extension Mapping',3);
echo '<hr />';

$exts = '';

//check if we need ip or status
global $db;
$q_g = 'SELECT * FROM endpoint_global';
$g_set = $db->getAll($q_g, DB_FETCHMODE_ASSOC);
foreach($g_set as $key=>$value){
        $g_settings[$value['key']] = $value['values'];
}
if($g_settings['emIP'] == 'Y' || $g_settings['emS'] == 'Y'){
    $ipNetwork = explode('.', $g_settings['internal']);
    $network = $ipNetwork[0] . '.' . $ipNetwork[1] . '.' . $ipNetwork[2] . '.0/24';
    $macs = endpoint_nmap_all($network, $use_nmap=TRUE);

    global $astman;

    //get the result of sip show peers through the asterisk manager
    $sippeers = $astman->send_request('Command', array('Command' => 'sip show peers'));
    //trim Privilege: Command from the data that is being returned
    $peers = ltrim($sippeers['data'], 'Privilege: Command');
    //echo out our peer list as you would see it in asterisk
    $peers = explode("\n", $peers);
    foreach($peers as $data){
        $p1 = explode('/', $data);
        if(is_numeric($p1[0])){
            $ip = trim(substr($data, 21, -1));
            $ip = trim(substr($ip, 0, 15));
            $ping = preg_replace('/^(.*)\(/', '', $data);
            $ping = preg_replace('/\)/', '', $ping);
            if(preg_match('/Unspecified/', $ip)){$ip = '';}
            if(preg_match('/Unspecified/', $ping)){$ping = '';}
            foreach($macs as $mac=>$ipM){
                if($ipM == $ip){$ipMac = $mac;}
            }
            $pExt[trim($p1[0])] = array('ip'=>$ip, 'ping'=>$ping, 'mac'=>$ipMac);
        }
        //Old way
        //$temp = preg_split('/[\s]+/', $data);
        //$peerList[$temp[1]] = $temp[6] . ' ' . preg_replace('/[()]/', '', $temp[7]) . 'ms';
    }
}

if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) {
      include_once('/etc/asterisk/freepbx.conf');
}

// get info
$ext_temp = endpoint_get_ext();
$cust_temp = endpoint_get_cust_ext();
if(empty($sort)){$sort = 'ext';}
if(empty($order)){$order = 'ASC';}
$sql = "SELECT * FROM endpoint_extensions ORDER BY $sort $order"; 
$res = $db->getAll($sql, DB_FETCHMODE_ASSOC); 
if($db->IsError($res)){ 
    die_freepbx($res->getDebugInfo()); 
} 
foreach($res as $key=>$value){
    $set_ext[$value['ext']] = array('ext'=>$value['ext'], 'brand'=>$value['brand'], 'mac'=>$value['mac'], 'template'=>$value['template'], 'brand_model'=>$value['model'], 'account'=>$value['account'], 'accessory'=>$value['accessory'], 'exp0'=>$value['exp0'], 'exp1'=>$value['exp1'], 'exp2'=>$value['exp2'], 'blf'=>$value['blf'], 'blf_label'=>$value['blf_label']);
    $usedExt[$value['ext']] = 'yes';
    if($value['account'] != null){$usedAcct[] = array($value['mac']=>$value['account']);}
}

//build ext associative array
$ext = "{";
$ext_list = '';
$all_ext = '';
foreach($ext_temp as $key=>$value) {
    $all_ext .= '<option value="' . $key . '">' . $key . ' ' . $value . '</option>';
    if(!isset($usedExt[$key])){
        //add slashes so json doesn't bomb out
        $ext .=  addslashes($key).": '".addslashes($value)."', ";
        $ext_list .= '<option value="' . $key . '">' . $key . ' ' . $value . '</option>';
    }
}
if(!empty($cust_temp)){
	foreach($cust_temp as $key=>$value) {
		$all_ext .= '<option value="' . $key . '-' . $value . '">' . $key . '-' . $value . ' (custom)</option>';
		if(!isset($usedExt[$key . '-' . $value])){
			//add slashes so json doesn't bomb out
			$ext .=  "'" . addslashes($key.'-'.$value)."': '(custom)', ";
			$ext_list .= '<option value="' . $key . '-' . $value . '">' . $key . '-' . $value . ' (custom)</option>';
		}
	}
}

$ext .=  addslashes('Custom').": '".addslashes('Extension')."'";
$ext_list .= '<option value="Custom">Custom Extension</option>';
$ext .= "}";

//build phone brand options
$brandsUsed = array('Aastra'=>'aastra', 'Algo'=>'algo', 'AND'=>'and', 'Audiocodes'=>'audiocodes', 'Cisco'=>'cisco', 'Cortelco'=>'cortelco', 'Cyberdata'=>'cyberdata', 'Digium'=>'digium', 'Grandstream'=>'grandstream', 'Mitel'=>'mitel', 'Mocet'=>'mocet', 'Obihai'=>'obihai', 'Panasonic'=>'panasonic', 'Phoenix'=>'phoenix', 'Polycom'=>'polycom', 'Sangoma'=>'sangoma', 'Snom'=>'snom', 'Uniden'=>'uniden', 'Vtech'=>'vtech', 'Yealink'=>'yealink', 'Xorcom'=>'xorcom');
$brands = "{None: '', ";
$brands_list = '';
foreach($brandsUsed as $k=>$v){
	//build brand lists
	$brands .= "$k: '$k', ";
	$brands_list .= '<option value="' . $k . '">' . $k . '</option>';
	//build template lists
	$t = endpoint_TemplateOptions($v);
	$$v = $t[0];
	$v2 = $v . '_list';
	$$v2 = $t[1];
	//build model lists
	$t = endpoint_ModelOptions($v);
	$v2 = $v . 'Models';
	$$v2 = $t[0];
	$v2 = $v . 'Models_list';
	$$v2 = $t[1];
}
$brands .= "}";

$tM = endpoint_get_all_models();
foreach($tM as $k=>$v){
	$allModels[$v['model']] = $v['exp'];
}

$newCount = 1000;
if(!empty($set_ext)){
	foreach($set_ext as $key=>$value){
		//set row background color    
		if(is_int($newCount/2)){$color = ' #d1e8b2';} else {$color = "#FFFFFF";}
		//hide advanced button, only show if needed
		$advanced = '0';
		$acctSelect = '';
		
		//check for accounts and how many
		$acctNum = endpoint_getAccountCount($value['brand_model']);
		if($acctNum['accounts'] != null){
				$acct = 1;
				$advanced = '1';
				$acctSelect = 'Line: <select name="acct_exist[' . $newCount . ']"><option value="' . $value['account'] . '" selected>' . $value['account'] . '</option>';
				
				if($value['brand_model'] == 'Algo8180'){
					$acctSelect .= '<option value="Ringer">Ringer</option><option value="DoorPhone">Door Phone</option>';
				} 
				if($value['brand'] == 'Cyberdata'){
					$acctSelect .= '<option value="Ringer">Ringer</option><option value="Pager">Pager</option>';
				}
				if($value['brand_model'] == 'SPA232D'){
					if($value['account'] == 'account1'){
						$acctSelect = 'Line: <select name="acct_exist[' . $newCount . ']"><option value="' . $value['account'] . '" selected>FXS 1' . '</option>';
					} else {
						$number = substr($value['account'], 7);
						$number = $number - 1;
						$acctSelect = 'Line: <select name="acct_exist[' . $newCount . ']"><option value="' . $value['account'] . '" selected>DECT ' . $number . '</option>';
					}
				
					while($acct <= $acctNum['accounts']){
						$test = 'no';
						foreach($usedAcct as $uK=>$uV){
							if(isset($uV[$value['mac']])){
								if('account' . $acct == $uV[$value['mac']]){
									$test = 'yes';
								}
							}
						}
						if($test == 'no'){
							if($acct == '1'){
								$acctSelect .= '<option value="account' . $acct . '">FXS ' . $acct . '</option>';
							} else {
								$num = $acct - 1;
								$acctSelect .= '<option value="account' . $acct . '">DECT ' . $num . '</option>';
							}
						}
						$acct++;
					}
				}
				if($value['brand'] != 'Cyberdata' && $value['brand_model'] != 'Algo8180' && $value['brand_model'] != 'SPA232D'){
					while($acct <= $acctNum['accounts']){
						$test = 'no';
						if(isset($usedAcct) && is_array($usedAcct)){
							foreach($usedAcct as $uK=>$uV){
								if(isset($uV[$value['mac']])){
									if('account' . $acct == $uV[$value['mac']]){
										$test = 'yes';
									}
								}
							}
						}
						if($test == 'no'){$acctSelect .= 'Line: <option value="account' . $acct . '">Account ' . $acct . '</option>';}
						$acct++;
					}
				}
				$acctSelect .= '</select></td>';
		}
		// selection box
		$exts .= '<tr style="background: ' . $color . ';" ><td><input type="checkbox" class="select" name="select_exist[' . $newCount . ']"></td>';
		// Extensions
		if(empty($ext_temp[$value['ext']])){$ext_temp[$value['ext']] = $cust_temp[$value['ext']] . ' (custom)';}
		$exts .= '<td><select name="ext_exist[' . $newCount . ']" id="ext_exist[' . $newCount . ']" class="ext">' . $ext_list;    
		$exts .= '<option value="' . $value['ext'] . '" selected>' . $value['ext'] . ' ' . $ext_temp[$value['ext']] . '</select>';
		if(!empty($acctSelect)){$exts .= '<br />' . $acctSelect;}
		$exts .= '</td>'; 
		// Brand
		$exts .= '<td><select name="brand_exist[' . $newCount . ']">' . $brands_list;
		$exts .= '<option value="' . $value['brand'] . '" selected>' . $value['brand'] . '</select>';
		// Mac Address
		$value['mac'] = strtoupper($value['mac']);
                $exts .= '<br /><input name="mac_exist[' . $newCount . ']" value="' . $value['mac'] . '" size="14" /></td>';
		if($g_settings['emIP'] == 'Y' || $g_settings['emS'] == 'Y'){
                    $exts .= '<td>';
                    if($g_settings['emIP'] == 'Y'){
                        //$exts .= '<a href="http://' . $macs[$value['mac']] . '" target="_blank">' . $macs[$value['mac']] . '</a>';
                        $exts .= '<a href="http://' . $pExt[$value['ext']]['ip'] . '" target="_blank">' . $pExt[$value['ext']]['ip'] . '</a>';
                    }
                    if($g_settings['emS'] == 'Y'){
                        //$exts .= '<br />' . $peerList[$macs[$value['mac']]];
                        $exts .= '<br />' . $pExt[$value['ext']]['ping'];
                    }
                    $exts .= '</td>';
                }
                
                // Template
		$exts .= '<td><select name="template_exist[' . $newCount . ']">';
		$exts .= ($value['brand'] == 'Aastra' ? $aastra_list : '');
		$exts .= ($value['brand'] == 'Algo' ? $algo_list : '');
		$exts .= ($value['brand'] == 'AND' ? $and_list : '');
		$exts .= ($value['brand'] == 'Audiocodes' ? $audiocodes_list : '');
		$exts .= ($value['brand'] == 'Cisco' ? $cisco_list : '');
		$exts .= ($value['brand'] == 'Cortelco' ? $cortelco_list : '');
		$exts .= ($value['brand'] == 'Cyberdata' ? $cyberdata_list : '');
		$exts .= ($value['brand'] == 'Digium' ? $digium_list : '');
		$exts .= ($value['brand'] == 'Grandstream' ? $grandstream_list : '');
		$exts .= ($value['brand'] == 'Mitel' ? $mitel_list : '');
		$exts .= ($value['brand'] == 'Mocet' ? $mocet_list : '');
		$exts .= ($value['brand'] == 'Obihai' ? $obihai_list : '');
		$exts .= ($value['brand'] == 'Panasonic' ? $panasonic_list : '');
		$exts .= ($value['brand'] == 'Phoenix' ? $phoenix_list : '');
		$exts .= ($value['brand'] == 'Polycom' ? $polycom_list : '');
		$exts .= ($value['brand'] == 'Sangoma' ? $sangoma_list : '');
		$exts .= ($value['brand'] == 'Snom' ? $snom_list : '');
                $exts .= ($value['brand'] == 'Uniden' ? $uniden_list : '');
                $exts .= ($value['brand'] == 'Vtech' ? $vtech_list : '');
		$exts .= ($value['brand'] == 'Yealink' ? $yealink_list : '');
		$exts .= ($value['brand'] == 'Xorcom' ? $xorcom_list : '');
		$test = $aastra_list . $algo_list . $and_list . $audiocodes_list . $cisco_list . $cortelco_list . $cyberdata_list . $digium_list . $grandstream_list . $mitel_list . $mocet_list . $obihai_list . $panasonic_list . $phoenix_list . $polycom_list . $sangoma_list . $snom_list . $uniden_list . $vtech_list . $yealink_list . $xorcom_list;
		if(!strstr($test, $value['template'])){$value['template'] = '';}
		$exts .= '<option value="' . $value['template'] . '" selected>' . $value['template'] . '</select>';
		// Model
		$exts .= '<br /><select name="brand_model_exist[' . $newCount . ']">';
		$exts .= ($value['brand'] == 'Aastra' ? $aastraModels_list : '');
		$exts .= ($value['brand'] == 'Algo' ? $algoModels_list : '');
		$exts .= ($value['brand'] == 'AND' ? $andModels_list : '');
		$exts .= ($value['brand'] == 'Audiocodes' ? $audiocodesModels_list : '');
		$exts .= ($value['brand'] == 'Cisco' ? $ciscoModels_list : '');
		$exts .= ($value['brand'] == 'Cortelco' ? $cortelcoModels_list : '');
		$exts .= ($value['brand'] == 'Cyberdata' ? $cyberdataModels_list : '');
		$exts .= ($value['brand'] == 'Digium' ? $digiumModels_list : '');
		$exts .= ($value['brand'] == 'Grandstream' ? $grandstreamModels_list : '');
		$exts .= ($value['brand'] == 'Mitel' ? $mitelModels_list : '');
		$exts .= ($value['brand'] == 'Mocet' ? $mocetModels_list : '');
		$exts .= ($value['brand'] == 'Obihai' ? $obihaiModels_list : '');
		$exts .= ($value['brand'] == 'Panasonic' ? $panasonicModels_list : '');
		$exts .= ($value['brand'] == 'Phoenix' ? $phoenixModels_list : '');
		$exts .= ($value['brand'] == 'Polycom' ? $polycomModels_list : '');
		$exts .= ($value['brand'] == 'Sangoma' ? $sangomaModels_list : '');
		$exts .= ($value['brand'] == 'Snom' ? $snomModels_list : '');
                $exts .= ($value['brand'] == 'Uniden' ? $unidenModels_list : '');
                $exts .= ($value['brand'] == 'Vtech' ? $vtechModels_list : '');
                $exts .= ($value['brand'] == 'Yealink' ? $yealinkModels_list : '');
		$exts .= ($value['brand'] == 'Xorcom' ? $xorcomModels_list : '');
		$exts .= '<option value="' . $value['brand_model'] . '" selected>' . $value['brand_model'] . '</select></td>';
		
		$exts .= '<td>';
		// Remove button
		$exts .= '<a href="/admin/config.php?display=endpoint&view=extension&action=removeExt&ext=' . $value['ext'] . '"><img src="images/trash.png" style="cursor:pointer" title="Remove this entry." class="delete_entrie">&nbsp;&nbsp;&nbsp;&nbsp;</a>';
		// Advanced button
		$exts .= '<input onclick="displayAdvanced(\'' . preg_replace('/ /', '-', $value['ext']) . '\')" type="button" style="width: 100px;" value="Advanced"/>';
		$exts .= '</td>';
		// Account
		$exts .='</tr>';
		$exts .= '<tr class="' . preg_replace('/ /', '-', $value['ext']) . '" style="display: none; background: ' . $color . ';" ><td></td><td>';
		
			// Optional Box
		switch($value['brand_model']){
			case 'M9':
			case 'MBU400':
                        case 'SPA232D':
                            $exts .= '<td colspan="6">';
                            $exts .= 'IEMI: <input name="accessory_exist[' . $newCount . ']" value="' . $value['accessory'] . '" placeholder="Handset ID" size="10"/></td>';
                            break;
			case 'EXP1240B':
                            $exts .= '<td colspan="6">';
                            $exts .= 'IPEI: <input name="accessory_exist[' . $newCount . ']" value="' . $value['accessory'] . '" placeholder="Handset ID" size="10"/></td>';
                            break;
			case 'SPA2102':
			case 'SPA3102':
			case 'PAP2':
			case 'SPA8000':
			case 'HT-503':
			case 'HT-286':
			case 'HT-502':
			case 'GXW-4004':
			case 'GXW-4008':
			case 'SPA112':
			case 'SPA122':
                            $exts .= '<td colspan="6">';
                            $exts .= '<input type="checkbox" name="accessory_exist[' . $newCount . ']" value="fax" ' . ($value['accessory'] == 'fax' ? 'checked' : '') . '>Use for Fax</td>';
                            break;
				
			default:
                            $exts .= '<td colspan="6">';
                            $e = $allModels[$value['brand_model']];
                            $c = 0;

                            $exp = endpoint_get_brand_models(strtolower($value['brand']), $type = 'exp');
                            $expModules = '<option value=""> None</option>';
                            foreach($exp as $k=>$v){
                                $expModules .= '<option value="' . $v['model'] . '"> ' . $v['model'] . '</option>';
                            }	

                            if($e == 'v'){
                                $d = $c+1;
                                if(!empty($value['exp' . $c])){$selected = '<option value="' . $value['exp' . $c] . '" selected>' . $value['exp' . $c] . '</option>';} else {$selected = '<option value="" selected >None</option>';}
                                $exts .= 'Expansion ' . $d . '<select name="exp' . $c . '_exist[' . $newCount . ']"> ' . $selected . '<option value="Vision"> Vision</option></select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                                $c++;

                            }
                            while($c < $e){
                                $d = $c+1;
                                if(!empty($value['exp' . $c])){$selected = '<option value="' . $value['exp' . $c] . '" selected>' . $value['exp' . $c] . '</option>';} else {$selected = '<option value="" selected >None</option>';}
                                $exts .= 'Expansion ' . $d . '<select name="exp' . $c . '_exist[' . $newCount . ']"> ' . $selected . $expModules . '</select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                                $c++;
                            }
                            $exts .= '</td></tr>';
                            $exts .= '<tr class="' . preg_replace('/ /', '-', $value['ext']) . '" style="display: none; background: ' . $color . ';" ><td></td><td colspan="6">BLF Substitution: <select name="blf_exist[' . $newCount . ']">' . $all_ext . '<option value="' . $value['blf'] . '" selected>' . $value['blf'] . '</select> BLF Label: <input name="blf_label_exist[' . $newCount . ']" value="' . $value['blf_label'] . '" placeholder="BLF Label" size="20"/></td>';

                            break;
		}	
		$newCount++;
		$exts .= '</tr>';
		 
	}
} //end if empty check
echo '<div id="extensions">';
echo '<form method="post" action="' . $_SERVER['REQUEST_URI'] . '">';
//start table layout
if($order == 'asc'){$sortO = 'desc';} else {$sortO = 'asc';}
echo '<table id="extensions" table border="0" cellpadding="1" cellspacing="0"> 
<thead><tr style="text-align: left; background-color: darkgreen; color: white;"> 
<th><a href="#" id="check_All" style="color:white;">Select</a></th><th><a href="/admin/config.php?display=endpoint&view=extension&sort=ext&order=' . $sortO . '" style="color:white;">Extension/Name</a></th>
<th><a href="/admin/config.php?display=endpoint&view=extension&sort=brand&order=' . $sortO . '" style="color:white;">Brand</a>
<br /><a href="/admin/config.php?display=endpoint&view=extension&sort=mac&order=' . $sortO . '" style="color:white;">MAC Address</a></th>
';
if($g_settings['emIP'] == 'Y' || $g_settings['emS'] == 'Y'){echo '<th>IP Address<br />Status</th>';}
echo '<th><a href="/admin/config.php?display=endpoint&view=extension&sort=template&order=' . $sortO . '" style="color:white;">Template</a>

<br /><a href="/admin/config.php?display=endpoint&view=extension&sort=model&order=' . $sortO . '" style="color:white;">Model</a></th>
<th></th></tr></thead><tbody>'; 
echo $exts;
echo '</tbody></table>';

echo '<BUTTON name="add_new" type="button" onClick="addExtension(' . $ext . ', ' . $brands . ', ' . $aastra . ', ' . $algo . ', ' . $and . ', ' . $audiocodes . ', ' . $cisco . ', ' . $cyberdata . ', ' . $digium . ', ' . $grandstream . ', ' . $obihai . ', ' . $panasonic . ', ' . $phoenix . ', ' . $polycom . ', ' . $sangoma . ', ' . $snom . ', ' . $uniden . ', ' . $vtech . ', ' . $yealink . ', ' . $xorcom . ')">Add Extension</button>';
echo '<a href="/admin/config.php?display=endpoint&csv_type=extensionOut"><input type="button" style="width: 100px;" value="Export List"/></a>';
echo '<input onclick="displayImport()" type="button" style="width: 100px;" value="Import List"/>';

echo '<br /><br /><select name="task"><option value="delete">Delete</option><option value="reboot">Reboot</option><option value="rebuild">Rebuild Configs</option><option value="save" selected>Save</option></select>';
echo '<input type="hidden" name="action" value="save_extensions">'
	 . '<input type="submit" value="Use Selected" />'
	 . '</form><br /><br />';
echo '</div>';

// div for import
echo '<div id="import" style="display:none;">';
echo '<p><form action="' . $_SERVER["REQUEST_URI"] . '&csv_type=extensionIn" name="uploadcsv" method="post" enctype="multipart/form-data">CSV File of Extensions to Load: <input name="csvFile" type="file" />';

echo '<br /><br />';
echo '<input type="submit" /></form><br /><br />';
echo '</div>';
echo '</div>';

    echo '<script>';
        foreach($brandsUsed as $k=>$v){
            if(!empty($$v)){
                echo 'var ' . $v . ' = ' . $$v . '; ';
            }
            $m = $v . 'Models';
            if(!empty($m)){
                echo 'var ' . $m . ' = ' . $$m . '; ';
            }  
        }
    echo '</script>';
?>
<div id="dialog-form" title="Create Custom Extension">
    <form name="custom_Ext" method="post" action="" >
	<fieldset>
<?php
$table = new CI_Table();
$table->add_row(array( 'data' => fpbx_label('Extension Number:', 'SIP Extension Number.')),
    array( 'data' => '<input type="text" size="20" name="cExt" id="cExt" value="" />'));
$table->add_row(array( 'data' => fpbx_label('Extension Secret:', 'SIP Password for Extension.')),
    array( 'data' => '<input type="text" size="20" name="cSecret" id="cSecret" value="" />'));
$table->add_row(array( 'data' => fpbx_label('Extension Label:', 'Label for Extension Display Name.')),
    array( 'data' => '<input type="text" size="20" name="cLabel" id="cLabel" value="" />'));
$table->add_row(array( 'data' => fpbx_label('Destination Server:', 'Required only if different than this PBX.')),
    array( 'data' => '<input type="text" size="20" name="cDestination" id="cDestination" value="" />'));
$table->add_row(array( 'data' => fpbx_label('Sip Port:', 'Required only if different than this PBX.')),
    array( 'data' => '<input type="text" size="20" name="cSipPort" id="cSipPort" value="" />'));
echo $table->generate();
$table->clear();
?>            
            <div id="record"></div>
            <br /><br /><center><input type="submit" name="send-button" id="send-button" value="Send" /></center>	

</fieldset>
    </form>
</div>

<?php
function endpoint_nmap_all($netmask, $use_nmap=TRUE) {
    global $db;
    shell_exec(exec('which nmap') . ' -v -sP ' . $netmask);
//Get arp list
    $arp_list = shell_exec(exec('which arp') . " -an");

//Throw arp list into an array, break by new lines
    $arp_array = explode("\n", $arp_list);

//Find all references to active computers by searching out mac addresses.
    $temp = array_values(array_unique(preg_grep("/[0-9a-f][0-9a-f][:-]" .
                            "[0-9a-f][0-9a-f][:-]" .
                            "[0-9a-f][0-9a-f][:-]" .
                            "[0-9a-f][0-9a-f][:-]" .
                            "[0-9a-f][0-9a-f][:-]" .
                            "[0-9a-f][0-9a-f]/i", $arp_array)));

//Go through each row of valid arp entries and pull out the information and add it into a nice array!
    $z = 0;
    foreach ($temp as $key => &$value) {

//Pull out the IP address from row. It's always the first entry in the row and it can only be a max of 15 characters with the delimiters
        preg_match_all("/\((.*?)\)/", $value, $matches);
        $ip = $matches[1];
        $ip = $ip[0];

//Pull out the mac address by looking for the delimiter
        $mac = substr($value, (strpos($value, ":") - 2), 17);

//Get rid of the delimiter
        $mac_strip = strtoupper(str_replace(":", "", $mac));

//arp -n will return a MAC address of 000000000000 if no hardware was found, so we need to ignore it
        if ($mac_strip != "000000000000") {

//Add into a final array
                $list[$mac_strip] = $ip;
    	}
     }
     return($list);
}