<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

global $db;
global $amp_conf;

$sql = "SELECT * FROM `extensionroutes` LIMIT 1";
$check = $db->query($sql);
if(!DB::IsError($check)) {
	out(_("extensionroutes table already exists, exiting"));
	return true;
}

$sql = "CREATE TABLE IF NOT EXISTS `extensionroutes` ( 
	exten VARCHAR( 20 ),
	route_id INT( 11 ),
  PRIMARY KEY (`exten`, `route_id`)
)";

outn(_("creating extensionroutes.."));
sql($sql);
out(_("ok"));

// Now add all routes to all extensions since by default they already have everything

$routes = core_routing_list();
$extens = core_users_list();

if(!empty($extens) && !empty($routes)) {
	$insert_arr = array();
	foreach($extens as $exten) {
		$ex = $exten[0];
		foreach ($routes as $route) {
			$insert_arr[] = array($ex, $route['route_id']);
		}
	}
	$compiled = $db->prepare("INSERT INTO `extensionroutes` (`exten`, `route_id`) VALUES (?,?)");
	$result = $db->executeMultiple($compiled,$insert_arr);
	if(DB::IsError($result)) {
		die_freepbx($result->getMessage()."Ininitalization of extensionroutes multi-insert failed");	
	}
	unset($insert_arr);
}

?>
