<?php
// vim: set ai ts=4 sw=4 ft=php:
include_once(__DIR__.'/functions.inc.php');
include_once(dirname(__DIR__).'/fax/functions.inc.php');
class Faxpro implements BMO {
	public function __construct($freepbx = null) {
		if ($freepbx == null)
			throw new Exception("Not given a FreePBX Object");

		$this->FreePBX = $freepbx;
		$this->db = $freepbx->Database;
	}

	public function doConfigPageInit($page) {

	}

	public function install() {

	}
	public function uninstall() {

	}
	public function backup(){

	}
	public function restore($backup){

	}
	public function genConfig() {

	}

	public function getSettings() {
		return fax_get_settings();
	}

	public function deleteFax($id) {
		return faxpro_del_fax($id,true);
	}

	public function deleteAttachment($name) {
		if(file_exists(__DIR__."/tmp/".$name)) {
			return unlink(__DIR__."/tmp/".$name);
		}
		return true;
	}

	public function saveAttachment($ext,$id,$name,$contents) {
		if(!file_exists(__DIR__."/tmp")) {
			if(mkdir(__DIR__."/tmp")) {
				return false;
			}
		}
		return file_put_contents(__DIR__."/tmp/".$name,$contents);
	}

	public function sendBackgroundFax($ext, $tonum, $files, $coversheet = array(), $local = false, $forward = false) {
		$vars = array(
			"user" => $ext,
			"tonum" => $tonum,
			"is_local" => $local,
			"is_forward" => $forward,
			"files" => $files
		);
		if(!empty($coversheet)) {
			$vars['coversheet'] = true;
			$vars['name'] = $coversheet['name'];
			$vars['msg'] = $coversheet['msg'];
			$vars['sender'] = $coversheet['sender'];
			$vars['tel'] = $coversheet['tel'];
			$vars['email'] = $coversheet['email'];
		}
		foreach($vars['files'] as &$file) {
			if(file_exists(__DIR__."/tmp/".$file)) {
				$file = __DIR__."/tmp/".$file;
			} elseif(file_exists($file)) {
				$file = $file;
			} else {
				return false;
			}
		}
		if(file_exists(__DIR__).'/bin/faxpro_background.php') {
			exec('php '.__DIR__.'/bin/faxpro_background.php '.escapeshellarg(json_encode($vars)).' > /dev/null 2>&1 &');
		}
	}

	public function putFaxDetails($id,$options) {
		if(empty($options) || !is_array($options)) {
			return false;
		}
		$options['faxid'] = $id;
		return faxpro_put_fax_details($options);
	}

	public function getFaxDetails($id) {
		return faxpro_get_fax_details($id);
	}

	public function putUserDetails($ext, $localstore, $stationid, $header, $name, $tel, $mail, $faxattachformat, $emailresults, $faxretries) {
		faxpro_save_user($ext, $localstore, $stationid, $header, $name, $tel, $mail, $faxattachformat, $emailresults, $faxretries);
	}

	public function getUserDetails($ext) {
		$sth = $this->db->prepare('SELECT * FROM fax_users WHERE user = ?');
		$sth->execute(array($ext));
		$out = $sth->fetchAll(PDO::FETCH_ASSOC);
		return !empty($out[0]) ? $out[0] : false;
	}

	public function getUserUsage($user) {
		return faxpro_get_user_usage($user);
	}

	public function getUserStorageInfo($user, $id = '') {
		return faxpro_get_user_storage($user, $id);
	}

	public function readFaxBinaryByMessageIDExtension($faxid,$ext,$start=0,$buffer=8192) {
		$fax = $this->getUserStorageInfo($ext,$faxid);
		$fax = !empty($fax[0]) ? $fax[0] : false;
		if(!empty($fax) && file_exists($fax['file']) && !empty($fax['length'])) {
			if($fax['new'] == 'yes') {
				$this->putFaxDetails($faxid,array('new' => 'no'));
			}
			$end = $fax['length'] - 1;
			$fp = fopen($fax['file'], "rb");
			fseek($fp, $start);
			if(!feof($fp) && ($p = ftell($fp)) <= $end) {
			    if ($p + $buffer > $end) {
			        $buffer = $end - $p + 1;
			    }
				$contents = fread($fp, $buffer);
				fclose($fp);
				return $contents;
			}
			fclose($fp);
		}
		return false;
	}
}
