<?php

$options = json_decode($argv[1],TRUE);
switch (json_last_error()) {
	case JSON_ERROR_NONE:
		break;
	break;
	case JSON_ERROR_DEPTH:
		out(" - Maximum stack depth exceeded");
		exit(1);
	break;
	case JSON_ERROR_STATE_MISMATCH:
		out(" - Underflow or the modes mismatch");
		exit(1);
	break;
	case JSON_ERROR_CTRL_CHAR:
		out(" - Unexpected control character found");
		exit(1);
	break;
	case JSON_ERROR_SYNTAX:
		out(" - Syntax error, malformed JSON");
		exit(1);
	break;
	case JSON_ERROR_UTF8:
		out(" - Malformed UTF-8 characters, possibly incorrectly encoded");
		exit(1);
	break;
	default:
		out(" - Unknown error");
		exit(1);
	break;
}

$get = array(
	'user'			=> null,
	'tonum'			=> '',
	'is_local'		=> false,
	'is_forward'	=> false,
	'coversheet'	=> false,
	'name'			=> '',
	'msg'			=> '',
	'tel'			=> '',
	'email'			=> '',
	'sender'		=> '',
);

foreach ($get as $k => $v) {
	$vars[$k] = isset($options[$k]) ? $options[$k] : $v;
}

if(empty($vars['user']) || empty($vars['tonum'])) {
	out("Critical Information Missing. Stopping");
	exit(1);
}

if(empty($options['files'])) {
	out("Missing Fax Data. Stopping");
	exit(1);
}

if(!file_exists(dirname(dirname(__DIR__)).'/functions.inc/class.fax.php')) {
	out("Cant Find important files. Stopping");
	exit(1);
}
require_once(dirname(dirname(__DIR__)).'/functions.inc/class.fax.php');

$faxSend = new FaxproSend($vars['user'], $vars['tonum'], $vars['is_local'], $vars['is_forward']);
foreach($options['files'] as $file) {
	if(file_exists($file)) {
		$faxSend->add_file($file);
		//unlink($file);
	} else {
		out("Fax File Missing. Stopping");
		exit(1);
	}
}

//add coverpage if requested
if ($vars['coversheet']) {
	$faxSend->add_coversheet($vars['name'], $vars['msg'],  $vars['sender'], $vars['tel'], $vars['email']);
}

$faxSend->send_fax();
