<?php

//get values passed in
$get = array(
		'finished::',
		'action::',
		'callerid::',
		'date::',
		'dest::',
		'direction::',
		'faxid::',
		'file::',
		'faxfile::',//tmp file name
		'from::',
		'pages::',
		'stationid::',
		'status::',
		'user::',
);
$opts = getopt('', $get);

foreach ($get as $g) {
	$tmp = trim($g, '::');
	$opts[$tmp] = isset($opts[$tmp]) ? $opts[$tmp] : '';
}
$finished = false;
switch ($opts['action']) {
	case 'receive':
		$check			= faxpro_validate_received_fax($opts['user'], $opts['file']);
		$opts['pages']	= $check['pages'];
		$opts['status']	= $check['msg'];
		//save file
		if ($check['status']) {
			$dir		= faxpro_user_dir_struct($opts['user'], 'in');
			$opts['file']= fax_file_convert('tif2pdf', $opts['file'],
								$dir . '/' . pathinfo($opts['file'], PATHINFO_FILENAME) . '.pdf',
								'Fax from ' . $opts['from']
			);
		}

		//set a faxid
		$opts['faxid'] = time() . rand(100, 999);
		$finished = true;
		break;
	case 'sent':
		if(isset($opts['finished'])) {
			//do something here as its the end
			$finished = true;
		}
		if (file_exists($opts['faxfile'])) {
			unlink($opts['faxfile']);
		}
		//make status more human
		switch($opts['status']){
			case 'FAX_NO_FAX':
				$opts['status'] = _('Failure: No fax machine detected');
				break;
			case 'FAX_FAILURE_PARTIAL':
				$opts['status'] = _('Failure: Transmission Error');
				break;
			case 'FAX_SUCCESS':
				$opts['status'] = _('Success');
				break;
			default:
				break;
		}
		break;

	default:
		break;
}


//save data
$data = array(
		'faxid'		=> $opts['faxid'],
		'user' 		=> $opts['user'],
		'dir'		=> $opts['direction'],
		'date'		=> time(),
		'dest'		=> $opts['dest'],
		'callid'	=> urldecode($opts['callerid']),
		'status'	=> $opts['status'],
		'stationid'	=> $opts['stationid'],
		'pages'		=> $opts['pages'],
		'file'		=> $opts['file'],
		'new'		=> ($opts['direction'] == 'in' ? 'yes' : 'no'),
		'finished'		=> $finished
);

faxpro_put_fax_details($data);

//TODO: cleanup stale tmp fax files
?>
