<?php
// vim: set ai ts=4 sw=4 ft=php:

// The following functions are only defined if the test above is true.
include_once(dirname(__FILE__) . '/class.fax.php');
function faxpro_configpageload() {
	global $currentcomponent, $display;
	$extdisplay = isset($_REQUEST['extdisplay'])
				? $_REQUEST['extdisplay']
				: null;
	if ($display == 'extensions' || $display == 'users') {
		//get settings in to variables
		if ($extdisplay) {
			extract(fax_get_user($extdisplay));
		}
		$section = _('Fax');
		$currentcomponent->addguielem($section,
			new gui_checkbox(
				'faxlocalstore',
				$faxlocalstore,
				_('Store Localy'),
				_('Chose this option to have faxes stored by '
				. 'the server; accessible via the ARI.'),
				'true',
				'',
				($faxenabled == 'true') ? '' : 'true'
			)
		);
		$currentcomponent->addguielem($section,
			new gui_textbox(
				'faxstationid',
				$faxstationid,
				_('Outgoing Station ID'),
				_('The outgoing Fax Machine Identifier. '
				. 'This is usually your fax number.'),
				'', '','', '',
				($faxenabled == 'true') ? '' : 'true'
			)
		);
		$currentcomponent->addguielem($section,
			new gui_textbox(
				'faxheader',
				$faxheader,
				_('Outgoing Header'),
				_('The outgoing Fax Machine Headers. '
				. 'This usually contains the name of the '
				. 'person or entity sending the fax.'),
				'', '','', '',
				($faxenabled == 'true') ? '' : 'true'
			)
		);
		$currentcomponent->addguielem($section,
			new gui_textbox(
				'faxcovername',
				$faxcovername,
				_('Coversheet Name'),
				_('The name that should appear on the outbound coversheet.'),
				'', '','', '',
				($faxenabled == 'true') ? '' : 'true'
			)
		);
		$currentcomponent->addguielem($section,
			new gui_textbox(
				'faxcovertel',
				$faxcovertel,
				_('Coversheet Tel'),
				_('The Phone number that will appear on the cover sheet.'),
				'', '','', '',
				($faxenabled == 'true') ? '' : 'true'
			)
		);
		$currentcomponent->addguielem($section,
			new gui_textbox(
				'faxcoveremail',
				$faxcoveremail,
				_('Coversheet Email'),
				_('The email address that will appear on the coversheet.'),
				'', '','', '',
				($faxenabled == 'true') ? '' : 'true'
			)
		);

		$currentcomponent->addoptlist('emailresultsopts', false);
		$currentcomponent->addoptlistitem('emailresultsopts', '', 'Use global setting');
		$currentcomponent->addoptlistitem('emailresultsopts', 'never', 'Never');
		$currentcomponent->addoptlistitem('emailresultsopts', 'always', 'Always');
		$currentcomponent->addoptlistitem('emailresultsopts', 'success', 'On Success');
		$currentcomponent->addoptlistitem('emailresultsopts', 'failure', 'On Failure');

		$currentcomponent->addguielem($section,
			new gui_selectbox(
				'emailresults',
				$currentcomponent->getoptlist('emailresultsopts'),
				$emailresults,
				_('Email Results'),
				_('When to email the results of an outgoing fax.'),
				false
			)
		);

		$currentcomponent->addoptlist('faxretrycount', false);
		$currentcomponent->addoptlistitem('faxretrycount', '', 'Use global setting');
		$currentcomponent->addoptlistitem('faxretrycount', '0', '0');
		$currentcomponent->addoptlistitem('faxretrycount', '1', '1');
		$currentcomponent->addoptlistitem('faxretrycount', '2', '2');
		$currentcomponent->addoptlistitem('faxretrycount', '3', '3');

		$currentcomponent->addguielem($section,
			new gui_selectbox(
				'faxretries',
				$currentcomponent->getoptlist('faxretrycount'),
				$faxretries,
				_('Retries'),
				_('Number of times to retry sending a failed fax.'),
				false
			)
		);
	}
}

function faxpro_configpageinit($pagename) {
	global $currentcomponent, $amp_conf;
	// On a 'new' user, 'tech_hardware' is set, and there's no extension.
	$get_vars = array(
		'extdisplay'=> '',
		'display'	=> ''
	);

	foreach ($get_vars as $k => $v) {
		$vars[$k] = isset($_REQUEST[$k]) ? $_REQUEST[$k] : $v;
	}
	if (!$vars['extdisplay']) {
		return true;
	}
	if (in_array($vars['display'], array('users', 'extensions'))) {
		$currentcomponent->addprocessfunc('faxpro_configpageload', 2);
		$currentcomponent->addprocessfunc('faxpro_configprocess', 2);
	}


	if (in_array($vars['display'], array('devices', 'extensions'))
		//&& version_compare($amp_conf['ASTVERSION'],'10','ge')
	) {
		$currentcomponent->addprocessfunc('faxpro_hook_devices', 2);
		$currentcomponent->addprocessfunc('faxpro_hookProcess_devices', 2);
	}
}

//prosses recived arguments
function faxpro_configprocess() {
	$get_vars = array(
				'action',
				'ext',
				'extension',
				'faxlocalstore',
				'faxstationid',
				'faxheader',
				'faxcovername',
				'faxcovertel',
				'faxcoveremail',
				'faxattachformat',
				'emailresults',
				'faxretries',
	);

	foreach ($get_vars as $v) {
		$vars[$v] = isset($_REQUEST[$v]) ? $_REQUEST[$v] : null;
	}
	$vars['ext'] = $vars['ext'] ? $vars['ext'] : $vars['extension'];

	if ($vars['action'] == 'edit') {
		faxpro_save_user(
			$vars['ext'],
			$vars['faxlocalstore'],
			$vars['faxstationid'],
			$vars['faxheader'],
			$vars['faxcovername'],
			$vars['faxcovertel'],
			$vars['faxcoveremail'],
			$vars['faxattachformat'],
			$vars['emailresults'],
			$vars['faxretries']
		);
	}
}

//returns an array in an easy-to-disect manner for page.fax.php
//this should probobly be depreciated, as it doesn't reflect the amount of licenses
//as asterisk sees it. instead, detect_fax() returns the amount that asterisk sees
function faxpro_ffa_license(){
	$info = '';
	$lics=faxpro_get_licenses();
	if(is_array($lics)){
		foreach($lics as $lic){
			if ($lic['Product'] == 'RESFFA' || $lic['Product'] == 'RESFAX') {
				$info[$lic['Key-ID']] = $lic['MaxCalls'];
			}
		}
	}
	return $info;
}

function faxpro_hookGet_config($engine){
	global $faxpro;
	if (!$faxpro) {
		return true;
	}

	$fax = fax_detect();
	//dont continue unless we have a fax module in asterisk and proper licenses!
	if (!in_array($fax['module'], array('app_fax', 'res_fax'))) {
		return false;
	}

	//Check for a valid fax engine like we do in fax, otherwise we will end up trying
	//to splice something that isn't available

	if (!($fax['ffa'] || $fax['spandsp'])) {
		return false;
	}

	global $ext, $amp_conf, $db, $core_conf;

	$context	= 'ext-fax';
	$rows		= faxpro_get_destinations();

	if($rows){//only run if we have rows
		foreach ($rows as $row){
			$exten = $row;
			$ext->splice($context, $exten, 'receivefax', new ext_setvar('ARIUSER',$exten));
			$ext->splice($context, $exten, 'receivefax', new ext_agi('fax.agi'));
		}
		$ext->replace($context, 'h', 'delete_opt', new ext_set('DELETE_AFTER_SEND', 'false'));
		$ext->splice($context, 'h', 'end',
			new ext_execif(
				'$[$["${ARIUSER}" != ""]]',
				'system',
				'${ASTVARLIBDIR}/bin/faxpro_helper.php '
				. '--action="receive" '
				. '--user="${ARIUSER}" '
				. '--dest="${ARIUSER}" '
				. '--callerid=\'${URIENCODE(${CALLERID(name)})} <${CALLERID(num)}>\' '
				. '--file="${ASTSPOOLDIR}/fax/${UNIQUEID}.tif" '
				. '--direction="in" '
				. '--status="${IF($[${EXISTS(${FAXOPT(statusstr)})}]?${FAXOPT(statusstr)}:${status})}"'
			)
		);
	}
	$context='send-fax';
	$ext->add($context, 's', '', new ext_noop('Sending fax from ${AMPUSER} to ${TO}'));
	$ext->add($context, 's', '',
		new ext_system(
			'${ASTVARLIBDIR}/bin/faxpro_helper.php '
			. '--faxid="${faxid}" '
			. '--stationid="${FAXOPT(localstationid)}" '
			. '--status="In Progress" '
		)
	);
	$ext->add($context, 's', '', new ext_sendfax('${file},zf'));
	$ext->add($context, 'h', '',
		new ext_system(
			'${ASTVARLIBDIR}/bin/faxpro_helper.php '
			. '--faxid="${faxid}" '
			. '--stationid="${FAXOPT(localstationid)}" '
			. '--status="${FAXOPT(statusstr)}" '
			. '--action="sent" '
		)
	);

	if (version_compare($amp_conf['ASTVERSION'],'10','ge')) {
		//hook in to outbound routes to set t38gateway option
		foreach ($routes = core_routing_list() as $r) {
			if (faxpro_hook_core_get('routing', $r['route_id']) == 'yes') {
				$c = 'outrt-' . $r['route_id'];
				//iterate through all patterns
				foreach(core_routing_getroutepatternsbyid($r['route_id']) as $p) {
					$formatPattern = core_routing_formatpattern($p);
                                        $e = $formatPattern['dial_pattern'];
                                        $ext->splice($c, $e, 3, new ext_set('FAXOPT(gateway)', 'yes'));
				}
			}
		}

		//hook in to device settings
		$can_hook = isset($core_conf)
				&& is_a($core_conf, 'core_conf');
		foreach (core_devices_list('all', true, true) as $d) {
			if (($status = faxpro_hook_core_get('devices', $d['id'])) == 'yes'
				&& $can_hook
			) {
				$core_conf->addSipAdditional($d['id'],
					'setvar=FAXOPT(gateway)',
					$status);
			}
		}
	}
}

function faxpro_get_destinations(){
	global $db;
	$sql = "SELECT user FROM fax_users WHERE faxenabled = 'true' and faxlocalstore = 'true'";
	$results = $db->getAll($sql);
	foreach($results as $result){
		$ret[] = $result['0'];
	}//flaten array tree
	return isset($ret) && $ret ? $ret : array();
}

function faxpro_get_licenses(){
	global $amp_conf;
	$rows = '';
	$dir = $amp_conf['ASTVARLIBDIR'].'/licenses/';
	if (!is_readable($dir)) {
		return true;
	}
	$contents = scandir($dir);
	foreach ($contents as $file) {
		//load file name in to an array, based on segments between periods
		$filearray = explode('.', $file);
		//test the last element for a suffix of lic
		if ($filearray[(count($filearray) - 1)] == 'lic') {
			//read file in to variable
			$lines = file($dir . $file);
			foreach ($lines as $line) { //loop thru lines
				$row = explode(':',$line,2); //explode line based on :
				/*
				 * load exploded line in to an array $filename1($explodename[1]=$explodeval[1])
				 * also, use trim to kill extra whitespaces. Thanks digium for the whitespaces! also, couldnt you
				 * just use a simple ini style file, insterad fo inventing a new format?!
				 *
				 */
				$rows[$filearray['0']][trim($row['0'])] = trim($row['1']);
			}
		}
  }
  return $rows;
}

function faxpro_hook_fax($viewing_itemid, $target_menuid){
	global $amp_conf;
	$logo_path = $amp_conf['ASTSPOOLDIR'] . '/faxpro/images/companylogo.jpg';

	//save faxpro settings
	if (isset($_REQUEST['action']) &&  $_REQUEST['action'] == 'edit') {
		faxpro_save_settings($_REQUEST);
	}

	if (isset($_REQUEST['submit']) && $_REQUEST['submit'] == _('Preview')) {
		faxpro_get_coversheet_preview();
		exit();
	}

	//this is what serves faxpro gui options to fax
	$tabindex = null;
	faxpro_upload_license();
	if (isset($_REQUEST['delete_logo']) && $_REQUEST['delete_logo'] == 'true') {
		unlink($logo_path);
		faxpro_save_settings(array('companylogo' => ''));
	}

	extract(fax_get_settings());
	$tabindex = 500;
	$html = '<table>';
	$fax = fax_detect();
	$lics = faxpro_ffa_license();
	if (isset($fax['license']) && $fax['license'] > 0 && $lics) {
		$html .= '<tr><td colspan="3"><h5>'. _('Fax Licenses').'<hr/></h5></td></tr>';
		$html .= '<tr><td><strong>'. _('License number') . '</strong></td><td><strong>'
								. _('Concurrent Faxes') . '</strong></td><tr>';
		$total = 0;
		foreach ($lics as $lic => $count){
			$html .= '<tr><td>' . $lic . '</td><td align=center>' . $count . '</td></tr>';
			$total += $count;
		}
		$html .= '<tr><td align=right><strong>' . _('Total') . '</td><td align=center>' . $total . '</td></tr>';
	} elseif ($fax['module'] != 'res_fax' && $fax['spandsp'] != TRUE) {
		$html .= '<tr><td colspan="3"><h5>'. _('Fax Licenses').'<hr/></h5></td></tr>';
		$html .= '<tr><td><font color="red">No fax modules Found! '
				. 'Please contact customer care for more '
				. 'information.</font></td></tr>';
	}

	$html .= '<script type="text/javascript" src="modules/faxpro/assets/js/faxpro.js"></script>';
	$append = '<tr><td colspan="3"><h5>'. _('Fax Cover Page Options').'<hr/></h5></td></tr>';
	if (!$fax['module']) {
		$append .= '<tr><td><font color="red">' . _("ERROR:") . '</font></td>';
		$append .= '<td><font color="red">Fax modules missing! Please contact customer care for more information.</td></font></tr>';
	} elseif (($fax['module'] == 'res_fax' && $fax['license'] < 1 && $fax['spandsp'] != TRUE)) { //if they have res fax they can still have spandsp
		$append .= '<tr><td><font color="red">' . _("ERROR:") . '</font></td>';
		$append .= '<td><font color="red">Fax licenses missing! This feature may not have been purchased for your system. Please contact your sales associate for more information on this feature.</td></font></tr>';
	}
	$append .= '<tr><td><a href="#" class="info">' . _('Company Logo')
			. ':<span>' . _('Company Logo. Filetype MUST be JPG')
			. '</span></a></td><td>';
	if (file_exists($logo_path)) {
		$append .= '<img src="data:image/jpeg;base64,' . base64_encode(file_get_contents($logo_path)) . '" border="0" alt="upload an image" id="logoimg" width=150px/>';
	}
	$append .= '<br/><input name="logo_file" type="file" tabindex="'.++$tabindex.'"/>';
	$append .= '&nbsp<input type="button" value="Delete logo" onclick="$(\\\'input[name=delete_logo]\\\').val(\\\'true\\\'); $(\\\'#logoimg\\\').hide();"><input type="hidden" name="delete_logo"></td></tr>';
	$append .= '<tr><td><a href="#" class="info">'._('Company Name').':<span></span></a></td>';
	$append .= '<td><input size="50" type="text" name="companyname" value="'. $companyname.'" tabindex="'.++$tabindex.'"></td></tr>';
	$append .= '<tr><td><a href="#" class="info">'._('Company Address 1').':<span></span></a></td>';
	$append .= '<td><input size="50" type="text" name="companyaddress1" value="'. $companyaddress1.'" tabindex="'.++$tabindex.'"></td></tr>';
	$append .= '<tr><td><a href="#" class="info">'._('Company Address 2').':<span></span></a></td>';
	$append .= '<td><input size="50" type="text" name="companyaddress2" value="'. $companyaddress2.'" tabindex="'.++$tabindex.'"></td></tr>';
	$append .= '<tr><td><a href="#" class="info">'._('Company Address 3').':<span></span></a></td>';
	$append .= '<td><input size="50" type="text" name="companyaddress3" value="'. $companyaddress3.'" tabindex="'.++$tabindex.'"></td></tr>';
	$append .= '<tr><td><a href="#" class="info">'._('Company Phone').':<span></span></a></td>';
	$append .= '<td><input size="50" type="text" name="companyphone" value="'. $companyphone.'" tabindex="'.++$tabindex.'"></td></tr>';
	$append .= '<tr><td><a href="#" class="info">'._('Company Web Site').':<span></span></a></td>';
	$append .= '<td><input size="50" type="text" name="companywebsite" value="'. $companywebsite.'" tabindex="'.++$tabindex.'"></td></tr>';
	$append .= '<tr><td><a href="#" class="info">'._('Company Footer').':<span>'. _('This text will appear at the bottom of every outbound fax.').'</span></a></td>';
	$lb=array("\r\n","\r","\n");
	$append.='<td><textarea style="width: 320px;" name="companyfooter" id="companyfooter" tabindex="'.++$tabindex.'" wrap="soft">'.str_replace($lb,'\\n',$companyfooter).'</textarea></td><td id="footercounter">'.(($companyfooter != '')?500-strlen(str_replace($lb,' ',$companyfooter)):'500').'</td></tr>';

	$append .= '<tr><td>' . fpbx_label(_('Preview Cover Page'), _('Preview cover page, will save your settings first')) . '</td>';
	$append .= '<td><input type="submit" id="coverpage_preview" name="submit" value="' . _('Preview') . '"</input></td></tr>';

	$append.='<tr><td colspan="3"><h5>'. _('User Control Panel Faxing Options').'<hr/></h5></td></tr>';
	$append.='<tr><td><a href="#" class="info">'._('Global Prefix').':<span>'. _('A number to prefix to the outbound fax to route a fax to a certain outbound route').'</span></a></td>';
	$append.='<td><input type="text" name="prefix" value="'.$prefix.'" tabindex="'.++$tabindex.'" onblur="if($(this).val()&&!/^(?:[\\\*#])?\\\d+$/.exec($(this).val())){alert(\\\'Prefix must be a numeric value and may be prefixed with a *.\\\');$(this).val(\\\'\\\')}" ></td></tr>';

	$append.='<tr><td colspan="3"><h5>'. _('Failure Recovery Options').'<hr/></h5></td></tr>';
	$append.='<tr><td><a href="#" class="info">'._('Retries').':<span>'. _('The maximum amount of times a fax will be retried on failure.').'</span></a></td>';
	$append.='<td><select name="retries">';
	$append.='<option value="0" '.($retries=='0'?'selected="selected"':'').'>0</option>';
	$append.='<option value="1" '.($retries=='1'?'selected="selected"':'').'>1</option>';
	$append.='<option value="2" '.($retries=='2'?'selected="selected"':'').'>2</option>';
	$append.='<option value="3" '.($retries=='3'?'selected="selected"':'').'>3</option>';
	$append.='</select></td></tr>';

	$append.='<tr><td colspan="3"><h5>'. _('Failure Notification Options').'<hr/></h5></td></tr>';
	$append.='<tr><td><a href="#" class="info">'._('Email Results').':<span>'. _('When to email the results of an outgoing fax.').'</span></a></td>';
	$append.='<td><select name="emailresults">';
	$append.='<option value="" '.($emailresults==''?'selected="selected"':'').'>Never</option>';
	$append.='<option value="always" '.($emailresults=='always'?'selected="selected"':'').'>Always</option>';
	$append.='<option value="success" '.($emailresults=='success'?'selected="selected"':'').'>On Success</option>';
	$append.='<option value="failure" '.($emailresults=='failure'?'selected="selected"':'').'>On Failure</option>';
	$append.='</select></td></tr>';

	$append.='<tr><td colspan="3"><h5>'. _('Local Storage Options').'<hr/></h5></td></tr>';
	$append.='<tr><td><a href="#" class="info">'._('Max Pages').':<span>'. _('The maximum amount of pages a user is allowed to store locally.').'</span></a></td>';
	$append.='<td><input type="text" name="maxpages" value="'.$maxpages.'" tabindex="'.++$tabindex.'" onblur="if($(this).val()&&!isInteger($(this).val())){alert(\\\'Max Pages must be a numeric value.\\\');$(this).val(\\\'\\\')}; if($(this).val() && !$(\\\'input[name=maxaction]:checked\\\').length){$(\\\'input[name=maxaction]\\\')[0].checked=true}" ></td></tr>';
	$append.='<tr><td><a href="#" class="info">'._('Excess Faxes').':<span>'. _('How the system should respond when a new fax arrives for a user whos quota is full.<ul><li>Reject: Reject the new fax and dissconect the call</li><li>Delete Oldest: Delete as many faxes as nesesary to accommodate the incoming fax, starting from the oldest.</li></ul>With either option, a fax larger that the quota will be deleted after it was recived.').'</span></a></td>';
	$append.='<td><span class="radioset"><input type="radio" name="maxaction" id="maxaction-reject" value="reject" tabindex="'.++$tabindex.'" '.(($maxaction=='reject')?'checked="checked"':'').'"><label for="maxaction-reject">Reject</label>';
	$append.='<input type="radio" name="maxaction" id="maxaction-delete" value="delete" tabindex="'.++$tabindex.'" '.(($maxaction=='delete')?'checked="checked"':'').'"><label for="maxaction-delete">Delete Oldest</label></span></td></tr>';

	$append.='</table>';
	$html .= '</table>';
	$html.="<script type='text/javascript'>
					function filterEnter(kc){if(kc == 13){return '<br/>'} }
					$(document).ready(function() {
						$('#faxoptionstable').append('".$append."');
						//auto grow textbox and limit input
						$('#companyfooter').css('transition', 'height 0.2s').autosize({append: '\\n'}).inputlimiter({limit: 500, boxId: 'footercounter', boxAttach: false,remTextHideOnBlur: false, remText: '%n', limitText: ''});
					});
			</script>";
	return $html;
}

/*
 * Save settings
 */
function faxpro_save_settings($data) {
	global $amp_conf;
	$logo_path = $amp_conf['ASTSPOOLDIR'] . '/faxpro/images/companylogo.jpg';

	$options = array("companylogo",
					"companyname",
					"companyaddress1",
					"companyaddress2",
					"companyaddress3",
					"companyphone",
					"companywebsite",
					"companyfooter",
					"maxpages",
					"maxaction",
					"prefix",
					"retries",
					"emailresults");
	//check what we are passed in against what we expect.
	//if we cycle through options and set data based on that
	// we will get things we don't need
	foreach ($data as $opt => $val) {
		if (in_array($opt,$options)) {
			$settings[$opt] = isset($data[$opt]) ? $data[$opt] : '';
		}
	}
	if (isset($settings['maxpages']) && !$settings['maxpages']) {
		!$settings['maxaction'] = '';
	};

	//save file, if any were uploaded
	if (
		isset($_FILES['logo_file'], $_FILES['logo_file']['name'])
		&& $_FILES['logo_file']['size'] > 0
		&& $_FILES['logo_file']['error'] === 0
	) {
		$file = $_FILES['logo_file'];
			$type = explode('/',$file['type']);

			//only save jpegs, as that is what the pdf class excpects
			if (in_array($type['1'], array('jpg', 'jpeg'))) {
				//ensure directory path exists
				if (!file_exists(dirname($logo_path))) {
					mkdir(dirname($logo_path), 0755, true);
				}

				$ret = move_uploaded_file($file['tmp_name'], $logo_path);
			}
	}
	return fax_save_settings($settings);
}

/*
 * Downloads a built fax coverpage
 */
function faxpro_get_coversheet_preview() {
	require_once(dirname(__FILE__) . '/class.fax.php');
	$fax = new FaxproSend('0', 'to number');
	$fax->user['faxnum'] = '<users fax num>';
	$fax->to['num'] = '<recipient\'s fax num>';
	$fax->add_coversheet('recipient\'s name>',
						'<coverpage body message>',
						'<users name>',
						'<users tel>',
						'<users email>') ;
	$fax->_generate_coverpage($fax->user, $fax->org, $fax->to, $fax->license, '<pagecount>', true);
}

//handel upload of new license files
function faxpro_upload_license(){
	global $amp_conf;

	if (!isset($_FILES['newlicense'])) {
		return false;
	}
	$file = $_FILES['newlicense'];
	if ($file['error'] > 0) {
		echo 'ERROR: '.$file['error'];
	} else {
		//confirm directory structure
		mkdir($amp_conf['ASTVARLIBDIR'].'/licenses/', 0755, true);
		move_uploaded_file($file['tmp_name'], $amp_conf['ASTVARLIBDIR'].'/licenses/'.$file['name']);
	}
}

function faxpro_save_user($ext, $localstore, $stationid, $header, $name, $tel, $mail, $faxattachformat = 'pdf', $emailresults = '', $faxretries = ''){
	global $db;

	$sql = 'UPDATE fax_users SET '
		. 'faxlocalstore = ?, faxstationid = ?, faxheader = ?, faxcovername = ?, faxcovertel =? , faxcoveremail =?, faxattachformat =?, emailresults =?, faxretries=? '
		. 'WHERE user = ?';

	$res = $db->query($sql, array($localstore, $stationid, $header, $name, $tel, $mail, $faxattachformat, $emailresults, $faxretries, $ext));
	db_e($res);

	return true;
}

function faxpro_get_user_usage($user) {
	global $db;
	return $db->getOne('SELECT count(pages) FROM fax_store WHERE user = ?',
	 			array($user));
}

/**
 * returns a list of a users stored faxes
 */
function faxpro_get_user_storage($user, $id = null) {
	global $db;
	if(empty($id)) {
		$sql = 'SELECT * FROM fax_store WHERE user = ? ORDER BY date DESC';
		$ret = $db->getAll($sql, array($user), DB_FETCHMODE_ASSOC);
	} else {
		$sql = 'SELECT * FROM fax_store WHERE user = ? AND faxid = ? ORDER BY date DESC';
		$ret = $db->getAll($sql, array($user, $id), DB_FETCHMODE_ASSOC);
	}
	db_e($ret);

	if ($ret) {
		foreach ($ret as $my => $f) {
			$ret[$my]['file_exists'] = file_exists($f['file']);
			$ret[$my]['length'] = ($ret[$my]['file_exists']) ? filesize($f['file']) : 0;
		}
		return $ret;
	}

	return array();

}

/**
 * Returns info about a given fax
 * @param sting - the fax id
 */
function faxpro_get_fax_details($id) {
	global $db;
	$ret = array();
	$sql = 'SELECT * FROM fax_store WHERE faxid = ?';
	$ret = $db->getAll($sql, array($id), DB_FETCHMODE_ASSOC);
	db_e($ret);

	if ($ret) {
		$ret = $ret[0];
		$ret['file_exists'] = file_exists($ret['file']);
	}

	return $ret;
}

/**
 * Sets info about a given fax
 * @param array - data to save
 */
function faxpro_put_fax_details($dets) {
	global $db;

	//posible options
	$opts = array(
			'faxid',
			'user',
			'dir',
			'date',
			'dest',
			'callid',
			'stationid',
			'status',
			'pages',
			'file',
			'new',
	);

	//check if this id exists yet
	if (!faxpro_get_fax_details($dets['faxid'])) {
		//new entry
		//fill in $data with all posible options
		foreach ($opts as $o) {
			$data[$o] = isset($dets[$o]) ? $dets[$o] : '';
		}
		$sql = 'INSERT INTO fax_store ('
			. 'faxid, '
			. 'user, '
			. 'dir, '
			. 'date, '
			. 'dest, '
			. 'callid, '
			. 'stationid, '
			. 'status, '
			. 'pages, '
			. 'file, '
			. 'new) '
			. 'VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)';
		$res = $db->query($sql, $data);
		db_e($res);
	} else {
		//sanitize array
		$data['faxid'] = $dets['faxid'];
		foreach ($opts as $o) {
			if (isset($dets[$o]) && $dets[$o]) {
				$data[$o] = $dets[$o];
			}
		}

		//dont allow these to be overwriten
		$unset = array(
					'user',
				 	'dir',
					'date',
					'dest',
					'callid',
					'file',
					'direction'
		);

		foreach ($unset as $u) {
			if (isset($data[$u])) {
				unset($data[$u]);
			}
		}

		//move faxid to the end
		unset($data['faxid']);

		$sql = 'UPDATE fax_store SET ';
		foreach ($data as $k => $v) {
			$sql .= $k . " = ?, ";
		}
		$sql = trim($sql, ', ');
		$sql .= ' WHERE faxid = ?';

		$data['faxid'] = $dets['faxid'];


		$res = $db->query($sql, $data);

		db_e($res);
	}

	return faxpro_get_fax_details($data['faxid']);
}

/**
 * Deletes a fax and its records
 */
function faxpro_del_fax($id, $del_file = false) {
	global $db;
	$fax = faxpro_get_fax_details($id);

	//return if fax is not found
	if (!$fax) {
		return true;
	}

	//remove db entry
	$res = $db->query('DELETE FROM fax_store WHERE faxid = ?', array($id));
	db_e($res);

	//remove file
	if ($del_file && file_exists($fax['file'])) {
		unlink($fax['file']);
	}

	return true;
}

/**
 * Receives a fax and prosses it
 * @param int - the ampuser the fax is for
 * @param string - absolute path to the reeived file
 *
 * @return array - a bool with status and a msg explenation
 */
function faxpro_validate_received_fax($user, $file) {
	$pages		= fax_tiffinfo($file, 'Page Number');
	//dont save if we have no pages
	if (!is_file($file) || $pages <= 0) {
		return array('status' => false, 'msg' => _('File or pages not found'), 'pages' => $pages);
	}

	$count		= faxpro_get_user_usage($user);
	$set		= fax_get_settings();

	//the amount of space we need to clear for this fax
	$remaining	= $set['maxpages'] - $count;

	//try to fit pages if $max['maxaction'] == 'delete' and the fax can theoretically fit
	if ($pages > $remaining && $pages > $set['maxpages'] && $max['maxaction'] == 'delete') {
		while ($remaining < $pages) {
			//get the oldest fax in the db
			$sql		= 'SELECT * FROM fax_store WHERE user = ? ORDER BY date LIMIT 1';
			$fax		= $db->getAll($sql, array($user), DB_FETCHMODE_ASSOC);
			//delete fax
			faxpro_del_fax($fax['faxid'], true);

			//add the amount of pages we just deleted, and loop
			$remaining	+= $fax['pages'];
		}
	}

	if ($pages <= $remaining) {
		return array('status' => true, 'msg' => _('OK'), 'pages' => $pages);
	} else {
		return array('status' => false, 'msg' => _('Quota exceded'), 'pages' => $pages);
	}
}

/**
 * Create and return the directory structure for a user
 */
function faxpro_user_dir_struct($user, $dir) {
	global $amp_conf;
	$path = $amp_conf['ASTSPOOLDIR'] . '/fax/' . $user . '/' . $dir;
	if (!is_dir($path)) {
		mkdir($path, 0755, true);
	}

	return $path;
}

function faxpro_hook_core($id, $page) {
	global $faxpro, $amp_conf;

	if (version_compare($amp_conf['ASTVERSION'],'10','lt')) {
		//oops, got to be asterisk 10 or higher!
		return true;
	}

	switch ($page) {
		case 'routing':
			$vars['id'] = empty($id) ? false : $id;
			$vars['t38gateway'] = faxpro_hook_core_get($page, $id);
			$view = $faxpro ? 'routing_hook.php' : 'routing_hook_hidden.php';
			echo load_view(dirname(__FILE__) . '/views/' . $view, $vars);
			break;
		default:
			break;
	}
}


function faxpro_hookProcess_core($these_opts_are, $useless) {
	$get_vars = array(
		'action'		=> '',
		'display'		=> '',
		'extdisplay'	=> '',
		't38gateway'	=> 'no',
	);

	foreach ($get_vars as $k => $v) {
		$vars[$k] = isset($_REQUEST[$k]) ? $_REQUEST[$k] : $v;
	}
	switch ($vars['display']) {
		case 'routing':
			if ($vars['action'] == 'editroute') {
				faxpro_hook_core_put('routing',
					$vars['extdisplay'],
					$vars['t38gateway']);
			} elseif ($vars['action'] == 'delroute') {
				faxpro_hook_core_del('routing', $vars['extdisplay']);
			}
			break;
		default:
			break;
	}
}

function faxpro_hook_core_get($page, $id) {
	if (!$page || !$id) {
		return false;
	}
	global $db;
	$sql = 'SELECT status FROM faxpro_hook_core WHERE page = ? and id = ?';
	$ret = $db->getOne($sql, array($page, $id));
	db_e($ret);
	return empty($ret) ? 'no' : $ret;
}


function faxpro_hook_core_put($page, $id, $status) {
	global $db;

	$sql = 'REPLACE into faxpro_hook_core (page, id, status) VALUES (?, ?, ?)';
	$ret = $db->query($sql, array($page, $id, $status));
	db_e($ret);

	return true;
}

function faxpro_hook_core_del($page, $id) {
	global $db;

	$sql = 'DELETE FROM faxpro_hook_core where page = ? and id = ?';
	$ret = $db->query($sql, array($page, $id));
	db_e($ret);

	return true;
}

function faxpro_hook_devices() {
	global $CC, $faxpro;
	$get_vars = array(
		'extdisplay' => '',
	);

	foreach($get_vars as $k => $v) {
		$vars[$k] = isset($_REQUEST[$k]) ? $_REQUEST[$k] : $v;
	}
	$vars['status'] = faxpro_hook_core_get('devices', $vars['extdisplay']);

	//dont show gui options if were unregistered
	if (!$faxpro) {
		$CC->addguielem('', new gui_hidden('t38gateway', $vars['status']));
		return true;
	}

	$CC->addoptlistitem('t38opts', 'yes', _('Yes'));
	$CC->addoptlistitem('t38opts', 'no', _('No'));

	$CC->addguielem(_('Device Options'),
		new gui_selectbox('t38gateway',
		$CC->getoptlist('t38opts'),
		$vars['status'],
		_('T38 Gateway'),
		_('Set if this device should act as a t38 gateway'),
		false
		));
}

function faxpro_hookProcess_devices() {
	$get_vars = array(
		'action' 		=> '',
		'extdisplay'	=> '',
		't38gateway'	=> 'no'
	);

	foreach($get_vars as $k => $v) {
		$vars[$k] = isset($_REQUEST[$k]) ? $_REQUEST[$k] : $v;
	}

	switch ($vars['action']) {
		case 'edit':
			faxpro_hook_core_put('devices',
				$vars['extdisplay'],
				$vars['t38gateway']);
			break;
		case 'del':
			faxpro_hook_core_del('devices', $vars['extdisplay']);
			break;
		default:
			break;
	}
}
