<div class="col-md-10">
	<h3><?php echo _('Fax Settings')?></h3>
	<div class="faxsettings">
		<div id="message" class="alert" style="display:none;"></div>
		<form role="form">
			<div class="form-group">
				<label for="faxemail" class="help"><?php echo _('Fax Email')?> <i class="fa fa-question-circle"></i></label>
				<input name="faxemail" type="email" class="form-control" id="faxemail" value="<?php echo $user['faxemail']?>" placeholder="john@tdl.net" autocapitalize="off" autocorrect="off">
				<span class="help-block help-hidden" data-for="faxemail"><?php echo _('Enter an email address where faxes sent to this extension will be delivered.')?></span>
			</div>
			<div class="form-group">
				<label for="faxattachformat" class="help"><?php echo _('Attachment Format') ?> <i class="fa fa-question-circle"></i></label><br/>
				<select name="faxattachformat" id="faxattachformat" class="form-control">
					<?php foreach($faxattachformats as $key => $value) { ?>
						<option value="<?php echo $key?>" <?php echo ($user['faxattachformat'] == $key) ? 'selected' : '' ?>><?php echo $value?></option>
					<?php } ?>
				</select>
				<span class="help-block help-hidden" data-for="faxattachformat"><?php echo _('Formats to convert incoming fax files to before emailing.')?></span>
			</div>
			<div class="form-group checkbox-row">
				<label for="faxlocalstore1" class="help"><?php echo _('Store Locally?')?> <i class="fa fa-question-circle"></i></label>
					<div class="onoffswitch">
						<input type="checkbox" name="faxlocalstore" class="onoffswitch-checkbox" id="faxlocalstore" value="true" <?php echo ($user['faxlocalstore'] == 'true') ? 'checked' : ''?>>
						<label class="onoffswitch-label" for="faxlocalstore">
							<div class="onoffswitch-inner"></div>
							<div class="onoffswitch-switch"></div>
						</label>
					</div>
				<span class="help-block help-hidden" data-for="faxlocalstore1"><?php echo _('Chose this option to have faxes stored by the server; accessible via the ARI.')?></span>
			</div>
			<div class="form-group">
				<label for="faxstationid" class="help"><?php echo _('Outgoing Station ID')?> <i class="fa fa-question-circle"></i></label>
				<input name="faxstationid" type="text" class="form-control" id="faxstationid" value="<?php echo $user['faxstationid']?>" placeholder="" autocapitalize="off" autocorrect="off">
				<span class="help-block help-hidden" data-for="faxstationid"><?php echo _('The outgoing Fax Machine Identifier. This is usually your fax number.')?></span>
			</div>
			<div class="form-group">
				<label for="faxheader" class="help"><?php echo _('Outgoing Header')?> <i class="fa fa-question-circle"></i></label>
				<input name="faxheader" type="text" class="form-control" id="faxheader" value="<?php echo $user['faxheader']?>" placeholder="" autocapitalize="off" autocorrect="off">
				<span class="help-block help-hidden" data-for="faxheader"><?php echo _('The outgoing Fax Machine Headers. This usually contains the name of the person or entity sending the fax.')?></span>
			</div>
			<div class="form-group">
				<label for="faxcovername" class="help"><?php echo _('Coversheet Name')?> <i class="fa fa-question-circle"></i></label>
				<input name="faxcovername" type="text" class="form-control" id="faxcovername" value="<?php echo $user['faxcovername']?>" placeholder="" autocapitalize="off" autocorrect="off">
				<span class="help-block help-hidden" data-for="faxcovername"><?php echo _('The name that should appear on the outbound coversheet.')?></span>
			</div>
			<div class="form-group">
				<label for="faxcovertel" class="help"><?php echo _('Coversheet Telephone')?> <i class="fa fa-question-circle"></i></label>
				<input name="faxcovertel" type="tel" class="form-control" id="faxcovertel" value="<?php echo $user['faxcovertel']?>" placeholder="123456789" autocapitalize="off" autocorrect="off">
				<span class="help-block help-hidden" data-for="faxcovertel"><?php echo _('TThe Phone number that will appear on the cover sheet.')?></span>
			</div>
			<div class="form-group">
				<label for="faxcoveremail" class="help"><?php echo _('Coversheet Email')?> <i class="fa fa-question-circle"></i></label>
				<input name="faxcoveremail" type="email" class="form-control" id="faxcoveremail" value="<?php echo $user['faxcoveremail']?>" placeholder="john@tdl.net" autocapitalize="off" autocorrect="off">
				<span class="help-block help-hidden" data-for="faxcoveremail"><?php echo _('The email address that will appear on the coversheet.')?></span>
			</div>
			<div class="form-group">
				<label for="emailresults" class="help"><?php echo _('Email Results') ?> <i class="fa fa-question-circle"></i></label><br/>
				<select name="emailresults" id="emailresults" class="form-control">
					<option value="0"><?php echo _('Use Global Setting')?></option>
					<?php foreach($emailresults as $key => $value) { ?>
						<option value="<?php echo $key?>" <?php echo ($user['emailresults'] == $key) ? 'selected' : '' ?>> <?php echo $value?></option>
					<?php } ?>
				</select>
				<span class="help-block help-hidden" data-for="emailresults"><?php echo _('When to email the results of an outgoing fax.')?></span>
			</div>
			<div class="form-group">
				<label for="faxretries" class="help"><?php echo _('Retries') ?>  <i class="fa fa-question-circle"></i></label><br/>
				<select name="faxretries" id="faxretries" class="form-control">
					<option value="null"><?php echo _('Use Global Setting')?></option>
					<?php foreach($retries as $key => $value) { ?>
						<option value="<?php echo $key?>" <?php echo ($user['faxretries'] != '' && $user['faxretries'] == $key) ? 'selected' : '' ?>> <?php echo $value?></option>
					<?php } ?>
				</select>
				<span class="help-block help-hidden" data-for="faxretries"><?php echo _('Number of times to retry sending a failed fax.')?></span>
			</div>
			<div class="form-group">
				<button onclick="Faxpro.saveSettings();return false;">Save</button>
			</div>
		</form>
	</div>
</div>
