<?php
// vim: :set filetype=php tabstop=4 shiftwidth=4 autoindent smartindent:
// FIXME:  Add auth checking. This is NOT SECURE. AT ALL.  DO NOT RELEASE.
header('Content-type: application/json');
include_once 'functions.inc.php';
include_once 'functions.inc/functions.inc.php';

$ha = new freepbxHA;

$fakeit = false;

#if (!isset($_REQUEST['command'])) {
#	$_REQUEST['command'] = "moveapache";
#}

#checkIfDone();

if (!isset($_REQUEST['command'])) {
	print json_encode(array("status" => "No Command given"));
	exit;
}

try {
	switch ($_REQUEST['command']) {
		// Config Params.
	case 'setconf':
		if ($_REQUEST['value'] === "null" || $_REQUEST['value'] === "undefined") {
			$val = null;
		} else {
			$val = $_REQUEST['value'];
		}
		print json_encode($ha->setConfig($_REQUEST['data'], $val));
		break;

	case 'getconf':
		print json_encode($ha->getConfig($_REQUEST['data']));
		break;

	case 'getip':
		print json_encode(array("status" => "ok", "ip" => $ha->net->getSuggestedIP()));
		break;

	case 'getallstatus':
		$ret['getpcsstatus'] = $ha->cman->getAllStatus();
		$ret['drbd-a'] = $ha->drbd->getDrbdInfo('freepbx-a');
		$ret['drbd-b'] = $ha->drbd->getDrbdInfo('freepbx-b');
		$thisHost = $ha->hosts->getHostname();
		$otherHost = $ha->hosts->getOtherHostname();
		$ret['getnodestatus'] = array ( 
			"thishost" => $thisHost,
			"otherhost" => $otherHost,
			$thisHost => $ret['getpcsstatus'][$thisHost."_status"],
			$otherHost => $ret['getpcsstatus'][$otherHost."_status"],
		);
		print json_encode($ret);
		break;

	case 'getpcsstatus':
		print json_encode($ha->cman->getAllStatus());
		break;
	case 'discoverinterfaces':
		print json_encode($ha->net->discoverInterfaces(true));
		break;

		// Status Page
	case 'drbd-a':
		print json_encode($ha->drbd->getDrbdInfo('freepbx-a'));
		break;
	case 'drbd-b':
		print json_encode($ha->drbd->getDrbdInfo('freepbx-b'));
		break;
	case 'getnodestatus':
		$status = $ha->cman->getAllStatus();
		$thisHost = $ha->hosts->getHostname();
		$otherHost = $ha->hosts->getOtherHostname();
		$r = array ( 
			"thishost" => $thisHost,
			"otherhost" => $otherHost,
			$thisHost => $status[$thisHost."_status"],
			$otherHost => $status[$otherHost."_status"],
		);
		print json_encode($r);
		break;
	case 'clearerr':
		if (isset($_REQUEST['rsc']) && isset($_REQUEST['node'])) {
			print json_encode($ha->cman->crm_resource("--resource ".$_REQUEST['rsc']." --node ".$_REQUEST['node']." -C"));
		} else {
			print json_encode(array("status" => "invalid params for crm_resource"));
		}
		break;

		// Currently unimplemented. Checks to make sure IP address given is currently reachable,
		// but not in use.
	case 'checkip':
		if (isset($_REQUEST['ip']) && !filter_var($_REQUEST['ip'], FILTER_VALIDATE_IP)) {
			doOutput(array('status' => 'filterfail'));
			break;
		}
		// Do this first, as pinging causes iproute to SIGFPE
		$isroutable = $ha->net->checkLocalIP($_REQUEST['ip']);

		if ($ha->net->ping($_REQUEST['ip'])) {
			doOutput(array("status" => "inuse"));
			return;
		}
		if ($isroutable) {
			doOutput(array("status" => "ok"));
		} else {
			doOutput(array("status" => "unrouteable"));
		}
		break;

	case 'getconfigs':
		print json_encode($ha->getSuggestedConf());
		break;
	case 'routecheck':
		if ($ha->net->checkRoute($_REQUEST['net'])) {
			print json_encode(array("status" => "exists"));
		} else {
			print json_encode(array("status" => "passed"));
		}
		break;
	case 'topipcheck':
		print json_encode($ha->net->topIpCheck($_REQUEST['net']));
		break;
	case 'bottomipcheck':
		print json_encode($ha->net->bottomIpCheck($_REQUEST['net']));
		break;

		// This currently does a pretty weak attempt at rolling back
		// the HA changes.
	case 'rollback':
		$ha->destroyHA();
		print json_encode(array("status" => "whoknows"));
		break;

		// Joining a cluster
	case 'addnodeinfo':
		include_once 'functions.inc/hastatus.php';
		$status = new HaStatus;
		print json_encode($status->getInfo());
		break;

	case 'checkbase64':
		include_once 'functions.inc/joincluster.php';
		$jc = new JoinCluster;
		print json_encode($jc->checkBase64($_REQUEST['data']));
		break;

	// Management page.
	case 'togglenode':
		if (!isset($_REQUEST['node']))
			throw new Exception("Need to specify a node");

                $me = $ha->whichMachineIsThis();
                if ($me == "PRIMARY") {
			$thishost = "freepbx-a";
			$otherhost = "freepbx-b";
                } else {
                        $thishost = "freepbx-b";
                        $otherhost = "freepbx-a";
                }

		if (!$ha->cman->isNodeOnline($otherhost) && $_REQUEST['node'] != 'other') {
			print json_encode(array("status" => "Cannot set both nodes to standby"));
			break;
		}

		if ($_REQUEST['node'] == 'this') {
			$r = $ha->cman->toggleNode($thishost);
		} else { 
			$r = $ha->cman->toggleNode($otherhost);
		}
		print json_encode(array("status" => $r));
		break;

	// Checks
	// Pre-flight checks.
	case 'preflight':
		include_once 'functions.inc/preflight.php';
		$pf = new PreFlight();

		if (!isset($_REQUEST['runcheck'])) {
			print json_encode($pf->getPreFlightChecks());
			break;
		}
		if (false) { // if ($fakeit) { // Should never fake preflights.
			print json_encode(array("status" => "ok"));
			break;
		}
		if (method_exists($pf, $_REQUEST['runcheck'])) {
			doOutput($pf->$_REQUEST['runcheck']($_REQUEST));
			break;
		}
		print json_encode(array("status" => "unimplemented"));
		break;

	// Join a cluster.
	case 'join':
		include_once 'functions.inc/joincluster.php';
		$jc = new JoinCluster;
		if (!isset($_REQUEST['runcheck'])) {
			print json_encode($jc->getJoinStuff());
			break;
		}
		if ($fakeit) {
			print json_encode(array("status" => "ok"));
			break;
		}
		if (method_exists($jc, $_REQUEST['runcheck'])) {
			doOutput($jc->$_REQUEST['runcheck']($_REQUEST));
			break;
		}
		print json_encode(array("status" => "unimplemented"));
		break;

	case 'dojoin':
		include_once 'functions.inc/joincluster.php';
		$jc = new JoinCluster;
		if (!isset($_REQUEST['runcheck'])) {
			print json_encode($jc->doJoin());
			break;
		}
		if (method_exists($jc, $_REQUEST['runcheck'])) {
			doOutput($jc->$_REQUEST['runcheck']($_REQUEST));
			break;
		}
		print json_encode(array("status" => "unimplemented"));
		break;

	// Creating a new cluster.
	case 'stage2':
		include_once 'functions.inc/stage2.php';
		$stage2 = new stage2;
		if (!isset($_REQUEST['runcheck'])) {
			print json_encode($stage2->getNewSetup());
			break;
		}
		if ($fakeit) {
			print json_encode(array("status" => "ok"));
			break;
		}
		if (method_exists($stage2, $_REQUEST['runcheck'])) {
			doOutput($stage2->$_REQUEST['runcheck']());
			break;
		}
		print json_encode(array("status" => "unimplemented"));
		break;

	case 'stage3':
		include_once 'functions.inc/stage3.php';
		$stage3 = new stage3;
		if (!isset($_REQUEST['runcheck'])) {
			print json_encode($stage3->getNewSetup());
			break;
		}
		if ($fakeit) {
			print json_encode(array("status" => "ok"));
			break;
		}
		if (method_exists($stage3, $_REQUEST['runcheck'])) {
			doOutput($stage3->$_REQUEST['runcheck']());
			break;
		}
		print json_encode(array("status" => "unimplemented"));
		break;

	case 'checks':
		include_once 'functions.inc/checks.php';
		$checks = new checks;
		if (!isset($_REQUEST['runcheck'])) {
			print json_encode($checks->getChecks());
			break;
		}
		if ($fakeit) {
			print json_encode(array("status" => "ok"));
			break;
		}
		if (method_exists($checks, $_REQUEST['runcheck'])) {
			doOutput($checks->$_REQUEST['runcheck']());
			break;
		}
		print json_encode(array("status" => "unimplemented"));
		break;

	// This is the tricky one.
	case 'moveapache':
		if ($fakeit) {
			print json_encode(array("status" => "ok"));
			exit;
		}
		// This is tricky. Run the actual script in the background, nohupped.
		// as it's going to kill me. 
		$fn = dirname(__FILE__)."/../moveapache.php";
		`nohup $fn > /tmp/apachemove.log 2>&1 &`;
		// Now all we can do is die. In fact, I'm probably already dead.
		break;

	// Ensure that FreePBX is working.
	case 'checkfreepbx':
		include '/etc/freepbx.conf';
		global $db;
		if (isset($db)) {
			print json_encode(array("status" => "ok"));
			break;
		} else {
			print "Error\n";
			break;
		}
		
	// Handle upgrades
	case 'doupgrade':
		doOutput(array("status" => "ok", "data" => $ha->update->doUpgrade()));
		break;

	// Fencing
	case 'getfencing':
		doOutput(array("status" => "ok", "data" => $ha->fencing->getAllFencing(), "fstatus" => $ha->fencing->getFencingStatus()));
		break;
	case 'updatefencing':
		doOutput($ha->fencing->updateFencing($_REQUEST));
		break;
	case 'getfencestatus':
		doOutput($ha->fencing->getFenceStatus($_REQUEST['node']));
		break;
	case 'checkfencing':
		$f = $_REQUEST['fencingparams'];
		$f['node'] = $_REQUEST['node'];
		doOutput($ha->fencing->checkFencing($f));
		break;
	case 'fence':
		doOutput($ha->fencing->doFence($_REQUEST));
		break;

	// VMware Fencing
	case 'vmwareListGuests':
		doOutput($ha->fencing->vmwareListGuests($_REQUEST));
		break;

	// Digium R-Series
	case 'rdisable':
		doOutput($ha->rseries->delRseries($_REQUEST['id']));
		break;
	case 'renable':
		doOutput($ha->rseries->addRseries($_REQUEST['id']));
		break;
	case 'rswitch':
		doOutput($ha->rseries->switchRseries($_REQUEST['id']));
		break;

	// Alerts
	case 'getsmtp':
		doOutput($ha->alerts->getExtern('ClusterMon-SMTP'));
		break;
	case 'getsnmp':
		doOutput($ha->alerts->getExtern('ClusterMon-SNMP'));
		break;
	case 'updatesmtp':
		doOutput($ha->alerts->updateSMTP($_REQUEST['val']));
		break;
	case 'updatesnmp':
		doOutput($ha->alerts->updateSNMP($_REQUEST['val']));
		break;
	case 'removesmtp':
		doOutput($ha->alerts->removeSMTP());
		break;
	case 'removesnmp':
		doOutput($ha->alerts->removeSNMP());
		break;

	default:
		print json_encode(array("status" => "Unknown command '".$_REQUEST['command']."'"));
	}
} catch (Exception $e) {
	doOutput(array("status" => "failed", "message" => $e->getMessage()));
}

function doOutput($arr) {
	global $ha;
	//if ($_REQUEST['runcheck'] != "waitmysql" && $_REQUEST['runcheck'] != "movemysql")
	//	$ha->setConfig("inst_".$_REQUEST['command']."_".$_REQUEST['runcheck'], json_encode($arr));
	$fh = fopen("/tmp/ajax.log", "a");
	fwrite($fh, json_encode($_REQUEST)." -- Result: ".json_encode($arr)."\n");
	fclose($fh);

	print json_encode($arr);
}

function checkIfDone() {
	global $ha;
	if (!isset($_REQUEST['runcheck']))
		return;

	if ($_REQUEST['command'] == "dojoin")
		return;

	// If MySQL is down, don't try to do anything.
	if ($_REQUEST['runcheck'] == "waitmysql" || $_REQUEST['runcheck'] == "movemysql")
		return;
	$res = $ha->getConfig("inst_".$_REQUEST['command']."_".$_REQUEST['runcheck']);
	$j = json_decode($res, true);
	// If it already ran sucessfully, don't try to do it again.
	if ($j['status'] == 'ok') {
		print $res;
		exit;
	}
}

