<?php
// vim: :set filetype=php tabstop=4 shiftwidth=4 autoindent smartindent:

class FileMgr {

	private $files = array ( "iSymphonyServer", "clustermon.sh", "Filesystem", "cluster.py", "freepbx_engine_hook_highavail");
	private $copyto = array ( 
		"iSymphonyServer" => "/etc/init.d/iSymphonyServer",
		"Filesystem" => "/usr/lib/ocf/resource.d/heartbeat/Filesystem",
		"clustermon.sh" => "/usr/local/asterisk/clustermon.sh",
		"freepbx_engine_hook_highavail" => "/var/lib/asterisk/bin/freepbx_engine_hook_highavail",
	);
	private $copiedfiles = array ( );
	private $prefix = "/var/www/html/admin/modules/freepbx_ha/files/";

	public function  __construct($file = null) {
		// No licence checking in this file.

		// Only run as root.
		if (posix_getuid() == 0) {
			if ($file == null) {
				$this->copyAll();
			} else {
				$this->copyFile($file);
			}
		}
	}

	public function getCopied() {
		return $this->copiedfiles;
	}

	private function copyFile($file = null) {
		if ($file == null)
			throw new Exception("No File given to copyFile");

		if (!in_array($file, $this->files))
			throw new Exception("$file is not a known file to copy");

		array_push($this->copiedfiles, $file);

		$fn = preg_replace("/[^a-zA-Z0-9]/", "", $file);
		if (method_exists($this, $fn)) {
			$this->$fn();
		} else if (isset($this->copyto[$file])) {
			copy($this->prefix.$file, $this->copyto[$file]);
			chmod($this->copyto[$file], 0755);
		} else {
			throw new Exception("Don't know how to handle $file");
		}
	}

	private function copyAll() {
		foreach ($this->files as $f) 
			$this->copyFile($f);
	}

	private function clusterpy() {

		// First, make sure we WANT to update it.
		$s = stat("/usr/lib/python2.6/site-packages/pcs/cluster.py");

		if ($s['size'] == "15248") {
			// 0.9.26 rpm
			return;
		} elseif ($s['size'] == "25204") {
			// Patched 0.9.90 rpm
			return;
		} elseif ($s['size'] == "25207") {
			// 0.9.90 rpm (broken)
			copy($this->prefix."cluster.py", "/usr/lib/python2.6/site-packages/pcs/cluster.py");
		} else {
			throw new Exception ("Unknown version of PCS installed. Please check for module update");
		}
	}
}

