<?php
// vim: :set filetype=php tabstop=4 shiftwidth=4 autoindent smartindent:

class Conf {

	private $conf;

	public function __construct($conf = null) {
		/* if (!function_exists('freepbxha_licensed') || !freepbxha_licensed())
			throw new Exception("License violation in ".__FILE__); */

		$this->parse_fpbx_conf($conf);

	}

	public function updateFpbxConf($password = null, $host = "mysql") {

		if ($password == null)
			throw new Exception("Blank password given for MySQL");

		include_once 'incron.php';
		$i = new incron;

		$newconf = array('AMPDBHOST' => $host, 'AMPDBPASS' => $password);
		$i->updateFpbxConf($newconf);
		return true;
	}

	public function getConf($var) {
		return $this->conf[$var];
	}

	public function parse_fpbx_conf($conf = null) {
		// Grab stuff from /etc/freepbx.conf (or whatever)
		if ($conf == null || !file_exists($conf)) {
			if (file_exists('/etc/freepbx.conf')) {
				$conf = '/etc/freepbx.conf';
			} else {
				if (file_exists(getenv('FREEPBX_CONF'))) {
					$conf = getenv('FREEPBX_CONF');
				} else {
					throw new Exception('Unable to locate FreePBX Configuration');
				}
			}
		}

		$fh = fopen($conf, "r");

		while (($line = fgets($fh)) !== false) {
			if (preg_match('/\[(.+)\](?:.+)=(.+);/', $line, $res)) {
				$varname = preg_replace("/'/", "", $res[1]);
				$val = preg_replace("/'/", "", trim($res[2]));
				if ($val != "")
					$retarr[$varname] = $val;
			}
		}
		$this->conf = $retarr;
		return $retarr;
	}

}
