<?php
// vim: :set filetype=php tabstop=4 shiftwidth=4 autoindent smartindent:

// Small script that shuts down apache, disables it, and adds it to the cluster.
// If, after 60 seconds-ish, apache isn't back up again, try to revert any
// changes that have been made.

define('inside_moveapache', true);
if (!function_exists('freepbxha_licensed')) {
	function freepbxha_licensed() { return true; }
}

$rsync = true;
if (isset($argv[1])) {
	$rsync = false;
	print "Secondary\n";
} else {
	print "Primary\n";
}

include_once "functions.inc.php";

$ha = new freepbxHA;

if (posix_getuid() != 0) {
	print "Not running as root\n";
	$ha->incron->moveApache($rsync);
	exit;
}

print "Running as root\n";
// Right, we're running as root now. Aww yis.

// Grab all the objects that are needed later.
$update = $ha->update;
$mysql = $ha->database;
$packages = $ha->packages;
$cman = $ha->cman;
$moveservices = $ha->moveservices;
$incron = $ha->incron;

$moveservices->rsync = $rsync;

print "Stopping httpd\n";
exec('/etc/init.d/httpd stop');
print "Disabling httpd\n";
exec('/sbin/chkconfig httpd off');
print "Enabling pacemaker\n";
exec('/sbin/chkconfig pacemaker on');
// You've had to chance to die nicely. 
print "Murdering httpd\n";
exec('pidof httpd | xargs kill -9 > /dev/null 2>&1');
print "Starting pacemaker\n";
exec('/etc/init.d/pacemaker start');

// Wait for the cluster to be visible on this node.
$z = `pcs status | grep Online:`;

$count = 0;
while (!isset($z)) {
        if ($count > 20) {
                // Rollback. Abort. Start local stuff up.
		print "Didn't start after 20 attempts\n";
                throw new Exception ("It didn't start. This is bad");
        }
        print "Not found\n";
        $z = `pcs status | grep Online:`;
        $count++;
}
print "Cluster is up\n";

print "Clustering httpd\n";
$moveservices->root_moveService('httpd', $rsync);
$cman->linkServiceToCluster('httpd');

print "Waiting for httpd\n";
if ($cman->waitForService('httpd_service') == false) {
	// Shit. Rollback. TODO.
}

print "Upgrading Cluster\n";
// Upgrade the Cluster if required
try { $ha->update->doUpgrade(); print "Upgraded\n"; } catch (Exception $e) { print "Failed - ".$e->getMessage()."\n"; }


