<?php
// vim: :set filetype=php tabstop=4 shiftwidth=4 autoindent smartindent:

class passwd {

	public function __construct() {
		/* if (!function_exists('freepbxha_licensed') || !freepbxha_licensed())
			throw new Exception("License violation in ".__FILE__); */
	}

	public function updateHome($user, $home) {

		// First, lets see if that user already has this home.
		if ($this->getHome($user) == $home) 
			return true;

		if (posix_getuid() != 0) {
			// Get root?
			throw new Exception("Sorry, not running as root.");
		}

		$pw = $this->getPasswdFile();
		$pw['asterisk'][5] = $home;
		$pw['asterisk'][6] = "/bin/bash";
		$this->writePasswdFile($pw);
		if ($this->getHome($user) != $home) {
			// Shit. Something bad happened. Put the copy back, and throw an exception.
			unlink('/etc/passwd');
			copy('/etc/passwd.bak', '/etc/passwd');
			throw new Exception("Unable to update home directory for user $user");
		}
		@mkdir($home);
		chown($home, $user);
		chmod($home, 0700);
		return true;
	}

	public function getHome($user) {
		$arr = posix_getpwnam($user);
		return $arr['dir'];
	}

	private function getPasswdFile() {
		$f = file("/etc/passwd");
		foreach ($f as $l) {
			$line = explode(":", trim($l));
			$retarr[$line[0]] = $line;
		}
		return $retarr;
	}

	private function writePasswdFile($p) {
		// Copy /etc/passwd to /etc/passwd.bak
		if (!copy("/etc/passwd", "/etc/passwd.bak"))
			throw new Exception('Unable to back up /etc/passwd');

		$fh = fopen("/etc/passwd", "w");
		foreach ($p as $l) {
			fwrite($fh, join(":", $l)."\n");
		}
	}

	public function getAsteriskUID() {
		$pw = posix_getpwnam("asterisk");
		return $pw['uid'];
	}
}
