<?php
@define('INSIDE_TESTS', true);

if (!function_exists('z')) {
	        function z($arr) { return ($arr['ret'] == 1); }
}

class systemTest extends PHPUnit_Framework_TestCase {

	protected $obj;

	public static function setUpBeforeClass() {
		$hosts = "# Comment.
::1         localhost
1.2.3.5     spaces spaces1 spaces2
1.2.3.6		tabs	tabs1	tabs2
  1.2.3.7	leading space is valid";
		@unlink("/tmp/hosts");
		file_put_contents("/tmp/hosts", $hosts);
	}

	protected function setUp() {
		include_once('hosts.php');
		$this->obj = new Hosts();
		$this->obj->hf = "/tmp/hosts";
		
	}

	public function testAddRemoveHosts() {
		$this->assertTrue(z($this->obj->addHost("fakehost", "1.2.3.4")), "Unable to add fakehost");
		$this->assertTrue(z($this->obj->removeHost("fakehost")), "Unable to remove fakehost");
		$this->assertFalse(z($this->obj->removeHost("fakehost")), "Able to remove fakehost twice");
		$this->assertTrue(z($this->obj->removeHost("spaces2")), "unable to remove spaces2");
		$this->assertTrue(z($this->obj->addHost("spaces2", "1.2.3.7")), "unable to add spaces2");
		$this->assertTrue(z($this->obj->addHost("spaces3", "1.2.3.7")), "unable to add spaces3");
	}

	public function testHostname() {
		$this->assertTrue($this->obj->getHostname() != false, "Unable to get current hostname");
		$hostname = $this->obj->getHostname();
		$this->assertTrue(z($this->obj->setHostname("testhostname")), "Unable to set hostname to testhostname");
		$this->assertEquals("testhostname", $this->obj->getHostname(), "Returned hostname incorrect");
		$this->obj->setHostname($hostname);
	}

}
