<?php
@define('INSIDE_TESTS', true);

class packagesTest extends PHPUnit_Framework_TestCase {

	protected $obj;
	protected $packages;

	protected function setUp() {
		include_once('functions.inc.php');
		include_once('packages.php');
		$this->obj = new Packages();
		$freepbxha = new freepbxHA();
		$defaults = $freepbxha->generateConfig();
		$this->packages = explode(" ", $defaults['PACKAGES']);
	}

	public function testCheckModulesAndPackages() {
		$this->assertFalse($this->obj->packageIsInstalled("fakepackage"), 'Fake package is installed');
		$this->assertTrue($this->obj->packageIsInstalled("sysadmin"), 'Sysadmin package is not installed');
	}

	public function testInstallPackages() {

		/* DISABLED REMOVING, takes too long. It works though. */
		/*
		// Make sure the required packages aren't on the system
		foreach ($this->packages as $package) {
			$this->obj->removePackage($package);
		} */
		foreach ($this->packages as $package) {
			$this->assertTrue($this->obj->installPackage($package), "Unable to install $package");
			// $this->assertTrue($this->obj->removePackage($package), "Unable to uninstall $package");
		}
	}
}
