<?php
@define('INSIDE_TESTS', true);

class sshTest extends PHPUnit_Framework_TestCase {

	protected $obj;

	protected function setUp() {
		include_once("ssh.php");
		$this->obj = new SSH();
		$this->obj->ak="/tmp/authorized_keys";
		$this->obj->pub="/tmp/id_rsa.pub";
		$this->obj->priv="/tmp/id_rsa";
		@unlink($this->obj->ak);
		@unlink($this->obj->pub);
		@unlink($this->obj->priv);
	}

	public function testSSH() {
		$this->assertTrue($this->obj->genSSHkey(), "Unable to generate SSH Key");
		$this->assertFalse($this->obj->genSSHkey(), "Able to generate SSH key twice");
		$this->assertNotNull($this->obj->getSSHkey(), "Unable to get the current SSH key");
		$this->assertTrue($this->obj->injectSSHkey($this->obj->getSSHkey()), "Unable to add this ssh key to authorized_hosts");
		$filelength = filesize($this->obj->ak); 
		$this->obj->injectSSHkey($this->obj->getSSHkey());
		$newfilelength = filesize($this->obj->ak); 
		$this->assertEquals($newfilelength, $filelength, "File sizes changed after inserting the same key twice");
		$this->assertTrue($this->obj->removeSSHkey($this->obj->getSSHkey()), "Unable to remove correct ssh key");
		$this->assertFalse($this->obj->removeSSHkey($this->obj->getSSHkey()), "Able to remove correct ssh key twice");
		$this->assertFalse($this->obj->removeSSHkey("TotallyFakeRSAkey"), "Able to remove non-existing SSH key");
	}
}
