<?php
// @define('INSIDE_TESTS', true);

class stage2Test extends PHPUnit_Framework_TestCase {

	protected $obj;

	public static function setUpBeforeClass() {
		include_once('stage2.php');
		include_once('functions.inc.php');
		$ha = new freepbxHA;
		$ha->destroyHA();
		$ha->getConfig('SERVICES'); // Just to create the tables
		$ha->setConfig("internalnet", "172.16.1.0/24");
		$ha->setConfig("PRIMARY_int", "eth0:0");
		$ha->setConfig("floatingip", "10.40.2.99");
	}


	public static function tearDownAfterClass() {
		unlink('/etc/sysconfig/network-scripts/ifcfg-eth0:0');
		`ifconfig eth0:0 0.0.0.0 2>/dev/null`;
	}

	protected function setUp() {
		$this->obj = new stage2();
	}

	public function testAssignIP() {

		$this->assertFileNotExists('/etc/sysconfig/network-scripts/ifcfg-eth0:0', "ifcfg file already exists.");
		$this->assertContains('ok', $this->obj->assignprivip_primary(), "assignpriv failed");
		$this->assertFileExists('/etc/sysconfig/network-scripts/ifcfg-eth0:0', "ifcfg file wasn't created");
	}

	public function testHostname() {
                include_once('hosts.php');
                $h = new Hosts;
                $h->setHostname('unknownname');
		$this->obj->changehostname();
		$this->assertEquals("freepbx-a", $h->getHostname(), "Hostname was not correctly set");
	}

	public function testStartIP() {
		$this->assertContains('ok', $this->obj->startip_primary(), "startip failed");

	}

	public function testCheckIP() {
		$this->assertContains('ok', $this->obj->checkip_primary(), "checkip failed");
	}

	public function testStartCluster() {
		$this->assertContains('ok', $this->obj->configcman(), "configcman failed");
		$this->assertContains('ok', $this->obj->startcman(), "startcman failed");
		$this->assertContains('ok', $this->obj->startpacemaker(), "startpacemaker failed");
		$this->assertContains('ok', $this->obj->startcman(), "startpacemaker failed");
		$this->assertContains('ok', $this->obj->waitfornode(), "waitfornode failed");
		$this->assertContains('ok', $this->obj->configpacemaker(), "configpacemaker failed");
	}

	public function testIPs() {
		$this->assertContains('ok', $this->obj->createservices(), "createservices failed");
		$this->assertContains('ok', $this->obj->assignclusterip(), "assignclusterip failed");
	}
}
