<?php
// vim: set filetype=php tabstop=4 shiftwidth=4 autoindent smartindent:

if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

fixhtaccess(); // Remove this when we have a proper ajax interface.

require_once("functions.inc/functions.inc.php");

if (!function_exists('freepbxha_licensed') || !freepbxha_licensed()) {
	include("views/unconfigured.php");
	return;
}

$ha = new freepbxHA;

$is = $ha->getConfig('installstate');

// Check first for a parameter. IF you've provided a param, use that. Otherwise
// just keep going.
if (isset($_REQUEST['action']))  {
	switch ($_REQUEST['action']) {
	case "status":
		include("views/status.php");
		break;
	case "newinstall":
		include("views/newinstall.php");
		break;
	case "stage2":
		include("views/stage2.php");
		break;
	case "stage3":
		include("views/stage3.php");
		break;
	case "join":
		include("views/join.php");
		break;
	case "view":
		include("views/view.".$_REQUEST['viewname'].".php");
		break;
	case "testme":
		header('Content-type: application/json');
		print json_encode(array("status" => "success"));
		break;
	default:
		include("views/unconfigured.php");
	}
} elseif (isset($is)) {
	switch ($is) {
	case "newmachine":
		$ha->newMachineAdded();
		// No break, display status.
	case "status":
	case "firstview":
	case "complete":
		include("views/status.php");
		break;
	case "newinstall":
		include("views/newinstall.php");
		break;
	case "stage2":
		include("views/stage2.php");
		break;
	case "stage3":
		include("views/stage3.php");
		break;
	default:
		include("views/unconfigured.php");
	}
} else {
	include("views/unconfigured.php");
}

function fixhtaccess() {
	$fh = fopen("/var/www/html/admin/.htaccess", "r");
	$modified = false;
	while ($line = fgets($fh)) {
		if (preg_match('/FilesMatch.+index.+config.+/', $line)) {
			if (!preg_match('/ajax/', $line)) {
				$output[] = '<FilesMatch "(^$|index\.php|config\.php|ajax\.php|\.(gif|GIF|jpg|jpeg|png|css|js|swf|txt|ico|ttf|svg|eot|woff)$)">'."\n";
				$modified = true;
			} else {
				$output[] = $line;
			}
		} else {
			$output[] = $line;
		}
	}
	if ($modified) {
		file_put_contents("/var/www/html/admin/.htaccess", implode("", $output));
	}
}
