<?php
// vim: :set filetype=phtml tabstop=4 shiftwidth=4 autoindent smartindent:
// Stuff. Zend. Copyright. Blah.
?>

<h3>Starting FreePBX High-Availablity Setup</h3>

<?php
$ajaxurl = "//".$_SERVER['HTTP_HOST']."/admin/modules/freepbx_ha/ajax.php";
?>


<div class='maindiv'>
<!-- This is recycling CSS stuff from Advanced Settings -->
<div class="dialogbox" id="box1" title="<?php echo _("Warning!"); ?>">
  <p>
<?php
echo _("This will make changes to this machine.")." ";
echo _("If you click 'Continue', the Corosync and Pacemaker services will be started,")." ";
echo _("and the Floating IP Address will be assigned to this machine.")." ";
echo _("This should not cause any issues, but we recommend you do not do this on a machine that is processing calls.")." ";
echo _("If you are ready to proceed, click 'Contine'");
?>
  </p>
</div>

<div class="dialogbox" id="box2" title="<?php echo _("Warning!"); ?>">
  <p>
<?php
echo _("You will now be redirected to the new floating IP address you specified.")." ";
echo _("If this times out, or doesn't work, you can reconnect to this current address and click 'Abort'.")." ";
echo _("That will attempt to revert all changes done, and you can check the IP address you supplied and start again.")." ";
echo _("If you are having further problems with this, please contact support.");
echo _("You will need to log in again.");
?>
  </p>
</div>

<div>
You need to have a new, floating IP address. This address moves between machines, and will move to the other machine if this
one fails. This is the IP address you will use in your phones, and to manage FreePBX
</div>

<div id='stage1'>
  <span class='left'> 
    <a href="javascript:void(null)" class="info">Floating IP Address
      <span>This IP Address must be a new, unused, IP address on your current network </span>
    </a>
  </span>
  <span class='right'>
    <input class="txtinput" id="floating_ip" type="text" size="15"> &nbsp;
    <img src="/admin/images/blank.gif" data-status="checking" id="ipcheckimg">
    <span id="iptext"></span>
  </span>
  <span class='left hidden'>
    Suggested PUBLIC Interface:
    <a class='info'><span>This is the interface that will be exposed to the client devices (eg, phones)</span></a>
  </span>
  <span class='right hidden' id='externalint'></span>
  <span class='left hidden'>
     Suggested PRIVATE Interface
    <a class='info'><span>This is the network used for communications between the two servers. It's normally
    a crossover cable.</span></a>
  </span>
  <span class='right hidden' id='internalint'></span>
  <span class='left hidden'>
     Internal Network
    <a class='info'><span>This is generated randomly, and should not be in use on your current network.</span></a>
  </span>
  <span class='right hidden'><span id='internalnet'></span><span id='neterror'></span></span>
</div>

<p />
<p />
<div class='bp'>
  <span class='left' style='width: 95%'>
    <span class="button endbuttons" onclick="continueSetup()" style='display: none'><?php echo _('Continue Setup')?></span>
    <span class="button endbuttons errors" onclick="changeSettings()" style='display: none'><?php echo _('Change Settings')?></span>
    <span class="button recheck errors" onclick="rollbackHA()" style='display: none'><?php echo _('Remove HA')?></span>
    <span class="button recheck" onclick="reCheckSetup()" style='display: none'><?php echo _('Re-Check')?></span>
  </span>
</div>

</div>
<script type='text/javascript'>
var ajaxurl = "<?php echo $ajaxurl; ?>";
$(document).ready(function() { window.confqueue = 0; startStage2(); });

function startStage2() {
	setConfig('installstate', 'stage2');
	getIP();
	$("#floating_ip").on('input paste keyup', function() { handleKeypress(function() { checkIP() }); });
	$("#floating_ip").focus();
}

function getIP() {
	// Ask for the suggested IP address
	$.ajax({
		url: ajaxurl,
		data: { command: "getip" },
		success: function(data) {
			$("#floating_ip").val(data['ip']);
			$("#floating_ip").removeAttr('disabled');
			checkIP();
		}
	});
}

function checkIP() {
	// Ajax query if this IP address is sane.
	if (typeof(window.ipcheck) != 'undefined') {
		window.ipcheck.abort();
	}
	$("#ipcheckimg").attr('src', '/admin/images/spinner.gif');
	$(".hidden").hide();
	$(".button").hide();
	window.ipcheck = $.ajax({
		url: ajaxurl,
		data: { command: "checkip", ip: $("#floating_ip").val() },
		success: function(data) {
			if (data['status'] == "ok") {
				$("#ipcheckimg").attr('src', '/admin/images/accept.png');
				$("#iptext").text("");
				getConfigPage();
			} else if (data['status'] == "filterfail") {
				$("#ipcheckimg").attr('src', '/admin/images/blank.gif');
				$("#iptext").text("");
				$(".hidden").hide();
				$(".ha-button-start").hide();
			} else if (data['status'] == "inuse") {
				$("#ipcheckimg").attr('src', '/admin/images/cancel.png');
				$("#iptext").text("IP Address allready active");
			} else if (data['status'] == "unrouteable") {
				$("#ipcheckimg").attr('src', '/admin/images/notify_error.png');
				$("#iptext").text("This IP Address may not be routable.");
				getConfigPage();
			} else {
				// No idea what I was given.
				$("#ipcheckimg").attr('src', '/admin/images/blank.gif');
				$("#iptext").text("");
			}
		},
	});
}

function getConfigPage() {
	// We're here because the IP Address has validated, and now we need to get the 
	// suggested config via ajax.
	if ($("#externalint").is(":hidden")) {
		$("#stage1").after("<span class='left' id='pleasewait'><?php echo _("Please wait, generating configuration..."); ?></span>");
	}
	$.ajax({
		url: ajaxurl,
		data: { command: "getconfigs" },
		success: function(data) { displayConfig(data); },
		error: function(data) { configError(data); }
}); 
}

function configError(data) {
	$("#pleasewait").html("<strong>Something bad happened, please contact support to proceed</strong>");
	consle.log(data);
}
	
function displayConfig(data) {
	$("#pleasewait").remove();
	$(".hidden").show();
	$("#externalint").html("<span>"+data['externalint']+"</span><span id='externalips'></span>");
	$("#externalint").data("int", data['externalint']);
	if (typeof(data['interfaces'][data['externalint']][1]) == "undefined") {
		// Only one IP address on that interface
		console.log("Single");
		// $("#externalips").text("(IP Address "+data['interfaces'][data['externalint']][0][0]+")");
	} else {
		// More than one IP Address
		var h = "(Addresses: ";
		$.each(data['interfaces'][data['externalint']], function(i, v) {
				h += v[0]+", ";
		});
		// Strip off the last ", ";
		h = h.slice(0, -2);

		h += ")";
		// $("#externalips").text(h);
	}
	$("#internalnet").html("<span>"+data['internalnet']+"</span><span id='internalchecks'></span>");
	$("#internalnet").data('net', data['internalnet']);
	$("#internalint").html("<span>"+data['internalint']+"</span><span id='internalips'></span>");
	$("#internalint").data('int', data['internalint']);
	var h = "<img id='routecheck' src='/admin/images/bullet.png'> &nbsp; ";
	h += "<img id='topipcheck' src='/admin/images/bullet.png'> &nbsp; ";
	h += "<img id='bottomipcheck' src='/admin/images/bullet.png'>";
	$("#internalchecks").html(h);
	checkInternal();
}

function reCheckSetup() {
	// Called by button after they've changed stuff.
	$(".hidden").hide();
	$(".ha-button-start").hide();
	var intnet = $("#internalnet>input").val();
	var intint = $("#internalint>select").val(); 
	var extint = $("#externalint>select").val(); 
	var fip = $("#floating_ip").val();
	setConfig("internalnet", intnet);
	setConfig("PRIMARY_int", intint);
	setConfig("PRIMARY_extint", extint);
	setConfig("floatingip", fip, function() { getConfigPage(); });
}

function checkInternal() {

	$.each([ 'routecheck', 'topipcheck', 'bottomipcheck' ], function(i, v) { $("#"+v).data('status', 'pending'); });

	$.each([ 'routecheck', 'topipcheck', 'bottomipcheck' ], function(i, v) {
		$.ajaxQueue({
			beforeSend: function() { $("#"+v).attr('src', '/admin/images/spinner.gif'); },
			url: ajaxurl,
				data: { command: v, net: $("#internalnet").data('net') },
				success: function(data) {
					if (data['status'] == 'noanswer' || data['status'] == 'passed') {
						$("#"+v).attr('src', '/admin/images/bullet_checked.png');
						$("#"+v).data('status', 'ok');
					} else {
						$("#"+v).attr('src', '/admin/images/cancel.png');
						$("#"+v).data('status', 'failed');
						$("#neterror").text(data['message']);
					}
					checkSuccess();
				}
		});
	});
}

function checkSuccess() {
	var state = true;
	var pending = false;
	$.each([ 'routecheck', 'topipcheck', 'bottomipcheck' ], function(i, v) {
		if ($("#"+v).data('status') == "failed") {
			state = false;
		}
		if ($("#"+v).data('status') == "pending") {
			state = false;
			pending = true;
		}
	});
	if (state) {
		$(".endbuttons").show();
	}

	if (!pending && !state) {
		// Something failed. Only show 'Retry'
		$(".errors").show();
	}
}

function continueSetup() {
	// This is called when someone clicks on the 'Continue' button.
	// Pop up the dialog and let them actually do it.
	$("#box1").dialog({
		resizable: false,
		modal: true,
		buttons: {
			"<?php echo _("Cancel");?>": function() { $(this).dialog("close"); },
			"<?php echo _("Continue");?>": function() { $(this).dialog("close"); setVars(); },
		},
	});
}

function setVars() {
	// Right, we're good to go. 
	var ei = $("#externalint").data('int');
	var net = $("#internalnet").data('net');
	var ii = $("#internalint").data('int'); 
	var fip = $("#floating_ip").val();
	setConfig("internalnet", net);
	setConfig("PRIMARY_int", ii);
	setConfig("PRIMARY_extint", ei); // Note: We don't actually use this anywhere. 
	setConfig("floatingip", fip);
	proceedSetup();
}

function proceedSetup() {
	$("h3").text("Continuing Setup");
	$("#box2").nextAll().remove(); 
	$("#box2").after("<div class='states firststage'><p>Configuring this machine:</p></div>");
	getChecks('stage2', function() { checkStage3() });
}

function checkStage3() {
	var complete = true;
	var pending = false;
	$.each($(".states"), function() {
		if (typeof($(this).data('complete')) != 'undefined' && $(this).data('complete') != true) {
			complete = false;
		}
		if (typeof($(this).data('pending')) != 'undefined' && $(this).data('pending') != false) {
			pending = true;
		}
	});

	console.log("Pending is "+pending+" and complete is "+complete);

	if (!pending) {
		var h ='<p /><p /><div class="bp"><span class="left" style="width: 95%"><span class="button stage2buttons" onclick="rollbackHA()" style="display: none"><?php echo _('Abort Setup')?></span> ';
		h += '<span class="button stage2buttons" id="stage2ok" onclick="showBox2()" style="display: none"><?php echo _('Continue Setup')?></span></span></div>';
		$(".states").last().after(h);
		$(".stage2buttons").show();
	}
}

function showBox2() {
	$("#box2").dialog({
		resizable: false,
		modal: true,
		buttons: {
			"<?php echo _("Abort");?>": function() { $(this).dialog("close"); rollbackHA(); },
			"<?php echo _("Continue");?>": function() { $(this).dialog("close"); stage3(); },
		},
	});
}

function stage3() {
	setConfig('installstate', 'stage3');
	getConfig('floatingip', function(data) {
		var u = window.location.protocol+"//"+data+"/admin/config.php?display=freepbx_ha";
		window.location.href = u;
	});
}

function changeSettings() {
	console.log("Change Settings");
	$(".ha-button-start").hide();
	$(".recheck").show();
	$.ajax({
		url: ajaxurl,
		data: { command: "discoverinterfaces" },
		success: function(data) { 
			// External Interface.
			var ei = $("#externalint").data('int');
			var h = selectOfInts(data, ei);
			h += " &nbsp; ";
			$("#externalint").html(h);
			// Internal Interface
			var ii = $("#internalint").data('int');
			h = selectOfInts(data, ii);
			h += " &nbsp; ";
			$("#internalint").html(h);
			// Internal network
			var net = $("#internalnet").data('net');
			h = "<input class='txtinput' type='text' size='15' value='"+net+"'> &nbsp; ";
			$("#internalnet").html(h);

		},
	});
}

function selectOfInts(data, i) {
	console.log(data);
	var h = "<select>";
	$.each(data, function(k, v) { 
		console.log("Comparing "+k+" and "+i);
		h += "<option value='"+k+"'";
		if (k === i) { h += " selected"; }
			h += ">"+k+"</option>";
       	});
	h += "</select>";
	return h;
}

</script>
