<?php
// vim: :set filetype=phtml tabstop=4 shiftwidth=4 autoindent smartindent:
// Stuff. Zend. Copyright. Blah.
?>

<?php
$status = $ha->cman->getAllStatus();
$d = $ha->drbd->getDrbdInfo();
$ajaxurl = "//".$_SERVER['HTTP_HOST']."/admin/modules/freepbx_ha/ajax.php";

include 'rnav.php';
?>

<h3>FreePBX HA Status</h3>

<div id='nodestatus'>
  <div>
    <span style='width: 7em; float: left;'>This node is:</span>
    <span class='hostname'> </span><br />
  </div>
  <div>
    <span style='width: 7em; float: left;'>Other node is:</span>
    <span class='hostname'> </span><br />
  </div>
</div>

<p>Service Status:</p>

<?php 
if (!$ha->update->isUpToDate()) {
	if ($ha->getConfig('installstate') != 'firstview') {
		print "<div class='upgradeable'><span>Upgrade Available (Click here)</span></div>\n";
	}
}

foreach ($status['rg'] as $service => $members) {
	print "<div class='servicestatus' id='$service'>";
	print "<span class='desc'>".$ha->getConfig("DESCR_".$service);
	print "<span class='name'>($service)</span></span>";
	print "<span class='items'>";
	foreach ($members as $srv) 
		print "<span class='item' id='$srv'><a href='#' class='tooltip'><img src='/admin/images/bullet.png'><span>Checking...</span></a></span>";
	print "</span>";
	print "<span>Running on:</span><span class='located' data-srvloc='$service'></span>";
	print "</div>\n";
}

?>

<div id='pcserrors'>Errors go here.</div>

<div class='drbd'>
  <div class='header'>DRBD Stuff</div>
  <span class='nodea'>
    <span class='nodename'>freepbx-a</span>
<?php 
  foreach ($d as $service => $var) {
	  print "    <div class='drbdstatus nodeastat' data-svc='$service'>Loading $service status...</div>\n";
  }
?>
  </span>
  <span class='nodeb'>
    <span class='nodename'>freepbx-b</span>
<?php 
  foreach ($d as $service => $var) {
	  print "    <div class='drbdstatus nodebstat' data-svc='$service'>Loading $service status...</div>\n";
  }
?>
  </span>
</div>

<div class='drbdhelp' id='Connected'>
  <span class='d'>Connected</span>
  <span class='t'>The connection between nodes has been successfully established</span>
</div>
<div class='drbdhelp' id='WFConnection'>
  <span class='d'>WFConnection</span>
  <span class='t'> This means that this node is waiting for the other node to become available</span>
</div>
<div class='drbdhelp' id='SyncSource'>
  <span class='d'>SyncSource</span>
  <span class='t'>The connection between the nodes is up, and the other node is syncronising from this node</span>
</div>
<div class='drbdhelp' id='SyncTarget'>
  <span class='d'>SyncTarget</span>
  <span class='t'>The connection between the nodes is up, and this node is syncronising from the other node</span>
</div>
<div class='drbdhelp' id='StandAlone'>
  <span class='d'>StandAlone</span>
  <span class='t'>This is normally a severe DRBD Error, and requires a manual resync. This can happen after a Split Brain event</span>
</div>
<div class='drbdhelp' id='NodeDown'>
  <span class='d'>NodeDown</span>
  <span class='t'>This machine is unable to reach the other node</span>
</div>

<div class='addnode'>If you wish to add an additional node to this cluster, please <a href="#" id='addclick'>Click Here</a> to toggle display of the details.</div>

<div id='addnodeinfo'>
<div>On the other machine it will be asking you for either a confirmation string, or the IP Address and Password of this machine.</div>
<div>Copy and paste this string into the other server: <span id='linkstr'>&nbsp;</span></div>
<div>If you cannot copy and paste between this machine and the other, the alternative details are:</div>
<div style='padding-top: 1em'><span class='otherinfo'>IP Address of this node:</span><span id='myip'></span></div>
<div><span class='otherinfo'>Random Password of this node:</span><span id='pass'></span></div>
</div>

<script type='text/javascript'>

var ajaxurl = "<?php echo $ajaxurl; ?>";

$(document).ready(function() { doSetup(); });

function doSetup() {
	$("#addclick").click(function() { addNode(); return false; });
	$(".upgradeable").click(function() { doUpgrade(); });
	doMainUpdate();
}

function doMainUpdate() {
	console.log("Update");
	$.ajaxQueue({
		url: ajaxurl,
		data: { command: "getallstatus" },
		success: function(data) { 
			processPCS(data['getpcsstatus']); 
			updateDrbd("nodea", data['drbd-a']);
			updateDrbd("nodeb", data['drbd-b']);
			updateNodeStatus(data['getnodestatus']); 
			doUpdateLoop();
		},
		error: function(data, why) {
			doError(data, why); 
			doUpdateLoop();
		},
	});
}

function doError(data, why) {
	console.log(why);
	var h = "<div><span style='width: 7em; float: left;'>This node is:</span><span class='hostname hostdown'>";
	h += "DOWN</span></div><div><span style='width: 7em; float: left;'>";
	h += "Other node is:</span><span class='hostname down'>UNKNOWN</span></div>";
	$("#nodestatus").html(h);
}

function addNode() {
	document.body.style.cursor = "wait";
	console.log("toggle");
	$("#addnodeinfo").toggle();
	// Don't queue this, just pull it straight out.
	$.ajax({
		url: ajaxurl,
		data: { command: "addnodeinfo" },
		success: function(data) { 
			document.body.style.cursor = "auto";
			var myip = data['raw'][0];
			var pass = data['raw'][1];
			var base64 = data['paste'];
			$("#linkstr").text(base64);
			$("#myip").text(myip);
			$("#pass").text(pass);
		},
	});
}

function doUpdateLoop() {
	window.pcstimer = window.setTimeout( function() { 
		if ($.ajaxQueue.len == 0) {
			doMainUpdate();
		} else {
			console.log("Queue running slow. Not updating");
			doUpdateLoop();
		}
	}, 20000);
}

function processPCS(d) {

	$.each($(".item"), function() {
		var id = $(this).attr('id');
		if (typeof(d[id]) == 'undefined') {
			// Don't know what this thing is.
			$("#"+id+">a>img").attr('src', '/admin/images/help_icon.gif');
			$("#"+id+">a>span").text('This service is Unknown. Contact Support');
		} else if (d[id] == "Stopped") {
			// This is bad. 
			$("#"+id+">a>img").attr('src', '/admin/images/cancel.png');
			$("#"+id+">a>span").text('This service is STOPPED.<br />Contact Support');
		} else {
			// It exists, and it's not stopped. 
			$("#"+id+">a>img").attr('src', '/admin/images/bullet_checked.png');
			r = d[id].match(/Started (.+)/);
			$("#"+id+">a>span").html(id+' is UP<br/ >Currently running on '+r[1]);
		}
	});

	$.each($(".located"), function() {
		var srv = $(this).data('srvloc');
		r = d[srv+"_fs"].match(/Started (.+)/);
		$(this).html(r[1]);
	});

	// console.log(JSON.stringify(d));
	if (typeof(d['errors']) != 'undefined') {
		// There are errors.
		var h = "";
		$.each(d['errors'], function(k, v) {
			h += "<div class='pcserror'>";
			h += "  <div style='width: 35em; float: left;'>";
			h += "    <span class='pcserrdesc'>"+v['desc']+"</span>";
			h += "    <span class='failcount "+v['failcount']['status']+"'>"+v['failcount']['message']+"</span>";
			h += "	</div>";
			h += "  <span class='clearerr button' data-rsc='"+v['rsc']+"' data-node='"+v['node']+"'>Clear Error</span>";
			h += "</div>\n";
		});
		$("#pcserrors").html(h);
		$("#pcserrors").slideDown();
		$(".clearerr").click(function() { clearErr(this); });
	} else {
		$("#pcserrors").slideUp(function() { $("#pcserrors").html(""); });
	}
}


function clearErr(v) {
	console.log($(v).data('rsc'));
	$.ajax({
		timeout: 1500,
		url: ajaxurl,
		data: { command: "clearerr", rsc: $(v).data('rsc'), node: $(v).data('node') },
		success: function (data) { updateDrbd("nodea", data); }
	});
}

function updateDrbd(node, data) {
	$.each($("."+node+"stat"), function() {
		var h;
		var s = $(this).data('svc');
		if (data === null) {
			h = "<div class='drbdchunk'><div><span class='drbdname'>"+s+"</span><span class='nodestate NodeDown'>NodeDown</span></div>";
			h += "<div>Volume not registered. Possibly Node is in Standby?</div></div>";
		} else {
			var v = data[s];
			var h = "<div class='drbdchunk'><div><span class='drbdname'>"+s+"</span><span class='nodestate "+v['connstate']+"'>"+v['connstate']+"<span></div>";
			if (typeof(v['syncpercent']) != 'undefined') {
				h += "<div><span class='drbdraw'>"+v['syncpercent']+"</span></div>";
			}
			if (typeof(v['syncfinish']) != 'undefined') {
				h += "<div><span class='drbdraw'>"+v['syncfinish']+"</span></div>";
			}
			h += "<div><span class='drbdinfo'>My/Other Connection state:</span><span class='roles'>"+v['roles']+"</span></div>";
			h += "<div><span class='drbdinfo'>My/Other Data State:</span><span class='diskstate'>"+v['diskstate']+"</span></div></div>";
		}
		$(this).html(h);
	});
	showDrbdHints();
}

function showDrbdHints() {
	$.each($(".drbdhelp"), function() {
		var c = $(this).attr('id');
		if ($("."+c).length == 0) {
			$("#"+c).fadeOut();
		} else {
			$("#"+c).fadeIn();
		}
	});
}

function doUpgrade() {
	document.body.style.cursor = "wait";
	$(".upgradeable>span").not(":first").remove();
	$(".upgradeable>span").filter(":first").css("text-decoration", "none");
	$(".upgradeable>span").filter(":first").html("Attempting to upgrade...");
	$(".upgradeable:hover").css("cursor", "wait");
	$.ajax({
		url: ajaxurl, 
		data: { command: 'doupgrade' },
		success: function(data) {
			if (data['status'] == "ok") { 
				$(".upgradeable>span").filter(":first").html("Upgrade Complete!");
				 window.setTimeout( function() { window.location.href = window.location.href; }, 500);
			} else {
				document.body.style.cursor = "auto";
				$(".upgradeable>span").filter(":first").html("Upgrade failed");
				$(".upgradeable>span:last-child").after("<span>"+data['message']+"</span>");
			}
		},
	});
}

</script>


