<?php
// vim: :set filetype=phtml tabstop=4 shiftwidth=4 autoindent smartindent:
// Stuff. Zend. Copyright. Blah.
?>

<?php
include 'rnav.php';
$ajaxurl = "//".$_SERVER['HTTP_HOST']."/admin/modules/freepbx_ha/ajax.php";

?>

<h3>FreePBX HA Alert Management</h3>

<?php
$serv = $ha->cman->getAllStatus();
?>

<p>
  Alert Management is NOT designed to be intelligent. It relies on intelligence in your management systems,
  either email or SNMP.  This means that if you set it up to point to your personal email without putting 
  some filters in place, you're going to be overwhelmed. For information on some suggested filters,
  please visit the FreePBX HA Wiki.
</p>

<?php
// Check to make sure that the monitoring script is on both servers.
$mysize = $ha->alerts->checkLocal();
if (!$mysize) {
	print "<div class='alerterror warning'>Alerting is not available due to the 'clustermon.sh' script not being present on this machine</div>";
	return;
}

$othersize = $ha->alerts->checkRemote();
if ($othersize != $mysize) {
	print "<div class='alerterror warning'>Warning: Clustermon.sh on the other machine is different to the version on this machine.</div>";
}
?>

<div id='smtpalert' class='bp'><span class='alerts'>SMTP Alerts are</span><span class='status check'><i>Checking...</i></span></div>
<div id='smtpinfo'><p>Current Email Address(s) to send alerts to: <input id='smtpinput' type='text' value='Loading...' disabled></input></p>
  <span class='button' data-cmd='updatesmtp'>Update</span>
  <span class='button' data-cmd='removesmtp'>Remove</span>
  <span class='button' data-cmd='abort'>Abort</span>
</div>
<div id='snmpalert' class='bp'><span class='alerts'>SNMP Alerts are</span><span class='status check'><i>Checking...</i></span></div>
<div id='snmpinfo'><p>IP Address to send alerts to: <input id='snmpinput' type='text' value='Loading...' disabled></input></p>
  <span class='button' data-cmd='updatesnmp'>Update</span>
  <span class='button' data-cmd='removesnmp'>Remove</span>
  <span class='button' data-cmd='abort'>Abort</span>
</div>
<script type='text/javascript'>

var ajaxurl = "<?php echo $ajaxurl; ?>";

$(document).ready(function() { doStart(); });

function doStart() {
    $.ajax({
        url: ajaxurl,
        data: { command: 'getpcsstatus' },
        success: function(data) { doOutput(data); }
    });
}


function doOutput(d) {
	// If it doesn't exist..
	if (typeof(d['cloneset']) == 'undefined') {
		// Create it.
		d['cloneset'] = new Object;
	}

	if (typeof(d['cloneset']['ClusterMon-SMTP']) == 'undefined') {
		$("#smtpalert>.check").html("Unconfigured");
	} else {
		$("#smtpalert>.check").html("Configured");
	}

	$("#smtpalert").append("<span class='button' data-cmd='smtp'>Manage</span>");

	if (typeof(d['cloneset']['ClusterMon-SNMP']) == 'undefined') {
		$("#snmpalert>.check").html("Unconfigured");
	} else {
		$("#snmpalert>.check").html("Configured");
	}
	$("#snmpalert").append("<span class='button' data-cmd='snmp'>Manage</span>");

	$(".button").click(function() { doClick($(this)); });
}

function doClick(x) {
	if (x.data('cmd') == 'smtp') {
		$("#snmpalert").hide();
		$("#smtpinfo").show();
        $.ajax({
            url: ajaxurl,
            data: { command: 'getsmtp' },
            success: function(data) { showIt($("#smtpinput"), data); }
        });
	} else if (x.data('cmd') == 'snmp') {
		$("#smtpalert").hide();
		$("#snmpinfo").show();
        $.ajax({
            url: ajaxurl,
            data: { command: 'getsnmp' },
            success: function(data) { showIt($("#snmpinput"), data); }
        });
	} else if (x.data('cmd') == 'abort') {
		window.location.href = window.location.href;
	} else if (x.data('cmd') == 'updatesmtp') {
		sendUpdate($("#smtpinput"), x.data('cmd'));
	} else if (x.data('cmd') == "updatesnmp") {
		sendUpdate($("#snmpinput"), x.data('cmd'));
	} else if (x.data('cmd') == "removesnmp" || x.data('cmd') == "removesmtp") {
		sendUpdate($("#snmpinput"), x.data('cmd'));
	} else {
		console.log(x.data('cmd'));
	}
}

function showIt(w, d) {
	w.val(d['dest']);
	w.removeAttr('disabled');
}

function sendUpdate(o, cmd) {
	$("#randomerror").remove();
	$(".button").button( "disable" );
	$("input").attr('disabled', 'disabled');
    $.ajax({
		url: ajaxurl,
		data: { command: cmd, val: o.val() },
		success: function(data) { 
			$(".button").button( "enable" );
			$("input").removeAttr('disabled');
			if (typeof(data['status']) != 'undefined') {
				o.after("<p id='randomerror'>"+data['message']+"</p>");
				return;
			}
			window.location.href = window.location.href;
		}
	});
}



</script>
