<?php
// vim: :set filetype=phtml tabstop=4 shiftwidth=4 autoindent smartindent:
// Stuff. Zend. Copyright. Blah.
?>

<?php
include 'rnav.php';
$ajaxurl = "//".$_SERVER['HTTP_HOST']."/admin/modules/freepbx_ha/ajax.php";

?>

<h3>FreePBX HA Fencing (STONITH) Management</h3>

<div>Fencing is <strong>critical</strong> to the reliability and stablity of your High-Av Cluster.</div>

<div>Fencing allows the cluster to manage the power state of the other nodes, and ensure that it's down
     when the services on that node are in an unknown state</div>

<?php
if (!$ha->getConfig('freepbxha-version')) {
?>
	<div>Fencing is currently NOT AVAILABLE on this cluster, due to a pending upgrade.</div>
<?php
	return;
}
?>
<div>Fencing is currently <span id='fstatus'><i>Checking...</i></span> on this cluster</div>

<div>Your current configuration is:</div>

<div class='fencing'>
  <div id='freepbx-a'>
	<span class='fencingname'>FreePBX-A:</span>
	<span class='fencingtype'></span>
    <div class='bp' id='freepbx-a-buttons'>
   	  <span class='button' id='edit-a'>Edit</span>
   	  <span class='button' id='status-a'>Status</span>
	  <span class='button bred' id='on-a'>Turn On</span>
	  <span class='button bred' id='fence-a'>Reboot</span>
	  <span class='button bred' id='off-a'>Turn Off</span>
    </div>
  </div>
  <div id='freepbx-b'>
    <span class='fencingname'>FreePBX-B:</span>
	<span class='fencingtype'></span>
    <div class='bp' id='freepbx-b-buttons'>
   	  <span class='button' id='edit-b'>Edit</span>
   	  <span class='button' id='status-b'>Status</span>
	  <span class='button bred' id='on-b'>Turn On</span>
	  <span class='button bred' id='fence-b'>Reboot</span>
	  <span class='button bred' id='off-b'>Turn Off</span>
	</div>
  </div>
</div>

<div class='fencingchange'>
  <div id='nodename'></div>
  <div id='typesel'><span>Select Fencing Type:</span><span id='fencesel'></span></div>
  <div id='fenceparam'>Params</div>
  <div class='bp'>
	<span class='button' id='checkbutton'>Check</span>
	<span class='button' id='applybutton'>Apply</span>
	<span class='button' id='abortbutton'>Abort</span>
  </div>
</div>

<script type='text/javascript'>

var ajaxurl = "<?php echo $ajaxurl; ?>";

$(document).ready(function() { showFencing(); });

function showFencing() {
	$(".fencingtype").empty();
	$.ajax({
        url: ajaxurl,
        data: { command: "getfencing" },
		success: function(data) { 
			console.log(data);
			if (data['status'] == "ok") {
				$.each(data['data'], function(k, v) { showNodeStatus(k, v); });
				$("#fstatus").html(data['fstatus']);
			} else {
				$("#freepbx-a>.fencingtype").after("<span class='fencingtype error'>Internal Error</span><span class='nstatus'></span>");
				$("#freepbx-b>.fencingtype").after("<span class='fencingtype error'>Internal Error</span><span class='nstatus'></span>");
				$("#fstatus").html('unknown');
			}
		},
	});

	var fences = [ "None", "VMware", "IPMI", "ILO", "DRAC" ];
	var h = "<select>";
	$.each(fences, function(k, v) { h += "<option value='"+v+"'>"+v+"</option>"; });
	h += "</select>";
	$("#fencesel").html(h);
	$("#fencesel>select").change(function() { showParams($("#fencesel>select").val()); });
	$("#checkbutton").click(function() { checkButton(); });
	$("#applybutton").click(function() { applyButton(); });
	$("#abortbutton").click(function() { abortButton(); });
	$("#edit-a").click(function() { editFencing('freepbx-a'); });
	$("#edit-b").click(function() { editFencing('freepbx-b'); });
	$("#fence-a").click(function() { doFence('freepbx-a', 'reboot'); });
	$("#fence-b").click(function() { doFence('freepbx-b', 'reboot'); });
	$("#off-a").click(function() { doFence('freepbx-a', 'off'); });
	$("#off-b").click(function() { doFence('freepbx-b', 'off'); });
	$("#on-a").click(function() { doFence('freepbx-a', 'on'); });
	$("#on-b").click(function() { doFence('freepbx-b', 'on'); });
	$("#status-a").click(function() { doStatus('freepbx-a'); });
	$("#status-b").click(function() { doStatus('freepbx-b'); });
}

function showNodeStatus(node, vals) {
	if (vals['type'] == null) {
		vals['type'] = "Unconfigured";
	} else {
		$("#"+node+"-buttons").show();
	}
	var f = $("#"+node+">.fencingtype");
	f.html(vals['type']);
	f.addClass(vals['type']);
	f.click(function() { editFencing(node) });
	$("#"+node).data('params', vals);
}

function buildParams() {
	// Build params from whatever we've got
	var params = {
		serverip: $("#serverip>input").val(),
		login: $("#login>input").val(),
		passwd: $("#passwd>input").val(),
		type: $("#fencesel>select").val(),
	}

	// VMware addition
	if (params['type'] == 'VMware') {
		if ($("#vmware_guestname>select").length == 1) {
			// Select box is there. Set it back to text.
			var n = $("#vmware_guestname>select").val();
			params['vmware_guestname'] = n;
			$("#vmware_guestname").empty();
			$("#vmware_guestname").html("<input class='txtinput' type='text' size='50' value='"+n+"'></input>");
		} else {
			params['vmware_guestname'] = $("#vmware_guestname>input").val();
		}
	}
	return params;
}

function applyButton() {
	params = buildParams();
	$("input").attr('disabled', 'disabled');
	$("input").css('text-style', 'italic');
	$.ajax({
		url: ajaxurl,
		data: { command: 'updatefencing', node: window.editing, fencingparams: params },
		success: function(data) {
			if (data['status'] != 'failed') {
				abortButton();
			} else {
				if ($("#checkline").length) {
					$("#checkline").html(data['message']);
				} else {
					$("#fenceparam>div").after("<div style='clear: both;' id='checkline'>"+data['message']+"</div>");
				}
			}

		},
	});
}

function checkButton() {
	console.log("Check Button");
	params = buildParams();
	if ($("#checkline").length) {
		$("#checkline").html("Checking...");
	} else {
		$("#fenceparam>div").after("<div style='clear: both;' id='checkline'>Checking...</div>");
	}
	$.ajax({
		url: ajaxurl,
		data: { command: 'checkfencing', node: window.editing, fencingparams: params },
		success: function(data) {
			var h = "<p>Command: <span style='font-family: monospace'>"+data['exec']+"</span><br />\n";
			h += "Output: <span style='font-family: monospace'>";
			$.each(data['out'], function(i, l) { h += l+"<br />\n"; });
			h +="</span></p>\n";
			$("#checkline").html(h);
		},
	});
}

function abortButton() {
	$("#freepbx-a-buttons").hide();
	$("#freepbx-b-buttons").hide();
	$("#freepbx-a").show();
	$("#freepbx-b").show();
	$(".fencingchange").hide(); 
	$(".button").off();
	showFencing();
}

function editFencing(node) {
	console.log("Edit fencing for "+node);
	$("#freepbx-a-buttons").hide();
	$("#freepbx-b-buttons").hide();
	$(".fstatus").empty();

	$(".fencingchange").show();
	if (node == "freepbx-a") {
		$("#freepbx-b").hide();
	} else {
		$("#freepbx-a").hide();
	}
	window.editing = node;
	var vals = $("#"+node).data('params');
	if (vals['type'] == "Unconfigured") {
		vals['type'] = "None";
	}
	$("#fencesel>select").val(vals['type']);
	$("#fencesel").data('params', vals);

	showParams(vals['type']);
	$.each($("#"+node).data('params'), function(k, v) { $("#"+k+">input").val(v);});
}

function showParams(type) {
	$(".addedbutton").remove();
	if (type == 'VMware') {
		$("#fenceparam").html(getVMware());
	} else if (type == 'IPMI') {
		$("#fenceparam").html(getGeneric('IPMI'));
	} else if (type == 'ILO') {
		$("#fenceparam").html(getGeneric('ILO'));
	} else if (type == 'DRAC') {
		$("#fenceparam").html(getGeneric('DRAC'));
	} else {
		$("#fenceparam").empty();
	}
}

function getVMware() {
	var r = {
		serverip: "VMware Server IP Address",
		login: "VMware Server Username",
		passwd: "VMware Server Password",
		vmware_guestname: "VMware Guest Name",
	};

	var h = "<div>";
	$.each(r, function(v, s) {
		h += "<div style='clear: both;'><span class='pdesc'>"+s+":</span>";
		h += "<span class='psel' id='"+v+"'><input class='txtinput' type='text' size='50' value=''></input></span></div>";
	});
	h += "</div>";
	// Add a button to get hosts
	$(".fencingchange>.bp>span:first").before("<span class='addedbutton button' id='listguests'>List Guests</span>");
	$("#listguests").click(function() { vmwareListGuests(); });
	return h;
}

function vmwareListGuests() {
	var currentGuest = null;
	if ($("#vmware_guestname>input").length != 0) {
		currentGuest = $("#vmware_guestname>input").val();
	}
		
	$("#vmware_guestname").html("<i>Loading...</i>");
	$.ajax({
        url: ajaxurl,
		data: {
			command: "vmwareListGuests",
			serverip: $("#serverip>input").val(),
			login: $("#login>input").val(),
			passwd: $("#passwd>input").val(),
		},
		success: function(data) {
			if (data['status'] != 'ok') {
				$("#vmware_guestname").html("<strong>"+data['message']+"</strong>");
			} else {
				var s = "<select>";
				$.each(data['data'], function(i, k) { 
					if (k == currentGuest) {
						s += "<option selected>"+k+"</option>";
					} else {
						s += "<option>"+k+"</option>";
					}
				});

				s += "</select>";
				$("#vmware_guestname").html(s);
			}
		},
	});
}

function getGeneric(name) {
	// Get this via ajax later?
	var r = { serverip: name+" IP Address", login: name+" Username", passwd: name+" Password", };

	var h = "<div>";
	$.each(r, function(v, s) {
		h += "<div style='clear: both;'><span class='pdesc'>"+s+":</span>";
		h += "<span class='psel' id='"+v+"'><input class='txtinput' type='text' size='50' value=''></input></span></div>";
	});
	h += "</div>";
	return h;
}

function doFence(node, type) {
	$(".fstatus").empty();
	if ($("#"+node+">.fstatus").length == 0) {
		$("#"+node+">.fencingtype").after("<div class='fstatus'></div>");
	}
	$("#"+node+">.fstatus").html("<i>Executing Fence...</i>");

	$.ajax({
        url: ajaxurl,
		data: { command: 'fence', node: node, fencecmd: type },
		success: function(data) {
			if (data['ret'] == 0) {
				$("#"+node+">.fstatus").html(" "+data['out']);
			} else {
				var h = "Error:<br />\n";
				$.each(data['out'], function(i, l) { h += l+"<br />\n"; });
				$("#"+node+">.fstatus").html(h);
			}
		},
	});
}

function doStatus(node) {
	$(".fstatus").empty();
	if ($("#"+node+">.fstatus").length == 0) {
		$("#"+node+">.fencingtype").after("<div class='fstatus'></div>");
	}
	$("#"+node+">.fstatus").html("<i>Querying Status...</i>");

	$.ajax({
        url: ajaxurl,
		data: { command: "getfencestatus", node: node },
		success: function(data) { 
			if (data['ret'] == 0 || data['ret'] == 2) {
				$("#"+node+">.fstatus").html(" "+data['out']); 
			} else {
				var h = "Error:<br />\n";
				$.each(data['out'], function(i, l) { h += l+"<br />\n"; });
				$("#"+node+">.fstatus").html(h); 
			}
		},
	});
}

</script>

