<?php
// vim: :set filetype=phtml tabstop=4 shiftwidth=4 autoindent smartindent:
// Stuff. Zend. Copyright. Blah.
?>

<?php
include 'rnav.php';
$ajaxurl = "//".$_SERVER['HTTP_HOST']."/admin/modules/freepbx_ha/ajax.php";

?>

<h3>FreePBX HA Management</h3>
<div id='nodestatus'>
  <div>
    <span style='width: 7em; float: left;'>This node is:</span>
    <span class='hostname'> </span><br />
  </div>
  <div>
    <span style='width: 7em; float: left;'>Other node is:</span>
    <span class='hostname'> </span><br />
  </div>
</div>

<div id='tools'>
  <p>Node management tools</p>
  <div class='mgmtcmds'></div>
  <div class='mgmtinfo'></div>
</div>
<div style="clear: both; width=95%" id="report"></div>

<script type='text/javascript'>

var ajaxurl = "<?php echo $ajaxurl; ?>";

$(document).ready(function() { 
	getNodeStatus(); 
	nodeLoop();
});

function togglenode(n) {
	genMgmtCmds();
	if (n == "this") {
		// Doom and gloom. You don't want to do this. 
		var h = '<div class="warning">Warning: This will cause an outage</div>';
		h += '<span>Setting the current node to standby will interrupt any calls in progress. It is not advisable to do so ';
		h += 'during production hours. The server will attempt a graceful shutdown of the services (eg, it will try to ';
		h += 'wait until there are no active calls) but will do a hard shutdown of asterisk after 30 seconds.</span>';
		h += '<div>Are you sure you want to proceed?</div>';
		h += '<div class="managebuttons"><span class="button" data-cmd="toggle" data-node="'+n+'">Yes, proceed</span>';
		h += '<span class="button" data-cmd="abort">No, abort</span>';
	} else {
		if (window.otherstatus == "online") {
			var h = '<div class="warning">Warning: You are disabling fault-tolerance</div>';
			h += '<span>Setting the other node to standby will remove fault-tolerance from the cluster. You need to re-enable ';
			h += 'it before the cluster will be able to fail over to the other node in case of a failure.</span>';
			h += '<div>Are you sure you want to proceed?</div>';
			h += '<div class="managebuttons">';
			h += '  <span class="button" data-cmd="toggle" data-node="'+n+'">Yes, proceed</span>';
			h += '  <span class="button" data-cmd="abort">No, abort</span>';
			h +='</div>';
		} else {
			var h = '<span>This will return the other node to full cluster membership.</span>';
			h += '<div class="managebuttons">';
			h += '  <span class="button" data-cmd="toggle" data-node="'+n+'">Yes, proceed</span>';
			h += '  <span class="button" data-cmd="abort">No, abort</span>';
			h += '</div>';
		}
	}
	if ($(".mgmtinfo").text() == $(h).text()) {
		$(".mgmtinfo").html("");
	} else {
		$(".mgmtinfo").html(h);
		$(".button").click(function() { handleClick(this) });
	}
}

function handleClick(t) {
	$("#report").html("");
	if ($(t).data('cmd') == 'toggle') { doToggle($(t).data('node')); }
	else if ($(t).data('cmd') == 'abort') { $(".mgmtinfo").html(""); }
	else { console.log($(t).data('cmd')+" was clicked"); }
}
function checkCluster() {
	window.ajaxdata = {};
	$("#report").html("");
	var h = "<div id='clustercheck'><div class='states'><h3>Checking Cluster</h3></div></div>";
	$(".mgmtinfo").html(h);
	getChecks('checks', dochecks);
}

function dochecks(allok, anyleft) {
	if (anyleft) {
		return;
	}
	var allreports = "";
	if (typeof(window.ajaxdata['localcommands']) != "undefined") {
		allreports += ajaxdata['localcommands'];
	}

	if (typeof(window.ajaxdata['commands']) != "undefined") {
		allreports += ajaxdata['commands'];
	}
	$("#report").html(allreports);
}

function getNodeStatus() {
	$.ajaxQueue({
		timeout: 2000,
		url: ajaxurl,
		data: { command: 'getnodestatus' },
		success: function (data) { updateNodeStatus(data); genMgmtCmds(); }
	});
}

function nodeLoop() {
	window.nodeloop =  window.setTimeout( function() { getNodeStatus(); nodeLoop(); }, 10000);
}

function genMgmtCmds() {
	var h = "<span class='left'>";
	if (window.thisstatus != "online") {
		h += "Set this node to online</span>";
	} else {
		h += "Set this node to standby</span>";
	}
	h += "<span class='right'><a href='#' onClick='togglenode(\"this\")'>Click here</a></span>";
	h += "<span class='left'>";
	if (window.otherstatus != "online") {
		h += "Set other node to online</span>";
	} else {
		h += "Set other node to standby</span>";
	}
	h += "<span class='right'><a href='#' onClick='togglenode(\"other\")'>Click here</a></span>";
	h += "<span class='left'>Verify Cluster Configuration</span><span class='right'><a href='#' onClick='checkCluster()'>Click here</a></span>";
	$(".mgmtcmds").html(h);
}

function doToggle(n) {
	console.log("doToggle");
	$.ajaxQueue({
		timeout: 2000,
		url: ajaxurl,
		data: { command: 'togglenode', node: n },
		success: function (data) { $(".mgmtinfo").html(data['status']); }
	});
}

</script>
