<?php
// vim: :set filetype=phtml tabstop=4 shiftwidth=4 autoindent smartindent:
// Stuff. Zend. Copyright. Blah.
?>

<?php
include 'rnav.php';
$ajaxurl = "//".$_SERVER['HTTP_HOST']."/admin/modules/freepbx_ha/ajax.php";

?>

<h3>Digium R-Series High-Av Hardware</h3>

<p>
  Digium R-Series failover appliances allow the FreePBX-HA Cluster to automatically
  switch Digital and Analog lines to the machine that's currently running Asterisk.
</p>

<p><a href='//schmoozecom.com/r-series.php'>More information on the R-Series HA Appliances is here</a></p>

<?php
if (!$ha->getConfig('freepbxha-version')) {
        echo "<div>R-Series hardware is NOT AVAILABLE on this cluster, due to a pending upgrade.</div>";
        return;
}

$count = $ha->rseries->getCount();
$status = $ha->cman->getAllStatus();

if ($count === 0) {
	echo "<div>This machine has no R-Series devices attached</div>\n";
	return;
}

if ($count == 1) {
	echo "<div>This machine has 1 R-Services device attached</div>\n";
} else {
	echo "<div>This machine has $count R-Services devices attached</div>\n";
}

foreach ($ha->rseries->getIDs() as $rid => $null) {
	$details = $ha->rseries->getInfo($rid);
	echo "<div class='rseries'><div class='rleft'><span class='rid'>R-Series ID $rid</span>\n";
	echo "<span class='rtype'>Model: ".$details['product']."</span>\n";
	echo "<span class='rserial'>Serial Number: ".$details['serialno']."</span><br />\n";
	echo "<span class='rporttype'>Interface Type: ".$details['ports'][1]['type']."</span>\n";
	echo "<span class='rportmode'>Current Mode: ".$details['ports'][1]['mode']."</span>\n ";
	echo "</div><div class='rright'>\n";
	if (isset($status['ms']["rseries$rid"])) {
		echo "<span class='button' data-cmd='rdisable' data-id='$rid'>Disable</span>\n";
	} else {
		echo "<span class='button' data-cmd='rswitch' data-id='$rid'>Switch</span>";
		echo "<span class='button' data-cmd='renable' data-id='$rid'>Enable</span>\n";
	}

	echo "</div></div>\n";
}

?>


<script type='text/javascript'>

var ajaxurl = "<?php echo $ajaxurl; ?>";

$(document).ready(function() { bindButtons(); });

function bindButtons() {
	$(".button").click(function() { buttonClicked($(this)); });
}

function buttonClicked(x) {
	console.log(x.data('cmd') + " with " + x.data('id'));
	$.ajax({
        url: ajaxurl,
        data: { command: x.data('cmd'), id: x.data('id') },
		success: function() { /*window.location.href = window.location.href;*/ }
    });
}

</script>


