<?php 
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
//	License for all code of this FreePBX module can be found in the license file inside the module directory
//	Copyright 2013 Schmooze Com Inc.
//
if (zend_loader_file_encoded()) {
	$lic_info	= zend_loader_file_licensed();
	$lic_exp	= isset($lic_info['pagepro_exp'])
				? preg_replace('/-/','',$lic_info['pagepro_exp'])
				: 00000000;
	if ($lic_exp > date('Ymd')) {
		$pagepro = true;
	} else {
		$pagepro = false;
	}
} else {
	$pagepro = true;
}

function pagingpro_hookGet_config($engine) {
	global $db, $ext, $version, $pagepro;
	if (!$pagepro) {
		return false;
	}
	switch($engine) {
		case "asterisk":
			$sql = "SELECT page_group, force_page, duplex FROM paging_config";
			$paging_groups = $db->getAll($sql, DB_FETCHMODE_ASSOC);
			$c = 'app-pagegroups';
			foreach ($paging_groups as $pging_group) {
				$grp  = trim($pging_group['page_group']);
				$pro = pagingpro_get($grp);
				if ($pro['busypage'] == 'noaction') {
					//do nothing when set to noaction
					//continue;
				}

				//replace intro message
				if ($pro['intro_recording'] == 'none') {
					$ext->splice($c, $grp, 'agi', 
						new ext_set('STREAM', 'NONE'));
				} elseif (function_exists('recordings_get_file')) {

					$ext->splice($c, $grp, 'agi', new ext_execif('$["${SKIP_INTRO}" != "TRUE"]', 'Set', "STREAM=".recordings_get_file($pro['intro_recording']), 'Set', "STREAM=NONE"));
					
					/*
					$ext->splice($c, $grp, 'agi', 
						new ext_set('STREAM', 
							recordings_get_file($pro['intro_recording'])));
					*/
					
			}
			
			//$ext->splice($c, $grp, 'agi', new ext_noop('jump'),'skipintro');
				
				//set callerid prepend
				if ($pro['cid_prepend']) {
					$ext->splice($c, $grp, 'agi', 
						new ext_set('CALLERID(name)', 
							$pro['cid_prepend'] . '${CALLERID(name)}'));
				}
				
				//if were set to force valet, always jump directly to busy, 
				//no need to lock if were not automated
				if ($pro['busypage'] == 'forcevalet') {
					$ext->splice($c, $grp, 'busy-check', 
						new ext_execif('$["${AUTOMATED_CALL}" != "TRUE"]', 
							'Goto', 'busy'));
				}

					
				//create recording of page if busy, if requested
				if ($pro['busypage'] != 'noaction') {
					$ext->replace($c, $grp, 'play-busy', 
						new ext_execif('$["${AUTOMATED_CALL}" = "TRUE"]', 
							'Busy'));
					$ext->splice($c, $grp, 'busy-hang', 
						new ext_gotoif('$["${AUTOMATED_CALL}" = "TRUE"]', 
							'busy-hang'));
						
					}
					
					//set page file name & record
					$ext->splice($c, $grp, 'busy-hang', 
						new ext_set('PAGE_RECORDING', 
							'${ASTSPOOLDIR}/tmp/PAGE_RECORDING-' 
							. $grp . '-${EPOCH}${RAND(100,999)}'));
					$ext->splice($c, $grp, 'busy-hang', 
						new ext_record('${PAGE_RECORDING}.sln,3,,k'));
			}		
				
			//build callfile
			$e = 'record-page';
			$ext->add($c, $e, '', 
						new ext_agi('pagingpro_call_spooler.agi,'
							. 'calltype=valet_page'));
			$ext->add($c, $e, '', new ext_return());
			
			
			//set call file if we have a recording and were not automated
			$ext->add($c, 'h', '',
				new ext_gosubif('$[$[!${ISNULL(${PAGE_RECORDING})}] '
								. ' & $[$[${STAT(e,${PAGE_RECORDING}.sln)}] || $[!${ISNULL(${PAGE_INTRO})}]]'
								. ' & $["${AUTOMATED_CALL}" != "TRUE"]]', 
								'record-page,1'));	
								
			//delete recording if page was done	
			$ext->add($c, 'h', '',
				new ext_execif('$[$[!${ISNULL(${PAGE_RECORDING})}] '
								. ' & $["${PAGE${PAGEGROUP}BUSY}" != "TRUE"]'
								. ' & $["${AUTOMATED_CALL}" = "TRUE"]]', 
								'System', 'rm ${PAGE_RECORDING}.sln'));
			//delete call file as well so we dont get in a weird paging loop with no audio :-O
			$ext->add($c, 'h', '',
				new ext_execif('$[$[!${ISNULL(${PAGE_RECORDING})}] '
								. ' & $["${PAGE${PAGEGROUP}BUSY}" != "TRUE"]'
								. ' & $["${AUTOMATED_CALL}" = "TRUE"]]', 
								'System', 'rm -f /var/spool/asterisk/outgoing/${FILE_NAME}'));
								
			//context to playback the pre-recorded page
			$c = 'pagingpro-play-message';
			$ext->add($c, 's', '', new extension('WaitForSilence(2000)'));
			$ext->add($c, 's', '', new ext_playback('${PAGE_RECORDING}'));
			$ext->add($c, 's', '', new ext_hangup());
			
			//context 'inject' a file in to a conference
			$c = 'pagingpro-chanspy';
			$ext->add($c, 's', '', new ext_answer());
			$ext->add($c, 's', '', new ext_wait(1));
			$ext->add($c, 's', '', new ext_playback('beep&extension'));
			$ext->add($c, 's', '', new ext_saydigits('${AMPUSER}'));
			$ext->add($c, 's', '', new ext_playback('dialed'));
			$ext->add($c, 's', '', new ext_saydigits('${DIALED}'));
			//$ext->add($c, 's', '', new ext_noop('${ORIG_CHANNEL} ${DEVICE_STATE(${ORIG_CHANNEL})}'));
			$ext->add($c, 's', '', 
				new ext_execif('$["${DEVICE_STATE(${ORIG_CHANNEL})}" = "NOT_INUSE"]',
				'Playback', 'sorry&this&channel&has-expired'));
			$ext->add($c, 's', '', 
				new ext_execif('$["${DEVICE_STATE(${ORIG_CHANNEL})}" = "NOT_INUSE"]',
				'Busy', 5));
			$ext->add($c, 's', '', 
				new ext_execif('$["${DEVICE_STATE(${ORIG_CHANNEL})}" = "NOT_INUSE"]',
				'Hangup'));
			$ext->add($c, 's', '', new ext_chanspy('${ORIG_CHANNEL}', 'qEB'));
			$ext->add($c, 's', '', new ext_hangup());
			
			//hook in to outbound routes dialplan
			$outbound_routes = core_routing_list();
			
			foreach ($outbound_routes as $r) {
				$page_group = pagingpro_core_routing_get($r['route_id']);
				//dbug('looking in ', $r['route_id']);
				if (!$page_group) {
					continue;
				}
				$c = 'outrt-' . $r['route_id'];
				$patterens = core_routing_getroutepatternsbyid($r['route_id']);
				foreach($patterens as $p) {
					$fpattern = core_routing_formatpattern($p);
					$e = $fpattern['dial_pattern'];
					
					$ext->splice($c, $e, 2, new ext_set('PAGEGROUP', $page_group));
					$ext->splice($c, $e, 3, 
						new ext_agi('pagingpro_call_spooler.agi,'
							. 'calltype=outbound_notify'));
				}
			}
			
			
			break;
	}
}

function pagingpro_hook_paging($viewing_itemid, $target_menuid) {
	global $amp_conf, $pagepro;
	if (!$pagepro) {
		return false;
	}
	$data 				= pagingpro_get($viewing_itemid);
	$data['amp_conf']	= $amp_conf;
	$rec_list			= function_exists('recordings_list') 
						? recordings_list() 
						: array();
	
	$data['rec']['none'] = _('None');
	$data['rec'][] = _('Default');
	foreach ($rec_list as $r) {
		$data['rec'][$r['id']] = $r['displayname'];
	}
	return $target_menuid 
			? load_view(dirname(__FILE__) . '/views/paging_hook.php', $data)
			: true;
}

function pagingpro_hookProcess_paging($viewing_itemid, $request) {
	global $pagepro;
	if (!$pagepro) {
		return false;
	}
	$action			= isset($_REQUEST['action'])
					? $_REQUEST['action']
					: '';
	$busypage		= isset($_REQUEST['busypage'])
					? $_REQUEST['busypage']	
					: 'valet';
	$cid_prepend	= isset($_REQUEST['cid_prepend'])
					? $_REQUEST['cid_prepend']	
					: '';
	$intro_recording= isset($_REQUEST['intro_recording'])
					? $_REQUEST['intro_recording']
					: '';
	$pagenbr		= isset($_REQUEST['pagenbr'])
					? $_REQUEST['pagenbr']		
					: '';
	$pagegrp		= isset($_REQUEST['pagegrp'])
					? $_REQUEST['pagegrp']		
					: '';
	$extdisplay		= isset($_REQUEST['extdisplay'])
					? $_REQUEST['extdisplay']	
					: '';
    
    $scheduler = false;
    if(isset($_REQUEST['schedulerenable']) && ($_REQUEST['schedulerenable'] == 'yes')) {
        foreach($_REQUEST['eventids'] as $ids) {
            if(isset($_REQUEST['eventtimeselect_'.$ids]) && isset($_REQUEST['eventdayselect_'.$ids])) {
                $time = $_REQUEST['eventtimeselect_'.$ids];
                foreach($_REQUEST['eventdayselect_'.$ids] as $day) {
                    $scheduler['events'][$ids]['time'][] = strtotime($day.' '.$time);
                }
            }
        }
                        
        $scheduler['range_start'] = isset($_REQUEST['rangestart']) && !empty($_REQUEST['rangestart']) ? strtotime($_REQUEST['rangestart']) : NULL;
        $scheduler['range_end'] = isset($_REQUEST['rangeend']) && !empty($_REQUEST['rangeend']) ? strtotime($_REQUEST['rangeend']) : NULL;
        
        foreach(array_keys($_REQUEST['exclusiondateselect']) as $key) {
            if(!empty($_REQUEST['exclusiondateselect'][$key])) {
                $scheduler['exclusions'][] = array(
                    'day' => strtotime($_REQUEST['exclusiondateselect'][$key]),
                    'comment' => $_REQUEST['exclusioncomment'][$key]
                );
            }
        }
		
		if(!isset($scheduler['events']) || empty($scheduler['range_start']) || empty($scheduler['range_end'])) {
			$scheduler = false;
		}
    }
    
    $pagenbr	= $pagenbr ? $pagenbr : $extdisplay;
    
    if(!empty($pagegrp) && ($pagenbr != $pagegrp) && ($action == 'submit') && $_REQUEST['submit'] != 'Delete') {
        pagingpro_del($pagegrp);
    }

    //This doesn't run. Like ever if action == 'delete' because it's NEVER DELETE
	if ($action == 'submit' && !empty($_REQUEST['submit']) && $_REQUEST['submit'] == 'Delete') {
		pagingpro_del($pagenbr);
	} elseif ($action == 'submit' && $pagenbr && paging_get_pagingconfig($pagenbr)) {
		$data = array('id'				=> $pagenbr, 
					'busypage' 			=> $busypage, 
					'intro_recording'	=> $intro_recording,
					'cid_prepend'		=> $cid_prepend,
                    'scheduler'         => $scheduler
				);
		pagingpro_put($data);
	}
}

// provide hook for routing
function pagingpro_hook_core($viewing_itemid, $target_menuid) {
	global $db, $pagepro;
	if (!$pagepro) {
		return false;
	}
	switch ($target_menuid) {
		case 'routing':
				$data['paging_groups'][] = _('None');
				foreach((array) paging_list() as $page) {
					$data['paging_groups'][$page['page_group']] 
						= $page['description']
						? $page['description']
						: _('Page Group') . ' ' . $page['page_group'];
				}
				if ($viewing_itemid) {
					$data['paging_group'] = pagingpro_core_routing_get($viewing_itemid);
					return load_view(dirname(__FILE__) . '/views/routing_hook.php', $data);
				}	
			break;
		default:
			return false;
			break;
	}
}

//prosses hook for core/routing
function pagingpro_hookProcess_core($viewing_itemid, $request) {
	global $pagepro;
	if (!$pagepro) {
		return false;
	}
	switch ($request['display']) {
        case 'routing':
			$action = isset($request['action']) ? $request['action'] : '';
			$page_id = isset($request['paging_notification']) 
						? $request['paging_notification'] 
						: '';
			$route = $viewing_itemid;
			

			switch ($action) {
				case 'editroute':
					if ($page_id && $route) {
						pagingpro_core_routing_put($page_id, $route);
					} elseif(!$page_id && $route) {
						pagingpro_core_routing_del($route);
					}
					break;
				case 'delroute':
					pagingpro_core_routing_del($route);
					break;
			}
        break;
	}
}

//get coure/routing settings
function pagingpro_core_routing_get($route) {
	global $db;
	$ret = $db->getOne('SELECT page_id FROM pagingpro_core_routing '
			. 'WHERE route = ?', array($route));
	db_e($ret);
	
	return $ret;
}

//deelte core/routing settings
function pagingpro_core_routing_del($route) {
	global $db;
	$ret = $db->query('DELETE FROM pagingpro_core_routing WHERE route = ?', 
			array($route));
	db_e($ret);
	
	return $ret;
}

//save core/routing settings
function pagingpro_core_routing_put($page_id, $route) {
	global $db;
	$sql = 'REPLACE INTO pagingpro_core_routing (page_id, route) VALUES (?, ?)';
	$ret = $db->query($sql, array($page_id, $route));
	db_e($ret);
	
	return $ret;
}

function pagingpro_get($id)  {
	global $db;
	$sql = 'SELECT * FROM pagingpro WHERE page_id = ?';
	$q = $db->getAll($sql, array($id), DB_FETCHMODE_ASSOC);
	db_e($q);
	
	$q = isset($q[0]) ? $q[0] : array();
	if (!isset($q['busypage']) || !$q['busypage']) {
		$q['busypage'] = 'valet';
	}
	if (!isset($q['intro_recording'])) {
		$q['intro_recording'] = '';
	}
	if (!isset($q['cid_prepend'])) {
		$q['cid_prepend'] = '';
	}
    
	$sql = 'SELECT * FROM pagingpro_scheduler_events WHERE page_id = ? ORDER BY event_num';
	$q['scheduler_info']['events'] = $db->getAll($sql, array($id), DB_FETCHMODE_ASSOC);
	db_e($q['scheduler_info']['events']);
    
	$sql = 'SELECT * FROM pagingpro_scheduler_range WHERE page_id = ?';
	$q['scheduler_info']['range'] = $db->getRow($sql, array($id), DB_FETCHMODE_ASSOC);
	db_e($q['scheduler_info']['range']);
    
	$sql = 'SELECT * FROM pagingpro_scheduler_exclusions WHERE page_id = ? ORDER BY time';
	$q['scheduler_info']['exclusions'] = $db->getAll($sql, array($id), DB_FETCHMODE_ASSOC);
	db_e($q['scheduler_info']['exclusions']);
    
	return $q;
}

function pagingpro_del($id) {
	global $db;
	$sql = 'DELETE FROM pagingpro WHERE page_id = ?';
	$q = $db->query($sql, array($id));
	db_e($q);
    
    $sql = 'DELETE FROM pagingpro_scheduler_events WHERE page_id = ?';
	$q = $db->query($sql, array($id));
	db_e($q);
        
    $sql = 'DELETE FROM pagingpro_scheduler_range WHERE page_id = ?';
	$q = $db->query($sql, array($id));
	db_e($q);
        
    $sql = 'DELETE FROM pagingpro_scheduler_exclusions WHERE page_id = ?';
	$q = $db->query($sql, array($id));
	db_e($q);

    //Delete all cron jobs
    $sql = 'SELECT * FROM pagingpro_scheduler_crons WHERE `page_id`='.$id;
    $all_crons = sql($sql,'getAll',DB_FETCHMODE_ASSOC);

    foreach($all_crons as $crons) {
        edit_crontab($crons['cron_name']);
    }
    
    $sql = 'DELETE FROM pagingpro_scheduler_crons WHERE page_id=?';
	$q = $db->query($sql, array($id));
	db_e($q);
}

function pagingpro_put($data) {
	global $db;
	$sql = 'REPLACE INTO pagingpro '
			. '(page_id, busypage, intro_recording, cid_prepend, enable_scheduler) '
			. 'VALUES (?, ?, ?, ?, ?)';
	$q = $db->query($sql, 
			array($data['id'], 
				$data['busypage'], 
				$data['intro_recording'], 
				$data['cid_prepend'],
                ($data['scheduler'] !== false) ? 1 : 0
                ));
	db_e($q);
    
    if($data['scheduler'] !== false) {
        $sql = 'DELETE FROM pagingpro_scheduler_events WHERE `page_id` = '.$data['id'];
        $db->query($sql);
        
        foreach($data['scheduler']['events'] as $key => $events) {
        	$sql = 'INSERT INTO pagingpro_scheduler_events '
        			. '(event_num, page_id, times) '
        			. 'VALUES (?, ?, ?)';
        
            $q = $db->query($sql,
                array(
                    $key,
                    $data['id'],
                    json_encode($events['time'])
                ));
            db_e($q);
        }
        
        $sql = 'DELETE FROM pagingpro_scheduler_range WHERE `page_id` = '.$data['id'];
        $db->query($sql);
        $sql = 'INSERT INTO pagingpro_scheduler_range '
        			. '(page_id, starttime,endtime) '
        			. 'VALUES (?, ?, ?)';
        $q = $db->query($sql,
            array(
                $data['id'],
                $data['scheduler']['range_start'],
                $data['scheduler']['range_end']
            ));
        db_e($q);
        
        $sql = 'DELETE FROM pagingpro_scheduler_exclusions WHERE `page_id` = '.$data['id'];
        $db->query($sql);
		if(!empty($data['scheduler']['exclusions'])) {
	        foreach($data['scheduler']['exclusions'] as $exclusions) {
	        	$sql = 'INSERT INTO pagingpro_scheduler_exclusions '
	        			. '(page_id, time, comment) '
	        			. 'VALUES (?, ?, ?)';
        
	            $q = $db->query($sql,
	                array(
	                    $data['id'],
	                    $exclusions['day'],
	                    $exclusions['comment']
	                ));
	            db_e($q);
	        }
		}
        
        pagingpro_schedule_next_event($data['id']);
    } else {
        //Delete all cron jobs
        $sql = 'SELECT * FROM pagingpro_scheduler_crons WHERE `page_id`='.$data['id'];
        $all_crons = sql($sql,'getAll',DB_FETCHMODE_ASSOC);
        foreach($all_crons as $crons) {
            edit_crontab($crons['cron_name']);
        }
    }
}

function pagingpro_schedule_next_event($page_id) {
    global $db, $amp_conf, $pagepro;
    if($pagepro) {
        //Get all event exclusions
        $sql = 'SELECT * FROM pagingpro_scheduler_exclusions WHERE page_id = '.$page_id;
        $exs = sql($sql,'getAll',DB_FETCHMODE_ASSOC);
        $all_exclusions = array();
        foreach($exs as $ex) {
            $all_exclusions[] = date('mdY',$ex['time']);
        }
    
        //Get all event range(s)
        $sql = 'SELECT * FROM pagingpro_scheduler_range WHERE page_id = '.$page_id;
        $range = sql($sql,'getRow',DB_FETCHMODE_ASSOC);
    
        //Get all event times
        $sql = 'SELECT * FROM pagingpro_scheduler_events WHERE page_id = '.$page_id;
        $events = sql($sql,'getAll',DB_FETCHMODE_ASSOC);
        $all_times = array();
        foreach($events as $event) {
            $all_times = array_merge($all_times,json_decode($event['times'],TRUE));
        }
    
        //Sort times, closest is first
        sort($all_times);
    
        foreach($all_times as $times) {
            $full_times[] = array(
                'day' => date('l',$times),
                'time' => date('H:i',$times)
            );
        }
    
        //Delete all cron jobs
        $sql = 'SELECT * FROM pagingpro_scheduler_crons WHERE `page_id`='.$page_id;
        $all_crons = sql($sql,'getAll',DB_FETCHMODE_ASSOC);
        foreach($all_crons as $crons) {
            edit_crontab($crons['cron_name']);
        }
    
        //Now Delete all Cron listings
        $sql = 'DELETE FROM pagingpro_scheduler_crons WHERE `page_id`='.$page_id;
        $db->query($sql);
		
        $search_range = 5000; //Number of days to search forward from here.
        for($i=0;$i<=$search_range;$i++){
            $time = strtotime("+".$i." day",$range['starttime']);
            $find = pp_arraysearchrecursive(date('l',$time),$full_times,'day');

            if($find !== FALSE) {
                foreach($find as $d) {
                    $date = date('m/j/Y',$time);
                    $event = strtotime($date.' '.$full_times[$d]['time']);
                    if(pp_setcron($page_id,$event,$all_exclusions, $range['starttime'],$range['endtime'])) {
                        //We found one so break by 2
                        break(2);
                    }
                } 
            }
        }
    }
}

function pp_setcron($page_id,$event,$exclusions, $range_start,$range_end) {
    global $db,$amp_conf,$pagepro;
    //Check for valid license
    if(!$pagepro) {
        return false;
    }
    //Sometimes we have event in here that shouldnt be so ignore it
    if(time() > $event) {
        return false;
    }
    //Check for exclusions, skip if we match
    if(in_array(date('mdY',$event),$exclusions)) {
        return false;
    }
    //Make sure it's within our schedule
    if((!empty($range_start) && ($range_start > $event)) || (!empty($range_end) && ($range_end < $event))) {
        if($range_start == $range_end) {
            //If the end range (or start range) is in our list of exlusions
            if(in_array(date('mdY',$range_end),$exclusions)) {
                return false;
            }
            //If we set the range start and end to the same day but the event is in the past then dont create it
            if(time() > strtotime(date('m/d/Y',$range_start). " ".date('H:i',$event))) {
                return false;
            }
        //Make sure our event is not the end date??
        } elseif(date('mdY',$event) != date('mdY',$range_end)) {
            return false;
        } 
    }
    
	$sql = 'INSERT INTO pagingpro_scheduler_crons '
			. '(page_id, cron_name, time) '
			. 'VALUES (?, ?, ?)';
            
    $q = $db->query($sql,
        array(
            $page_id,
            'pagepro-scheduler.php -p '.$page_id.' -t '.$event,
            $event
        ));
    db_e($q);
            
    edit_crontab('pagepro-scheduler.php -p '.$page_id.' -t '.$event, array('minute' => date('i',$event), 'hour' => date('G',$event), 'dom' => date('j',$event), 'month' => date('n',$event), 'command' => $amp_conf['AMPBIN'].'/pagepro-scheduler.php -p '.$page_id.' -t '.$event.' 2>&1 >/dev/null'));
    return true;
}

/**
* This function is for amportal 'start'
**/
function pp_startup() {
    $sql = "SELECT `page_id` FROM pagingpro WHERE enable_scheduler=1";
    $schedulers = sql($sql,'getAll',DB_FETCHMODE_ASSOC);
    foreach($schedulers as $scheduler) {
        pagingpro_schedule_next_event($scheduler['page_id']);
    }
}

function pp_execute_pager($options) {
    global $amp_conf,$astman;
    $sql = "SELECT * FROM pagingpro WHERE enable_scheduler=1 AND page_id=".$options['p'];
    $page_info = sql($sql,'getRow',DB_FETCHMODE_ASSOC);
    
    $sql = "SELECT `description` FROM paging_config WHERE page_group=".$options['p'];
    $page_name = sql($sql,'getOne');
    
    $call = array(
        "Channel" => "Local/".$page_info['page_id']."@from-internal",
        "Application" => "Playback",
        "Data" => recordings_get_file($page_info['intro_recording']), 
        "MaxRetries" => 0,
        "Callerid" => '"'.$page_name.'" <'.$page_info['page_id'].'>',
		'Set' => 'SKIP_INTRO=TRUE'
        
    );
    
    $base_dir = dirname(__FILE__);
    
    require_once($base_dir.'/includes/call_file.class');
    
    $call_file = new call_file($amp_conf['ASTSPOOLDIR']);

    //I dont like this method
	require_once($amp_conf['AMPWEBROOT'].'/admin/modules/pagingpro/includes/class.astinfo.php');
    $astinfo = new astinfo($astman);
    $astver = $astinfo->check_asterisk();
    if($astver) {
        $call_file->write($options['t'],$call);
    }
    pagingpro_schedule_next_event($options['p']);
}

function pp_arraysearchrecursive($needle, $haystack, $index= null) {
    $aIt     = new RecursiveArrayIterator($haystack); 
    $it    = new RecursiveIteratorIterator($aIt); 
    $resultkeys = false;
    while($it->valid()) {        
        if (((isset($index) AND 
        ($it->key() == $index)) OR 
        (!isset($index))) AND 
        (!is_array($it->current()) AND 
        (strpos($it->current(), $needle)!==false))) { //$it->current() == $needle 
            $resultkeys[]=$aIt->key(); //return $aIt->key(); 
        } 
        $it->next(); 
    } 
    return $resultkeys;  // return all finding in an array 
}
