<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }
/** parkpro_configpageinit
 * Short initialize parkinglot list for devices
 * Long provides guielements with the required parkinglot
 * list for the device/extension lists
 *
 * @author Philippe Lindheimer
 * @param string $dispnum
 * @return mixed
 */

function parkpro_configpageinit($dispnum) {
global $currentcomponent;
switch ($dispnum) {
  case 'extensions':
    // if tech_hardware set, this is an initial extension/device creation
    // otherwise, determine if the target extension/device is DAHDI
    //
		if (isset($_REQUEST['tech_hardware']) && (
			$_REQUEST['tech_hardware'] == 'sip_generic' ||
			$_REQUEST['tech_hardware'] == 'iax2_generic' ||
			$_REQUEST['tech_hardware'] == 'dahdi_generic' )) {
			$extdisplay = '';
		} elseif (!isset($_REQUEST['parkpro_parkinglot']) && !isset($_REQUEST['extdisplay'])) {
			return true;
		} else {
			$device_info = core_devices_get($_REQUEST['extdisplay']);
			if (empty($device_info) || $device_info['tech'] != 'sip' && $device_info['tech'] != 'iax2' && $device_info['tech'] != 'dahdi') {
				return true;
			}
		}
  break;
  case 'devices':
	if (isset($_REQUEST['tech_hardware']) && (
			$_REQUEST['tech_hardware'] == 'sip_generic' ||
			$_REQUEST['tech_hardware'] == 'iax2_generic' ||
			$_REQUEST['tech_hardware'] == 'dahdi_generic' )) {
		$extdisplay = '';
	} elseif (!isset($_REQUEST['parkpro_parkinglot'])) {
		$extdisplay = isset($_REQUEST['extdisplay']) ? $_REQUEST['extdisplay'] : '';
		$device_info = core_devices_get($extdisplay);
		if (empty($device_info) || $device_info['tech'] != 'sip' && $device_info['tech'] != 'iax2' && $device_info['tech'] != 'dahdi') {
			return true;
		}
	}
  break;
  default;
	return true;
  break;
  }

	$parklist = parkpro_get('all');
	foreach ($parklist as $lot) {
		$currentcomponent->addoptlistitem('parkpro_parkinglots', $lot['id'], $lot['name']);
	}
	$currentcomponent->setoptlistopts('parkpro_parkinglots', 'sort', false);

  $currentcomponent->addguifunc("parkpro_{$dispnum}_configpageload");

	if (!empty($_REQUEST['action'])) {
		$currentcomponent->addprocessfunc("parkpro_{$dispnum}_configprocess");
	}
}

function parkpro_devices_configpageload() {
  parkpro_configpageload('device');
}

function parkpro_extensions_configpageload() {
  parkpro_configpageload('extension');
}

function parkpro_configpageload($mode) {
	global $currentcomponent;
	global $parkpro;

	$extdisplay = isset($_REQUEST['extdisplay'])?$_REQUEST['extdisplay']:null;
	$parkpro_parkinglot = parkpro_device_get($extdisplay);

	$parkinglot_select = $currentcomponent->getoptlist('parkpro_parkinglots');
	
	if($parkpro) {
		$currentcomponent->addguielem('Device Options', new gui_selectbox( 'parkpro_parkinglot', $parkinglot_select, $parkpro_parkinglot,
		  _('Parkinglot'), sprintf(_('Choose a default parkinglot for this %s'),$mode), false));
	} else {
		$currentcomponent->addguielem('Device Options', new gui_hidden('parkpro_parkinglot', $parkpro_parkinglot));
	}	  
}

function parkpro_extensions_configprocess() {
	switch ($_REQUEST['action']) {
	case 'add':
	case 'edit':
		parkpro_device_save($_REQUEST['extension'], $_REQUEST['parkpro_parkinglot']);
		break;
	case 'del':
		parkpro_del($_REQUEST['extdisplay']);
		break;
	}
}

function parkpro_devices_configprocess() {
	switch ($_REQUEST['action']) {
	case 'add':
	case 'edit':
		parkpro_device_save($_REQUEST['deviceid'], $_REQUEST['parkpro_parkinglot']);
		break;
	case 'del':
		parkpro_del($_REQUEST['extdisplay']);
		break;
	}
}
