<?php
function pinsetspro_applyhooks() {
	global $CC;
	// Add the 'process' function - this gets called when the page is loaded,
	//to hook into displaying stuff on the page.
	$CC->addguifunc('pinsetspro_configpageload');
}

// This is called before the page is actually displayed, so we can use addguielem(). draws hook on the extensions/users page
function pinsetspro_configpageload() {
	global $CC, $display, $pinsetspro;
	$extdisplay = isset($_REQUEST['extdisplay'])
				? $_REQUEST['extdisplay']
				: null;
	if ($display == 'extensions' || $display == 'users'){
		$routes = core_routing_list();
		$section= _('Pinless Dialing');
		foreach($routes as $route){
			$status = pinsetspro_astdb_get($extdisplay, $route['route_id']);
			if ($pinsetspro) {
				$CC->addguielem($section,
					new gui_checkbox('route|' . $route['route_id'],
							$status, $route['name'],
							_('Bypass pin requirments when dialing via outbound '
							. 'route ' . $route['name']),
							'true','','')
						);
			} else {
				$CC->addguielem($section,
					new gui_hidden('route|' . $route['route_id'], $status)
				);
			}
		}
	}
}

function pinsetspro_configpageinit($pagename) {
	global $CC;
	$dispaly = isset($_REQUEST['display'])
		? $_REQUEST['display'] : '';
	$extdisplay = isset($_REQUEST['extdisplay'])
		? $_REQUEST['extdisplay'] : '';
	// On a 'new' user, 'tech_hardware' is set, and there's no extension.
	if (($dispaly == 'users'||$dispaly == 'extensions') && $extdisplay != '') {
		$CC->addprocessfunc('pinsetspro_configpageload', 1);
		$CC->addprocessfunc('pinsetspro_configprocess', 1);
	}
}

//prosses recived arguments
function pinsetspro_configprocess() {
	$extdisplay = isset($_REQUEST['extdisplay'])
		? $_REQUEST['extdisplay'] : null;
	$display = isset($_REQUEST['display'])
		? $_REQUEST['display'] : null;
	$action = isset($_REQUEST['action'])
		? $_REQUEST['action'] : null;
	//if we are editing users/extensions
	if(($display == 'extensions' || $display == 'users') && $action == 'edit'){
		$routes = core_routing_list();
		foreach($routes as $route){//loop thru routes
			$setting = (isset($_REQUEST['route|' . $route['route_id']])
					&& $_REQUEST['route|' . $route['route_id']] == 'true')
				? 1 : null;
			//update astdb based on user selection
			pinsetspro_astdb_put($extdisplay, $route['route_id'], $setting);
		}
	}
}
function pinsetspro_astdb_get($ampuser,$trunk){
	global $astman;
	if(!$astman){
		return false;
	}
	//update with new name
	return $astman->database_get('AMPUSER/' . $ampuser . '/nopinset', $trunk);
}

function pinsetspro_astdb_put($ampuser,$trunk,$value){
	global $astman;
	if(!$astman){
		return false;
	}
	if($value){
		//add new key
		$astman->database_put('AMPUSER/' . $ampuser . '/nopinset',
			$trunk, $value);
		}else{
		//delete old key
		$astman->database_del('AMPUSER/' . $ampuser . '/nopinset', $trunk);
	}
}
function pinsetspro_hook_pinsets_get_config_macro($engine) {
	global $ext, $pinsetspro, $amp_conf;
	if (!$pinsetspro) {
		return false;
	}
	switch($engine) {
		case 'asterisk':
			$c = 'macro-pinsets';
			$ext->remove($c, 's', 0);
			$ext->remove($c, 's', 0);
			$ext->remove($c, 's', 0);
			$ext->remove($c, 's', 0);
			$ext->remove($c, 'cdr', 0);
			$ext->remove($c, 'cdr', 0);

			//remove  current macro and replace it
			$ext->add($c, 's', '', new ext_set('PINSETUSER',
				'${IF($["${EXTTOCALL}"!=""]?${EXTTOCALL}:${AMPUSER})}'));
			$ext->add($c, 's', '', new ext_gotoif('${ARG2} = 1','cdr,1'));
			$ext->add($c, 's', '', new ext_execif(
				'$["${DB(AMPUSER/${PINSETUSER}/nopinset/${ARG3})}" != "1"]',
				'Authenticate',
				$amp_conf['ASTETCDIR'] . '/pinset_${ARG1}'));
			$ext->add($c, 's', '', new ext_execif(
				'$["${DB(AMPUSER/${PINSETUSER}/nopinset/${ARG3})}" != "1"]',
				'ResetCDR'));

			// authenticate with the CDR option (a)
			$ext->add($c, 'cdr', '', new ext_execif(
				'$["${DB(AMPUSER/${PINSETUSER}/nopinset/${ARG3})}" != "1"]',
				'Authenticate',
				$amp_conf['ASTETCDIR'] . '/pinset_${ARG1},a'));
			$ext->add($c, 'cdr', '', new ext_execif(
				'$["${DB(AMPUSER/${PINSETUSER}/nopinset/${ARG3})}" != "1"]',
				'ResetCDR'));
			break;
	}
}

function pinsetspro_hook_pinsets_get_config($engine) {
	global $ext, $pinsetspro;
	if(!$pinsetspro) {
		return false;
	}
	switch($engine) {
		case "asterisk":
			$usage_list = pinsets_list_usage('routing');
			if (is_array($usage_list) && count($usage_list)) {
				$pinsets = pinsets_list(true);
				$addtocdr = array();
				foreach ($pinsets as $pinset) {
					$addtocdr[$pinset['pinsets_id']] = $pinset['addtocdr'];
				}
				foreach ($usage_list as $thisroute) {
					$context = 'outrt-'.$thisroute['foreign_id'];
					$patterns = core_routing_getroutepatternsbyid(
						$thisroute['foreign_id']);
					foreach ($patterns as $pattern) {
						$fpattern = core_routing_formatpattern($pattern);
						$exten = $fpattern['dial_pattern'];
						//$ext->remove($context, $exten, 1);
						$ext->replace($context, $exten, 1,
								new ext_macro('pinsets',
									$thisroute['pinsets_id'] . ','
									. $addtocdr[$thisroute['pinsets_id']] . ','
									. $thisroute['foreign_id']));
					}
				}
			}
			break;
	}
}

function pinsetspro_sysadmin_getinfo() {
    return array(
        "name" => "Pinsets Pro", // Required. Descriptive name.
        "expires" => true,         // Optional. Defaults to false (never expires)
        "keyname" => "pinset_pro_exp", // Optional. Only checked if 'expires' is true
    );
}
