<?php

if(isset($amp_conf)){
	$cdrdb=DB::connect('mysql://'.$amp_conf['AMPDBUSER'].':'.$amp_conf['AMPDBPASS'].'@'.$amp_conf['AMPDBHOST'].'/asteriskcdrdb'); // attempt connection
}

//query db and draw select boxes. this ensure that the user cant submit data that wont match
function pinsetspro_draw_select($detail,$name,$current=''){
	global $cdrdb;
	switch($detail){
		case 'accounts':
			$sql=' select distinct accountcode from cdr where accountcode not like ""';
		break;
		case 'year':
			$sql='SELECT DISTINCT DATE_FORMAT(calldate,"%Y") AS year FROM cdr ORDER BY year';
			$current = $current ? $current : date('Y', time());
		break;
		case 'month':
			$sql='SELECT DISTINCT DATE_FORMAT(calldate,"%M") AS month FROM cdr ORDER BY DATE_FORMAT(calldate,"%m")';
			$current = $current ? $current : date('M', time());
		break;
		case 'day':
			$sql='SELECT DISTINCT DATE_FORMAT(calldate,"%d") AS day FROM cdr ORDER BY day';
			$current = $current ? $current : date('d', time());
		break;
	}

	$items=$cdrdb->getCol($sql);
	$html='<select name="'.$name.'">';
	//harcoded options
	switch($detail){
		case 'accounts':
			$html.='<option value="all" '.($item==$current?'SELECTED':'').'>All</option>';
		break;
	}
	//dynamic options
	foreach($items as $item){
		$html.='<option value="'.$item.'" '.($item==$current?'SELECTED':'').'>'.$item.'</option>';
	}
	$html.='</select>';
	echo $html;
}

//return array with report data
function pinsetspro_get_report(){
	global $cdrdb;
	$get=array('frommonth','fromday','fromyear','tomonth','today','toyear','source','destination','duration','billsec','account');
	foreach($get as $g){
		$$g=isset($_REQUEST[$g])?trim($_REQUEST[$g]):'';
	}
	$from = $fromyear.'-'.date("m",strtotime($frommonth.' 01')).'-'.$fromday;
	$to = $toyear.'-'.date("m",strtotime($tomonth.' 01')).'-'.$today;
	
	//bump to next day if were looking at one day only
	if ($from == $to) {
		$eto = strtotime($to) + (60 * 60 * 24);
		$to = date('Y', $eto) . '-' . date('m', $eto) . '-' . date('d', $eto);
	}

	$sql='SELECT calldate, accountcode, src, dst, duration, billsec FROM cdr WHERE calldate >= "'. $from .'" and calldate <= "'. $to .'"'; 
	
	//dynamicly build the rest of the select statment
	if($account=='all'){
		$sql.=' and accountcode !=""';
	}else{
		$sql.=' and accountcode ="'.$account.'"';
	}
	if($source){
		$sql.=' AND src = "'.$cdrdb->escapeSimple($source).'"';
	}
	if($destination){
		$sql.=' AND dst = "'.$cdrdb->escapeSimple($destination).'"';
	}
	if($duration){
		$sql.=' AND duration = "'.$cdrdb->escapeSimple($duration).'"';
	}
	if($billsec){
		$sql.=' AND billsec = "'.$cdrdb->escapeSimple($billsec).'"';
	}
	//get query
	$data=$cdrdb->getAll($sql,DB_FETCHMODE_ASSOC);

	return $data;
}

//return cvs with report data. this will use the same parms as the web gui report
function pinsetspro_get_cvs(){
	global $cdrdb;
	$q=pinsetspro_get_report();

	$data='';
	//add column headers, based on the DB colmun headers
	foreach(array_keys($q[0]) as $h){
		$data.='"'.$h.'",';
	}
	$data.="\n";
	foreach($q as $r){
		foreach($r as $my => $h){
			//dbug($my, $h);
			switch ($my) {
				case 'duration':
				case 'billsec':
					$data.='"'.pinsetspro_rTime($h).'",';
					break;
				default:
					$data.='"'.$h.'",';
					break;
			}
			
		}
		$data.="\n";
	}
	//return data, then exit so that we dont leak any other data in to the file.
	//use time() in filename for a unique file every time
	header('Content-type: text/x-csv');
	header('Content-Disposition: attachment; filename=pinset-report-totals-'.time().'.csv');
	echo $data;
	exit;
}

//return cvs with report data. this will use the same parms as the web gui report
function pinsetspro_get_totals_cvs(){
	global $cdrdb;
	$q=pinsetspro_get_report_summery();
	
	$data='';
	//add column headers
	$data.='"Account Code","Duration","Billable Time"';
	$data.="\n";
	foreach($q as $my => $r){
		$data.='"'.$my .'","'. pinsetspro_rTime($r['duration']) . '","' . pinsetspro_rTime($r['billsec']) . '",';
		$data.="\n";
	}
	//return data, then exit so that we dont leak any other data in to the file.
	//use time() in filename for a unique file every time
	header('Content-type: text/x-csv');
	header('Content-Disposition: attachment; filename=pinset-reports-summery-'.time().'.csv');
	echo $data;
	exit;
}

function pinsetspro_get_report_summery() {
	$report = pinsetspro_get_report();
	foreach ($report as $r) {
		if (!isset($sum[$r['accountcode']]['duration'])) {
			$sum[$r['accountcode']]['duration'] = 0;
		}
		if (!isset($sum[$r['accountcode']]['billsec'])) {
			$sum[$r['accountcode']]['billsec'] = 0;
		}
		$sum[$r['accountcode']]['duration'] += $r['duration'];
		$sum[$r['accountcode']]['billsec'] += $r['billsec'];
	}
	return $sum;
}

function pinsetspro_rTime($sec) {
	$hour	= floor($sec / 3600);
	$min	= floor(($sec / 60) - $hour * 60);
	$sec	= $sec - ($hour * 3600) - ($min * 60);
	
	//add two zeros for nice numbers
	$min	= ($min < 10) ? '0' . $min : $min;
	$sec	= ($sec < 10) ? '0' . $sec : $sec;
	
	//format time in to hours:minutes:seconds
	$time 	= $hour . ':' . $min . ':' . $sec;
	
	return $time;
}
?>
