<?php

// check to see if this script is already running
exec('ps ax | grep import_queue_data | grep -v grep | grep -v /bin/sh | wc -l',$result);
$alreadyrunning = (integer) $result[0];

if ($alreadyrunning > 1) {
  echo "ERROR: An instance of this script is already running on this system.\n";
  exit;
}

if (!isset($debug)) $debug = false;
if (!isset($execute)) $execute = true;
$reimport = false;

require_once('/var/www/html/admin/modules/qxact_reports/functions.inc/report_functions.php');
require_once('/var/www/html/admin/modules/qxact_reports/functions.php');

$processfiles = array();
unset($argv[0]);
foreach ($argv as $thisarg) {
	
	if (file_exists($thisarg)) {
		$reimport = true;
		$processfiles[] = $thisarg;
	} elseif (file_exists($amp_conf['ASTLOGDIR']."/$thisarg")) { 
		$reimport = true;
		$processfiles[] = $amp_conf['ASTLOGDIR']."/$thisarg";
	} else {
		switch ($thisarg) {
			
			case '--no-execute': 
			case '--noexecute': 
				$execute = false;
				// notice there is no break here because we want debug set to true as well below
				
			case '--debug':
				$debug = true;
				break;
			
			default:
				echo "WARNING: Skipping $thisarg - File not found or invalid argument.\n";
		}
	}
}

if (!$reimport){
$qry = "
SELECT 
  (SELECT MAX(time) FROM qxact_calls) AS a,
  (SELECT MAX(time) FROM qxact_agent_actions) AS b,
  (SELECT MAX(time) FROM qxact_agent_calls) AS c,
  (SELECT MAX(time) FROM qxact_system_events) AS d
";

$row = $db->getRow($qry, DB_FETCHMODE_ASSOC);
$datelimit = $row['a'];
$datelimit = ($row['b'] > $datelimit?$row['b']:$datelimit);
$datelimit = ($row['c'] > $datelimit?$row['c']:$datelimit);
$datelimit = ($row['d'] > $datelimit?$row['d']:$datelimit);
} else {
	$datelimit = time() - 7889229;
}


if (count($processfiles) == 0) {
	// set the default log file if we are not reimporting 
	$processfiles[] = $amp_conf['ASTLOGDIR'].'/queue_log';
}

// start looping for reimport 

foreach ($processfiles as $thisfile) {
	
	if ($debug) echo "Importing $thisfile\n\n";
	
	$agent_calls = array();
	$agent_actions = array();
	$system_events = array();
	$calls = array();
	$did_numbers = array();

	$log_file = fopen( $thisfile, "r" );

	if ( $log_file ) {
	  while (!feof($log_file)) {
		$line = rtrim(fgets($log_file, 4096));

		// 0 = timestamp
		// 1 = uniqueid
		// 2 = queue
		// 3 = agent
		// 4 = eventname
		// 5-8 = optional params based on event
		if (strlen($line)>1) {
		  $a_line = explode('|',$line);
		  
		  if ($a_line[0] > $datelimit) {
		    if ($debug) echo "${a_line[0]} > $datelimit\n";

		    switch ($a_line[4]) {
		      // agent calls
		      case 'RINGNOANSWER':
		        $agent_calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'ringtime' => $a_line[5]
		        );
		      break;
		      case 'AGENTDUMP':
		        $agent_calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		        );
		      break;
		      // agent actions 
		      case 'AGENTLOGIN':
		        $agent_actions[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => clean_event($a_line[4]),
		          'channel' => $a_line[5]
		        );
		      break;
		      case 'AGENTLOGOFF':
		        $agent_actions[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => clean_event($a_line[4]),
		          'channel' => $a_line[5],
		          'logintime' => $a_line[6]
		        );
		      break;
		      case 'ADDMEMBER':
		        $agent_actions[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => clean_event($a_line[4]),
		        );
		      break;
		      case 'REMOVEMEMBER':
		        $agent_actions[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => clean_event($a_line[4]),
		        );
		      break;
		      
		      case 'AGENTCALLBACKLOGIN':
		        $agent_actions[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => clean_event($a_line[4]),
		        );
		      break;
		      case 'AGENTCALLBACKLOGOFF':
		        $agent_actions[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => clean_event($a_line[4]),
		        );
		      break;
		      case 'PAUSE':
		        $agent_actions[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => clean_event($a_line[4]),
		        );
		      break;
		      case 'UNPAUSE':
		        $agent_actions[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => clean_event($a_line[4]),
		        );
		      break;
		      // system events
		      case 'CONFIGRELOAD':
		      case 'QUEUESTART':
		        $system_events[] = Array(
		          'time' => $a_line[0],
		          'queuename' => $a_line[2],
		          'event' => $a_line[4]
		        );
		      break;
		      // call events
		      case 'ABANDON':
		        $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'position' => $a_line[5],
		          'origpos' => $a_line[6],
		          'waittime' => $a_line[7]
		        );
		      break;
		      case 'COMPLETEAGENT':
		      case 'COMPLETECALLER':
		      $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'waittime' => $a_line[5],
		          'calltime' => $a_line[6],
		          'origpos' => $a_line[7]
		        );
		      break;
		      case 'CONNECT':
		        $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'waittime' => $a_line[5]
		        );
		      break;
		      case 'ENTERQUEUE':
		        $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'callerid' => $a_line[6]
		        );
		      break;
		      case 'EXITEMPTY':
		        $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'position' => $a_line[5],
		          'origpos' => $a_line[6],
		          'waittime' => $a_line[7]
		        );
		      break;
		      case 'EXITWITHKEY':
		        $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'key' => $a_line[5],
		          'position' => $a_line[6],
		          'origpos' => $a_line[7],
		          'waittime' => $a_line[8]
		        );
		      break;
		      case 'EXITWITHTIMEOUT':
		        $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'position' => $a_line[5],
		          'origpos' => $a_line[6],
		          'waittime' => $a_line[7]
		        );
		      break;
		      case 'SYSCOMPAT':
		        $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		        );
		      break;
		      case 'TRANSFER':
		        $calls[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          // transfer events are not properly reported at this time, we may
		          // add this field to the db in the future if we can find a way to
		          // get useful transfer events from asterisk
		          //'xferdest' => $a_line[5].'@'.$a_line[6],
		          'waittime' => $a_line[7],
		          'calltime' => $a_line[8]
		        );
		      break;
		      case 'DID':
		        $did_numbers[] = Array(
		          'time' => $a_line[0],
		          'uniqueid' => $a_line[1],
		          'queuename' => $a_line[2],
		          //'agent' => clean_agent($a_line[3]),
		          'event' => $a_line[4],
		          'did' => $a_line[5]
		        );
		    } // end switch
		  } else {
		    if ($debug) echo "skipping because ${a_line[0]} <= $datelimit\n";
		  } // end if date
		} // end if strlen 
	  } // end while
	  fclose($log_file);
	  
	  //print_r($calls);
	  //echo "\n\n\n";
	  //print_r($agent_calls);
	  //echo "\n\n\n";
	  //print_r($agent_actions);
	  //echo "\n\n\n";
	  //print_r($system_events);
	} else {
	  echo "ERROR: Unable to open default log file $log_path for import.\n";
	}

	if (count($calls) > 0) {
		
		// check if we are reimporting this data and drop conflicts
		if ($reimport) {
			// sanity check to make sure that the dates are rational (date within last 90 days)
			if (($calls[0]['time'] >= (time() - 7889229)) && $calls[0]['time'] >= (time() - 7889229)){
				$cstart = $calls[0]['time'];
				$clast = (integer) count($calls) - 1;
				$cend = $calls[$clast]['time'];
				$qry = "DELETE FROM `qxact_calls` WHERE `time` BETWEEN $cstart AND $cend";
				if ($debug) echo "$qry\n\n";
				if ($execute) $db->query($qry);
			}
		}
		
		$qry = "INSERT INTO qxact_calls (`time`,`uniqueid`,`queuename`,`agent`,`event`,`callerid`,`waittime`,`calltime`,`origpos`,`position`,`key`) VALUES \n";
		foreach($calls as $call) {
			$qry .= '('.
				db_prep_int($call['time']).','.
				db_prep_char($call['uniqueid']).','.
				db_prep_char($call['queuename']).','.
				db_prep_char($call['agent']).','.
				db_prep_char($call['event']).','.
				@db_prep_char($call['callerid']).','.
				@db_prep_int($call['waittime']).','.
				@db_prep_int($call['calltime']).','.
				@db_prep_int($call['origpos']).','.
				@db_prep_int($call['position']).','.
				@db_prep_int($call['key']).
			"),\n";
		}
		
		$qry = substr($qry,0,-2);
		if ($debug) echo $qry."\n\n";
		if ($execute) $db->query($qry);
	}

	if (count($agent_calls) > 0) {
		// check if we are reimporting this data and drop conflicts
		if ($reimport) {
			// sanity check to make sure that the dates are rational (date within last 90 days)
			if (($agent_calls[0]['time'] >= (time() - 7889229)) && $agent_calls[0]['time'] >= (time() - 7889229)){
				$cstart = $agent_calls[0]['time'];
				$clast = (integer) count($agent_calls) - 1;
				$cend = $agent_calls[$clast]['time'];
				$qry = "DELETE FROM `qxact_agent_calls` WHERE `time` BETWEEN $cstart AND $cend";
				if ($debug) echo "$qry\n\n";
				if ($execute) $db->query($qry);
			}
		}
	
		$qry = "INSERT INTO qxact_agent_calls (`time`,`uniqueid`,`queuename`,`agent`,`event`,`ringtime`) VALUES \n";
		foreach($agent_calls as $call) {
			$qry .= '('.
				db_prep_int($call['time']).','.
				db_prep_char($call['uniqueid']).','.
				db_prep_char($call['queuename']).','.
				db_prep_char($call['agent']).','.
				db_prep_char($call['event']).','.
				@db_prep_int($call['ringtime']).
			"),\n";
		}
		$qry = substr($qry,0,-2);
		if ($debug) echo $qry."\n\n";
		if ($execute) $db->query($qry);
	}


	if (count($agent_actions) > 0) {
	
		// check if we are reimporting this data and drop conflicts
		if ($reimport) {
			// sanity check to make sure that the dates are rational (date within last 90 days)
			if (($agent_actions[0]['time'] >= (time() - 7889229)) && $agent_actions[0]['time'] >= (time() - 7889229)){
				$cstart = $agent_actions[0]['time'];
				$clast = (integer) count($agent_actions) - 1;
				$cend = $agent_actions[$clast]['time'];
				$qry = "DELETE FROM `qxact_agent_actions` WHERE `time` BETWEEN $cstart AND $cend";
				if ($debug) echo "$qry\n\n";
				if ($execute) $db->query($qry);
			}
		}
		
		$qry = "INSERT INTO qxact_agent_actions (`time`,`uniqueid`,`queuename`,`agent`,`event`,`channel`,`logintime`,`reason`) VALUES \n";
		foreach($agent_actions as $action) {
			$qry .= '('.
				db_prep_int($action['time']).','.
				db_prep_char($action['uniqueid']).','.
				db_prep_char($action['queuename']).','.
				db_prep_char($action['agent']).','.
				db_prep_char($action['event']).','.
				@db_prep_char($action['channel']).','.
				@db_prep_int($action['logintime']).','.
				@db_prep_char($action['reason']).
			"),\n";
		}
		$qry = substr($qry,0,-2);
		if ($debug) echo $qry."\n\n";
		if ($execute) $db->query($qry);
	}

	if (count($system_events) > 0) {
		// check if we are reimporting this data and drop conflicts
		if ($reimport) {
			// sanity check to make sure that the dates are rational (date within last 90 days)
			if (($system_events[0]['time'] >= (time() - 7889229)) && $system_events[0]['time'] >= (time() - 7889229)){
				$cstart = $system_events[0]['time'];
				$clast = (integer) count($system_events) - 1;
				$cend = $system_events[$clast]['time'];
				$qry = "DELETE FROM `qxact_system_events` WHERE `time` BETWEEN $cstart AND $cend";
				if ($debug) echo "$qry\n\n";
				if ($execute) $db->query($qry);
			}
		}
		$qry = "INSERT INTO qxact_system_events (`time`,`queuename`,`event`) VALUES \n";
		foreach($system_events as $event) {
			$qry .= '('.
				db_prep_int($event['time']).','.
				db_prep_char($event['queuename']).','.
				db_prep_char($event['event']).
			"),\n";
		}
		$qry = substr($qry,0,-2);
		if ($debug) echo $qry."\n\n";
		if ($execute) $db->query($qry);
}

} // end of loop


// CLEANUP - These items run only once at the end 

//Remove data older than 3 months before we start doing other things that take lots of time
$qry = "DELETE FROM qxact_agent_actions WHERE time < UNIX_TIMESTAMP() - 7889229;";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

$qry = "DELETE FROM qxact_agent_calls WHERE time < UNIX_TIMESTAMP() - 7889229;";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

$qry = "DELETE FROM qxact_calls WHERE time < UNIX_TIMESTAMP() - 7889229;";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

$qry = "DELETE FROM qxact_system_events WHERE time < UNIX_TIMESTAMP() - 7889229;";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);


// fix agent names
// $qry = "UPDATE qxact_calls, users SET qxact_calls.agent = users.name WHERE (qxact_calls.agent = users.extension OR qxact_calls.agent = CONCAT('SIP/',users.extension) OR qxact_calls.agent = REPLACE(users.name,' ',''))";
$qry = "UPDATE qxact_calls, users SET qxact_calls.agent = users.name WHERE (qxact_calls.agent = users.extension) AND time >= $datelimit";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

$qry = "UPDATE qxact_agent_actions, users SET qxact_agent_actions.agent = users.name WHERE (qxact_agent_actions.agent = users.extension) AND time >= $datelimit";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

// fix NONE to blank in agent names
$qry = "UPDATE qxact_calls SET agent = '' WHERE agent = 'NONE'";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

$qry = "UPDATE qxact_agent_actions SET agent = '' WHERE agent = 'NONE'";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

// fix queue names
$qry = "UPDATE qxact_calls, queues_config SET qxact_calls.queuename = queues_config.descr where qxact_calls.queuename = queues_config.extension";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

$qry = "UPDATE qxact_agent_calls, queues_config SET qxact_agent_calls.queuename = queues_config.descr where qxact_agent_calls.queuename = queues_config.extension";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

$qry = "UPDATE qxact_agent_actions, queues_config SET qxact_agent_actions.queuename = queues_config.descr where qxact_agent_actions.queuename = queues_config.extension";
if ($debug) echo "\n\n$qry\n\n";
if ($execute) $db->query($qry);

// update did numbers
foreach($did_numbers as $adid) {
  $thisuniqueid = $adid['uniqueid'];
  $thisdid =  $adid['did'];
  $qry = "UPDATE qxact_calls SET did = '$thisdid' where uniqueid = '$thisuniqueid'";
  if ($debug) echo "\n\n$qry\n\n";
  if ($execute) $db->query($qry);
}

// update callerid fields
// This simply finds any calls that have some callerid data missing and looks to see if we have it somewhere else
// then updates every instance of that uniqueid to have the correct callerid.
$qry = "SELECT DISTINCT uniqueid FROM qxact_calls WHERE callerid = ''";
if ($debug) echo "\n\n$qry\n\n";
$result = sql($qry,"getAll",DB_FETCHMODE_ASSOC);

$uniqueids = array();
foreach($result as $thisone) {
  $uniqueids[] = $thisone['uniqueid'];
}
if (count($uniqueids > 0)) {
	$uniqueids = "('".implode("','",$uniqueids)."')";
	$qry = "SELECT DISTINCT uniqueid, callerid FROM qxact_calls where callerid > '' AND uniqueid IN $uniqueids";
	if ($debug) echo "\n\n$qry\n\n";
	$rows = sql($qry,"getAll",DB_FETCHMODE_ASSOC);
	foreach ($rows as $row) {
	  $qry="UPDATE qxact_calls SET callerid = '".$row['callerid']."' WHERE uniqueid = '".$row['uniqueid']."'";
	  if ($debug) echo $qry."\n";
	  if ($execute) $db->query($qry);
	}
}



?>
