<?php

set_time_limit(1200);
require_once(dirname(__FILE__) . '/../functions.inc/report_queries.php');
$debug = 0;
if ($debug) {
    echo "<!-- POST DATA: \n";
    print_r($_POST);
    echo "--> \n\n";
}

// check to make sure we have all the data we need
if (!$agents || !$queues || !$template_id) {
    die('Not all required fields were provided');
}

// we need to pull the template data from the database
$sql = "SELECT * FROM qxact_reports WHERE id = $template_id ORDER BY name ASC";
$qxact_db->query($sql);

// load it into an array
$result = $qxact_db->a_row();

// the data is serialized in the database, so we need to turn it back into
// an array that is almost identical to the $_POST[] array from a form
$template_data = unserialize($result['data']);

$thistable = 1;

// we are going to loop through the tables saved in the template data in the DB
// and set all the dynamic variables with the correct values for each table
while ($template_data['t'.$thistable.'_type']) {

    ${"t${thistable}_name"}=($template_data["t${thistable}_name"]?$template_data["t${thistable}_name"]:'Table 1');
    ${"t${thistable}_type"}=$template_data["t${thistable}_type"];
    ${"t${thistable}_type_label"} = first_column_label(${"t${thistable}_type"});
    ${"t${thistable}_columns"}=(is_array($template_data["t${thistable}_".${"t${thistable}_type"}."_columns"]) ?
        $template_data["t${thistable}_".${"t${thistable}_type"}."_columns"]:Array());
    //echo "t${thistable}_".${"t${thistable}_type"}."_columns";
    //print_r(${"t${thistable}_columns"});
    $thistable++;
}

// number of tables is pulled from the number of loops above minus one
$tables = $thistable-1;

// I don't think this is necessary since I use a different variable name later...
$thistable = 1;
?>
<table cellspacing="0" cellpadding="3" align="center" style="border-width:1px;border-style:solid;border-color:#000000;border-top:0px;border-left:0px;border-right:0px;width:100%;">
    <tr>
        <th colspan="2" style="background:#cccccc;">Report Summary</th>
    </tr>
    <tr>
        <th align="left" valign="top" colspan="1"  style="background:#99cc99;border:0px;border-top:1px;border-bottom:1px;border-color:#000000;border-style:solid;">Date Range</th>
        <td colspan="1" style="background:#99cc99;border:0px;border-top:1px;border-bottom:1px;border-color:#000000;border-style:solid;"><?php echo date("Y M j",$from_timestamp) ?> - <?php echo
date("Y M
j",$to_timestamp)
?> (<?php echo format_time_duration(($to_timestamp - $from_timestamp)-(($to_timestamp - $from_timestamp)%86400)) ?>)</td>
    </tr>
    <tr>
        <th align="left" valign="top"  style="border: 1px solid #000000;border-top:0px;border-left:0px;background:#eeeeee;">Queues</th>
        <td style="background:#eeeeee;border:0px;border-top:0px;border-bottom:1px;border-color:#000000;border-style:solid;"><?php
            foreach($queues as $queue) {
                echo "$queue <br>\n";
            }
            ?></td>
    </tr>
    <tr>

        <th align="left" valign="top" style="border: 1px solid #000000;border-bottom:0px;border-left:0px;border-top:0px;background:#99cc99;">Agents</th>
        <td style="background:#99cc99;border:0px;border-top:0px;border-color:#000000;border-style:solid;"><?php
            foreach($agents as $agent) {
                echo clean_agent($agent) . " <br>\n";
            }
            ?></td>
    </tr>
</table>

<br />
<br />
<br />

<?php

// each table needs to be constructed, we use this while loop to do that
while ($thistable <= $tables) {

    // load all column queries into an array
    $queries = Array();
    foreach(${"t${thistable}_columns"} as $column) {
        $sql = ${"${"t${thistable}_type"}_columns"}[$column][4];
        $sql = str_replace('##QUEUES##',format_sql_array($queues),$sql);
        $sql = str_replace('##AGENTS##',format_sql_array($agents),$sql);
        $sql = str_replace('##FROMTIMESTAMP##',$from_timestamp,$sql);
        $sql = str_replace('##TOTIMESTAMP##',$to_timestamp,$sql);
        $sql = str_replace('##SLAINCREMENT##','15',$sql);
        $queries[] = $sql;
    }

    // SQL debug
    if ($debug>1) {
      echo "\n\n<pre>\n";
      print_r($queries);
      echo "\n\n</pre>\n";
    }

    // We now need to loop through these queries and build an array of results
    $report_table = Array();
    foreach($queries as $query) {
        $qxact_db->query($query);
        $report_table[] = $qxact_db->a_all();
    }

    // sql debug
    if ($debug>2) {
      echo "<pre>\n\n";
      print_r($report_table);
      echo "\n\n</pre>";
    }
    if (count($report_table)) {
?>
    <table align="center" cellspacing="0" cellpadding="3" width="100%" style="border-color:#057691;border-top:2px;border-right:0px;border-left:0px;border-bottom:2px;">

    <tr>
        <th colspan="<?php echo (count(${"t${thistable}_columns"})+1) ?>" style="text-align:center;background:#cccccc;">
            <p style="text-decoration:underline;margin-bottom:-6px;">
                <?php echo ${"t${thistable}_name"} ?>
			<p style="font-family:Arial,Helvetica,sans-serif;font-size:8pt;color:#000000;font-weight:bold;margin-left:-72px;margin-bottom:-16px;">Export as:&nbsp;&nbsp;&nbsp;
            <form name="<?php echo ${"t${thistable}_type"} ?>_tocsv" method="post" action="<?php echo  $_SERVER['REQUEST_URI'] ?>">
                <input type="hidden" name="from_day" value="<?php echo $from_day ?>"/>
                <input type="hidden" name="from_month" value="<?php echo $from_month ?>"/>
                <input type="hidden" name="from_year" value="<?php echo $from_year ?>"/>
                <input type="hidden" name="from_timestamp" value="<?php echo $from_timestamp ?>"/>
                <input type="hidden" name="to_day" value="<?php echo $to_day ?>"/>
                <input type="hidden" name="to_month" value="<?php echo $to_month ?>"/>
                <input type="hidden" name="to_year" value="<?php echo $to_year ?>"/>
                <input type="hidden" name="to_timestamp" value="<?php echo $to_timestamp ?>"/>
                <input type="hidden" name="queues" value="<?php echo implode('%`&',$queues) ?>"/>
                <input type="hidden" name="agents" value="<?php echo implode('%`&',$agents) ?>"/>
                <input type="hidden" name="table_id" value="<?php echo ${thistable} ?>"/>
                <input type="hidden" name="template_id" value="<?php echo $template_id ?>"/>
				<input type="hidden" name="action" value="csv"/>
                <input type="IMAGE" name="csv" value="csv" src="modules/qxact_reports/assets/images/excel.png" />
                </p>
            </form>

        </th>
    <tr>
        <?php
        foreach(${"t${thistable}_columns"} as $column) {
        ?>
            <th><?php echo ${"${"t${thistable}_type"}_columns"}[$column][1] ?></th>
        <?php
        } // end foreach
        ?>
    </tr>
    <tr>
        <?php
        for ($rownum=0;$rownum<count($report_table[0]);$rownum++) {
            foreach ($report_table as $col) {
                $column = key($col[$rownum]);
                $value = $col[$rownum][$column];
        ?>
                <td align="right" nowrap="NOWRAP" style="background:#cccfff;border:1px solid #057691;"><?php echo column_format($value,$column) ?></td>

        <?php
                if (is_numeric($value)) {
                    ${"${column}_sum"}[] = $value;
                }
            } // end foreach $report_table
        ?>
        </tr>
        <tr>
        <?php
        } // end for
        $first=1;
        foreach($report_table as $col) {
            if ($first) {
                $first=0;
        ?>
                <td align="right" nowrap="NOWRAP" style="background:#eeeeee;">Totals:</td>
        <?php
            }else{
                $column = key($col[0]);
        ?>
                <td align="right" nowrap="NOWRAP" style="background:#eeeeee;"><?php echo column_sum_format(${"${column}_sum"},$column) ?></td>
        <?php
                unset(${"${column}_sum"});
            }
        } // end foreach
        ?>
    </tr>
</table>
<br />
<br />
<br />
    <?php
    } // end if count($report_table)
    $thistable++;
    //break;
} // end tables loop

?>
