<?php
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) {
	include_once('/etc/asterisk/freepbx.conf');
}

if(isset($callrecrpt)) {
	unset($callrecrpt);
}

if (zend_loader_file_encoded()) {
	$lic_info       = zend_loader_file_licensed();
	$lic_exp        = isset($lic_info['callrecrpt_exp'])?preg_replace('/-/','',$lic_info['callrecrpt_exp']):'00000000';
	if ($lic_exp > date('Ymd')) {
			$callrecrpt = true;
	} else {
			$callrecrpt = false;
	}
} else {
        $callrecrpt = true;
}

if ($callrecrpt != TRUE) {
	exit;
}

require_once "DB.php";
$amp_conf = backupRecordings_parse_amportal_conf("/etc/amportal.conf");
$db = get_dbh();
if ($db){
	$sql = "select * from sysadmin_options where `key` = 'fromemail'";
	$result = $db->getRow($sql, DB_FETCHMODE_ASSOC);
	$from = $result['value'];

	$sql = "select * from recording_report where `key` = 'recordingEmail'";
	$result = $db->getRow($sql, DB_FETCHMODE_ASSOC);
	$to = $result['value'];

	$sql = "select * from globals where `variable` = 'ArchiveLimit'";
	$result = $db->getRow($sql, DB_FETCHMODE_ASSOC);
	$archiveLimit = $result['value'];

	if ($from && $to){
		if (backupRecordingsSendmail($to, $from)){
			performbackup($archiveLimit);
		}
	}
}

function rotatebackups(){
	// Directory to look for files
	exec(fpbx_which('date') . '>>/var/log/asterisk/recording_report');
	$dir = '/var/spool/asterisk/monitor';
	if(file_exists("$dir/backup3.tar")){
		exec('/bin/rm -f ' . $dir . '/backup3.tar');
		exec(fpbx_which('echo') . ' backup3.tar removed.>>/var/log/asterisk/recording_report');
	}
	if(file_exists("$dir/backup2.tar")){
		rename($dir . '/backup2.tar', $dir . '/backup3.tar');
		exec(fpbx_which('echo') . ' backup2.tar renamed to backup3.tar.>>/var/log/asterisk/recording_report');
	}
	if(file_exists("$dir/backup1.tar")){
		rename($dir . '/backup1.tar', $dir . '/backup2.tar');
		exec(fpbx_which('echo') . ' backup1.tar renamed to backup2.tar.>>/var/log/asterisk/recording_report');
	}
}

function performbackup($archiveLimit){
	exec(fpbx_which('echo') . ' Starting archive of all recordings older than ' . $archiveLimit . '.>>/var/log/asterisk/recording_report');
	$dir = '/var/spool/asterisk/monitor';
	// set the archive limit +1 cause we run on the first
	$archiveLimit = $archiveLimit +1;
	// Holds the files that need to be backed up
	$backupfiles = array();
	// Open a known directory, and proceed to read its contents
	if (is_dir($dir)){
		if ($dh = opendir($dir)){
			// get the current time and set archive dates
			$date = explode('-', date('Y-m-d'));
			unset($date[2]);
			if($date[1] <= $archiveLimit){
				$year = $date[0] -1;
				$month = $date[1] - $archiveLimit;
				if($month == 0){$month = 12;}
				if ($month < 0){$month = $month + 12;}
			} else {
				$year = $date[0];
				$month = $date[1] - $archiveLimit;
			}
			exec(fpbx_which('echo') . ' Going to backup anything older than ' . $month . '-' . $year .'.>>/var/log/asterisk/recording_report');

			//get directories to archive
			$yearDir = array_diff(scandir($dir), array('..', '.'));
			foreach($yearDir as $k=>$v){
				if($v<=$year && is_numeric($v)){
					$years[] = $v;
				}
			}
			foreach ($years as $yearK => $yearV) {
				$monthDir = array_diff(scandir($dir . '/' . $yearV), array('..', '.'));
				foreach($monthDir as $k=>$v){
					if($year > $yearV){
						$archive[] = $yearV . '/' . $v;
					} else {
						if($v<=$month && is_numeric($v)){
							$archive[] = $yearV . '/' . $v;
						}
					}
				}
			}

			$tar = '';
			if (is_array($archive) && !empty($archive)) {
				rotatebackups();
				$txt = "List of directories to be backed up then deleted:\n";
				foreach($archive as $k=>$v){
					$txt .= $v . "\n";
					$tar .= $v . ' ';
				}
				file_put_contents('/var/log/asterisk/recording_report', $txt, FILE_APPEND);
				system("cd $dir && " . fpbx_which('tar') . ' cf backup1.tar ' . $tar, $retval);
				if($retval == 0){
					//delete files
					foreach($archive as $k=>$v){
					echo $v . "\n";
						exec("cd $dir && " . fpbx_which('rm') . " -rf $v");
					}
				}
			}
		}
	}
}
function backupRecordingsSendmail($to, $from){
	$headers = 'From: ' . $from . "\r\n" . 'Reply-to: ' . $to;
	$subject = "Call Recordings backed up.";
	$mail_body = "We have just performed a monthly backup of your call recordings.

	If you wish to save your call recordings, please log in and download your call recording archives.";
	return mail($to, $subject, $mail_body, $headers, ('-f ' . $from));
}

function backupRecordings_parse_amportal_conf($filename){
	$file = file($filename);
	foreach ($file as $line){
		if (preg_match("/^\s*([a-zA-Z0-9]+)\s*=\s*(.*)\s*([;#].*)?/",$line,$matches)){
			$conf[ $matches[1] ] = $matches[2];
		}
	}
	return $conf;
}

function get_dbh(){
	global $amp_conf;

	// datasource in in this style: dbengine://username:password@host/database
	$datasource = $amp_conf['AMPDBENGINE'] . '://' . $amp_conf['AMPDBUSER'] . ':' . $amp_conf['AMPDBPASS'] . '@' . $amp_conf['AMPDBHOST'] . '/' . $amp_conf['AMPDBNAME'];

	// attempt connection
	$dbh = DB::connect($datasource);

	if(DB::isError($dbh)) {
		echo $dbh->getMessage();
		die_freepbx($dbh->getMessage());
		return;
	}

	return $dbh;
}


