<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}

if(isset($callrecrpt)) {
        unset($callrecrpt);
}

if (zend_loader_file_encoded()) {
        $recording_report_lic_info       = zend_loader_file_licensed();
        $recording_report_lic_exp        = isset($recording_report_lic_info['callrecrpt_exp'])?preg_replace('/-/','',$recording_report_lic_info['callrecrpt_exp']):'00000000';

	if ($recording_report_lic_exp > date('Ymd')) {
                $callrecrpt = true;
        } else {
                $callrecrpt = false;
        }
} else {
        $callrecrpt = true;
}

if ($callrecrpt != FALSE) {

  function recordingReportGetDir($directory){
  	global $amp_conf;
  	$dir = array_diff(scandir($directory), array('..', '.'));
  	return($dir);
  }

  function recordingReportDeleteRecordings($recordings){
  	foreach($recordings as $k=>$v){
  		$error = exec('/bin/rm -f ' . $v, $retval);
  		echo $error;
  	}
  }

  function recordingReportGetDuration($file){
  	global $amp_conf;
  	$bitrateOfAudioFile = 128;

  	$length = floor( filesize($file) / $bitrateOfAudioFile * 0.008);

  	$days = floor($length / 86400);

  	$hours2 = (string) (( $length - (86400 * $days)) / 3600);
      	$hours = (int)floor($hours2);

  	$minString = "0".substr($hours2, strpos($hours2, "."), 3);
      	$minutes = floor(60 * (float)$minString);

  	$seconds = str_pad(round(fmod($length,60)), 2, "0", STR_PAD_LEFT);

  	$playlength = ((int)$days>0)? $days.":" : "";
      	$playlength .= ((int)$hours>0)? $hours.":" : (((int)$days>0)? "00:" : "");
      	$playlength .= ((int)$minutes>0)? $minutes.":" : (((int)$days>0 || (int)$hours>0)? "00:" : "");

  	if(empty($playlength)) {
  		$playlength .= "0:";
  	}

  	$playlength .= ((int)$seconds>0)? $seconds : "00";

  	return($playlength);
  }

  function recording_report_put_email($email) {
  	global $db;
  	$sql = "REPLACE INTO recording_report (`key`, value) VALUES ('recordingEmail', '$email')";
  	$sql = $db->query($sql);
  	if($db->IsError($ret)) {
      	die_freepbx($ret->getDebugInfo()."\n".$ret->getUserInfo()."\n".$db->last_query);
    	}
  }

  function recording_report_get_email() {
          global $db;

          $ret = $db->getOne('SELECT value FROM recording_report WHERE `key` = "recordingEmail"');
  		if($db->IsError($ret)) {
  	    	die_freepbx($ret->getDebugInfo()."\n".$ret->getUserInfo()."\n".$db->last_query);
  	  	}

  		return $ret;
  }
  function recording_report_get_from() {
          global $db;

          $ret = $db->getOne('SELECT value FROM sysadmin_options WHERE `key` = "fromemail"');
  		if($db->IsError($ret)) {
  	    	die_freepbx($ret->getDebugInfo()."\n".$ret->getUserInfo()."\n".$db->last_query);
  	  	}

  		return $ret;
  }


  // Everything below this comment hooks into the Notifications page
  function recording_report_configpageinit($pagename) {
  	global $currentcomponent;

  	switch ($pagename) {
  		case 'sysadmin':
  			if (isset($_REQUEST['view']) && $_REQUEST['view'] == 'notifications') {
  				recording_report_applyhooks();
  				$currentcomponent->addprocessfunc('recording_report_configprocess', 8);
  			}
  	}
  }

  //hooks recording_report -> other mods
  function recording_report_applyhooks(){
  	global $currentcomponent;
  	$currentcomponent->addguifunc("recording_report_configpageload");
  }

  //draw  gui
  function recording_report_configpageload() {
  	global $currentcomponent;
  	$currentcomponent->addguielem('Email Destinations', new gui_textbox('recording_report_email', recording_report_get_email(), _('Call Recording Report'), _('This module will send you reminders to download your call recording archives.'), "", "", true),7,6);
  }

  // Does the save work
  function recording_report_configprocess() {
  	if (
  		isset($_REQUEST['display']) && $_REQUEST['display'] == 'sysadmin'
  		&& isset($_REQUEST['view']) && $_REQUEST['view'] == 'notifications'
  		&& isset($_REQUEST['action']) && $_REQUEST['action'] == 'save'
  		&& isset($_REQUEST['recording_report_email'])
  	) {
  			recording_report_put_email($_REQUEST['recording_report_email']);
  		}

  }

  function recording_report_sysadmin_getinfo() {
      return array(
        "name" => "Call Recording Reports", // Required. Descriptive name.
        "expires" => true,         // Optional. Defaults to false (never expires)
        "keyname" => "callrecrpt_exp", // Optional. Only checked if 'expires' is true
      );
  }
} //end callrecrpt if
