<?php

class FaxProFaxes{
	private $api;
	
	function __construct($api) {
		$this->api = & $api;
		include_once(dirname(__FILE__) . '/../../sysadmin/functions.inc.php');
		include_once(dirname(__FILE__) . '/../../fax/functions.inc.php');
		include_once(dirname(__FILE__) . '/../functions.inc.php');
	}
	
	function index() {
		return $this->get_faxpro_users();
	}
	
	/**
	 * @verb GET
	 * @returns - a list of users' faxes
	 * @uri /fax/users/:id/faxes
	 */
	 function get_faxpro_users_id_faxes($params) {
		$faxes = array();
		foreach(faxpro_get_user_storage($params['id']) as $fax) {
			$id = $fax['faxid'];
			$faxes[$id] = $fax;
			unset(
				$faxes[$id]['faxid'], 
				$faxes[$id]['file'],
				$faxes[$id]['user']
			);
		}
		return $faxes ? $faxes : false;
	 }
	
	/**
	 * @verb GET
	 * @returns - the metadata of a specific fax 
	 * @uri /fax/users/:id/faxes/:faxid
	 */
	 function get_faxpro_users_id_faxes_id($params) {
		$fax = array();

		$fax = faxpro_get_user_storage($params['id'], $params['faxid']);
		if (isset($fax[0])) {
			$fax = $fax[0];
			unset(
				$fax['faxid'], 
				$fax['file'],
				$fax['user']
			);
		}
		return $fax ? $fax : false;
	 }
	
	/**
	 * @verb GET
	 * @returns - the actual fax file
	 * @uri /fax/users/:id/faxes/:faxid/fax
	 */
	 function get_faxpro_users_id_faxes_id_fax($params) {
		$fax = array();

		$fax = faxpro_get_user_storage($params['id'], $params['faxid']);
		if (isset($fax[0]) && $fax[0]['file_exists']) {
			download_file($fax[0]['file']);
			return true;
		}
		return false;
	 }
	
	/**
	 * @verb POST
	 * @uri /fax/users/:id/faxes
	 */
	 function post_faxpro_users_id_faxes($params) {
		$vars['user'] = $params['id'];
		
		$get = array(
				'tonum'			=> '',
				'is_local'		=> false,
				'dest'			=> '',
				'coversheet'	=> false,
				'name'			=> '',
				'msg'			=> '',
				'tel'			=> '',
				'email'			=> '',
				'sender'		=> '',
				
		);
		
		foreach ($get as $k => $v) {
			$vars[$k] = isset($params[$k]) ? $params[$k] : $v;
		}
		$vars['coversheet'] = $vars['coversheet']  !== false ? true : false;
		
		if (!isset($_FILES, $_FILES['fax'])) {
			echo _('No files received!') . PHP_EOL;
			exit();
		}
			
		$fax = new FaxproSend($vars['user'], $vars['tonum'], $vars['is_local']);

		//add files		
		for ($i = 0; $i < count($_FILES['fax']['name']); $i++) {
			$files	= & $_FILES['fax'];

			$ext	= preg_replace('/[^[:alpha:]]/i', 
						'', 
						pathinfo($files['name'][$i], 
						PATHINFO_EXTENSION));
			$file	= $files['tmp_name'][$i] . '.' . $ext;
			move_uploaded_file($files['tmp_name'][$i], $file);
			
			$fax->add_file($file);
			unlink($file);
		}

		//add coverpage if requested
		if ($vars['coversheet']) {
			$fax->add_coversheet($vars['name'], 
				$vars['msg'],  
				$vars['sender'], 
				$vars['tel'], 
				$vars['email']);
		}
		
		return $fax->send_fax(false);
	 }
}
