<?php

class FaxProUsers{
	private $api;
	
	function __construct($api) {
		$this->api = & $api;
		include_once(dirname(__FILE__) . '/../functions.inc.php');
	}
	
	function index() {
		return $this->get_faxpro_users();
	}
	
	/**
	 * @verb GET
	 * @returns - a list of users' fax settings
	 * @uri /fax/users
	 */
	 function get_faxpro_users($params) {
		$users = array();
		foreach (fax_get_user() as $user) {
			$users[$user['user']] = $user;
			unset($users[$user['user']]['user']);
		}

		return $users ? $users : false;
	 }

	/**
	 * @verb GET
	 * @returns - a list of users' fax settings
	 * @uri /fax/users
	 */
	 function get_faxpro_users_id($params) {
		$users = fax_get_user($params['id']);
		if (isset($users['user'])) {
			unset($users['user']);
		}
		return $users ? $users : false;
	 }
	
	/**
	 * @verb PUT
	 * @uri /fax/users/:id
	 */
	 function put_faxpro_users_id($params) {
		$vars = array(
				'localstore',
				'stationid',
				'header',
				'covername',
				'covertel',
				'coveremail'
		);
		foreach ($vars as $k) {
			$params[$k] = isset($params[$k]) ? $params[$k] : '';
		}
	 	return faxpro_save_user(
	 					$params['id'], 
	 					$params['localstore'], 
	 					$params['stationid'], 
	 					$params['header'], 
	 					$params['covername'], 
	 					$params['covertel'], 
	 					$params['coveremail']
	 	);
	 }
}
