<?php

class Parkpro{
	private $api;
    	
	function __construct($api) {
		$this->api = & $api;

		if (function_exists('parkpro_licensed')) {
			list($parkpro,$pagepro) = parkpro_licensed();
			if (isset($parkpro) && $parkpro === true) {
				$this->licensed = true;
			}
		}
	}	
	
	function index() {
		return $this->get(null);
        }

       /**
	* @verb GET
	* @returns 
	* @uri /parkpro
	*/
        function get($params) {
		if (!$this->licensed) {
			return false;
		}

        	return true;
	}

	/**
         * @verb GET
         * @returns - a list of parkpro lots
         * @uri /parkpro/lots
         */
         function get_parkpro_lots($params) {
		if (!$this->licensed) {
			return false;
		}

	        $lots = array();

		$parkpro_alllots = parkpro_get('all');

		foreach ($parkpro_alllots as $lot) {
                        $lots[$lot['id']]['id'] = $lot['id'];
                        $lots[$lot['id']]['parkext'] = $lot['parkext'];
                        $lots[$lot['id']]['parkpos'] = $lot['parkpos'];
                        $lots[$lot['id']]['numslots'] = $lot['numslots'];
                        $lots[$lot['id']]['type'] = $lot['type'];
                	unset($lot);
		}

                return $lots ? $lots : false;
         }

        /**
         * @verb GET
         * @returns - a list of lots' parkpro settings
         * @uri /parkpro/lots/:id
         */
         function get_parkpro_lots_id($params) {
		if (!$this->licensed) {
			return false;
		}

		$lots = parkpro_get($params['id']);

		return $lots ? $lots : false;
         }

	/**
         * @verb PUT
         * @uri /parkpro/lots/:id
         */
         function put_parkpro_lots_id($params) {
		if (!$this->licensed) {
			return false;
		}

		return parking_save($params);
         }

	/**
         * @verb GET
         * @returns - a list of users' parkpro lots
         * @uri /parkpro/users
         */
         function get_parkpro_users($params) {
		if (!$this->licensed) {
			return false;
		}

	        $lots = array();

		$parkpro_alllots = parkpro_device_get();

		foreach ($parkpro_alllots as $lot => $lotid) {
                        $lots[$lot] = $lotid;
                	unset($lot);
		}

                return $lots ? $lots : false;
         }

        /**
         * @verb GET
         * @returns - users parkpro lot
         * @uri /parkpro/users/:id
         */
         function get_parkpro_users_id($params) {
		if (!$this->licensed) {
			return false;
		}

		$lot = parkpro_device_get($params['id']);

                return $lot ? $lot : false;
         }

	/**
         * @verb PUT
         * @uri /parkpro/users/:id
         */
         function put_parkpro_users_id($params) {
		if (!$this->licensed) {
			return false;
		}

		return parkpro_device_save($params['id'], $params['lot']);
         }
}
