<?php
// bootstrap freepbx
$bootstrap_settings['freepbx_auth'] = false;
$restrict_mods = array('restapi' => true);
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) { 
	include_once('/etc/asterisk/freepbx.conf'); 
}

$api = new Api;

$url = $_GET['url'];
$verb = "GET";
if (isset($_GET['verb'])) {
	$verb = $_GET['verb'];
}
$token = $_GET['token'];
$tokenkey = $_GET['tokenkey'];
$body = $_GET['body'];

$nonce = restapi_tokens_generate();
$data = $api->auth->get_data_hash($token, $url, $verb, $nonce, $body);
$sig = $api->auth->get_signature($data, $tokenkey);

$ch = curl_init($url);

$headers = array(
	"Nonce: " . $nonce,
	"Signature: " . $sig,
	"Token: " . $token,
	"Content-Type: application/json"
);
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $verb);
curl_setopt($ch, CURLOPT_POSTFIELDS, $body);

$response = curl_exec($ch);

print($response);

?>
