<?php

// bootstrap freepbx
$bootstrap_settings['freepbx_auth'] = false;
$restrict_mods = array(
	'userman' => true,
	'restapps' => true,
	'restapi' => true,
	'endpoint' => true,
	'sysadmin' => true
);
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) {
	include_once('/etc/asterisk/freepbx.conf');
}

$user_agent = parse_user_agent();

parse_str($_SERVER['QUERY_STRING'], $page_args);

$path = explode("/", trim($_SERVER['PATH_INFO'], "/"));
$server_uri = "http://" . $_SERVER['SERVER_NAME'] . ":" . $_SERVER["SERVER_PORT"] . htmlspecialchars(strtok($_SERVER['REQUEST_URI'], "?")) . "?" . (isset($page_args["user"]) ? "user=" . $page_args["user"] : "");

if (strlen($user_agent["mac"]) == 12) {
	$ep_users = endpoint_api(array('mac' => $user_agent["mac"]));

	if (is_array($ep_users) && count($ep_users) >= 1) {
		if (isset($page_args["user"])) {
			/* user was specified in URL.  Make sure it's in the list. */
			foreach ($ep_users as $u) {
				if ($u["ext"] == $page_args["user"]) {
					$user = $u["ext"];
					break;
				}
			}

			unset($page_args["user"]);
		}

		if ($user == NULL) {
			$user = $ep_users[0]["ext"];
		}
	}
}

if ($user == NULL) {
	$user = $page_args["user"];
	unset($page_args["user"]);
}

$body = json_decode(file_get_contents('php://input'), true);

$app_args = array();
foreach ($page_args as $key => $val) {
	if ($key == "action" || $key == "actiondata" || $key == "linestate" || substr($key, 0, 4) == "app_") {
		$app_args[$key] = $val;
	} else {
		continue;
	}

	unset($page_args[$key]);
}
foreach ($body as $key => $val) {
	if (substr($key, 0, 4) == "app_") {
		$app_args[$key] = $val;
	} else {
		continue;
	}

	unset($body[$key]);
}

switch ($user_agent["brand"]) {
case "aastra":
case "yealink":
	$body = aastra_get_body($page_args);
	break;
}

if ($body && count($body) > 0) {
	$page_data = $ctrl->application_page_set($path[0], $path[1], $user, $app_args, json_encode($body));
}

if ($page_data == NULL) {
	$page_data = $ctrl->application_page_get($path[0], $path[1], $user, $app_args);
}

$page_output = $page_data;

switch ($user_agent["brand"]) {
case "aastra":
case "yealink":
	$page_output = aastra_get_page($page_data, $page_args);
	aastra_set_content_type();
	break;
}

echo $page_output;

?>
