<?php
//	License for all code of this FreePBX module can be found in the license file inside the module directory
//	Copyright 2013 Schmooze Com Inc.
//

if (file_exists("/var/lib/asterisk/agi-bin/LoadLicenseIfExists.php")) {
	include_once("/var/lib/asterisk/agi-bin/LoadLicenseIfExists.php");
}

$dir = dirname(__FILE__);

require_once($dir . '/functions.inc/license.php');
if (!function_exists('restapps_licensed')) {
	function restapps_licensed() {
		return false;
	}
}

$restapps = restapps_licensed();

require_once($dir . '/functions.inc/controller.class.php');

$ctrl = new Controller();

function parse_expansions() {
	$expansions = array(NULL, NULL, NULL);

	if (isset($_SERVER["X-Aastra-ExpMod1"])) {
		$expansions[0] = $_SERVER["X-Aastra-ExpMod1"];
	}
	if (isset($_SERVER["X-Aastra-ExpMod2"])) {
		$expansions[1] = $_SERVER["X-Aastra-ExpMod2"];
	}
	if (isset($_SERVER["X-Aastra-ExpMod3"])) {
		$expansions[2] = $_SERVER["X-Aastra-ExpMod3"];
	}

	return $expansions;
}

function parse_user_agent() {
	$user_agent_str = $_SERVER["HTTP_USER_AGENT"];

	$agent_patterns = array(
		"/^(?P<brand>[Aa]astra)(?P<model>.*?) MAC:(?P<mac>.*?) V:(?P<firmware>.*?)-(?P<protocol>.*)$/" => NULL,
		"/^(?P<brand>[Yy]ealink) (?P<model>.*?) (?P<firmware>.*?) (?P<mac>.*)$/" => array("protocol" => "SIP"),
		"/^(?P<model>VP530P) (?P<firmware>.*?) (?P<mac>.*)$/" => array("brand" => "yealink", "protocol" => "SIP"),
		"/^(?P<brand>Digium)-(?P<model>.*?)\/(?P<firmware>.*?)$/" => array("mac" => $_SERVER["HTTP_X_DIGIUM_MAC"], "protocol" => "SIP")
	);

	foreach ($agent_patterns as $agent_pattern => $defaults) {
		if (preg_match($agent_pattern, $user_agent_str, $matches)) {
			if (isset($defaults)) {
				foreach ($defaults as $key => $val) {
					$matches[$key] = $val;
				}
			}
			$user_agent = array();
			$user_agent["brand"] = strtolower($matches["brand"]);
			$user_agent["model"] = $matches["model"];
			$user_agent["mac"] = str_replace(array("-", ":"), "", strtoupper($matches["mac"]));
			$user_agent["firmware"] = $matches["firmware"];
			$user_agent["protocol"] = $matches["protocol"];

			$expansions = parse_expansions();
			$user_agent["expansion0"] = $expansions0;
			$user_agent["expansion1"] = $expansions1;
			$user_agent["expansion2"] = $expansions2;

			return $user_agent;
		}
	}

	return NULL;
}

?>
