<?php

/* Build a ZIP file for the named application */
function digium_application_package($application, $display = NULL) {
	global $amp_conf;
	$path = dirname(__FILE__) . "/../digium_phone/";
	$filename = $amp_conf['AMPWEBROOT'] . "/restapps/application_" . $application . ".zip";

	$zip = new ZipArchive();
	if (!$zip->open($filename, ZipArchive::CREATE | ZipArchive::OVERWRITE)) {
		return;
	}

	$app = json_decode(file_get_contents($path . "app.json"));
	$app->name = $application;
	$app->displayName = $display ? $display : $application;

	if (file_exists($path . $application . ".png")) {
		$app->iconFile = $application . ".png";

		$zip->addFile($path . $app->iconFile, $app->iconFile);
	}

	foreach ($app->jsFiles as $jsFile) {
		$zip->addFile($path . $jsFile, $jsFile);
	}

	/* otherFiles isn't used by the phone.  It's just a handy way for us to put other files into the ZIP. */
	if (isset($app->otherFiles)) {
		foreach ($app->otherFiles as $otherFile) {
			$zip->addFile($path . $otherFile, $otherFile);
		}
		unset($app->otherFiles);
	}

	$zip->addFromString("app.json", json_encode($app));

	$ret = $zip->close();

	return $ret ? $filename : NULL;
}

function digium_autoanswer() {
	return array('Alert-Info' => 'intercom');
}

?>
