<?php

ini_set('error_log','/var/log/restapps.log');

// bootstrap freepbx
$bootstrap_settings['freepbx_auth'] = false;
$restrict_mods = array(
	'userman' => true,
	'restapps' => true,
	'restapi' => true,
	'endpoint' => true
);
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) {
	include_once('/etc/asterisk/freepbx.conf');
}

if ($restapps !== true) {
	die('REST Applications module is not licensed.' . PHP_EOL);
}

freepbx_log(FPBX_LOG_INFO, 'REST apps daemon started.');

/* Upgrade the DB connector */
if ($db->phptype == "mysql") {
	$dbengine = 'mysqli';

	$datasource = $dbengine . '://'
		. $amp_conf['AMPDBUSER']
		. ':'
		. $amp_conf['AMPDBPASS']
		. '@'
		. $amp_conf['AMPDBHOST']
		. '/'
		. $amp_conf['AMPDBNAME'];
	$db = freepbx_DB::connect($datasource); // attempt connection
}

$restopts = restapi_opts_get();
dbug('restopts', $restopts);
if ($restopts && $restopts["token"] && $restopts["tokenkey"]) {
	$rest = new RESTClient(NULL, $restopts["token"], $restopts["tokenkey"]);
} else {
	die('Unable to obtain credentials for REST API.' . PHP_EOL);
}

foreach($ctrl->applications as $application) {
	$func = $application->name . "_daemon_init";
	if (is_callable($func)) {
		call_user_func($func);
	}
}

$astman->Events("on");

$last_db_ping = time();
while (true) {
	if (time() > ($last_db_ping + (60 * 60))) {
		/* PING! */
		$db->getOne("SELECT 1");
		$last_db_ping = time();
	}
	$astman->wait_response(true);
}

?>
