<?php

// bootstrap freepbx
$bootstrap_settings['freepbx_auth'] = false;
$restrict_mods = array(
	'restapps' => true,
	'restapi' => true,
	'endpoint' => true
);
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) { 
	include_once('/etc/asterisk/freepbx.conf'); 
}

$user_agent = parse_user_agent();

$path = explode("/", trim($_SERVER['PATH_INFO'], "/"));
$server_uri = "http://" . $_SERVER['SERVER_NAME'] . ":" . $_SERVER["SERVER_PORT"] . htmlspecialchars(strtok($_SERVER['REQUEST_URI'], "?")) . "?" . (isset($page_args["user"]) ? "user=" . $page_args["user"] : "");

parse_str($_SERVER['QUERY_STRING'], $page_args);

if (strlen($user_agent["mac"]) == 12) {
	$ep_users = endpoint_api(array('mac' => $user_agent["mac"]));

	if (count($ep_users) == 1) {
		$user = $ep_users[0]["ext"];
	} else if (count($ep_users) > 1) {
		/* Multiple users configured for device.  URL must specify one. */
		foreach ($ep_users as $u) {
			if ($u["ext"] == $page_args["user"]) {
				unset($page_args["user"]);
				$user = $u["ext"];
			}
		}
	}
} else if ($user == NULL) {
	$user = $page_args["user"];
	unset($page_args["user"]);
}

$rest = new RESTClient($user, NULL, NULL);

/* License check */
if ($restapps === true) {
	$buttons = endpoint_apiButtons($user);
}

foreach ($buttons as $button) {
	if (!isset($button["value"])) {
		continue;
	}
	$button_name = str_replace("REST-", "", $button["value"]);

	$func_prefix = NULL;
	$hasbutton = false;

	foreach ($ctrl->applications as $application) {
		if ($button_name == $application->display) {
			$func_prefix = $application->name;
			$hasbutton = true;
		} else {
			foreach ($application->pages as $page) {
				if (!$page->display) {
					continue;
				}

				if ($button_name == $page->display) {
					$func_prefix = $application->name . '_' . $page->name;
					$hasbutton = true;
					break;
				}
			}
		}

		if ($hasbutton) {
			break;
		}
	}

	if ($hasbutton) {
		$func = $func_prefix . "_sync_cb";
		if (is_callable($func)) {
			call_user_func($func, $user);
		}
	}
}

switch ($user_agent['brand']) {
	case "aastra":
	case "yealink":
		$page_output = aastra_sync_data();
		aastra_set_content_type();
		break;
}

echo $page_output;

?>
