<?php
//This must stay for backwards compatibility with older modules that aren't
//	aware of ZEND_LICENSE_LOADED. As some use this to determine if the license
//	was loaded successfully
$load_license = false;

// If we've already been loaded...
if (defined('ZEND_LICENSE_LOADED')) {
	$load_license = true;
	return;
}

if (empty($bootstrap_settings['bootstrapped'])) {
	$restrict_mods = true;
	if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) {
		  include_once('/etc/asterisk/freepbx.conf');
	}
}

// Check to make sure we have the zend loader available, otherwise don't even bother.
if (!function_exists('zend_loader_enabled') || !zend_loader_enabled() ) {
	return false;
}

//re #872 for why we call global $amp_conf here
global $amp_conf;

//preload all autoloaded includes, as zend apprently breaks that
if (function_exists('fpbx_framework_autoloader')) {
	fpbx_framework_autoloader(true);
}

$lic_file 	= '';
$shmzDir 	= '/etc/schmooze';
if (is_dir($shmzDir)) {
	$dir 		= scandir($shmzDir);
	$lic_dir 	= $shmzDir;
} else {
	$dir 		= scandir($amp_conf['ASTAGIDIR']);
	$lic_dir	= $amp_conf['ASTAGIDIR'];
}

// Find licence files in our directory.
$licences = glob($lic_dir."/lic*zl");

foreach ($licences as $l) {
	// Check to see it actually looks sane.
	$tmparr = parse_ini_file ($l, false, INI_SCANNER_RAW);
	if (isset($tmparr['Product-Name'])) {
		// Yay. Does this file match our zend host ID?
		$myid = zend_get_id();
		if ($tmparr['hostid'] == $myid[0]) {
			// There's a good chance this is a licence for this host. Load it!
			// 'true' means 'overwrite any previous licence'
			zend_loader_install_license($l, true);
			define('ZEND_LICENSE_LOADED', true);
			$load_license = true;
		}
	}
}
