#!/usr/bin/env php
<?php

$bootstrap_settings['freepbx_auth'] = false;
$restrict_mods = array('sysadmin' => true);
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) { 
	  include_once('/etc/asterisk/freepbx.conf'); 
}

//get our cli arguements
$longopts = array(
        'hash::',
	'curl::',
	'email::',
	'register::',
	'location::',
);
$vars = getopt('h::c::e::r::l::', $longopts);

foreach ($vars as $key => $value) {
	switch ($key) {
		case 'hash':
		case 'h':
			$vars['hash'] = TRUE;
			break;
		case 'curl':
		case 'c':
			$vars['curl'] = TRUE;
			break; 
		case 'register':
		case 'r':
			$vars['register'] = TRUE;
			break;
		case 'email':
		case 'e':
			$email_address = trim($value);
			if(!filter_var($email_address, FILTER_VALIDATE_EMAIL)) {
				echo 'Please try again, entering a valid email address';
				exit;
			}
			$vars['email'] = $email_address;	
			break;
		case 'location':
		case 'l':
			$vars['location_name'] = trim($value);
			break;
		default:
			unset($vars[$key]);
			break;
	}
	if (strlen($key) == 1) {
		unset($vars[$key]);
	}
}

/*if(!isset($vars['email'])) {
	$vars['email'] = false;
}*/

//check if we were started from the cli or by a service
$cli = (php_sapi_name() == 'cli' ? false : true);

$lic = sysadmin_fetch_license(sysadmin_get_pbxid(), $cli, $cli, $vars);

if (!$lic) { // && $vars['register'] !==  TRUE) {
	$vars['curl'] = TRUE;
	$lic = sysadmin_fetch_license(sysadmin_get_pbxid(), $cli, $cli, $vars);
}

print_r($lic);

if (!$lic) {
	echo "License download failed, please try again \n";
} else {
	echo "License updates successfully! \n";
}


?>
