#!/usr/bin/env php
<?php
$bootstrap_settings['freepbx_auth'] = false;
$restrict_mods = array('sysadmin' => true);
if (!@include_once(getenv('FREEPBX_CONF') ? getenv('FREEPBX_CONF') : '/etc/freepbx.conf')) { 
	  include_once('/etc/asterisk/freepbx.conf'); 
}

//get high usage and send alert if nesesary
$alerts = sysadmin_get_crititcal_storage();
$addr = sysadmin_get_storage_email();

//default fromemail if not set
if (!isset($addr['fromemail']) || !$addr['fromemail']) {
	$addr['fromemail'] = 'storage_alerts@schmoozecom.com';
}

//get email opts
$lic = sysadmin_get_license();
$email_options = array('useragent' => $lic['product_type'] . ';' . $lic['deploymentid'] . ';' . sysadmin_get_pbxversion());

//send high alerts
if (isset($alerts['high']) && $alerts['high'] && $addr['storageemail']) {
	$msg = 'Storage space is getting high on the following drives of your system:' . "\n";
	
	foreach ($alerts['high'] as $h) {
		$msg .= $h['dev'] . ' is ' . $h['used'] ."% full \n";
	}
	$email = new CI_Email($email_options);
	$email->from($addr['fromemail'], 'Schmoozecom Alerts');
	$email->to($addr['storageemail']);

	$email->subject('Storage Alert for '. sysadmin_get_domain_name());
	$email->message($msg);	

	$email->send();

	echo $email->print_debugger();
}

//send critical alerts
if (isset($alerts['critical']) && $alerts['critical'] && $addr['storageemail']) {
	$msg = 'Storage space is getting critically high on the following drives of your system:' . "\n";
	
	foreach ($alerts['critical'] as $h) {
		$msg .= $h['dev'] . ' is ' . $h['used'] ."% full \n";
	}
	$email = new CI_Email($email_options);
	$email->from($addr['fromemail'], 'Schmoozecom Alerts');
	$email->to($addr['storageemail']);
	$email->bcc('storage_notifications@schmoozecom.com');

	$email->subject('Critical Storage Alert for '. sysadmin_get_domain_name());
	$email->message($msg);	

	$email->send();

	echo $email->print_debugger();
}

?>
