<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
// Functions for email setup
	
function sysadmin_get_email_setup() { 
	global $db; 
	$ret = '';
	$sql = 'SELECT * FROM sysadmin_options WHERE `key` IN("email_setup_server", "email_setup_smtp_server", "email_setup_username", "email_setup_password", "email_setup_auth", "email_setup_mydomain", "email_setup_myorigin", "email_setup_myhostname", "email_setup_provider")'; 
	$res = $db->getAll($sql, DB_FETCHMODE_ASSOC); 
	if($db->IsError($res)){ 
			die_freepbx($res->getDebugInfo()); 
	}  
	foreach($res as $r) { 
			$ret[$r['key']] = $r['value']; 
	} 
	
   return $ret; 
} 

function sysadmin_put_email_setup($email_setup) {
	global $db;
	//save to db
	if($email_setup['server'] == 'internal') {
		$data = array(
		array('email_setup_server', trim($email_setup['server'])),
		array('email_setup_smtp_server', null),
		array('email_setup_auth', 'no'),
		array('email_setup_domain', null),
		array('email_setup_username', null),
		array('email_setup_password',  null),
		array('email_setup_myhostname', trim($email_setup['myhostname'])),
		array('email_setup_myorigin', trim($email_setup['myorigin'])),
		array('email_setup_mydomain', trim($email_setup['mydomain'])),
		);
	} else {
		$data = array(
		array('email_setup_server', trim($email_setup['server'])),
		array('email_setup_smtp_server', trim($email_setup['smtp_server'])),
		array('email_setup_username', trim($email_setup['username'])),
		array('email_setup_password',  trim($email_setup['password'])),
		array('email_setup_auth', trim($email_setup['auth'])),
		array('email_setup_myhostname', null),
		array('email_setup_myorigin', null),
		array('email_setup_mydomain', null),
		array('email_setup_provider', $email_setup['provider']),
		);
	}
	//dbug($data);
	$sql = $db->prepare('REPLACE INTO sysadmin_options (`key`, `value`) VALUES (?, ?)');	
	$ret = $db->executeMultiple($sql, $data);
	if($db->IsError($ret)) {
    	die_freepbx($ret->getDebugInfo()."\n".$ret->getUserInfo()."\n".$db->last_query);
  	}
}
	 
function sysadmin_set_email_setup() { 
        file_put_contents('/var/spool/asterisk/sysadmin/email_setup', time()); 
}

function sendmail($email_address) {
		exec("echo \"This is a test email from your PBXact Phone System, please do not respond to this message\" | mail -s \"Test Email from your PBXact Phone System\" $email_address");
		echo "<br /><br />Test Email Sent!";
}
	

//Function to get our FreePBX Configuration Options
function getconf($filename) {
  $file = file($filename);
  foreach($file as $line => $cont){
	if(substr($cont,0,1)!='#'){
		$d=explode('=',$cont);
		if(isset($d['0'])&& isset($d['1'])){$conf[trim($d['0'])]=trim($d['1']);}
	}
  }
  return $conf;
}
	
function sysadmin_setup_email() {

	error_reporting(1);
	//Include PEAR DB
	include_once('DB.php');
	
	//Get our database information right from FreePBX and attempt to connect
	$amp_conf = getconf((isset($_ENV['FREEPBXCONFIG']) && strlen($_ENV['FREEPBXCONFIG']))?$_ENV['FREEPBXCONFIG']:'/etc/amportal.conf');
	if (!isset($db)) {
		$db = DB::connect('mysql://'.$amp_conf['AMPDBUSER'].':'.$amp_conf['AMPDBPASS'].'@'.$amp_conf['AMPDBHOST'].'/'.$amp_conf['AMPDBNAME']); // attempt connection
	}

	// Check to see if we have info in the database, if so, exit.

	$email_setup_server = $db->getOne('SELECT value FROM sysadmin_options WHERE `key` = "email_setup_server"');
		if($db->IsError($email_setup_server)) {
			die($email_setup_server->getDebugInfo()."\n".$email_setup_server->getUserInfo()."\n".$db->last_query);
		}
	if($email_setup_server != null) {
		return;
		//exit();
	}

	//Set our variables for postfix
		$file_location = '/etc/postfix/main.cf';
		$auth_file_location = '/etc/postfix/sasl_passwd';
		$postfix_file = file_get_contents($file_location, true);

	//define the patterns we are searching for ex. relayhost = 192.168.1.1
		$postfix_pattern = '/^\s*relayhost\s*=\s*\[{0,1}(.*)\]{0,1}\s*$/m';
		$postfix_myorigin = '/^\s*myorigin\s*=\s*\[{0,1}(.*)\]{0,1}\s*$/m';
		$postfix_mydomain = '/^\s*mydomain\s*=\s*\[{0,1}(.*)\]{0,1}\s*$/m';
		$postfix_myhostname = '/^\s*myhostname\s*=\s*\[{0,1}(.*)\]{0,1}\s*$/m';

	//find our matches
		preg_match_all($postfix_pattern, $postfix_file, $postfix_match);
		preg_match_all($postfix_myorigin, $postfix_file, $postfix_myorigin_match);
		preg_match_all($postfix_mydomain, $postfix_file, $postfix_mydomain_match);
		preg_match_all($postfix_myhostname, $postfix_file, $postfix_myhostname_match);

	//determine if internal or external relayhost
	//Note: [1][0] is our position in the array for the actual data so that we don't have "relayhost = "
		if (isset($postfix_match[1][0]))
		{
			//insert into db here
			$email_setup_server = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_server", "external")');
			if($db->IsError($email_setup_server)) {
				die($email_setup_server->getDebugInfo()."\n".$email_setup_server->getUserInfo()."\n".$db->last_query);
			}
			//since it is external, we need to get the server and auth settings
			$email_setup_smtp_server = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_smtp_server", "' . $postfix_match[1][0] . '")');
			if($db->IsError($email_setup_smtp_server)) {
				die($email_setup_smtp_server->getDebugInfo()."\n".$email_setup_smtp_server->getUserInfo()."\n".$db->last_query);
			}
					
			//determine if we have smtp_sasl_auth_enabled already
			exec('sed -n \'s/^\s*smtp_sasl_auth_enable\s*=\s*\([yesno]\{2,3\}\)/\1/p\' '.$file_location, $auth_enabled);
			if ($auth_enabled[0] == 'yes') {
				$email_setup_auth = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_auth", "yes")');
				if($db->IsError($email_setup_auth)) {
					die($email_setup_auth->getDebugInfo()."\n".$email_setup_auth->getUserInfo()."\n".$db->last_query);
				}
				
				// Now we need to get username, password for auth
				$sasl = file_get_contents($auth_file_location);
				$ret = explode(" ", $sasl);
				$authinfo = explode(":", $ret[1]);
				$email_setup_username = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_username", "' . $authinfo[0] . '")');
				if($db->IsError($email_setup_username)) {
					die($email_setup_username->getDebugInfo()."\n".$email_setup_username->getUserInfo()."\n".$db->last_query);
				}
				$email_setup_password = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_password", "' . $authinfo[1] . '")');
				if($db->IsError($email_setup_password)) {
					die($email_setup_password->getDebugInfo()."\n".$email_setup_password->getUserInfo()."\n".$db->last_query);
				}
				
			} else {
				// No authentication, so no data needed in db
			} 
		} else {
			//insert into db here
			$email_setup_server = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_server", "internal")');
			if($db->IsError($email_setup_server)) {
				die($email_setup_server->getDebugInfo()."\n".$email_setup_server->getUserInfo()."\n".$db->last_query);
			}
			
			//Determine if we have a myorigin in postfix
			//Note: [1][0] is our position in the array for the actual data so that we don't have "myorigin = "
			if (isset($postfix_myorigin_match[1][0]))
			{
				//Enter into db
				$email_setup_myorigin = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_myorigin", "' . $postfix_myorigin_match[1][0] . '")');
				if($db->IsError($email_setup_myorigin)) {
					die($email_setup_myorigin->getDebugInfo()."\n".$email_setup_myorigin->getUserInfo()."\n".$db->last_query);
				}
			} else {
				//nothing needed in db
			}

			//Determine if we have a mydomain in postfix
			//Note: [1][0] is our position in the array for the actual data so that we don't have "mydomain = "
			if (isset($postfix_mydomain_match[1][0]))
			{
					//Enter into db
					$email_setup_mydomain = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_mydomain", "' . $postfix_mydomain_match[1][0] . '")');
					if($db->IsError($email_setup_mydomain)) {
							die($email_setup_mydomain->getDebugInfo()."\n".$email_setup_mydomain->getUserInfo()."\n".$db->last_query);
					}
			} else {
					//nothing needed in db
			}

			//Determine if we have a myhostname in postfix
			//Note: [1][0] is our position in the array for the actual data so that we don't have "myhostname = "
			if (isset($postfix_myhostname_match[1][0]))
			{
				//Enter into db
				$email_setup_myhostname = $db->QUERY('INSERT INTO sysadmin_options (`key`, `value`) VALUES ("email_setup_myhostname", "' . $postfix_myhostname_match[1][0] . '")');
				if($db->IsError($email_setup_myhostname)) {
					die($email_setup_myhostname->getDebugInfo()."\n".$email_setup_myhostname->getUserInfo()."\n".$db->last_query);
				}
			
			} else {
					//nothing needed in db
			}
			return;
			//exit();
		}
}
	
?>
