<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
$dir = dirname(__FILE__);

require_once($dir . '/ddns.php');
require_once($dir . '/dns.php');
require_once($dir . '/email_setup.php');
require_once($dir . '/ftp.php');
require_once($dir . '/guihooks.php');
require_once($dir . '/intrusion.php');
require_once($dir . '/license.php');
require_once($dir . '/network.php');
require_once($dir . '/portmgmt.php');
require_once($dir . '/storage.php');
require_once($dir . '/tz.php');
require_once($dir . '/updates.php');
require_once($dir . '/ups.php');
require_once($dir . '/vpn.php');
require_once($dir . '/abnormalcallvolume.php');
require_once($dir . '/modules.php');
require_once($dir . '/sales.php');

function sysadmin_get_domain_name() {
    $lic = sysadmin_get_license();
    if ($lic && isset($lic['fqdn']) && $lic['fqdn'] != '') {
		return $lic['fqdn'];
    } else {
		return '';
	}
}

function sysadmin_get_pbxid() {

	if (file_exists('/etc/schmooze/pbxid')) {
		$ret = file_get_contents('/etc/schmooze/pbxid');

	} elseif (file_exists('/etc/asterisk/pbxid')) {
		$ret = file_get_contents('/etc/asterisk/pbxid');
	} elseif (file_exists('/etc/pbxactid')) {
		$ret = file_get_contents('/etc/pbxactid');
	} elseif (file_exists('/etc/pbxid')) {
		$ret = file_get_contents('/etc/pbxid');
	} else {
		$ret = '';
	}

	return $ret ? trim($ret) : false;
}


function sysadmin_get_pbxversion() {
	//we used to use /etc/pbxactversion, but now we want to be using /etc/asterisk/pbx-version
	//so check the new one first
	//for oss though we use /etc/asterisk/freepbxdistro-version

	if (file_exists('/etc/schmooze/pbx-version')) {
		$ret = file_get_contents('/etc/schmooze/pbx-version');
	} elseif (file_exists('/etc/asterisk/pbx-version')) {
		$ret = file_get_contents('/etc/asterisk/pbx-version');
	} elseif (file_exists('/etc/schmooze/freepbxdistro-version')) {
		$ret = file_get_contents('/etc/schmooze/freepbxdistro-version');
	} elseif (file_exists('/etc/asterisk/freepbxdistro-version')) {
		$ret = file_get_contents('/etc/asterisk/freepbxdistro-version');
	} elseif (file_exists('/etc/pbxactversion')) {
		$ret = file_get_contents('/etc/pbxactversion');
	} else {
		$ret = false;
	}

	return $ret ? trim($ret) : false;
}

function sysadmin_get_pbxactfailsafe() {
	//we used to use /etc/pbxactfailsafe, but now we want to be using /etc/asterisk/pbx-failsafe
	//so check the new one first

	if (file_exists('/etc/schmooze/pbx-failsafe')) {
		$ret = file_get_contents('/etc/schmooze/pbx-failsafe');
	} elseif (file_exists('/etc/asterisk/pbx-failsafe')) {
		$ret = file_get_contents('/etc/asterisk/pbx-failsafe');
	} elseif (file_exists('/etc/pbxactfailsafe')) {
		$ret = file_get_contents('/etc/pbxactfailsafe');
	} else {
		$ret = false;
	}

	return $ret ? trim($ret) : false;
}

function sysadmin_get_pbx_vendor() {
        //we use this to determine the vendor if we have a freepbxdistro system

        if (file_exists('/etc/schmooze/pbx-brand')) {
                $ret = trim(file_get_contents('/etc/schmooze/pbx-brand'));
        }

        return  $ret ? trim(strtolower($ret)) : false;

}

function sysadmin_module_distro_id() {
	$distro = _module_distro_id();

	//check for freepbxdistro file, otherwise grab from freepbx
	if (file_exists('/etc/asterisk/pbx-version')) {
		$pbx_type = 'freepbxdistro';
		$pbx_version = trim(file_get_contents('/etc/asterisk/pbx-version'));
		$create_distro = true;
	} elseif (file_exists('/etc/schmooze/pbx-version')) {
		$pbx_type = 'freepbxdistro';
		$pbx_version = trim(file_get_contents('/etc/schmooze/pbx-version'));
		$create_distro = true;
	}

	if ($create_distro === true) {
		$distro['pbx_type'] = $distro['pbx_type'] != 'unknown' ? strtolower($distro['pbx_type']) : $pbx_type;

		$distro['pbx_version'] = $distro['pbx_version'] != 'unknown' ? $distro['pbx_version'] : $pbx_version;
		$distro['vendor'] = sysadmin_get_pbx_vendor();
	}

        return $distro;
}

function sysadmin_power($action) {
	switch ($action) {
		case 'Power Off':
			file_put_contents('/var/spool/asterisk/sysadmin/poweroff', time());
			break;
		case 'Reboot':
			file_put_contents('/var/spool/asterisk/sysadmin/reboot', time());
			break;
	}
}


function sysadmin_get_freepbxdistro_version() {

	if (is_dir('/etc/schmooze')) {
		$file = '/etc/schmooze/pbx-version';
	} else {
		$file = '/etc/asterisk/freepbxdistro-version';
	}

	if (file_exists($file)) {
		return file_get_contents($file);
	} else {
		return false;
	}
}

function sysadmin_get_freepbxdistro_failsafe() {

	if (is_dir('/etc/schmooze')) {
                $file = '/etc/schmooze/pbx-failsafe';
        } else {
                $file = '/etc/asterisk/freepbxdistro-failsafe';
        }

	if (file_exists($file)) {
		return file_get_contents($file);
	} else {
		return false;
	}
}

function sysadmin_restart_httpd() {
	file_put_contents('/var/spool/asterisk/sysadmin/restart_httpd', time());
}

//restart ejabberd
function sysadmin_restart_xmpp() {
	file_put_contents('/var/spool/asterisk/sysadmin/restart_xmpp', time());
}

//logfiles hook
function sysadmin_get_config($engine) {
	global $ext, $logfiles_conf, $amp_conf;
	switch ($engine) {
		case 'asterisk':
			//check extension count vs extension on the system and die if there is an issue
			if (sysadmin_extensions_limit('remaining') < 0) {
				fatal('Unable to load configuration due to extension count being less than available');
				//TODO: add notification to notifications and remove when fixed
			}
			if (isset($logfiles_conf) && ($logfiles_conf instanceof logfiles_conf)) {
				//TODO: if/when there is an option to dissable intrusion detection
				//make this dependant on that option
				if(version_compare($amp_conf['ASTVERSION'],'11.0','ge')) {
                                        $logfiles_conf->addLoggerLogfiles('fail2ban', 'notice,warning,security');
                                } else {
                                        $logfiles_conf->addLoggerLogfiles('fail2ban', 'notice,warning');
                                }
			}
			break;
	}

}

//SHMZ
function sysadmin_extensions_limit($type='') {
	global $extcount, $Extensions;

	if (!isset($extcount, $Extensions)) {
		//remove custom extension from the list count as they dont count towards quotas
		$extcount = count(core_devices_list()) - count(core_devices_list('custom'));
		if (zend_loader_file_encoded()) {
			$lic_info = sysadmin_get_license();
			switch($lic_info['deploy_type']) {
				case 'PBXact':
                                case 'PBXtended':
                                        $Extensions = isset($lic_info['Extensions']) ? $lic_info['Extensions'] : 0;
                                        break;
                                case 'OSS':
                                case 'FreePBX-Distro':
                                default:
                                        $Extensions = false;
                                        break;
			}
		} else {
			$lic_info = sysadmin_get_license();
                        switch($lic_info['deploy_type']) {
				case 'PBXact':
			        case 'PBXtended':
       					$Extensions = isset($lic_info['Extensions']) ? $lic_info['Extensions'] : 0;
                                        break;
				case 'OSS':
        			case 'FreePBX-Distro':
				default:
        				$Extensions = false;
                                        break;
                        }
			$Extensions = isset($Extensions) ? $Extensions : 0;
		}
    	}
        switch($type) {
		case 'count':
			return $extcount;
			break;
		case 'remaining':
			if ($Extensions === false) {
				return $extcount;
			}
			return $Extensions-$extcount;
			break;
		default:
			return $Extensions;
			break;
	}
}
/**
 * short FreePBX Documentation Label generator
 * long Function  used to generate FreePBX Documentation 'labels' that can
 * link to additional documentation at an offsite location
 *
 * @author Bryan Walters <junk@secretop.com>
 * @param string $link
 * @return string
 * @todo change format to take advantage of html's data attribute. No need for spans!
 * @todo remove this in future releases once this has been put into upstream 2.11, and 2.10 is no longer supported
 *
 * {@source }
 */
 if (!function_exists('fpbx_doc_label')) {
	function fpbx_doc_label($link) {
        	if ($link) {
                	$ret = '<a href="' . $link . '" target="_fpbx_doc" class="doc" tabindex="-1">'
                        	. '<span class="help">'
                                . 'D'
                                . '</span></a>';
                }

                return isset($ret)?$ret:'';
	}
}
?>
