<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
// Functions for intrusion_detection 
function sysadmin_intrusion_detection_status() { 
	exec('/etc/init.d/fail2ban status', $ret);  
	if (isset($ret[0]) && trim($ret[0]) == 'Fail2ban is stopped') { 
		return 'stopped'; 
	} else { 
		return 'running'; 
	} 

} 

function sysadmin_check_intrusion_detection_conf() { 
   $lic    = sysadmin_get_license(); 
   $conf   = '/etc/fail2ban/fail2ban.conf'; 
	
	if (file_exists($conf)) { 
		return true; 
	} else { 
		return false; 
	} 
} 
 
function sysadmin_intrusion_detection($action) { 
	switch ($action) { 
		case 'Stop': 
			file_put_contents('/var/spool/asterisk/sysadmin/intrusion_detection_stop', time()); 
		break; 
		case 'Start': 
		case 'Restart': 
			file_put_contents('/var/spool/asterisk/sysadmin/intrusion_detection_start', time()); 
		break; 
		case 'Run Setup': 
			file_put_contents('/var/spool/asterisk/sysadmin/intrusion_detection_get', time()); 
		break; 
	} 
} 
	
function sysadmin_get_intrusion_detection() { 
	global $db; 
	$ret = '';
	$sql = 'SELECT * FROM sysadmin_options WHERE `key` '
		. 'IN("fail2ban_ban_time", "fail2ban_find_time", "fail2ban_email", '
		. '"fail2ban_max_retry", "fail2ban_whitelist")'; 
	$res = $db->getAll($sql, DB_FETCHMODE_ASSOC); 
	db_e($res);
	foreach($res as $r) { 
		$ret[$r['key']] = $r['value']; 
	} 
	
   return $ret; 
} 



function sysadmin_get_banned() { 
	file_put_contents('/var/spool/asterisk/sysadmin/intrusion_detection_banned', time()); 
	sleep(3);
	$banned = file_get_contents('/var/spool/asterisk/sysadmin/banned');
	$ret = explode("-- ", $banned);
	$ips = '';
	$count = count($ret);
	//unset($ret[0], $ret[$count-1]);
	array_shift($ret);	
	foreach($ret as $key => $value) {
		$value = explode(' ', $value);
		$value = $value[1];
		$ips[] = $value ;
	}
	return $ips; 
} 

function sysadmin_put_intrusion_detection($ids) {
	global $db;
	//save to db
	$data = array(
		array('fail2ban_ban_time', $ids['ban_time']),
		array('fail2ban_find_time', $ids['find_time']),
		array('fail2ban_email', trim($ids['email'])),
		array('fail2ban_max_retry',  $ids['max_retry']),
		array('fail2ban_whitelist', trim($ids['whitelist']))
	);
	$sql = $db->prepare('REPLACE INTO sysadmin_options (`key`, `value`) '
		. 'VALUES (?, ?)');	
	$ret = $db->executeMultiple($sql, $data);
	db_e($ret);
}
	 
function sysadmin_set_intrusion_detection() { 
	file_put_contents('/var/spool/asterisk/sysadmin/intrusion_detection', time()); 
}
?>
