<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
//load obfuscated + licensed sysadmin_get_license() if we have a license file
//if (isset($lic_file)) {
	require_once(dirname(__FILE__) . '/licensed.php');
//}


//if we dont have a valid license file installed, we wont be able to load sysadmin_get_license(),
//so return something usefull here
if (!function_exists('sysadmin_get_license')) {
	function sysadmin_get_license() {
		return false;
	}
}

function sysadmin_fetch_license($deployment, $auto = true, $silent = false, $opts = array()) {
	global $amp_conf;
	//fail if we dont have a deployment or cant fins the zend functions
	/*if(!$deployment || !function_exists("zend_get_id")) {
		return false;
	}*/

	//set the update script to run again in the next 60 minutes in case we carsh & burn
	//we will reset the schedule when were finished running this function
	sysadmin_set_license_cron('nexthour');

	//if $auto = true we are being run without user interaction. Randomize the wait time before execution by up to 60 seconds.
	if ($auto) {
		sleep(rand(0, 60));
	}
    //Note: If we want to support virtual systems, then we would want to change the
    //zend_get_id() to zend_get_id(true)
	$lic 			= sysadmin_get_license();
	$ids			= @zend_get_id();
	$host_id		= $ids[0];
	$host_id		= base64_encode($host_id);
	$date			= base64_encode(mktime());
	$deployment_t		= base64_encode($deployment);
	$email			= (isset($opts['email']))?$opts['email']:false;
	$email 			= base64_encode($email);
	$location_name		= (isset($opts['location_name']))?$opts['location_name']:'';
	$location_name 		= base64_encode($location_name);
	$url 			= "http://licensing.pbxact.com/license.php";
	$distro_id		= sysadmin_module_distro_id();
	$distro_id_t		= $distro_id['pbx_type'];
	$distro_id_v		= $distro_id['vendor'];
	$distro_id		= base64_encode($distro_id_t);
	$distro_vendor		= base64_encode($distro_id_v);
	$data_q			= array('host_id'=> "$host_id",
					'date'=>"$date",
					'deployment'=>"$deployment_t",
				  	'distro_id' =>"$distro_id",
					'distro_vendor' => "$distro_vendor",
					'location_name' => "$location_name",
				  );

    if ($opts['register'] === TRUE) {
                //$url            = "http://licensing.pbxact.com/license-testing.php";
		$data_q['email'] = "$email";
		$data_q['registration'] = true;
        }

	$data			= http_build_query($data_q);

	if (isset($opts['hash']) && $opts['hash'] === TRUE) {
		$zend_hardware_hash = zend_get_id();
		echo "Your zend id is: " . implode('^',$zend_hardware_hash) . "\n\n";
		echo "Below is your system hash:\n\n".$data."\n\n";
		if (count($opts) == 1) {
			exit;
		}
	}

	if (isset($opts['curl']) && $opts['curl'] === TRUE) {
        	echo "Attempting to fetch license using curl...\n";
		$ch = curl_init();
        	curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        	$contents = curl_exec($ch);
		curl_close($ch);
	} else {
		if (!$silent) {
			echo "Attempting to fetch license...\n";
		}
		$sctx			= stream_context_create(array('http' =>
								array(
									'method' => 'POST',
									'content' => $data,
									'header'  => 'Content-type: application/x-www-form-urlencoded'
								)
						));
		$fh2			= fopen($url, "rb", false, $sctx);
		$contents		= stream_get_contents($fh2);
		fclose($fh2);
	}

	if (!$silent) {
		echo $contents;
	}

	//dbug($contents);

	//check to see if we get a blank license, if so exit the script and don't overwrite the license file
	if ($contents == '') {
		return false;
	}

	$shmzDir = '/etc/schmooze';

	if (preg_match("/Registration ID:/", $contents)) {
		$deployment_id = explode(':',$contents, 2);
		if (!$silent) {
			echo "Deployment Name: ".trim($deployment_id[1]);
		}
		if (is_dir($shmzDir)) {
			file_put_contents($shmzDir . '/pbxid', trim($deployment_id[1]));
		} else {
			file_put_contents($amp_conf['ASTETCDIR'] . '/pbxid',trim($deployment_id[1]));
		}

		//don't kill the server if this is an ajax call as ajax doesn't like that
		/*if(!isset($_SERVER['HTTP_X_REQUESTED_WITH'])) {
			sysadmin_restart_httpd();
		}*/
		//don't exit just return
		return;
	}

	//put contents in an array
	$lic_arr = explode("\n", $contents);
	foreach ($lic_arr as $lic_ar) {
		if ($lic_ar) {
			$l = explode('=', $lic_ar);
			if ($l[0]) {
				$lic[trim($l[0])] = isset($l[1]) ? trim($l[1]) : '';
			}

		}
	}

	//check for incorrect date/time
	if (isset($lic['Error: the date on your machine is wrong. You will need to fix your date, then re-run the installation program'])) {
		return false;
	}

	//check for errors
	if (isset($lic['Error: We did not receive a pbx id or host id'])) {
		return false;
	}

	//confirm hardware id && some sanity checks on lisence file data
	if ($lic['hostid'] != $ids[0] || $lic['Hardware-Locked'] != 'Yes') {
		return false;
	}

	if (!isset($lic['Verification-Code'], $lic['Registered-To'],
		$lic['license_expiration'], $lic['deploymentid'], $lic['fqdn'])
	) {
		return false;
	}

	if (!($lic['Produced-By'] == 'Schmooze Communications' || $lic['Produced-By'] == 'Schmooze Com Inc.')) {
		return false;
	}

	//write license file if everything seems ok
	if (is_dir($shmzDir)) {
		exec('rm -rf ' .$shmzDir . '/license-*.zl');
		file_put_contents($shmzDir . '/license-'
					. $deployment . '.zl', $contents);
	} else {
		exec('rm -rf /var/lib/asterisk/agi-bin/license-*.zl');
		file_put_contents('/var/lib/asterisk/agi-bin/license-'
						. $deployment . '.zl', $contents);
	}
	//make sure that we have a valid pbxid file
	//if (!sysadmin_get_pbxid()) {
		if (is_dir($shmzDir)) {
			file_put_contents($shmzDir . '/pbxid', $lic['deploymentid']);
		} else {
			file_put_contents('/etc/asterisk/pbxid', $lic['deploymentid']);
		}
	//}

	//set the next license check
	//if the license is set to expire in the next 7 days, check every day
	//if the license is set to expire in the next 24 hours, keep on checking every few hours
	//if it expired in the last 14 days, check once per day
	//expires[0] - year
	//expires[1] - month
	//expires[2] - day
	$expires = explode('-', $lic['license_expiration']);//2050-01-01

	//php < 5.2 cant prosses dates past 2038
	if ($expires[0] > 2037 && version_compare(phpversion(), '5.2', 'le')) {
		$expires[0] = 2037;
	}
	$date = date_parse($expires[0].'-'.$expires[1].'-'.$expires[2]);
	$expires = mktime(0, 0, 0, $date['month'], $date['day'], $date['year']);

	$in_a_day = time() + (24 * 60 * 60);
	$in_a_week = time() + (24 * 60 * 60 * 8);
	$in_two_weeks = time() + (24 * 60 * 60 * 14);
	switch (true) {
		case ($expires <= $in_a_day):
			//dbug('day');
			sysadmin_set_license_cron('next_few_hours');
                        break;
		 case ($expires <= $in_a_week): //expires in less than a week
			//dbug('less than a week');
                        sysadmin_set_license_cron('daily');
                        break;
		case ($expires <= $in_two_weeks): //expired in the last 14 days
			//dbug('2 weeks');
			sysadmin_set_license_cron('daily');
			break;
		default: //checks weekly
			sysadmin_set_license_cron('',$expires);
			break;
	}

	//set permissions on the license file
	if (is_dir($shmzDir)) {
		system('chown ' . $amp_conf['AMPASTERISKWEBUSER'] . ':'
                	        . $amp_conf['AMPASTERISKGROUP']
                	        . ' ' . $shmzDir . '/license-'
                	        . $deployment . '.zl');
	} else {
		system('chown ' . $amp_conf['AMPASTERISKWEBUSER'] . ':'
				. $amp_conf['AMPASTERISKGROUP']
				. ' /var/lib/asterisk/agi-bin/license-'
				. $deployment . '.zl');
	}

	//restart apache cause there may be issues with the old license being cached or soemthing
	sysadmin_restart_httpd();

	$ret = sysadmin_get_license();
	if (!$ret && $lic) {
		$ret = $lic;
	}
	return $ret ? $ret : false;

}

function sysadmin_set_license_cron($action = '', $expiration = '') {

	//if $action == nexthour we need another check within the next hour
	switch($action) {
		case 'nexthour':
			$at 			= time() + rand(300, 3600);
			$add['minute'] 	= date('i', $at);
			$add['hour'] 	= date('G', $at);
			break;
		case 'delete':
			$add			= '';
			break;
		case 'next_few_hours':
			//next 1-6 hours (random)
			$at				= time() + rand(3600, 21600);
			$add['minute'] 	= date('i', $at);
			$add['hour'] 	= date('G', $at);
			break;
		case 'daily':
			$add['minute'] 	= rand(0, 59);
			$hour 			= rand(0, 6) + 22;
			$add['hour'] 	= $hour > 23 ? $hour - 23 : $hour;
			break;
		default: //once per week
			$dow 			= date('w', $expiration); //get day of week not numeric month
			$dow_math 		= $dow - 1;
            //day of the week needs to be between 0 and 6
            $dow_math       = ($dow_math < 0)?1:$dow_math;
            $highest_dow 	= ($dow_math >= 0)?$dow_math:6-$dow_math;
			$add['minute']  = rand(0, 59);
			$hour			= rand(0, 6) + 22;
			$add['hour']	= $hour > 23 ? $hour - 23 : $hour;
			$add['dow']		= rand(0,$highest_dow);
	}

	//add command to run
	if ($add) {
		$add['command'] = 'php /var/lib/asterisk/agi-bin/update_license.php 2>&1 >/dev/null';
	}

	edit_crontab('update_license.php', $add);
}

function sysadmin_is_module_licensed($mod) {

	if (!zend_loader_file_encoded()) {
		return true;
	}

	//translation of module name to our key name.
	//if not found, well just pass the raw $mod directly for testing
	$mod_lic_keys = array(
		'areminder'			=> 'areminder_exp',
		'callerid'			=> 'callerid_man_exp',
		'calllimit'			=> 'outcalllimit_exp',
		'callrecording'		=> 'callrecrpt_exp',
		'conferencespro'	=> 'confpro_exp',
		'directorypro'		=> 'companydirpro_exp',
		'endpoint'			=> 'epm_exp',
		'extensionroutes'	=> 'extroute_exp',
		'faxpro'			=> 'xfax_exp',
		'freepbx_ha'		=> 'highavail_exp',
		'grammar'			=> 'magicbutton_exp',
		'ivrpro'			=> 'ivrpro_exp',
		'outroutemsg'		=> 'outboundnotifications_exp',
		'pagingpro'			=> 'pagepro_exp',
		'pinsetspro'		=> 'pinset_pro_exp',
		'presence'			=> 'presence_status_exp',
		'qxact_reports'		=> 'qxact_exp',
		'restapi'			=> 'restapi_exp',
		'restapps'			=> 'restapps_exp',
		'sysadmin'			=> 'sysadmin_exp',
		'vmnotify'			=> 'vmnotify_exp',
		'voicemail_report'	=> 'vm_reports_exp',
		'webcallback'		=> 'webcallback_exp',
		'xactview'			=> 'xview_exp',
		'xmpp'				=> 'xmpp_exp',
		'parkpro'			=> 'parkpro_exp',
		'cos'				=> 'classofservice_exp'
	);

	if (array_key_exists($mod, $mod_lic_keys)) {
		$mod = $mod_lic_keys[$mod];
	}
	$lic_info	= sysadmin_get_license();
	$lic_exp	= isset($lic_info[$mod])
				? preg_replace('/-/', '', $lic_info[$mod])
				: 00000000;

	if ($lic_exp > date('Ymd')) {
		return true;
	} else {
		return false;
	}
}
?>
