<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
function sysadmin_get_ifs() {
	//get a list of physical adapters
	$dev_list = '/proc/net/dev';
	
	if (file_exists($dev_list) AND is_readable($dev_list)) {
		
		//read file
		$proc = file_get_contents($dev_list);
		
		//put in to an array based on lines
		$lines = explode(PHP_EOL, $proc);
		
		//discard the first two lines
		unset($lines[0], $lines[01]);
		
		//loop through adapters and grab some stats while were at it
		foreach ($lines as $l) {
			if (!$l) {
				break; //dont scour in blank lines
			}
			$this_l = explode(':', $l);
			$dev_name = trim($this_l[0]);
			$stats = preg_split('/\s+/', trim($this_l[1]));

			$pys_net[$dev_name]['rx_bytes'] 	= $stats[0];
			$pys_net[$dev_name]['rx_packets']	= $stats[1];
			$pys_net[$dev_name]['rx_errs']		= $stats[2];
			$pys_net[$dev_name]['rx_drop']		= $stats[3];

			$pys_net[$dev_name]['tx_bytes']		= $stats[8];
			$pys_net[$dev_name]['tx_packets']	= $stats[9];
			$pys_net[$dev_name]['tx_errs']		= $stats[10];
			$pys_net[$dev_name]['tx_drop']		= $stats[11];

			$pys_net[$dev_name]['errs']			= $stats[2] + $stats[10];
			$pys_net[$dev_name]['drop']			= $stats[3] + $stats[11];
		}			
	}
	
	//scan directory for all psobile interface config files
	$ifs = scandir('/etc/sysconfig/network-scripts/');

	//loop through the files we found
	foreach ($ifs as $if) {
		if (
			strpos(trim($if),'ifcfg-eth') === 0 
			|| strpos(trim($if),'ifcfg-wlan') === 0
			|| strpos(trim($if),'ifcfg-em') === 0
			|| strpos(trim($if),'ifcfg-p') === 0
		) {
			$my_if =  str_replace('ifcfg-', '', $if);
			
			//if its an eth or a wlan, parse the file and add to the array
			$my_if_file = '/etc/sysconfig/network-scripts/' . $if;
			if (file_exists($my_if_file) && is_readable($my_if_file)) {
				
				$comment = array(';', '#');
				
				//read file as an array
				$line = file($my_if_file, FILE_SKIP_EMPTY_LINES | FILE_IGNORE_NEW_LINES);
				foreach ($line as $ln) {
					if (!in_array(substr($ln, 0, 1), $comment)) {
						$part = explode('=', $ln);
						//dbug('$f_line', $f_line);
						$trim = ' "';//values to trim
						$this_face[trim($part[0], $trim)] = trim($part[1], $trim);
					}
				}
			}
			//dbug('$this_face', $this_face);
			
			//enasure we have DEVICE set
			if (!isset($this_face['DEVICE'])) { 
				$this_face['DEVICE'] = $my_if;
			}
			
			//make sure bootproto isnt set to static
			if (isset($this_face['BOOTPROTO']) && $this_face['BOOTPROTO'] == 'static') { 
				$this_face['BOOTPROTO'] = 'none';
			}
			
			//set possible values so there not blank
			$this_face['BOOTPROTO']	= isset($this_face['BOOTPROTO'])	
									? $this_face['BOOTPROTO']	
									: '';
			$this_face['ONBOOT']	= isset($this_face['ONBOOT'])		
									? $this_face['ONBOOT']		
									: '';
			$this_face['IPADDR']	= isset($this_face['IPADDR'])		
									? $this_face['IPADDR']		
									: '';
			$this_face['NETMASK']	= isset($this_face['NETMASK'])		
									? $this_face['NETMASK']		
									: '';
			$this_face['GATEWAY']	= isset($this_face['GATEWAY'])		
									? $this_face['GATEWAY']		
									: '';
			$this_face['HOSTNAME']	= isset($this_face['HOSTNAME'])		
									? $this_face['HOSTNAME']	
									: '';
			$this_face['ONBOOT']	= isset($this_face['ONBOOT'])		
									? $this_face['ONBOOT']		
									: '';
			$this_face['HWADDR']	= isset($this_face['HWADDR'])		
									? $this_face['HWADDR']		
									: '';
			$this_face['VLAN']		= isset($this_face['VLAN'])		
									? $this_face['VLAN']		
									: '';
							//dbug($this_face);		
			//add stats if we have them
			if (isset($pys_net[$my_if]) && is_array($pys_net[$my_if]) && preg_match('/\./', $my_if) != true) {
				$this_face['stats']	= $pys_net[$my_if];
				$this_face['type']	= 'physical';
				
				//unset so that we know that this one is "taken"
				unset($pys_net[$my_if]);
			} else {
				$this_face['type']	= 'virtual';
				//unset so that we know that this one is "taken"
				unset($pys_net[$my_if]);
			}
			
			//add a mac address if its missing and we can find it
			if (!$this_face['HWADDR'] && $this_face['type'] == 'physical') {
				//get results from `ip`
				exec('ip -f link addr show ' . $this_face['DEVICE'], $ip_ret);
				if ($ip_ret) {
					$r = preg_split('/\s+/', $ip_ret[1]); //split based on whitespace
					if ($r[1] == 'link/ether') { //make sure array is formated as we excpect it
						$this_face['HWADDR'] = $r[2];
					}
				}
				
			}
			//add settings to array
			$ret[] = $this_face;
			unset($this_face);
		}
	}
	
	//now, iterate over the phsicaly adapters to ensure that we didnt miss any
	foreach ($pys_net as $pys => $stat) {
		if  (strpos($pys,'eth') === 0 OR strpos($pys,'wlan') === 0) {
			if (!isset($var['netface'][$pys])) {
				$this_face['DEVICE']	= $pys;
				$this_face['BOOTPROTO']	= '';
				$this_face['ONBOOT']	= '';
				$this_face['IPADDR']	= '';
				$this_face['NETMASK']	= '';
				$this_face['GATEWAY']	= '';
				$this_face['HOSTNAME']	= '';
				$this_face['stats'] 	= $stat;
				$this_face['type'] 		= 'physical';
				//add a mac address if we can find it
				//get results from `ip`
				exec('ip -f link addr show ' . $this_face['DEVICE'], $ip_ret);
				if ($ip_ret) {
					//split based on whitespace
					$r = preg_split('/\s+/', $ret[1]); 
					//make sure array is formated as we excpect it
					if ($r[1] == 'link/ether') { 
						$this_face['HWADDR'] = $r[2];
					}
				}
				$ret[] 					= $this_face;
			}
		}
	}
	return $ret;
}



function sysadmin_put_ifs($json) {
	global $amp_conf, $db;
	$orig = sysadmin_get_ifs();
	
	if (file_exists($amp_conf['AMPWEBROOT'] . '/admin/common/json.inc.php')) { 
		require_once($amp_conf['AMPWEBROOT'] . '/admin/common/json.inc.php');
	
		$j = new Services_JSON(SERVICES_JSON_LOOSE_TYPE);
		$network =  $j->decode($json);
	} else {
		//The following should need a second param of TRUE so we get back an associative array and not objects
		$network = json_decode($json, TRUE);
	}

	dbug($network);
	foreach($network['ifs'] as $iface){
		//strip excess characters from mac and adjust case
		if(!empty($network[$iface]['HWADDR'])){
			$network[$iface]['HWADDR'] = strtoupper($network[$iface]['HWADDR']);
			$temp = preg_match_all('/[0-9A-Fa-f]+/', $network[$iface]['HWADDR'], $match);
			$network[$iface]['HWADDR'] = $match[0][0] . $match[0][1] . $match[0][2] . $match[0][3] . $match[0][4] . $match[0][5];	
		}
	}

	if (isset($network['ifs'])) {
		unset($network['ifs']);
	}
	//ensure that physical devices werent renamed/removed by adding them if there missing
	foreach ($orig as $o) {
		if(!isset($network[$o['DEVICE']]) && $o['DEVICE']['type'] == 'physical') {
			$network[$o['DEVICE']] = array(
										'BOOTPROTO' => $o['BOOTPROTO'],
										'ONBOOT'	=> $o['ONBOOT'],
										'IPADDR'	=> $o['IPADDR'],
										'NETMASK'	=> $o['NETMASK'],
										'GATEWAY'	=> $o['GATEWAY'],
										'HOSTNAME'	=> $o['HOSTNAME'],
										'type'		=> 'physical'
										);
		}
		//centos 6 doesnt want to see ip address info when using dhcp
		if ($network[$o['DEVICE']]['BOOTPROTO'] == 'dhcp') {
			unset(
				$network[$o['DEVICE']]['IPADDR'],
				$network[$o['DEVICE']]['NETMASK'],
				$network[$o['DEVICE']]['GATEWAY']
			);
		}
	}
	
	//save to db
	$ret = $db->query('REPLACE INTO sysadmin_options (`key`, value) VALUES (?, ?)', array('network', serialize($network)));
	if($db->IsError($ret)) {
    	die_freepbx($ret->getDebugInfo()."\n".$ret->getUserInfo()."\n".$db->last_query);
  	}
}

function sysadmin_set_network() {
	file_put_contents('/var/spool/asterisk/sysadmin/network', time());
}
?>
