<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
$status_msg = array(
	0	=> 'Unknown Status',
	100	=> 'Initializing update process',
	110 => 'Submitting update request',
	115 => 'Update sequence initialized',
	120	=> 'Requesting updates',
	130	=> 'Processing update',
	300 => 'Starting stage 1',
	310 => 'Stage 1 complete',
	320 => 'Starting stage 2',
	330 => 'Stage 2 complete',
	340 => 'Starting stage 3',
	350 => 'Stage 3 complete',
	360 => 'Starting stage 4',
	370 => 'Stage 4 complete',
	380 => 'Starting stage 5',
	390 => 'Stage 5 complete',
	400 => 'Starting stage 6',
	410 => 'Stage 6 complete',
	800 => 'Upgrade script complete',
	850 => 'Upgrade process successfully completed!',
	900 => 'Update already in progress (locked)',
	910	=> 'Error acquiring update',
	920 => 'Error running update script'
);

function sysadmin_service_set_cron($cronstate, 
			$hour = '', 
			$minute = '', 
			$month = '', 
			$day = '', 
			$weekday = ''){
	global $db;
	//build times for time periods
	switch ($cronstate) {
		/*
		case 'now':
			//set minutes rounded to the next 5, plus another two minutes
			$round 		= ceil(date('i', time()) / 5) * 5;
			if ( $round < 60) {
				$minute	= $round + 2;
				$hour 	= date('H', time());
			} else {
				$minute = '02';
				$hour 	= date('H', time()) + 1;
			}
			$month		= date('m', time());
			$day		= date('d', time());
			$weekday	= date('w', time());	
			break;*/
		case 'annually':
			$hour		= rand(0,6);
			$minute		= rand(0,60);
			$month		= rand(1,12);
			$day		= rand(1,28);
			$weekday	= '*';
			break;
		case 'quarterly':
			$hour		= rand(0,6);
			$minute		= rand(0,60);
			$month 		= rand(1,4) . ',' . rand(5,8) . ',' . rand(9,12);
			$day 		= rand(1,28);
			$weekday	= '*';
			break;
		case 'monthly':
			$hour		= rand(0,6);
			$minute		= rand(0,60);
			$month		= '*';
			$day		= rand(1,28);
			$weekday	= '*';
			break;
		case 'weekly':
			$hour		= rand(0,6);
			$minute		= rand(0,60);
			$month		= '*';
			$day		= '*';
			$weekday	= rand(0,6);
			break;
		case 'daily':
			$hour		= rand(0,6);
			$minute		= rand(0,60);
			$month		= '*';
			$day		= '*';
			$weekday	= '*';
			break;
	}
	//build array fof data for multiple insert
	$data = array (	array('update_cronstate', $cronstate),
					array('update_hour', $hour),
					array('update_minute', $minute),
					array('update_month', $month),
					array('update_day', $day),
					array('update_weekday', $weekday),
					array('update_dirty', 'true'));
	$sql = $db->prepare('REPLACE INTO sysadmin_options (`key`, value) '
			. 'VALUES (?, ?)');
	$ret = $db->executeMultiple($sql, $data);
	db_e($ret);
}

function sysadmin_service_get_cron(){
	global $db;
	$ret 	= array();
	$sql 	= 'SELECT * from sysadmin_options WHERE `key`'
			. 'IN ("update_cronstate", "update_hour", '
			. '"update_minute", "update_month", "update_day", '
			. '"update_weekday")';
	$return = $db->getAll($sql, DB_FETCHMODE_ASSOC);

	//return data as a single-dimensional array
	foreach ($return as $r){
		$ret[$r['key']] = explode(',',$r['value']);
	}
	
	return $ret;
}

function sysadmin_fetch_update_list() {
	$lic		= sysadmin_get_license();
	$url		= 'http://upgrades.schmoozecom.net/updates.php';
	$data		= http_build_query(
					array(
						'd'	=> trim($lic['deploymentid']),
						'v'	=> sysadmin_get_pbxversion()
					)
				);

	$sctx		= @stream_context_create(
					array('http' => 
						array('method' => 'POST', 'content' => $data)));
	$fh2		= fopen($url, "rb", false, $sctx);
	$contents	= stream_get_contents($fh2);

	fclose($fh2);
	unset($data);
	$xml = simplexml_load_string($contents);
	if (isset($xml->error)) {
		$ret['status'] = 'error';
		$ret['data'] = $xml->message;
	} else {
		$ret['status'] = 'ok';
		foreach ($xml as $x) {
			$ret['data'][(string) $x->update->version[0]] = 
				array('url' => (string) $x->update->url, 
					'changelog' => (string) $x->update->changelog);
		}
		
	}
	return $ret;
}

function sysadmin_put_update_request($version) {
	global $db;
	$sql = 'REPLACE INTO sysadmin_options (`key`,value) '
			. 'VALUES ("version_upgrade", ?)';
	$ret = $db->query($sql, array($version));
	db_e($ret);
}

function sysadmin_get_update_request() {
	global $db;
	$sql = 'SELECT value FROM sysadmin_options WHERE `key` = "version_upgrade"';
	$ret = $db->getOne($sql);
	db_e($ret);

	return $ret;
}
function sysadmin_set_update_system() {
	file_put_contents('/var/spool/asterisk/sysadmin/update_system', time());
}

function sysadmin_set_update_cron() {
	file_put_contents('/var/spool/asterisk/sysadmin/update_system_cron', time());
}

function sysadmin_get_update_status($type = '', $last = '', $ver = '') {
	global $db, $status_msg;
	$ret = '';
	switch ($type) {
		case 'lock':
			$sql = 'SELECT value FROM sysadmin_options WHERE `key` = "upgrade_lock"';
			$lock = $db->getOne($sql);
			$ret = $lock == 'true' ? true : false;
			break;
		case 'status':
			$sql = 'SELECT * FROM sysadmin_update_log';
			if ($last) {
				$sql .= ' WHERE time > ' . $db->escapeSimple($last);
			}
			if ($ver) {
				$sql .= $last ? ' AND' : ' WHERE';
				$sql .= ' version = "' . $db->escapeSimple($ver) . '"';
			}
			$ret = $db->getAll($sql, DB_FETCHMODE_ASSOC);
			break;
		case 'start_time':
			$sql = 'SELECT value FROM sysadmin_options WHERE `key` = "update_start_time"';
			$ret = $db->getOne($sql);
			break;
		default:
			$ret = false;
	}
	db_e($ret);
	switch ($type) {
		case 'status':
			foreach ($ret as $my => $d) {
				if($d['status_id'] && isset($status_msg[$d['status_id']])) {
					$ret[$my]['status'] = $status_msg[$d['status_id']];
				} elseif(!$data[$my]['status']) {
					$ret[$my]['status'] = $status_msg[0];
				}
				$ret[$my]['date_string'] = date('Y-m-d H:i:s', $d['time'] / 10000);
			}
			break;
	}

	return $ret;
}

function sysadmin_set_update_status($type, $msg) {
	global $db;
	switch ($type) {
		case 'lock':
			$sql = $db->prepare('REPLACE INTO sysadmin_options (`key`, value) '
				. 'VALUES (?, ?)');
			$data = array(
						array('upgrade_lock', 'true'), 
						array('update_start_time', microtime(true) * 10000));
			$ret = $db->executeMultiple($sql, $data);
			break;
		case 'unlock':
			$sql = 'UPDATE sysadmin_options set value = "false" '
					. 'WHERE `key` = "upgrade_lock"';
			$ret = $db->query($sql); 
			break;
		case 'msg':
			if (!isset($msg['time']) || !$msg['time']) {
				$msg['time'] = microtime(true) * 10000;
			}
			if (!isset($msg['version']) || !$msg['version']) {
				$msg['version'] = '';
			}
			if (!isset($msg['status']) || !$msg['status']) {
				$msg['status'] = '';
			}
			if (!isset($msg['status_id']) || !$msg['status_id']) {
				$msg['status_id'] = 0;
			} else {
				$msg['status'] = '';//never overide known status messages
			}
			$sql = 'INSERT INTO sysadmin_update_log '
					. '(version, status_id, time, status) VALUES (?, ? ,?, ?)';
			$ret = $db->query($sql, $msg);
			break;
	}
	db_e($ret);
}

?>
