<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
// Functions for ups setup
	
function sysadmin_get_ups_setup() { 
	global $db; 
	$ret = '';
	$sql = 'SELECT * FROM sysadmin_options WHERE `key` IN("ups_enabled", "ups_name", "ups_cable_type", "ups_device", "ups_type", "ups_delay", "ups_batt", "ups_min", "ups_timeout", "ups_common", "ups_changeme", "ups_commfailure", "ups_commok", "ups_offbattery", "ups_onbattery")'; 
	$res = $db->getAll($sql, DB_FETCHMODE_ASSOC); 
	if($db->IsError($res)){ 
			die_freepbx($res->getDebugInfo()); 
	}  
	foreach($res as $r) { 
			$ret[$r['key']] = $r['value']; 
	} 
   
   return $ret; 
} 

function sysadmin_put_ups($ups_setup) {
	if ($ups_setup['common'] == 'on') {
		$ups_setup['ups_changeme'] = $ups_setup['ups_common'];
		$ups_setup['ups_commfailure'] = $ups_setup['ups_common'];
		$ups_setup['ups_commok'] = $ups_setup['ups_common'];
		$ups_setup['ups_offbattery'] = $ups_setup['ups_common'];
		$ups_setup['ups_onbattery'] = $ups_setup['ups_common'];
		$ups_setup['ups_common'] = null;
	}

	global $db;
	//save to db
	$data = array(
	array('ups_enabled', $ups_setup['server']),
	array('ups_name', trim($ups_setup['ups_name'])),
	array('ups_cable_type',  trim($ups_setup['ups_cable_type'])),
	array('ups_type',  trim($ups_setup['ups_type'])),
	array('ups_device', trim($ups_setup['ups_device'])),
	array('ups_delay',  trim($ups_setup['ups_delay'])),
	array('ups_batt',  trim($ups_setup['ups_batt'])),
	array('ups_min',  trim($ups_setup['ups_min'])),
	array('ups_timeout',  trim($ups_setup['ups_timeout'])),
	array('ups_common',  trim($ups_setup['ups_common'])),
	array('ups_changeme',  trim($ups_setup['ups_changeme'])),
	array('ups_commfailure',  trim($ups_setup['ups_commfailure'])),
	array('ups_commok',  trim($ups_setup['ups_commok'])),
	array('ups_offbattery',  trim($ups_setup['ups_offbattery'])),
	array('ups_onbattery',  trim($ups_setup['ups_onbattery'])),	
	);
	
	$sql = $db->prepare('REPLACE INTO sysadmin_options (`key`, `value`) VALUES (?, ?)');	
	$ret = $db->executeMultiple($sql, $data);
	if($db->IsError($ret)) {
    	die_freepbx($ret->getDebugInfo()."\n".$ret->getUserInfo()."\n".$db->last_query);
  	}
}
	
function sysadmin_set_ups() { 
        file_put_contents('/var/spool/asterisk/sysadmin/ups_setup', time()); 
}

?>
