<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
$dir = dirname(__FILE__);

//dbug('request', $_REQUEST);
//setup variables
$getvars = array('action',
				'ajax',
				'cronstate',
				'day',
				'deployment',
				'deploymentid',
				'dns',
				'fromemail',
				'hour',
				'interval',
				'intrusion_detection',
				'last_update',
				'minute',
				'month',
				'network',
				'power',
				'staticip',
				'storageemail',
				'tz_area',
				'tz_continent',
				'test_email',
				'ups',
				'version',
				'view',
				'vpn',
				'weekday',
				'register',
				'portal-acct',
				'portal_email',
				'unused_dep',
				'location_name');

foreach ($getvars as $gvar) {
	$var[$gvar] 	= isset($_REQUEST[$gvar]) ? $_REQUEST[$gvar] : '';
}
$var['lic'] 		= sysadmin_get_license();

//enable simple switching between deployment types when testing
//will work for unencoded files ONLY
if (!zend_loader_file_encoded()) {

	//get suggested deployment type - forst from post, fall back to session
	$run_as 		= isset($_REQUEST['sysadmin_run_as_deploy_type'])
					? $_REQUEST['sysadmin_run_as_deploy_type'] : '';
	$run_as_sess 	= isset($_SESSION['sysadmin_run_as_deploy_type'])
					? $_SESSION['sysadmin_run_as_deploy_type'] : '';
	$run_as 		= $run_as
					? $run_as : $run_as_sess;

	//set real deployment type
	$var['lic']['deploy_type_default'] = $var['lic']['deploy_type'];
	if ($run_as) {
		if ($run_as != 'Lic-File') {
			$var['lic']['deploy_type'] = $run_as;
			$_SESSION['sysadmin_run_as_deploy_type'] = $run_as;
		} else {
			unset($_SESSION['sysadmin_run_as_deploy_type']);
		}
	}
	unset($run_as, $run_as_sess);
}

switch ($var['lic']['deploy_type']) {
	case 'PBXact':
	case 'PBXtended':
		//allowed to run all pages
		break;
	case 'OSS':
	default:
		//since sysadmin can be purchased for additional pro options, we need to determine if they are licensed for this based on the date in the license file
		if(str_replace('-','',$var['lic']['sysadmin_exp']) > date('Ymd')) {
			switch($var['view']) {
				case 'ddns':
				case 'dns':
				case 'email_setup':
				case 'email_debug':
				case 'ftp':
				case 'intrusion_detection':
				case 'license':
				case 'network':
				case 'notifications':
				case 'power':
				case 'storage':
				case 'timezone':
				case 'updates':
				case 'ups':
				case 'vpn':
				case 'abnormalcallvolume':
				case 'portmgmt':
				case '':
					continue;
					break;
				default:
					header('HTTP/1.1 403 Forbidden');
					exit;
					break;
			}
		} else {
			switch($var['view']) {
				case 'intrusion_detection':
				case 'dns':
				case 'license':
				case 'network':
				case 'notifications':
				case 'power':
				case 'storage':
				case 'timezone':
				case 'abnormalcallvolume':
				case 'portmgmt':
				case '':
					continue;
					break;
				default:
					header('HTTP/1.1 403 Forbidden');
					exit;
					break;
			}
		}
}

//run action if returned
if ($var['action']) {
	switch ($var['action']) {

		case 'check_lic':
			$deploy = $var['lic']['deploymentid']
					? $var['lic']['deploymentid']
					: $var['deploymentid'];
			sysadmin_fetch_license($deploy, false);
			break;

		case 'register_deployment':
			$register = ($var['register'] == 'YES') ? TRUE : FALSE;
			$portal_acct = ($var['portal-acct'] == 'YES') ? TRUE : FALSE;
			$portal_email = $var['portal_email'] ? $var['portal_email'] : '';
			$unused_deployment = $var['unused_dep'] ? $var['unused_dep'] : FALSE;
			$location_name = $var['location_name'] ? $var['location_name'] : '';
			$fetch_lic = FALSE;

            //if register and new account
			if ($register && !$portal_acct) {

				//remove vars we don't need
				$unused_post_vars = array('register',
							'deployment_id',
							'unused_dep',
							'portal-acct',
							'portal_email',
							'action');
				foreach ($unused_post_vars as $key => $value) {
					unset($_POST[$value]);
				}

				//array to string
				$post_str = http_build_query($_POST);

                //TODO: need to move this domain to ssl?
				$ch = curl_init('https://www.schmoozecom.com/oss-reg.php');
				curl_setopt ($ch, CURLOPT_POST, 1);
				curl_setopt ($ch, CURLOPT_POSTFIELDS, $post_str);
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 1);
                                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
				curl_setopt ($ch, CURLOPT_RETURNTRANSFER , 1);
				$curl_response = curl_exec ($ch);

				if(!curl_errno($ch)) {
					$curl_info = curl_getinfo($ch);
				}

				curl_close ($ch);

				//check curl response
				$error = '';
				if (strpos($curl_response,'A new org and user has been created.') === FALSE) {
					$error = 'ERROR 687: An error has occurred creating your portal account, please contact customer care at +1 (920) 886-8130 for further assistance.';
				}

				if ($curl_info['http_code'] == '200' && empty($error)) {
					//if 200 response register this system to the new account
					$reg_opts = array (
							'email' => $_POST['contact_email'],
							'register' => TRUE,
							'location_name' => $location_name
							);

					sysadmin_fetch_license('', false, true, $reg_opts);

					$fetch_lic = TRUE;
				}


			//if register, portal_acct, and email
			} elseif ($register && $portal_acct && filter_var($portal_email, FILTER_VALIDATE_EMAIL)) {
				$reg_opts = array (
						'email' => $portal_email,
						'register' => TRUE,
						'location_name' => $location_name
						);

		                sysadmin_fetch_license('',false,true,$reg_opts);
				$error_code = '761';
				$fetch_lic = TRUE;
			} elseif ($register && $unused_deployment == 'YES') {
				$error_code = '818';
				$fetch_lic = TRUE;
            		}


			//get brand new license
			if ($fetch_lic === TRUE) {
				$deploy = $var['lic']['deploymentid']
						? $var['lic']['deploymentid']
						: $var['deploymentid'];
				if (!isset($deploy) || empty($deploy)) {
					$deploy = sysadmin_get_pbxid();
				}
				$reg_lic = sysadmin_fetch_license($deploy, false, true);
				
				if (!$reg_lic) {
					$error = 'ERROR '.$error_code.': An error has occurred, please contact customer care at +1 (920) 886-8130 for further assistance.';
				}
			}

			if (!empty($error)) {
				$data['error'] = $error;
			}

			break;
		case 'save_intrusion_detection':
			$getids = array('ban_time', 'max_retry', 'find_time', 'email', 'whitelist', 'banned');
			foreach ($getids as $gids) {
				$ids[$gids]     = isset($_REQUEST[$gids]) ? $_REQUEST[$gids] : '';
			}
			sysadmin_put_intrusion_detection($ids);
			sysadmin_set_intrusion_detection();
			break;

		case 'save_email_setup':
			$getemail_setup = array('server',
					'smtp_server',
					'username',
					'password',
					'auth',
					'mydomain',
					'myorigin',
					'myhostname',
					'provider');
			foreach ($getemail_setup as $gemail_setup) {
				$email_setup[$gemail_setup] = isset($_REQUEST[$gemail_setup])
											? $_REQUEST[$gemail_setup]
											: '';
			}
			sysadmin_put_email_setup($email_setup);
			sysadmin_set_email_setup();
			break;

		case 'save_ftp_setup':
			$getftp_setup = array('server', 'username', 'password', 'olduser','tftp');
			foreach ($getftp_setup as $gftp_setup) {
				$ftp_setup[$gftp_setup] = isset($_REQUEST[$gftp_setup])
										? $_REQUEST[$gftp_setup]
										: '';
			}
			sysadmin_put_ftp($ftp_setup);
			sysadmin_set_ftp();
			break;

		case 'debug_email_setup':
			sendmail($var['test_email']);
			break;

		case 'intrusion_detection':
			sysadmin_intrusion_detection($var['intrusion_detection']);
			break;

		case 'power':
			sysadmin_power($var['power']);
			break;

		case 'save_portmgmt_setup':
			$getportmgmt_setup = array('xml', 'ucp', 'acp', 'hpro', 'restapps', 'restapi');
			foreach ($getportmgmt_setup as $gportmgmt_setup) {
				$portmgmt_setup[$gportmgmt_setup] = isset($_REQUEST[$gportmgmt_setup]) ? $_REQUEST[$gportmgmt_setup] : '';
			}
			sysadmin_put_portmgmt($portmgmt_setup);
			sysadmin_set_portmgmt();
			break;

		case 'save_network':
			sysadmin_put_ifs($var['network']);
			sysadmin_set_network();
			break;

		case 'save_dns':
			sysadmin_put_dns(trim($var['dns']));
			sysadmin_set_dns();
			break;

		case 'set_timezone':
			sysadmin_put_timezone($var['tz_area'][$var['tz_continent']]);
			sysadmin_set_timezone();
			break;

		case 'updates':
			if($var['version']) {
				sysadmin_set_update_status('msg',
					array('version' => $var['version'], 'status' => '100'));
				//ensure there is no lock being held
				if (!sysadmin_get_update_status('lock')) {
					sysadmin_set_update_status('lock');
					sysadmin_set_update_status('msg',
						array('version' => $var['version'], 'status' => '110'));
					sysadmin_put_update_request($var['version']);
					sysadmin_set_update_system();
				} else {
					//log an error
					sysadmin_set_update_status('msg',
						array('version' => $var['version'], 'status' => '900'));
				}
			} else {
				foreach (array('hour', 'minute', 'month', 'day','weekday') as $time) {
					if (is_array($var[$time])) {
						$var[$time] = implode(',', $var[$time]);
					} elseif(!$var[$time]) { //default to * if not set
						$var[$time] = '*';
					}
				}
				sysadmin_service_set_cron($var['cronstate'],
						$var['hour'],
						$var['minute'],
						$var['month'],
						$var['day'],
						$var['weekday']);
				sysadmin_set_update_cron();
			}
			break;

		case 'save_ups_setup':
			$getups_setup = array('server',
						'ups_name',
						'ups_cable_type',
						'ups_type',
						'ups_delay',
						'ups_batt',
						'ups_min',
						'ups_timeout',
						'ups_device',
						'common',
						'ups_common',
						'ups_changeme',
						'ups_commfailure',
						'ups_commok',
						'ups_offbattery',
						'ups_onbattery');
			foreach ($getups_setup as $gups_setup) {
				$ups_setup[$gups_setup] = isset($_REQUEST[$gups_setup])
										? $_REQUEST[$gups_setup]
										: '';
			}
			sysadmin_put_ups($ups_setup);
			sysadmin_set_ups();
			break;

		case 'set_ddns':
			//default interval to 59 if were using a static ip
			$var['interval'] = $var['staticip'] ? '59' : $var['interval'];
			sysadmin_set_ddns($var['interval'], $var['staticip']);
			break;

		case 'storage':
			$email = array('storageemail' => $var['storageemail']);
			sysadmin_put_storage_email($email);
			sysadmin_set_mdadm();
			break;

		case 'vpn':
			sysadmin_vpn($var['vpn']);
			break;

		case 'save_abnormal':
			$getabnormal_setup = array('noct',
						'nodt',
						'ioct',
						'iodt',
						'abnormal_email');

			foreach ($getabnormal_setup as $gabnormal_setup) {
        			$abnormal_setup[$gabnormal_setup]     = isset($_REQUEST[$gabnormal_setup]) ? $_REQUEST[$gabnormal_setup] : '';
			}

			sysadmin_abnormalcallvolume_put_email($abnormal_setup['abnormal_email']);
			unset($abnormal_setup['abnormal_email']);
			sysadmin_abnormalcallvolume_put_threshold($abnormal_setup);
			break;
		case 'save_notifications':
			$notifications_setup = array('fromemail',
						'storageemail',
						'fail2ban_email',
						'abnormal_email',
						'ups_changeme',
						'ups_commfailure',
						'ups_offbattery',
						'ups_commok',
						'ups_onbattery');
			foreach ($notifications_setup as $gnotifications_setup) {
				$notify_setup[$gnotifications_setup] = isset($_REQUEST[$gnotifications_setup]) ? $_REQUEST[$gnotifications_setup] : '';
			}
			sysadmin_put_storage_email($notify_setup);
			sysadmin_set_intrusion_detection();
			sysadmin_set_mdadm();
			sysadmin_set_ups();
			break;
	}
}

//echo the page if were not ajax, otherwise, return data
//just set the data variable, dont echo anything in the switch!
if (!isset($_SERVER['HTTP_X_REQUESTED_WITH'])
	|| strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) != 'xmlhttprequest'
) {
  echo load_view($dir . '/views/rnav.php', $var);
} else {
	//Why aren't we outputting the content-type here? --BW
	$data = (!isset($data)) ? '' : $data;
	switch ($var['ajax']) {
		case 'status_update':
			$data = sysadmin_get_update_status('status',
						$var['last_update'],
						$var['version']);
			break;
	}
	echo json_encode($data);
	exit();
}


switch($var['view']) {
	case 'sysadmin':
		echo load_view($dir . '/views/sysadmin.php', $var);
		break;

	case 'debug':
		echo load_view($dir . '/views/debug.php', $var);
		break;

	case 'dns':
		$var['dns'] = sysadmin_get_dns();
		echo load_view($dir . '/views/dns.php', $var);
		break;

	case 'ddns':
		//not sure why we werent getting the interval before, so let's get it from an existing function
		$temp 			= sysadmin_get_ddns();
		$var['interval']	= $temp['interval'];
		$var['domain']		= sysadmin_get_domain_name();
		$var['deployment'] 	= $var['lic']['deploymentid'];
		$var['extdomain']	= 'ext-' . $var['domain'];
		$var['discip']		= sysadmin_get_public_ip(true);
		$var['staticip']	= sysadmin_get_public_ip(false);
		echo load_view($dir . '/views/ddns.php', $var);
		break;

	case 'email_setup':
		$var['email_setup']	= sysadmin_get_email_setup();
		echo load_view($dir . '/views/email_setup.php', $var);
		break;

	case 'email_debug':
		$var['email_setup']	= sysadmin_get_email_setup();
		echo load_view($dir . '/views/email_debug.php', $var);
		break;

	case 'ftp':
		$var['ftp'] = sysadmin_get_ftp_setup();
		echo load_view($dir . '/views/ftp.php', $var);
		break;

	case 'intrusion_detection':
		$var['i_d_conf'] 	= sysadmin_check_intrusion_detection_conf();
		$var['banned']		= sysadmin_get_banned();
		$var['status']		= sysadmin_intrusion_detection_status();
		$var['ids']			= sysadmin_get_intrusion_detection();
		echo load_view($dir . '/views/intrusion_detection.php', $var);
		break;

	case 'license':
		echo load_view($dir . '/views/license.php', $var);
		break;

	case 'network':
		$var['netface'] = sysadmin_get_ifs();
		$var['json_inc'] = $amp_conf['AMPWEBROOT'] . '/admin/common/json.inc.php';
		echo load_view($dir . '/views/network.php', $var);
		break;

	case 'notifications':
		$var['email']			= sysadmin_get_storage_email($var);
		$var['currentcomponent']	= $currentcomponent;
		echo load_view($dir . '/views/notifications.php', $var);
		break;

	case 'power':
		echo load_view($dir . '/views/power.php', $var);
    	break;

	case 'portmgmt':
		$var['portmgmt'] = sysadmin_get_portmgmt();
		echo load_view($dir . '/views/portmgmt.php', $var);
    	break;

	case 'storage':
		$var['fs']		= sysadmin_get_filesystems();
		$var['mdadm']	= sysadmin_get_mdadm();
		$var['email']	= sysadmin_get_onlystorage_email();
		$var['raid']    = sysadmin_get_raid_status();
		echo load_view($dir . '/views/storage.php', $var);
    	break;

	case 'timezone':
		echo load_view($dir . '/views/timezone.php', $var);
    	break;

	case 'updates':
		$var['firmware'] 		= sysadmin_get_pbxversion();
		$var['update_status']	= sysadmin_get_update_status('lock');
		$var['last_request']	= sysadmin_get_update_request();
		$var['updates']			= sysadmin_fetch_update_list();
		//$var['update_status'] = sysadmin_get_update_status('status',
		//		sysadmin_get_update_status('start_time'));
		echo load_view($dir . '/views/updates.php', $var);
    	break;

	case 'ups':
		$var['ups'] = sysadmin_get_ups_setup();
		echo load_view($dir . '/views/ups.php', $var);
		break;

	case 'vpn':
		$var['vpnconf']	= sysadmin_check_openvpn_conf();
		$var['status']	= sysadmin_vpn_status();
		$var['vpnip']   = sysadmin_get_vpn_ip();
		echo load_view($dir . '/views/vpn.php', $var);
    	break;

	case 'abnormalcallvolume':
		$var['currentcomponent']	= $currentcomponent;
		$var['ab'] = sysadmin_abnormalcallvolume_get_threshold();
		$var['ab_email'] = sysadmin_abnormalcallvolume_get_email();
		echo load_view($dir . '/views/abnormalcallvolume.php', $var);
	break;

	default:
		if ($var['lic']['deploy_type'] == 'FreePBX-Distro') {
			$var['service_pack']	= sysadmin_get_freepbxdistro_failsafe();
			$var['firmware'] 		= sysadmin_get_freepbxdistro_version();
		} elseif (sysadmin_get_freepbxdistro_version() != FALSE) {
			$var['service_pack']	= sysadmin_get_freepbxdistro_failsafe();
			$var['firmware']		= sysadmin_get_freepbxdistro_version();
		} else {
			$var['service_pack']	= sysadmin_get_pbxactfailsafe();
			$var['firmware'] 		= sysadmin_get_pbxversion();
		}

		echo load_view($dir . '/views/index.php', $var);
		break;
	}

?>
