<?php
//http://www.faqs.org/docs/securing/chap9sec90.html
echo '<script type="text/javascript" src="modules/sysadmin/assets/js/views/network.js"></script>';
echo '<form id="network_set_form" method="post" action="' . $_SERVER['REQUEST_URI'] . '">';
echo heading('Network Settings',3);
echo '<hr class="hr-sysadmin"/>';
$table = new CI_Table();

//TODO: load virtual interface data
//if we have no adapters, generate message and exit
if (!$netface) {
	echo 'No network adapters found!';
	return;
}

$padding = 0;
//build adapter select
$net_opts[] = '<select id="select_network_device" readonly="readonly">';
//check lenght of adapter to use for padding
foreach ($netface as $net) {
	$padding = ((strlen($net['DEVICE']) > $padding) ? strlen($net['DEVICE']) : $padding);
}

//build json object and select options
foreach ($netface as $net) {
	$json['ifs'][] = $net['DEVICE'];
	//strip special char from mac
	//$net['HWADDR'] = strtoupper($net['HWADDR']);
	//$temp = preg_match_all('/[0-9A-Fa-f]+/', $net['HWADDR'], $match);
	//$net['HWADDR'] = $match[0][0] . $match[0][1] . $match[0][2] . $match[0][3] . $match[0][4] . $match[0][5];
	
	$json[$net['DEVICE']] = array(	
									'name'		=>  $net['DEVICE'],
									'BOOTPROTO' => ($net['BOOTPROTO'] ? $net['BOOTPROTO'] : 'none'),
									'ONBOOT'	=> ($net['ONBOOT'] ? $net['ONBOOT'] : 'yes'),
									'IPADDR'	=> $net['IPADDR'],
									'NETMASK'	=> $net['NETMASK'],
									'GATEWAY'	=> $net['GATEWAY'],
									'HOSTNAME'	=> $net['HOSTNAME'],
									'HWADDR'	=> $net['HWADDR'],
									'VLAN'		=> ($net['VLAN'] ? $net['VLAN'] : ''),
									'type'		=> $net['type']
								);
	
	//add data stats if we have them
	if (isset($net['stats']) && is_array($net['stats']) && isset($net['stats']['rx_bytes'], $net['stats']['tx_bytes'])) {
		$in 	= number_format($net['stats']['rx_bytes']/1048576, 2);
		$out 	= number_format($net['stats']['tx_bytes']/1048576, 2 );
		$stat 	=  ' (' . $out . 'Mb/' . $in . 'Mb)';
	} else {
		$stat = ' (virtual) ';
	}
	$net_opts[] = '<option value="' . $net['DEVICE'] . '">' . str_pad($net['DEVICE'], $padding) . $stat . '</option>';
}

//close select
$net_opts[] = '</select>';

//generate table
$table->add_row(array('data' => fpbx_label('Network Interface:'), 'class' => 'ifselect'),
 		array('data' => implode($net_opts), 'class' => 'ifselect')	);
$table->add_row(fpbx_label('Interface Name:', 'Virtual interface names should be derived from the primary interface\'s name. For example, a virtual interface on interface <code>eth0</code> should be named <code>eth0:X</code> where <code>X</code> is an incremental value (i.e. <code>eth0:0</code>, <code>eth0:1</code>, <code>eth0:2</code>, as needed).<br />
VLAN interface names should be derived from the primary interface\'s name. For example, a virtual interface on interface <code>eth0</code> should be named <code>eth0.X</code> where <code>X</code> is the VLAN number.'),
			'<input type="text" name="ifname" value="" placeholder="Interface Name" disabled="true"/>'
			);
$table->add_row(fpbx_label('IP Protocol:', 'Protocol used when system boots. Set this to none if you will be defining an ip below'),
			'<span class="radioset">
			<input type="radio" name="bootproto"  id="bootproto-none" value="none"/>
			<label for="bootproto-none">None</label>
			
			<input type="radio" name="bootproto" id="bootproto-dhcp" value="dhcp"/> 
			<label for="bootproto-dhcp">DHCP</label>
			
			<input type="radio" name="bootproto" id="bootproto-bootp" value="bootp"/> 
			<label for="bootproto-bootp">BOOTP</label>
			</span>'
			);
$table->add_row(array( 'data' => fpbx_label('Static IP:'), 'class' => 'static_only'),
			array( 'data' => '<input type="text" name="staticip" value="" placeholder="enter ip address"/>', 'class' => 'static_only')
			);
$table->add_row(array( 'data' => fpbx_label('Netmask:'), 'class' => 'static_only'),
			array( 'data' => '<input type="text" name="netmask" value="" placeholder="netmask"/>', 'class' => 'static_only')
			);
$table->add_row(array( 'data' => fpbx_label('Gateway:', 'The gateway this device should use'), 'class' => 'static_only'),
			array( 'data' => '<input type="text" name="gateway" value="" placeholder="gateway"/>', 'class' => 'static_only')
			);
$table->add_row(array( 'data' => fpbx_label('Mac Address:'), 'class' => 'static_only'),
			array( 'data' => '<input type="text" name="macaddr" value="" placeholder="mac address"/>', 'class' => 'static_only')
			);
$table->add_row(fpbx_label('On Boot:','Enable or disable the interface from being started automatically when the system boots up'),
			'<span class="radioset">
			<input type="radio" name="onboot"  id="onboot-yes" value="yes"/>
			<label for="onboot-yes">Yes</label>
			
			<input type="radio" name="onboot" id="onboot-no" value="no"/> 
			<label for="onboot-no">No</label>

			</span>'
			);
$table->add_row(array('data' => fpbx_label('VLAN:','Enable or disable the interface from being a VLAN'), 'id' => 'vlanLabel', 'class' => 'hidden'),
			array('data' => '<span class="radioset">
			<input type="radio" name="vlan"  id="vlan-yes" value="yes"/>
			<label for="vlan-yes">Yes</label>
			
			<input type="radio" name="vlan" id="vlan-no" value="no"/> 
			<label for="vlan-no">No</label>

			</span>', 'id' => 'vlanRadio', 'class' => 'hidden')
			);

$table->add_row('<input type="submit" name="Save Settings" id="save_set" value="Save Settings"/>
			<input type="submit" class="hidden" id="save_new_if" name="Save Interface" value="Save Virtual Interface"/>',
			'<input type="submit" class="hidden" id="addip" name="Save Settings" value="Add Virtual Interface"/>
			<input type="submit" class="hidden" id="delip" name="Save Settings" value="Remove Virtual Interface"/>'
			);
								
echo $table->generate();

?>

	<input type="hidden" name="action" value="save_network">
	<input type="hidden" name="display" value="sysadmin">
	<input type="hidden" name="view" value="network">
	<input type="hidden" name="network" value="">
</form>

<script type="text/javascript">
var network = <?php if (file_exists($json_inc)) { require_once($json_inc); $j = new Services_JSON; echo $j->encode($json);} else { echo json_encode($json);}?>;
</script>
