<?php

require_once('/var/lib/asterisk/agi-bin/phpagi.php');
include('vmnotify-common.php');

$agi = new AGI();

$spooldir = (strlen($amp_conf['ASTSPOOLDIR']) > 1?$amp_conf['ASTSPOOLDIR']:'/var/spool/asterisk');
$varlibdir = (strlen($amp_conf['ASTVARLIBDIR']) > 1?$amp_conf['ASTVARLIBDIR']:'/var/lib/asterisk');

// for some reason it fails if get_variable isn't called twice?
//
$vmnotifyid = $agi->get_variable("id");
$vmnotifyid = $agi->get_variable("id");
$vmnotifyid = $vmnotifyid['data'];

$query = $db->query("
  SELECT v.*, n.* 
  FROM 
    vmnotify_notifications AS n 
    JOIN vmnotify AS v 
    USING(mailbox)
  WHERE n.id=$vmnotifyid 
  LIMIT 1") or die("Could not execute query.");

$query->fetchinto($row,DB_FETCHMODE_ASSOC);

if(count($row) < 1) {
	exit;
}

$mailbox = $row['mailbox'];
$recipients = $row['recipients'];
$recipients = unserialize($recipients);
ksort($recipients,SORT_NUMERIC);
$outcid = $row['outcid'];
$outcidname = $row['outcid'];
$cidtype = $row['cidtype'];
$getname = $row['getname'];
$retrycount = $row['retrycount'];
$retrydelay = $row['retrydelay'];
$prioritydelay = $row['prioritydelay'];
$emailsuccess = $row['emailsuccess'];
$emailfail = $row['emailfail'];
$emailfrom = $row['emailfrom'];
$emailsubject = $row['emailsubject'];
$emailbody = $row['emailbody'];
$emailattach = $row['emailattach'];
$status = $row['status'];
$retry = $row['retry'];
$previouspriority = $row['priority'];
$time = $row['time'];
$callerid = $row['callerid'];
$length = $row['length'];

$outcidstring = '"'.$outcidname.'" <'.$outcid.'>';

if ($cidtype=='fixed'||$cidtype=='forcemb') {
  $cidvar = "__TRUNKCIDOVERRIDE=$outcid";
}else{
  $cidvar = "__REALCALLERIDNUM=$outcid";
}

// check if this notification has already been accepted and if so exit
vmnotify_accepted();


// get new priority or -1 if no new priority found 
$thispriority = 0;
$i = 0;
$priority = -1;

foreach($recipients as $ptmp => $rtmp) {
  if (!isset($firstpriority)) {
    $firstpriority = $ptmp;
    $firstrecipients = explode(',',$rtmp);
  }
  if ($ptmp > $previouspriority) {
    $priority = (integer) $ptmp;
    $recipients = explode(',',$rtmp);
    break;
  }
}


if ($priority === -1) {
  $retry++;
  if ($retry > $retrycount) {
    // this means we have completely failed and need to send the emails out
    
    $qry = "UPDATE vmnotify_notifications SET status=2 WHERE id=$vmnotifyid";
    $db->query($qry);
    $priority = $previouspriority;
    $retry--;
    vmnotify_send_emails(false);
    exit;
  }else{
    // reset to lowest priority and new retry
    $qry = "UPDATE vmnotify_notifications SET priority=$firstpriority, retry=$retry WHERE id=$vmnotifyid";
    $priority = $firstpriority;
    $recipients = $firstrecipients;
    $db->query($qry);
  }
}else{
  // we don't need to delay the call files since this is a priority escalation and not a retry
  // so we set the retry delay to 0 seconds and then proceed to create call files 
  $retrydelay = 0;
  // update the database with the current priority
  $qry = "UPDATE vmnotify_notifications SET priority=$priority WHERE id=$vmnotifyid";
  $db->query($qry);
  
}

$calltime = time() + $retrydelay + 5;

// create call files for this round of notifications 

foreach($recipients as $rnum) {

  $qry = "
    INSERT INTO vmnotify_events (
      `notification_id`,
      `time`,
      `number`,
      `priority`,
      `status`
    ) VALUES (
      $vmnotifyid,
      UNIX_TIMESTAMP(NOW()),
      '$rnum',
      $priority,
      0
    )
  ";
    
  $result = $db->query($qry);
  // get id of just inserted row
  $result = $db->query("SELECT last_insert_id() AS last_insert_id");
  $result->fetchinto($row,DB_FETCHMODE_ASSOC);
  $rid = $row['last_insert_id'];
  
  $filecont = "
Channel: Local/$rnum@vmnotify-main
CallerID: $outcidstring
WaitTime: 30
Application: AGI
Data: vmnotify-main.php
Set: __id=$vmnotifyid
Set: __rid=$rid
Set: __rnum=$rnum
Set: $cidvar
";
  
  $filename = "/tmp/$mailbox-$vmnotifyid-$retry-$priority-$rnum.call";
  $fh = fopen($filename,'w');
  fwrite($fh,$filecont);
  fclose($fh);
  touch($filename,$calltime);
  rename($filename,"$spooldir/outgoing/$mailbox-$vmnotifyid-$retry-$priority-$rnum.call");
  freepbx_log(FPBX_LOG_INFO, "vmnotify-audit: launched callfile in for id $vmnotifyid to priority: $priority callback number: $rnum");
}

// create audit call file

$filecont = "
Channel: Local/1@vmnotify-dummy
Application: AGI
Data: vmnotify-audit.php
Set: __id=$vmnotifyid
";
  
$filename = "/tmp/$mailbox-$vmnotifyid-$retry-$priority-audit.call";
$fh = fopen($filename,'w');
fwrite($fh,$filecont);
fclose($fh);
$calltime = ((integer) time() + (integer) $retrydelay + (integer) $prioritydelay + (integer) $length);
touch($filename,$calltime);
rename($filename,"$spooldir/outgoing/$mailbox-$vmnotifyid-$retry-$priority-audit.call");
freepbx_log(FPBX_LOG_INFO, "vmnotify-audit: launched audit callfile for id $vmnotifyid priority: $priority");


# exit
exit;










