<?php

if (zend_loader_file_encoded()) {
        $vmnotify_lic_info      = zend_loader_file_licensed();
        $vmnotify_lic_exp        = isset($vmnotify_lic_info['vmnotify_exp'])?preg_replace('/-/','',$vmnotify_lic_info['vmnotify_exp']):'00000000';
        if ($vmnotify_lic_exp > date('Ymd')) {
                $vmnotify_licensed = true;
        } else {
                $vmnotify_licensed = false;
        	die('We were unable to verify that your are licensed for this product. Please update your license file or contact customer care for more information.');
	}
} else {
        $vmnotify_licensed = true;
}

function vmnotify_accepted() {
	// checks database to see if this notification has already been accepted
	// if it has we playback a message and hang up, otherwise we return false
	global $db, $agi, $vmnotifyid, $rid;
	$sqlstatus = "SELECT status FROM vmnotify_notifications WHERE id='$vmnotifyid'";
	$result = $db->query($sqlstatus); // this will execute on the last opened database connection
								// so make sure you have opened one before calling this function
	$result->fetchinto($row,DB_FETCHMODE_ASSOC);
	$status = $row['status'];
	$agi->Exec('NoOp',$status);
	if ($status != '0') {
		$agi->stream_file('vmnotify-too-late');
		if(isset($rid)) {
		  vmnotify_log_event(3,$rid);
		}
		$agi->hangup();
		exit;
	}
	return false;
}

// Stream Caller's CID and return

function vmnotify_saycid() {
  global $agi, $callerid;
	$agi->say_digits("$callerid");
	return true;
}

// Stream mailbox number or greeting

function vmnotify_sayname() {
	global $agi, $mailbox, $spooldir;
	if (is_file("$spooldir/voicemail/default/$mailbox/greet.wav")) {
		$agi->stream_file("$spooldir/voicemail/default/$mailbox/greet");
	} else {
		$agi->say_digits("$mailbox");
	}
	return true;
}

function vmnotify_log_event($status, $rid) {
	global $db;
	if ($rid == '') {
		freepbx_log(FPBX_LOG_WARNING, "vmnotify: blank id sent to vmnotify_log_event with status: $status");
		return true;
	}
	$qry = "UPDATE vmnotify_events SET `status` = $status, `time` = ".time()." WHERE id = $rid";
	$db->query($qry);
	freepbx_log(FPBX_LOG_INFO, "vmnotify: event logged id: [$rid] status: $status");
}


function vmnotify_send_emails($success) {

  global $agi, $mailbox, $emailsuccess, $emailfail, $emailfrom, $emailsubject, $emailbody, $emailattach, $varlibdir, $vmnotifyid, $callerid;

  //dbug('in send email');
  $emailsubject = vmnotify_parse_email_subject($emailsubject,$success);

  if ($success) {
    $emailto = $emailsuccess;
		$mtype = 'SUCCESS';
  }else{
    $emailto = $emailfail;
		$mtype = 'FAILURE';
  }

  if (strlen($emailto) > 0) {

 		$config = array('mailtype' => 'html', 'charset' => 'iso-8859-1', 'useragent' => 'VMNotify');

		$email = new CI_Email($config);
		$email->to($emailto);
		$email->from($emailfrom);
		$email->subject($emailsubject);

		if($emailattach) {
			$email->attach("$varlibdir/sounds/vmnotify/$mailbox/$vmnotifyid/msg0000.wav");
		}

		$emailtext = vmnotify_parse_email_body($emailbody,$success);
		$emailhtml = ('<p><font face="Courier, Courier New, Fixed">'.preg_replace('/\n/',"\n<br />",$emailtext).'</font></p>');

		$email->message($emailhtml);
		$result = $email->send();
		//dbug('sending vmnotify email', $email->print_debugger());
		freepbx_log(FPBX_LOG_INFO, "vmnotify: $mtype email sent for id: $vmnotifyid callerid: $callerid to: $emailto");

	}
}


function vmnotify_parse_email_body($emailbody,$status,$format='text') {
  global $db, $callerid, $mailbox, $time, $length, $rnum, $vmnotifyid, $retry, $priority;
  $emailbody = vmnotify_parse_email_subject($emailbody,$status);

  if(strpos($emailbody,'{{LOG}}')===FALSE) {
    return $emailbody;
  }else{
    $qry = "SELECT * FROM vmnotify_events WHERE notification_id=$vmnotifyid ORDER BY `time` ASC";
   	$result = $db->query($qry); // this will execute on the last opened database connection
								// so make sure you have opened one before calling this function
		$log = "\n";

		while($result->fetchinto($row,DB_FETCHMODE_ASSOC)) {
			$time = date('r',$row['time']);
			$number = $row['number'];
			switch($row['status']) {
				case 1:
					$status = 'Accepted';
					break;
				case 2:
					$status = 'Declined';
					break;
				case 3:
					$status = 'Too Late';
					break;
				case 4:
					$status = 'Listened';
					break;
				default:
					$status = 'No Answer';
			}
			$log .= "$time - $number - $status\n";
		}
		$log .= "\n\n";
  }
  $emailbody = str_replace('{{LOG}}',$log,$emailbody);

  return $emailbody;
}

function vmnotify_parse_email_subject($emailbody,$status) {
  global $callerid, $mailbox, $time, $length, $rnum, $vmnotifyid, $retry, $priority;
  $emailbody = str_replace('{{STATUS}}',($status?'SUCCESSFUL':'FAILED'),$emailbody);
  $emailbody = str_replace('{{CALLERID}}',$callerid,$emailbody);
  $emailbody = str_replace('{{MAILBOX}}',$mailbox,$emailbody);
  $emailbody = str_replace('{{TIME}}',date('r',$time),$emailbody);
  $emailbody = str_replace('{{LENGTH}}',$length,$emailbody);
  $emailbody = str_replace('{{ACCEPTEDBY}}',$rnum,$emailbody);
  $emailbody = str_replace('{{ID}}',$vmnotifyid,$emailbody);
  $emailbody = str_replace('{{RETRY}}',$retry,$emailbody);
  $emailbody = str_replace('{{PRIORITY}}',$priority,$emailbody);
  return $emailbody;
}

if(!function_exists('stream_multiple')) {
	function stream_multiple($p_sFileList,$p_sKeys) {
		$aFiles = explode('&',$p_sFileList);
		$result = 0;
		foreach ($aFiles as $sFile)
		{
			$aInput = $GLOBALS['agi']->stream_file($sFile, $p_sKeys, 0);
			if ($aInput['result']!=0) return $aInput;
		}
		return $aInput;
	}
}


if(!function_exists('parse_amportal_conf')) {
	function parse_amportal_conf($filename) {
		$file = file($filename);
		foreach ($file as $line) {
			if (preg_match("/^\s*([a-zA-Z0-9]+)\s*=\s*(.*)\s*([;#].*)?/",$line,$matches)) {
				$conf[ $matches[1] ] = $matches[2];
			}
		}
		return $conf;
	}
}

?>

