<?php

require_once('/var/lib/asterisk/agi-bin/phpagi.php');
include('vmnotify-common.php');

$agi = new AGI();
$agi->exec('DumpChan','');

$spooldir = (strlen($amp_conf['ASTSPOOLDIR']) > 1?$amp_conf['ASTSPOOLDIR']:'/var/spool/asterisk');
$varlibdir = (strlen($amp_conf['ASTVARLIBDIR']) > 1?$amp_conf['ASTVARLIBDIR']:'/var/lib/asterisk');

/* Connect to database parse voicemail notify variables */

// for some reason the get_variable fails if not done twice?
//
$vmnotifyid = $agi->get_variable("id");
$vmnotifyid = $agi->get_variable("id");
$vmnotifyid = $vmnotifyid['data'];

$rid = $agi->get_variable("rid");
$rid = $agi->get_variable("rid");
$rid = $rid['data'];

$rnum = $agi->get_variable("rnum");
$rnum = $agi->get_variable("rnum");
$rnum = $rnum['data'];

$query = "
  SELECT v.*, n.* 
  FROM 
    vmnotify_notifications AS n 
    JOIN vmnotify AS v 
    USING (mailbox)
  WHERE n.id=$vmnotifyid 
  LIMIT 1
";

$result = $db->query($query) or die("Could not execute query.");
$result->fetchInto($row,DB_FETCHMODE_ASSOC);  

if(count($row) < 1) {
	freepbx_log(FPBX_LOG_ERROR, "vmnotify-main: no information available to process id: $vmnotifyid calling callback number: $rnum for rid: $rid");
	die("No results found in database\n");
}

$mailbox = $row['mailbox'];
$recipients = unserialize($row['recipients']);
ksort($recipients,SORT_NUMERIC);
$outcid = $row['outcid'];
$getname = $row['getname'];
$retrycount = $row['retrycount'];
$retrydelay = $row['retrydelay'];
$prioritydelay = $row['prioritydelay'];
$emailsuccess = $row['emailsuccess'];
$emailfail = $row['emailfail'];
$emailfrom = $row['emailfrom'];
$emailsubject = $row['emailsubject'];
$emailbody = $row['emailbody'];
$emailattach = $row['emailattach'];
$status = $row['status'];
$retry = $row['retry'];
$priority = $row['priority'];
$time = $row['time'];
$callerid = $row['callerid'];
$length = $row['length'];
$greetingid = (int) $row['greetingid'];
$instructionsid = (int) $row['instructionsid'];

freepbx_log(FPBX_LOG_INFO, "vmnotify-main: attempting to process id: $vmnotifyid calling callback number: $rnum for rid: $rid concerning callerid: $callerid");

// Get Recordings from IDs
$rSQL = $db->query("SELECT * FROM recordings WHERE id IN ($greetingid,$instructionsid)");

while ($test = $rSQL->fetchInto($arecording,DB_FETCHMODE_ASSOC)) {
	$recordings[$arecording['id']] = $arecording['filename'];
}

$greeting = (isset($recordings["$greetingid"])?$recordings["$greetingid"]:'vmnotify-greeting');
$instructions = (isset($recordings["$instructionsid"])?$recordings["$instructionsid"]:'vmnotify-instructions');

  /////////////////
 // ENTRY POINT //
/////////////////

sleep(1);
vmnotify_accepted();

$agi->stream_file('silence/1');
stream_multiple($greeting,'');
vmnotify_sayname();

$rcinput = 0;
$thisloop = 1;

while (($rcinput < 1) && ($thisloop <= 2)) {
  vmnotify_accepted();
  $rcinput = stream_multiple($instructions,'123');
  $rcinput = (integer) chr($rcinput['result']);
  $agi->exec('NoOp',"rcinput: $rcinput");
  
  if($rcinput == 3) {
    vmnotify_accepted();
    vmnotify_saycid();
    $rcinput=0;
    $thisloop=1;
  }else{      
    $thisloop++;
  }
}


switch ($rcinput) {
  case 1:
  
  	vmnotify_log_event(4,$rid);
  	
    $pbinput = 0;
    $thisloop = 1;
    $playdur = 0;
    
    while ($pbinput < 1 && $thisloop <= 3) {
    	sleep(1);
      vmnotify_accepted();
      $pbinput = $agi->stream_file("$varlibdir/sounds/vmnotify/$mailbox/$vmnotifyid/msg0000",'123',$offset);
      $offset = $pbinput['offset'];
      $agi->exec('NoOp',"offset: $offset");
      $pbinput = (integer) chr($pbinput['result']);
      $agi->exec('NoOp',"pbinput: $pbinput");
      if($pbinput < 1) {
        vmnotify_accepted();
        $pbinput = $agi->stream_file('vmnotify-instructions2','123',0);
        $pbinput = (integer) chr($pbinput['result']);
      }
      
      if($pbinput == 2) {
        vmnotify_log_event(2,$rid);
		$agi->stream_file('vmnotify-goodbye');
        exit;
      }
      
      if($pbinput == 1) {
        vmnotify_accepted();
        mysql_query("UPDATE vmnotify_notifications SET status=1 WHERE id=$vmnotifyid");
        vmnotify_log_event(1,$rid);
        $agi->stream_file('vmnotify-thankyou');
        $agi->stream_file('vmnotify-goodbye');
        vmnotify_send_emails(true);
      }
      
      if($pbinput == 3) {
        vmnotify_accepted();
        vmnotify_saycid();
        $pbinput=0;
        $thisloop=1;
      }else{      
        $thisloop++;
      }
    }

    break;
  case 2:
    vmnotify_log_event(2);
    $agi->stream_file('vmnotify-goodbye');
    exit;
    
  default:
    $agi->stream_file('vmnotify-goodbye');
    exit;
}

?>
