<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}
if (zend_loader_file_encoded()) {
	$vmnotify_lic_info	= zend_loader_file_licensed();
	$vmnotify_lic_exp        = isset($vmnotify_lic_info['vmnotify_exp'])?preg_replace('/-/','',$vmnotify_lic_info['vmnotify_exp']):'00000000';
	if ($vmnotify_lic_exp > date('Ymd')) {
		$vmnotify_licensed = true;
	} else {
		$vmnotify_licensed = false;
	}
} else {
	$vmnotify_licensed = true;
}

function vmnotify_set_request_vars() {
    global $mailbox, $recipients, $outcid, $outcidname, $cidtype, $retrycount, $retrydelay, $prioritydelay, $mailboxname, $emailsuccess, $emailattach, $emailfail, $emailfrom, $emailsubject, $emailbody, $enabled, $greetingid, $instructionsid;

    $recipients = (isset($_REQUEST['recipients'])?vmnotify_clean_recipients($_REQUEST['recipients']):'');
    $cidtype = (isset($_REQUEST['cidtype'])?$_REQUEST['cidtype']:'default');
    $outcid = (isset($_REQUEST['outcid'])?preg_replace("/[^0-9\+]/" ,"", trim($_REQUEST['outcid'])):'');
    $outcidname = (isset($_REQUEST['outcidname'])?preg_replace("/[',]/" ,"", trim($_REQUEST['outcidname'])):'');
    $retrycount = (isset($_REQUEST['retrycount'])?$_REQUEST['retrycount']:'');
    $retrydelay = (isset($_REQUEST['retrydelay'])?$_REQUEST['retrydelay']:'');
    $prioritydelay = (isset($_REQUEST['prioritydelay'])?$_REQUEST['prioritydelay']:'');
    $mailbox = (isset($_REQUEST['mailbox'])?$_REQUEST['mailbox']:'');
    $emailsuccess = (isset($_REQUEST['emailsuccess'])?$_REQUEST['emailsuccess']:'');
    $emailattach = (isset($_REQUEST['emailattach'])?$_REQUEST['emailattach']:'');
    $emailfail = (isset($_REQUEST['emailfail'])?$_REQUEST['emailfail']:'');
    $emailfrom = (isset($_REQUEST['emailfrom'])?$_REQUEST['emailfrom']:'');
    $emailsubject = (isset($_REQUEST['emailsubject'])?$_REQUEST['emailsubject']:'');
    $emailbody = (isset($_REQUEST['emailbody'])?$_REQUEST['emailbody']:'');
    $emailattach = (isset($_REQUEST['emailattach'])?$_REQUEST['emailattach']:'');
    $enabled = (isset($_REQUEST['enabled'])?$_REQUEST['enabled']:1);
    $greetingid = (int) $_REQUEST['greetingid'];
    $instructionsid = (int) $_REQUEST['instructionsid'];


    if (strlen($mailbox) > 0) {
        $qry = "SELECT name FROM users WHERE extension = '$mailbox'";

        $result=sql($qry,"getAll",DB_FETCHMODE_ASSOC);
        if (is_array($result)) {
            $row = $result[0];
            $mailboxname = $row['name'];
        }
    }
}


function vmnotify_get_db_vars() {
    global $mailbox, $mailboxname, $recipients, $outcid, $outcidname, $cidtype, $retrycount, $retrydelay, $prioritydelay, $emailsuccess, $emailattach, $emailfail, $emailfrom, $emailsubject, $emailbody, $enabled, $greetingid, $instructionsid;

    $qry = "
        SELECT
            v.*,
            u.name AS name
        FROM
            vmnotify AS v
            JOIN users AS u
            ON v.mailbox = u.extension
        WHERE mailbox = '$mailbox'
    ";

    $result=sql($qry,"getAll",DB_FETCHMODE_ASSOC);
    if (is_array($result)) {
        $row = $result[0];
    }

    $mailbox = $row['mailbox'];
    $mailboxname = $row['name'];
    $recipients = unserialize($row['recipients']);

    $outcid = $row['outcid'];
    $outcidname = $row['outcidname'];
    $cidtype = $row['cidtype'];
    $retrycount = $row['retrycount'];
    $retrydelay = $row['retrydelay'];
    $prioritydelay = $row['prioritydelay'];
    $emailsuccess = $row['emailsuccess'];
    $emailattach = $row['emailattach'];
    $emailfail = $row['emailfail'];
    $emailfrom = $row['emailfrom'];
    $emailsubject = $row['emailsubject'];
    $emailbody = $row['emailbody'];
    $emailattach = $row['emailattach'];
    $enabled = $row['enabled'];
    $greetingid = $row['greetingid'];
    $instructionsid = $row['instructionsid'];

}

function vmnotify_set_default_vars() {
    global $mailbox, $mailboxname, $recipients, $outcid, $outcidname, $cidtype, $retrycount, $retrydelay, $prioritydelay, $emailsuccess, $emailattach, $emailfail, $emailfrom, $emailsubject, $emailbody, $enabled, $greetingid, $instructionsid;

    $mailbox = '';
    $mailboxname = '';
    $recipients = Array();
    $outcidname = '';
    $outcid = '';
    $outcidname = '';
    $cidtype = 'default';
    $retrycount = 2;
    $retrydelay = 300;
    $prioritydelay = 120;
    $emailsuccess = '';
    $emailattach = 0;
    $emailfail = '';
    $emailfrom = '';
    $enabled = 1;
    $greetingid = 0;
    $instructionsid = 0;
    $emailsubject = '{{STATUS}} voicemail notification from {{MAILBOX}} --- [{{ID}}]';
    $emailbody = 'A new voicemail notification was sent from
mailbox {{MAILBOX}} on {{TIME}}.

-----------------------------------------
          Notification Details:
-----------------------------------------

Status:          {{STATUS}}
Message CID:     {{CALLERID}}
Length:          {{LENGTH}} seconds
Accepted By:     {{ACCEPTEDBY}}
Notification ID: {{ID}}
Number Retries:  {{RETRY}}
Final Priority:  {{PRIORITY}}

-----------------------------------------
           Notification Log:
-----------------------------------------
{{LOG}}

    ';
}

function vmnotify_build_rnav() {
    global $vmnotify_action, $mailbox, $vmnotify_licensed;

    if($vmnotify_licensed!==true) {
        return '';
    }


    // select array of all vmnotify ids in the database as well as the name and number associated with the mailbox user
    $qry = "
        SELECT
            v.mailbox AS mailbox,
            u.name AS name
        FROM
            vmnotify AS v
            INNER JOIN users AS u
            ON v.mailbox = u.extension
        ORDER BY u.name ASC
    ";
    $result=sql($qry,"getAll",DB_FETCHMODE_ASSOC);

    // output an ordered list with "New" at the top, and then a link for every mailbox

    $html = '
        <ul>
            <li><a '.($vmnotify_action=='New'? 'class="current "':'').' href="config.php?display=vmnotify&info=false">New Notification</a></li>
            ';

    if (is_array($result)) {
        foreach ($result as $row) {

            $thismailbox = $row['mailbox'];
            $thisname = $row['name'];

            $curitem = ($vmnotify_action=="New"? 'class="current "':'');
            $html .= "<li><a $current href='config.php?display=vmnotify&mailbox=$thismailbox'>$thisname ($thismailbox)</a></li>\n";
        }
    }
    $html .= "</ul>";

    // return HTML output
    return $html;
}


function vmnotify_build_exten_select() {
    global $vmnotify_action, $mailbox;

    // select array of all users on the system with a voicemail box but not yet configured with a notification
    $qry = "
        SELECT
            name,
            extension
        FROM users
        WHERE (
            voicemail != 'novm'
        )AND(
            extension NOT IN (
                SELECT mailbox FROM vmnotify
            )
        )
        ORDER BY name ASC
    ";
    $result=sql($qry,"getAll",DB_FETCHMODE_ASSOC);

    // output list of <options>s for drop-down menu

    $html = '';
    if (is_array($result)) {
        foreach ($result as $row) {
            $thismailbox = $row['extension'];
            $thisname = $row['name'];
            $html .= "<option value='$thismailbox'>$thisname ($thismailbox)</option>\n";
        }
    }

    // return HTML output
    return $html;

}

function vmnotify_delete() {
    $mailbox = $_REQUEST['mailbox'];

    $qry = "DELETE FROM vmnotify WHERE mailbox = '$mailbox'";
    sql($qry);
    header('Location: config.php?display=vmnotify');
    exit;
}


function vmnotify_save() {
    global $recipients, $outcid, $outcidname, $cidtype, $retrycount, $retrydelay, $prioritydelay, $mailbox, $mailboxname, $emailsuccess, $emailattach, $emailfail, $emailfrom, $emailsubject, $emailbody, $enabled, $greetingid, $instructionsid;

    $recipients = serialize($recipients);

    if ($cidtype=='mailbox'||$cidtype=='forcemb') {
      $outcid = $mailbox;
    }
    if (strlen($outcidname)<1) {
        $outcidname = "VMNFY-$mailboxname";
    }
    $outcidname = addslashes($outcidname);

    $saveqry = "
        UPDATE
            vmnotify
        SET
            `mailbox` = '$mailbox',
            `recipients` = '$recipients',
            `outcid` = '$outcid',
            `outcidname` = '$outcidname',
            `cidtype` = '$cidtype',
            `retrycount` = $retrycount,
            `retrydelay` = $retrydelay,
            `prioritydelay` = $prioritydelay,
            `emailsuccess` = '$emailsuccess',
            `emailfail` = '$emailfail',
            `emailfrom` = '$emailfrom',
            `emailsubject` = '$emailsubject',
            `emailbody` = '$emailbody',
            `emailattach` = $emailattach,
            `enabled` = $enabled,
            `greetingid` = $greetingid,
            `instructionsid` = $instructionsid
        WHERE
            `mailbox` = '$mailbox'
    ";

    sql($saveqry);
    header('Location: config.php?display=vmnotify');
    exit;
}

function vmnotify_new() {
    global $recipients, $outcid, $outcidname, $cidtype, $retrycount, $retrydelay, $prioritydelay, $mailbox, $mailboxname, $emailsuccess, $emailattach, $emailfail, $emailfrom, $emailsubject, $emailbody, $enabled, $greetingid, $instructionsid;

    if ($cidtype=='mailbox'||$cidtype=='forcemb') {
        $outcid = $mailbox;
    }
    if (strlen($outcidname)<1) {
        $outcidname = "VMNFY-$mailboxname";
    }

    $recipients = serialize($recipients);

    $outcidname = addslashes($outcidname);

    $qry = "INSERT INTO vmnotify (
        `mailbox`,
        `recipients`,
        `outcid`,
        `outcidname`,
        `cidtype`,
        `retrycount`,
        `retrydelay`,
        `prioritydelay`,
        `emailsuccess`,
        `emailfail`,
        `emailfrom`,
        `emailsubject`,
        `emailbody`,
        `emailattach`,
        `enabled`,
        `greetingid`,
        `instructionsid`
    ) VALUES (
        '$mailbox',
        '$recipients',
        '$outcid',
        '$outcidname',
        '$cidtype',
        $retrycount,
        $retrydelay,
        $prioritydelay,
        '$emailsuccess',
        '$emailfail',
        '$emailfrom',
        '$emailsubject',
        '$emailbody',
        $emailattach,
        $enabled,
        $greetingid,
        $instructionsid
    )";
    sql($qry);

    header('Location: config.php?display=vmnotify');
    exit;

}


function vmnotify_clean_recipients($userinput) {

    $rtemp = explode("\n",$userinput);
    $recipients = Array();

    foreach ($rtemp as $recipient) {
        if (trim(strlen($recipient)) > 0) {
            $rthis = explode(',',$recipient);
            $thispriority = (integer) $rthis[1];
            $thisrecipient = (string) trim($rthis[0]);
            $comma = (isset($recipients[$thispriority])?',':'');
            $recipients[$thispriority] .= $comma.$thisrecipient;
        }
    }

    ksort($recipients,SORT_NUMERIC);
    return $recipients;


}


function vmnotify_display_recipients($recipients=Array()) {
    $textout = '';
    foreach($recipients as $priority => $recipientlist) {
        $recipientarray = explode(',',$recipientlist);
        foreach($recipientarray as $recipient) {
            $textout .= "$recipient, $priority\n";
        }
    }
    return $textout;
}


function vmnotify_get_config() {
    global $ext;
    $ext->add('vmnotify-main', '_X.', '', new ext_macro('blkvm-set'));
    $ext->add('vmnotify-main', '_X.', '', new ext_dial('Local/${EXTEN}@from-internal','45,M(auto-blkvm)'));
    $ext->add('vmnotify-main', '_X.', '', new ext_hangup());
    $ext->add('vmnotify-dummy', '1', '', new ext_answer());
    $ext->add('vmnotify-dummy', '1', '', new ext_wait('300'));
    $ext->add('vmnotify-dummy', '1', '', new ext_hangup());

}

function vmnotify_sysadmin_getinfo() {
    return array(
        "name" => "Voicemail Notifications", // Required. Descriptive name.
        "expires" => true,         // Optional. Defaults to false (never expires)
        "keyname" => "vmnotify_exp", // Optional. Only checked if 'expires' is true
    );
}
