<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}

if (zend_loader_file_encoded()) {
        $voicemail_report_lic_info   = zend_loader_file_licensed();
        $voicemail_report_lic_exp        = isset($voicemail_report_lic_info['vm_reports_exp'])?preg_replace('/-/','',$voicemail_report_lic_info['vm_reports_exp']):'00000000';
        if ($voicemail_report_lic_exp > date('Ymd')) {
                $voicemail_report_licensed = true;
        } else {
                $voicemail_report_licensed = false;
        }
} else {
        $voicemail_report_licensed = true;
}

function voicemail_report_main_page($additional_title = false) {
	if ($additional_title) {
		echo "<h2>Voicemail Reports - $additional_title</h2>";
	} else {
		echo "<h2>Voicemail Reports</h2>";
	}
			
	echo '<div class="rnav"><ul>';
	echo '<li><a href="config.php?type=tool&display=voicemail_report&action=check_greetings">Greetings & Settings</a></li>';
	echo '<li><a href="config.php?type=tool&display=voicemail_report&action=view_voicemails">View Voicemails</a></li>';
	echo '<hr />';

}

// This function joins data from voicemail.conf to actual sound files found on the system
function voicemail_report_get_vmboxes() {
	global $amp_conf; 

	$raw_file = file_get_contents($amp_conf['ASTETCDIR'] . "/voicemail.conf");
	$file = explode("\n", $raw_file);

	$voicemail_data_structure = array();

	foreach ($file as $line) {
		//grab the current max execution time and reset it everytime we run through this loop
		$max_execution_time = ini_get('max_execution_time');
		ini_set('max_execution_time', $max_execution_time);
		
		$pattern = '/\s*(\d{1,})\s*=>\s*(\d{0,}),.*?,(.*?),.*?,.*attach=(\w*)\|saycid=(\w*)\|envelope=(\w*)\|delete=(\w*)/';
		preg_match($pattern, $line, $matches);

		if ($matches) {
			$mbox = " ".$matches[1];
			$a =  array('password' => $matches[2], 
						'email' => $matches[3], 
						'attach' => $matches[4], 
						'saycid' => $matches[5], 
						'envelope' => $matches[6], 
						'delete' => $matches[7], );
			$b = voicemail_report_format_vm_info(voicemail_report_get_vm_files($amp_conf['ASTSPOOLDIR'] . "/voicemail/default/" . $matches[1]));

			foreach ($a as $k => $v) {
				$b[$mbox][$k] = $v;
			}

			$voicemail_data_structure[$mbox] = $b[$mbox];
		}
	}
	
	ksort($voicemail_data_structure);
	return $voicemail_data_structure;
}

// This returns them in a formatted data structure
function voicemail_report_format_vm_info($raw_data) {
	global $amp_conf; 

	$voicemail_data_structure	= array();
	$session_recordings			= array('');

	$pattern_greet 		= '/(\d{1,})\/greet\.wav$/';
	$pattern_busy 		= '/(\d{1,})\/busy\.wav$/';
	$pattern_unavail 	= '/(\d{1,})\/unavail\.wav$/';
	$pattern_temp		= '/(\d{1,})\/temp\.wav$/';
	$pattern_voicemail	= '/(\d{1,})\/(.*?)\/(msg\d{1,})\.(.*)/';
	$pattern_nofiles	= '/\/(\d{1,})$/';

	if ($raw_data) {
		foreach ($raw_data as $file) {
			if (preg_match($pattern_greet, $file, $matches)) {
				$voicemail_data_structure[" ".$matches[1]]['greet'] = array_push($session_recordings, $amp_conf['ASTSPOOLDIR'] . '/voicemail/default/' . $matches[1] . '/greet.wav') - 1;
			} else if (preg_match($pattern_busy, $file, $matches)) {
				$voicemail_data_structure[" ".$matches[1]]['busy'] = array_push($session_recordings, $amp_conf['ASTSPOOLDIR'] . '/voicemail/default/' . $matches[1] . '/busy.wav') - 1;
			} else if (preg_match($pattern_unavail, $file, $matches)) {
				$voicemail_data_structure[" ".$matches[1]]['unavail'] = array_push($session_recordings, $amp_conf['ASTSPOOLDIR'] . '/voicemail/default/' . $matches[1] . '/unavail.wav') - 1;
			} else if (preg_match($pattern_temp, $file, $matches)) {
				$voicemail_data_structure[" ".$matches[1]]['unavail'] = array_push($session_recordings, $amp_conf['ASTSPOOLDIR'] . '/voicemail/default/' . $matches[1] . '/temp.wav') - 1;
			} else if (preg_match($pattern_voicemail, $file, $matches)) {
					if ($matches[4] == 'txt') {
						$file = $amp_conf['ASTSPOOLDIR'] . '/voicemail/default/' . $matches[1] . '/' . $matches[2] . '/' . $matches[3] . '.' . $matches[4];

						$lines = file($file);


						$voicemail_information = array();

						foreach ($lines as $line) {
							$words = explode("=", $line);
							if ($words && count($words) >= 2) {
								$voicemail_information[$words[0]] = $words[1];
							}
						}

						/*if ($matches[2] == 'INBOX'){
							$matches[2] = 'New';
						}*/

						$voicemail_data_structure[" ".$matches[1]]['voicemails'][$matches[2]][$matches[3]][$matches[4]] = $voicemail_information;
					} else {
						/*if ($matches[2] == 'INBOX') {
							$matches[2] = 'New';
						}*/

						$voicemail_data_structure[" ".$matches[1]]['voicemails'][$matches[2]][$matches[3]][$matches[4]] = array_push($session_recordings, $amp_conf['ASTSPOOLDIR'] . '/voicemail/default/' . $matches[1] . '/' . $matches[2] . '/' . $matches[3] . '.' . $matches[4]) - 1;
					}
			} else if (preg_match($pattern_nofiles, $file, $matches) && !isset($voicemail_data_structure[$matches[1]])) {
				$voicemail_data_structure[" ".$matches[1]] = ''; 
			}	
		}
	}
	
	$_SESSION['voicemail_recordings'] = $session_recordings;

	return $voicemail_data_structure;
}

//http://www.jimcode.org/2012/07/recursive-filesearch-php-glob-function/
//https://gist.github.com/wooki/3215801
if(!function_exists('glob_recursive')) {
	function glob_recursive($pattern, $flags = 0) {
		$files = glob($pattern, $flags);
		foreach (glob(dirname($pattern).'/*', GLOB_ONLYDIR|GLOB_NOSORT) as $dir) {
			$files = array_merge($files, glob_recursive($dir.'/'.basename($pattern), $flags));
    }
    return $files;
	}
}

// This gets all the recordings, and greetings
function voicemail_report_get_vm_files($directory) {
        global $files;

        if (!is_array($files)) {
                $files = array();
        }
        $f = glob_recursive($directory.'/*.{wav,txt}', GLOB_BRACE);

        $files = array_merge($files, $f);

        return $files;
}

// Display actual voice mail messages
function voicemail_report_get_vm_msgs() {
	global $amp_conf;

	$voicemail_data = voicemail_report_get_vmboxes();

	voicemail_report_echo_right_nav($voicemail_data);
	echo "<script>var TSort_Data = new Array ('voicemails', 's', 's', 's', 's', 'i');</script>";

	echo '<p>';
	echo 'This page allows you to review all the voicemail messages currently residing on the system.';
	echo '</p>';

	echo '<p>';
	echo 'Mailbox -- The mailbox this message belongs to.<br>';
	echo 'Date -- The date this message was left.<br>';
	echo 'Folder -- The folder this message currently resides in.<br>';
	echo 'Caller ID -- The person who left the message.<br>';
	echo 'Duration -- The length of the message in seconds.<br>';
	echo 'Listen -- Click the blue icon to listen to this recording.<br>';
	echo '</p>';

	echo '<br><br>';

	echo '<table id="voicemails" style="border: #808080 1px solid;"><thead><tr>';
	echo '<th style="width: 200px; text-align: left;">Mailbox</th>';
	echo '<th style="width: 275px; text-align: left;">Date</th>';
	echo '<th style="width: 75px; text-align: left;">Folder</th>';
	echo '<th style="width: 300px; text-align: left;">Caller ID</th>';
	echo '<th style="width: 75px; text-align: left;">Duration</th>';
	echo '<th style="width: 50px; text-align: left;">Listen</th>';
	echo '</tr></thead>';

	$voicemails_session = array('');

	if ($amp_conf['AMPEXTENSIONS'] == 'deviceanduser') {
		$devices = core_users_list();
	} else {
		$devices = core_devices_list();
	}

	foreach (array_keys($voicemail_data) as $mailbox) {
		if (isset($voicemail_data[$mailbox]['voicemails'])) {
			foreach(array_keys($voicemail_data[$mailbox]['voicemails']) as $folder) {
				foreach (array_keys($voicemail_data[$mailbox]['voicemails'][$folder]) as $voicemail) {
					echo '<tr>';
					$found = 0;
					foreach ($devices as $ext) {
						if ($ext[0] == $mailbox) {
							echo '<td><a name="' . $mailbox . '"></a>' . $ext[1] . ' ' . $ext[0] . '</td>';
							$found = 1;
						} 
					}
					
					if ($found != 1) {
						echo '<td><a name="' . $mailbox . '"></a>' . $mailbox . '</td>';
					}

					echo '<td>' . date('m/d/y h:i:s (T)', $voicemail_data[$mailbox]['voicemails'][$folder][$voicemail]['txt']['origtime']) . '</td>';
					//echo '<td>' . $voicemail_data[$mailbox]['voicemails'][$folder][$voicemail]['txt']['origdate'] . '</td>';
					echo '<td>' . $folder . '</td>';
					echo '<td>' . $voicemail_data[$mailbox]['voicemails'][$folder][$voicemail]['txt']['callerid'] . '</td>';
					echo '<td>' . $voicemail_data[$mailbox]['voicemails'][$folder][$voicemail]['txt']['duration'] . '</td>';

					$voicemail_file;

					if ($voicemail_data[$mailbox]['voicemails'][$folder][$voicemail]['wav']) {
						$voicemail_file = $voicemail_data[$mailbox]['voicemails'][$folder][$voicemail]['wav'];
					} else if ($voicemail_data[$mailbox]['voicemails'][$folder][$voicemail]['WAV']) {
						$voicemail_file = $voicemail_data[$mailbox]['voicemails'][$folder][$voicemail]['WAV'];
					}
					
					echo '<td><img src="/admin/assets/voicemail_report/images/play.png" width="20" height="20" '
						. 'title="Click here to play this recording." border="0"'
						. 'data-sound-id="' . $voicemail_file . '" '
						. 'class="play_sound"></td>';

					echo '</tr>';
				}
			}
		}
	}

	echo '</table><br><br>';
}

// Display what greetins need to be recorded
function voicemail_report_check_greetings() {
	global $amp_conf;

	$voicemail_data = voicemail_report_get_vmboxes();
	
	echo "<script>var TSort_Data = new Array ('greetings', 's', 'i', 's', 's', 's', 's', 's');</script>";

	voicemail_report_echo_right_nav($voicemail_data);

	echo '<p>';
	echo 'This page is designed to give you further insight into your voicemail system. You can quickly tell who needs to record greetings in order to make things like the name directory not spell out names. You can also easily see who is setup to receive voicemail to email.';
	echo '</p>';
	
	echo '<p>';
	echo 'Mailbox -- The mailbox that all of the following options apply to.<br>';
	echo 'Password -- The password for the mailbox.<br>';
	echo 'Name	-- This recording is played when someone enters the name directory or when a caller first reaches their mailbox.<br>';
	echo 'Busy -- This recording is played if you are busy.<br>';
	echo 'Unavailable -- This recording is played if you are unavailable.<br>';
	echo 'Temporary -- This recording is played if someone has recorded an out of the office message.<br>';
	echo 'Attach -- Email will be sent to the address shown in this column when a voicemail is left.<br>';
	echo 'Delete -- If this column reads "Yes" then email will be deleted from the mailbox when it is emailed.<br>';
	echo '</p>';

	echo '<p>';
	echo 'You can sort this table at any time by clicking on a header below.';
	echo '</p>';

	echo '<br><br>';

	echo '<table id="greetings" style="border: #808080 1px solid;"><thead><tr>';
	echo '<th style="width: 200px; text-align: left;">Mailbox</th>';
	echo '<th style="width: 100px; text-align: left;">Password</th>';
	echo '<th style="width: 60px; text-align: left;">Name</th>';
	echo '<th style="width: 60px; text-align: left;">Busy</th>';
	echo '<th style="width: 80px; text-align: left;">Unavailable</th>';
	echo '<th style="width: 80px; text-align: left;">Temporary</th>';
	echo '<th style="width: 400px; text-align: left;">Attach</th>';
	echo '<th style="width: 50px; text-align: left;">Delete</th>';
	echo '</tr></thead>';

	if ($amp_conf['AMPEXTENSIONS'] == 'deviceanduser') {
		$devices = core_users_list();
	} else {
		$devices = core_devices_list();
	}

	$play_img = '/admin/assets/voicemail_report/images/play.png';
	foreach (array_keys($voicemail_data) as $mailbox) {
		echo '<tr>';
		$found = '';
		foreach ($devices as $device) {
			if ($mailbox == $device[0]) {
				echo '<td><a name="' . $mailbox . '"></a>' . $device[1] . ' - ' . $mailbox . '</td>';
				$found = 1;
				break;
			}
		}
		
		if ($found != 1) {
			echo '<td><a name="' . $mailbox . '"></a>' . $mailbox . '</td>';
		}
		echo '<td>' . $voicemail_data[$mailbox]['password'] . '</td>';

		if (isset($voicemail_data[$mailbox]['greet'])){
			echo '<td><img src="' . $play_img . '" width="20" height="20" '
				. 'title="Click here to play this recording." border="0"'
				. 'data-sound-id="' . $voicemail_data[$mailbox]['greet'] . '" '
				. 'class="play_sound"></td>';
		} else {
			echo '<td></td>';
		}

		if (isset($voicemail_data[$mailbox]['busy'])) {
			echo '<td><img src="' . $play_img . '" width="20" height="20" '
				. 'title="Click here to play this recording." border="0"'
				. 'data-sound-id="' . $voicemail_data[$mailbox]['busy'] . '" '
				. 'class="play_sound"></td>';
		} else {
			echo '<td></td>';
		}

		if (isset($voicemail_data[$mailbox]['unavail'])) {
			echo '<td><img src="' . $play_img . '" width="20" height="20" '
				. 'title="Click here to play this recording." border="0"'
				. 'data-sound-id="' . $voicemail_data[$mailbox]['unavail'] . '" '
				. 'class="play_sound"></td>';
		} else {
			echo '<td></td>';
		}

		if (isset($voicemail_data[$mailbox]['temp'])) {
			echo '<td><img src="' . $play_img . '" width="20" height="20" '
				. 'title="Click here to play this recording." border="0"'
				. 'data-sound-id="' . $voicemail_data[$mailbox]['temp'] . '" '
				. 'class="play_sound"></td>';
		} else {
			echo '<td></td>';
		}

		if (isset($voicemail_data[$mailbox]['attach']) && $voicemail_data[$mailbox]['attach'] == 'yes') {
			echo '<td>' . $voicemail_data[$mailbox]['email'] . '</td>';
		} else {
			echo '<td></td>';
		}

		if (isset($voicemail_data[$mailbox]['delete']) && $voicemail_data[$mailbox]['delete'] == 'yes') {
			echo '<td>Yes</td>';
		} else {
			echo '<td></td>';
		}

		echo '</tr>';
	}

	echo '</tr></table><br><br>';
}

function voicemail_report_echo_right_nav($voicemail_data) {
	echo '</ul></div>';
}

include_once('sales.php');
