<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

if (zend_loader_file_encoded()) {
  $lic_info = zend_loader_file_licensed();
  $lic_exp  = isset($lic_info['vqplus_exp'])?preg_replace('/-/','',$lic_info['vqplus_exp']):00000000;
  if ($lic_exp > date('Ymd')) {
    $vqplus = true;
  } else {
    $vqplus = false;
  }
} else {
	  $vqplus = true;
}

/** vqplus_hook_queues
 * Short generate html for GUI hooks into the Queues module
 * Long this is effectively the controller for the Queues hooks
 * and is used to generate the appropirate view into the Queues
 * module It is given the viewigt_itemid which is the queue number
 * and the target_menuid which is the page type in the queues module.
 * It returns the html for the requested parameters.
 *
 * @author Philippe Lindheimer
 * @param string $viewing_itemid
 * @param string $target_menuid
 * @return string
 */
function vqplus_hook_queues($viewing_itemid, $target_menuid) {
	global $vqplus;

	if (!$vqplus) {
		return '';
	}

	if ($target_menuid == 'queues')	{
		$vars = vqplus_queues_get($viewing_itemid);

        $vars['lazymembers']['no'] = _('No');
        $vars['lazymembers']['yes'] = _('Yes');

		$vars['qrules'][0] = _('none');
		foreach (vqplus_qrules_list() as $k => $v) {
			$vars['qrules'][$k] = $v;
		}
		return load_view(dirname(__FILE__) . '/../views/hook_queues/edit.php', $vars);
	}
}

/** vqplus_hookProcess_queues
 * Short process the post back for the specified viewing_itemid
 * Long process the postback for a given viewing_itemid when the
 * Queues module posts back. The full $_REQUEST array is passed in
 * as a parameter.
 *
 * @author Philippe Lindheimer
 * @param string $viewing_itemid
 * @param string $target_menuid
 */
function vqplus_hookProcess_queues($viewing_itemid, $request) {
	global $vqplus;

	if (!$vqplus) {
		return '';
	}
	if (empty($request['action'])) {
		return true;
	}

	$get_vars = array(
			'action' => '',
			'account' => '',
			'vqplus_cdest' => '',
			'vqplus_adest' => '',
			'vqplus_upil' => 'no',
			'vqplus_lazymembers' => 'no',
	);
	foreach ($get_vars as $k => $v) {
		$vars[$k] = isset($request[$k]) ? $request[$k] : $v;
	}

	$get_vars = array(
			'vqplus_rule_id' => null,
			'vqplus_min_penalty' => null,
			'vqplus_max_penalty' => null,
	);
	foreach ($get_vars as $k => $v) {
		$vars[$k] = isset($request[$k]) && trim($request[$k]) != '' ? $request[$k] : $v;
	}

	$goto[1211] = 'vqplus_cdest';
	$goto[1212] = 'vqplus_adest';
	$goto[1214] = 'vqplus_full_dest';
	$goto[1215] = 'vqplus_joinempty_dest';
	$goto[1216] = 'vqplus_leaveempty_dest';
	$goto[1217] = 'vqplus_joinunavail_dest';
	$goto[1218] = 'vqplus_leaveunavail_dest';
	foreach ($goto as $i => $var) {
		if (isset($request['goto' . $i]) && isset($request[$request['goto' . $i] . $i])) {
			$vars[$var] = $request[$request['goto' . $i] . $i];
		}
	}

	switch ($vars['action']) {
		case "add":
			$conflict_url = array();
			$usage_arr = framework_check_extension_usage($vars['account']);
			if (empty($usage_arr)) {
				vqplus_queues_save($vars);
			} else {
				dbug("extension conflict in queues reported by vqplus hook");
			}
			break;
		case "edit":  //just delete and re-add
			vqplus_queues_save($vars);
			break;
		case "delete":
			vqplus_queues_del($vars['account']);
			break;
	}
}
