<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

$autoincrement = (($amp_conf["AMPDBENGINE"] == "sqlite") || ($amp_conf["AMPDBENGINE"] == "sqlite3")) ? "AUTOINCREMENT":"AUTO_INCREMENT";

$sql['virtual_queue_config'] = "
	CREATE TABLE IF NOT EXISTS virtual_queue_config (
		id INTEGER NOT NULL $autoincrement,
		name VARCHAR(40) NOT NULL DEFAULT '',
		priority INT DEFAULT NULL,
		position INT DEFAULT NULL,
		min_penalty INT DEFAULT NULL,
		max_penalty INT DEFAULT NULL,
		rule_id INT DEFAULT NULL,
		joinannounce_id INT DEFAULT NULL,
		agentannounce_id INT DEFAULT NULL,
		music VARCHAR(100) DEFAULT NULL,
		maxwait VARCHAR(8) DEFAULT NULL,
		cidpp VARCHAR(100) NOT NULL DEFAULT '',
		alertinfo VARCHAR(254) NOT NULL DEFAULT '',
		language VARCHAR(50) NOT NULL DEFAULT '',
		callconfirm_id INT DEFAULT NULL,
		dest VARCHAR(100) NOT NULL DEFAULT '',
		cdest VARCHAR(100) NOT NULL DEFAULT '',
		adest VARCHAR(100) NOT NULL DEFAULT '',
		gotodest VARCHAR(100) NOT NULL DEFAULT '',
		full_dest VARCHAR(100) NOT NULL DEFAULT '',
		joinempty_dest VARCHAR(100) NOT NULL DEFAULT '',
		leaveempty_dest VARCHAR(100) NOT NULL DEFAULT '',
		joinunavail_dest VARCHAR(100) NOT NULL DEFAULT '',
		leaveunavail_dest VARCHAR(100) NOT NULL DEFAULT '',
		PRIMARY KEY (id)
	)";

$sql['vqplus_queue_config'] = "
	CREATE TABLE IF NOT EXISTS vqplus_queue_config (
		queue_num VARCHAR(20) NOT NULL default '',
		min_penalty INT DEFAULT NULL,
		max_penalty INT DEFAULT NULL,
		rule_id INT DEFAULT NULL,
		cdest VARCHAR(100) NOT NULL DEFAULT '',
		adest VARCHAR(100) NOT NULL DEFAULT '',
		full_dest VARCHAR(100) NOT NULL DEFAULT '',
		joinempty_dest VARCHAR(100) NOT NULL DEFAULT '',
		leaveempty_dest VARCHAR(100) NOT NULL DEFAULT '',
		joinunavail_dest VARCHAR(100) NOT NULL DEFAULT '',
		leaveunavail_dest VARCHAR(100) NOT NULL DEFAULT '',
		upil VARCHAR(6) NOT NULL DEFAULT 'no',
		lazymembers VARCHAR(6) NOt NULL DEFAULT 'no',
		PRIMARY KEY (queue_num)
	)";

$sql['vqplus_qrule_config'] = "
	CREATE TABLE IF NOT EXISTS vqplus_qrule_config (
		id INTEGER NOT NULL $autoincrement,
		name VARCHAR(40) NOT NULL DEFAULT '',
		PRIMARY KEY (id)
	)";

$sql['vqplus_qrule_detail'] = "
	CREATE TABLE IF NOT EXISTS vqplus_qrule_detail (
		rule_id INTEGER NOT NULL,
		elapsed INTEGER NOT NULL,
		min_penalty VARCHAR(10) NOT NULL DEFAULT '',
		max_penalty VARCHAR(10) NOT NULL DEFAULT '',
		PRIMARY KEY (rule_id, elapsed)
	)";

foreach ($sql as $t => $s) {
	out(sprintf(_("creating table %s if needed"), $t));
	$result = $db->query($s);
	if(DB::IsError($result)) {
		die_freepbx($result->getDebugInfo());
	}
}

outn(_("checking for upil field.."));
$sql = "SELECT `qregex` FROM vqplus_queue_config";
$check = $db->getRow($sql, DB_FETCHMODE_ASSOC);
if(DB::IsError($check)) {
	// add new field
	$sql = "ALTER TABLE vqplus_queue_config ADD `upil` VARCHAR(6) NOT NULL DEFAULT 'no'";
	$result = $db->query($sql);
	if(DB::IsError($result)) {
		out(_("ERROR failed to update upil field"));
	} else {
		out(_("OK"));
	}
} else {
	out(_("already exists"));
}

outn(_("checking for lazymembers field.."));
$sql = "SELECT `lazymembers` FROM vqplus_queue_config";
$check = $db->getRow($sql, DB_FETCHMODE_ASSOC);
if(DB::IsError($check)) {
        // add new field
        $sql = "ALTER TABLE vqplus_queue_config ADD `lazymembers` VARCHAR(6) NOT NULL DEFAULT 'no'";
        $result = $db->query($sql);
        if(DB::IsError($result)) {
                out(_("ERROR failed to update lazymembers field"));
        } else {
                out(_("OK"));
        }
} else {
        out(_("already exists"));
}
