<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

/* View for the Queues GUI hook
 *
 */

$vqformat = "<tr><td>%s</td><td>%s</td></tr>\n";
$html = '';

$html .= '<tr><td colspan="2">' . fpbx_section_header(_("Queue Plus Options")) . "</td></tr>\n";
//Min Penalty
$vqplus_data = array();
$vqplus_data['name'] = 'vqplus_min_penalty';
$vqplus_data['type'] = 'number';
$vqplus_data['min'] = '0';
$vqplus_data['max'] = '100';
$vqplus_data['size'] = '10';
if ($vqplus_min_penalty == '') {
	$vqplus_data['disabled'] = true;
}
$label = fpbx_label(_('Initial Min Penalty'),
	_('The minimum penalty an agent must have to be included in this queue. This penalty can change dynamically if a queue rule is also applied.'));
$html .= sprintf($vqformat, $label, fpbx_form_input_check($vqplus_data, $vqplus_min_penalty, '', '<small>' . _('Enable') . '</small>', '', true));

//Max Penalty
$vqplus_data = array();
$vqplus_data['name'] = 'vqplus_max_penalty';
$vqplus_data['type'] = 'number';
$vqplus_data['min'] = '0';
$vqplus_data['max'] = '100';
$vqplus_data['size'] = '10';
if ($vqplus_max_penalty == '') {
	$vqplus_data['disabled'] = true;
}
$label = fpbx_label(_('Initial Max Penalty'),
			_('The maximum penalty an agent must have to be included in this queue. This penalty can change dynamically if a queue rule is also applied.'));
$html .= sprintf($vqformat, $label, fpbx_form_input_check($vqplus_data, $vqplus_max_penalty, '', '<small>' . _('Enable') . '</small>', '', true));

// Penalty Rules
$html .= sprintf($vqformat, fpbx_label(_('Queue Penalty Rules'),
					_('Queue penalty rules, part of the generated queuerules.conf, allow the QUEUE_MIN_PENALTY.'
					. 'and QUEUE_MAX_PENALTY to change as a caller ages in a queue. Make sure to set the Initial min and max penalties above when using rules.')),
					form_dropdown('vqplus_rule_id', $qrules, $vqplus_rule_id));

$label = fpbx_label(_('Caller Post Hangup Destination'),
			_('Destination to send the caller to upon the agen hanging up the call, often used to send a caller to take a post call survey. This functionality requires the agent to be a normal extension and the Agent Restrictions to be set to either "Extensions Only" or "No Follow-Me or Call Forward".'));
$html .= sprintf($vqformat, $label, drawselects($vqplus_cdest, 1211, false, false, _("none")));

$label = fpbx_label(_('Agent Post Hangup Destination'),
			_('Destination to send the agent to upon the caller hanging up the call. This functionality requires the agent to be a normal extension and the Agent Restrictions to be set to either "Extensions Only" or "No Follow-Me or Call Forward".'));
$html .= sprintf($vqformat, $label, drawselects($vqplus_adest, 1212, false, false, _("none")));

$label = fpbx_label(_('Queue Fail Over on FULL Destination'),
			_('Optional destination to the normal failover destiantion when the call exits the queue with QUEUESTATUS: FULL.'));
$html .= sprintf($vqformat, $label, drawselects($vqplus_full_dest, 1214, false, false, _("Use Fail Over Destination")));

$label = fpbx_label(_('Queue Fail Over on JOINEMPTY Destination'),
			_('Optional destination to the normal failover destiantion when the call exits the queue with QUEUESTATUS: JOINEMPTY.'));
$html .= sprintf($vqformat, $label, drawselects($vqplus_joinempty_dest, 1215, false, false, _("Use Fail Over Destination")));

$label = fpbx_label(_('Queue Fail Over on LEAVEEMPTY Destination'),
			_('Optional destination to the normal failover destiantion when the call exits the queue with QUEUESTATUS: LEAVEEMPTY.'));
$html .= sprintf($vqformat, $label, drawselects($vqplus_leaveempty_dest, 1216, false, false, _("Use Fail Over Destination")));

$label = fpbx_label(_('Queue Fail Over on JOINUNAVAIL Destination'),
			_('Optional destination to the normal failover destiantion when the call exits the queue with QUEUESTATUS: JOINUNAVAIL.'));
$html .= sprintf($vqformat, $label, drawselects($vqplus_joinunavail_dest, 1217, false, false, _("Use Fail Over Destination")));

$label = fpbx_label(_('Queue Fail Over on LEAVEUNAVAIL Destination'),
			_('Optional destination to the normal failover destiantion when the call exits the queue with QUEUESTATUS: LEAVEUNAVAIL.'));
$html .= sprintf($vqformat, $label, drawselects($vqplus_leaveunavail_dest, 1218, false, false, _("Use Fail Over Destination")));

$label = fpbx_label(_('Lazymembers'),
            _('Temporarily ignore an agent who has previously not picked up the active call (this is done on a per call basis).'));
$html .= sprintf($vqformat, $label, form_dropdown('vqplus_lazymembers', $lazymembers, $vqplus_lazymembers));

$label = fpbx_label(_("Auto-Unpause If Life"), _("Most installations should keep this DISABLED. When enabled in conjunction with Join/Leave When Empty being set to Yes will automatically un-pause all agents in a queue upon a new caller entering the queue where there is any current agent shoing a 'sign of life' in the form of INUSE, RINGINUSE, ONHOLD, etc."));

$vqplus_upil_status = $vqplus_upil == 'yes' ? true : false;
$vqplus_upil_true_label = form_label(_('Enabled'), 'vqplus_upil_true');
$vqplus_upil_true = array(
	'name'		=> 'vqplus_upil',
	'tabindex'	=> ++$tabindex,
	'id'		=> 'vqplus_upil_true',
	'value'		=> 'yes',
	'checked'		=> $vqplus_upil_status,
);

$vqplus_upil_false_label = form_label(_('Disabled'), 'vqplus_upil_false');
$vqplus_upil_false = array(
	'name'		=> 'vqplus_upil',
	'tabindex'	=> ++$tabindex,
	'id'		=> 'vqplus_upil_false',
	'value'		=> 'no',
	'checked'		=> !$vqplus_upil_status,
);

$vqplus_radio = '<span class="radioset">';
$vqplus_radio .= $vqplus_upil_true_label . form_radio($vqplus_upil_true);
$vqplus_radio .= $vqplus_upil_false_label . form_radio($vqplus_upil_false);
$vqplus_radio .='</span>';

$html .= sprintf($vqformat, $label, $vqplus_radio);

echo $html;
