<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

/* $Id: page.vqueues.php 13980 2012-04-19 14:46:08Z mbrevda $ */
/* controller for vqueues
 */

if (zend_loader_file_encoded()) {
  $lic_info = zend_loader_file_licensed();
  $lic_exp  = isset($lic_info['vqplus_exp'])?preg_replace('/-/','',$lic_info['vqplus_exp']):00000000;
  if ($lic_exp > date('Ymd')) {
    $vqplus = true;
  } else {
    $vqplus = false;
  }
} else {
	  $vqplus = true;
}

$get_vars = array(
		'id' => '',
		'action' => '',
		'display' => 'vqueue',
		'Submit' => '',
		'name' => '',
		'cidpp' => '',
		'alertinfo' => '',
		'language' => '',
		'maxwait' => -1,
		'dest' => '',
		'cdest' => '',
		'adest' => '',
		'gotodest' => '',
		'full_dest' => '',
		'joinempty_dest' => '',
		'leaveempty_dest' => '',
		'joinunavail_dest' => '',
		'leaveunavail_dest' => '',
);
foreach ($get_vars as $k => $v) {
	$vars[$k] = isset($_REQUEST[$k]) ? $_REQUEST[$k] : $v;
}

$get_vars = array(
		'callconfirm_id' => null,
		'music' => null,
		'joinannounce_id' => null,
		'agentannounce_id' => null,
		'priority' => null,
		'position' => null,
		'rule_id' => null,
		'min_penalty' => null,
		'max_penalty' => null,
);
foreach ($get_vars as $k => $v) {
	$vars[$k] = isset($_REQUEST[$k]) && trim($_REQUEST[$k]) != '' ? $_REQUEST[$k] : $v;
}

$goto[0] = 'dest';
$goto[1] = 'cdest';
$goto[2] = 'adest';
$goto[3] = 'gotodest';
$goto[4] = 'full_dest';
$goto[5] = 'joinempty_dest';
$goto[6] = 'leaveempty_dest';
$goto[7] = 'joinunavail_dest';
$goto[8] = 'leaveunavail_dest';
foreach ($goto as $i => $var) {
	if (isset($_REQUEST['goto' . $i]) && isset($_REQUEST[$_REQUEST['goto' . $i] . $i])) {
		$vars[$var] = $_REQUEST[$_REQUEST['goto' . $i] . $i];
	}
}

if ($vars['Submit'] == _('Delete')) {
	$vars['action'] = 'delete';
	$_REQUEST['action'] = 'delete';
}

//action actions
switch ($vars['action']) {
	case 'delete':
		vqplus_vqueue_del($vars['id']);
		redirect_standard();
	break;
	case 'Submit':
		$_REQUEST['id'] = vqplus_vqueue_save($vars);
		$_REQUEST['action'] = 'modify';
		needreload();
		redirect_standard('id', 'action');
	break;
	case 'save_settings':
		needreload();
		redirect_standard('id');
	break;
	default:
	break;
}

//rnav
$vars['virtual_queues'] = vqplus_vqueue_get();
echo load_view(dirname(__FILE__) . '/vqueue/rnav.php', $vars);

//view actions

$vars['hooks'] = $module_hook->hookHtml;
$vars['amp_conf'] = $amp_conf;

$rec_list	= function_exists('recordings_list') ? recordings_list() : array();
$vars['rec'][''] = _('unchanged');
$vars['rec'][0] = _('none');
foreach ($rec_list as $r) {
	$vars['rec'][$r['id']] = $r['displayname'];
}

$music_list = music_list();
$vars['mlist'][''] = _('unchanged');
$vars['mlist']['inherit'] = _('inherit');
$vars['mlist']['default'] = _('default');
foreach ($music_list as $mclass) {
	$vars['mlist'][$mclass] = $mclass;
}

$vars['qrules'][''] = _('unchanged');
$vars['qrules'][0] = _('none');
foreach (vqplus_qrules_list() as $k => $v) {
	$vars['qrules'][$k] = $v;
}

$vars['mwlist'][-1] = _('unchanged');
$vars['mwlist'][''] = _('unlimited');
for ($i=10; $i < 60; $i+=10) {
	$vars['mwlist'][$i] = $i . ' ' . _("seconds");
}
for ($i=60; $i < 300; $i+=30) {
	$vars['mwlist'][$i] = queues_timeString($i,true);
}
for ($i=300; $i < 1200; $i+=60) {
	$vars['mwlist'][$i] = queues_timeString($i,true);
}
for ($i=1200; $i <= 3600; $i+=300) {
	$vars['mwlist'][$i] = queues_timeString($i,true);
}

$vars['action'] = ($vqplus === TRUE) ? $vars['action'] : 'sales';
switch ($vars['action']) {
	case 'add':
	case 'modify':
	case 'submit':
		if ($vars['id']) {
			$vars = array_merge($vars, $vars['virtual_queues'][$vars['id']]);
			//$vars = array_merge($vars, vqplus_vqueue_get_config($vars['id']));
		}

		echo load_view(dirname(__FILE__) . '/vqueue/edit.php', $vars);
		break;
	case 'sales':
        	echo sysadmin_get_sales_html('vqplus');
        	break;
	case 'delete':
	default:
		echo load_view(dirname(__FILE__) . '/vqueue/edit.php', $vars);
		break;
}
?>
