<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

/* View for the Queue Rule Configuration GUI
 *
 * TODO: Add js asset with this view to do validation of qrules
 */
$html = ''; 
$html .= heading(_('Queue Penalty Rules'), 3) . '<hr class="vqplus-qrules-hr"/>';

$html .= form_open($_SERVER['REQUEST_URI'], 'id="vqplus_qr_form"');
$html .= form_hidden('display', $display);
$html .= form_hidden('id', $id);
$html .= form_hidden('action', 'Submit');

$table = new CI_Table;
if ($id) {
	$table->add_row(array('colspan' => 3,
		'data' => heading(_('Modify Rule Set'), 5) . '<hr />'));
} else {
	$table->add_row(array('colspan' => 3,
		'data' => heading(_('Add Rule Set'), 5) . '<hr />'));
}

//name
$label = fpbx_label(_('Name'),
			_('Provide a descriptive name for this rule set.'));
$table->add_row($label, array('data' => form_input(array('name' => 'name', 'size' => '50'), $name), 'colspan' => 2));

$table->add_row(array('data' => fpbx_section_header(_("Queue Rules Table")), 'colspan' => 3));

// Column Headers

$duration_label = fpbx_label(_('Duration'), _('Duration in second of this current rule prior to making the perscribed rule change. The duration is since the previous rule, it is not the abosolute time as is used in queuerules.conf.'));
$maxp_label = fpbx_label(_('MAX Penalty Change'), 
	_('New QUEUE_MAX_PENALTY value, can either be an absolute penalty, or relative change to the current penalty value by prepending "+" or "-" before it.'));
$minp_label = fpbx_label(_('MIN Penalty Change'), 
	_('New QUEUE_MIN_PENALTY value, can either be an absolute penalty, or relative change to the current penalty value by prepending "+" or "-" before it.'));
$table->add_row($duration_label, $maxp_label, $minp_label);

$data = array();
$data['type'] = 'number';
$data['min'] = '0';
$data['max'] = '999';
$data['size'] = '10';
$data['class'] = 'queue_rule_duration';

$min['pattern'] = $max['pattern'] = '^[+-]?[0-9]*$';
$min['class'] = $max['class'] = 'queue_penalty';
$min['title'] = $max['title'] = '[+-]NN See Tooltip Above';
for ($row = 0; $row < 10; $row++) {
	$data['name'] = $data['id'] = 'duration[' . $row .']';
	$min['name'] = $min['id'] = "min_penalty[$row]";
	$max['name'] = $max['id'] = "max_penalty[$row]";
	$table->add_row(
		form_input($data, $duration[$row]),
		form_input($max, $max_penalty[$row]),
		form_input($min, $min_penalty[$row])
	);
}

$html .= $table->generate();
$html .= $hooks . br(2);

$html .= form_submit('Submit', _('Submit'));
if ($id) {
	$html .= form_submit('Submit', _('Delete'));
}
echo $html;
