<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }
/* View for the Virtual Queues GUI
 *
 */

$html = ''; 
$html .= heading(_('Virtual Queues'), 3) . '<hr class="vqplus-vqueue-hr"/>';

$html .= form_open($_SERVER['REQUEST_URI'], 'id="vqplus_vq_form"');
$html .= form_hidden('display', $display);
$html .= form_hidden('id', $id);
$html .= form_hidden('action', 'Submit');

$table = new CI_Table;
if ($id) {
	$table->add_row(array('colspan' => 2,
		'data' => heading(_('Modify Virtual Queue'), 5) . '<hr />'));
} else {
	$table->add_row(array('colspan' => 2,
		'data' => heading(_('Add Virtual Queue'), 5) . '<hr />'));
}

//name
$label = fpbx_label(_('Name'),
			_('Provide a descriptive name for this virtual queue.'));
$table->add_row($label, form_input('name', $name));

//cid prepend
$label = fpbx_label(_('CID Name Prefix'),
			_('CID prefix to prepend to the callers name, commonly used to help the agent know what queue the call came in to.'));
$table->add_row($label, form_input('cidpp', $cidpp));

//Alert Info
$label = fpbx_label(_('Alert Info'),
			_('Alert Info to add to SIP header when sent to the agent that is commonly used to create some form of distinctive ring to the agent.'));
$table->add_row($label, form_input('alertinfo', $alertinfo));

//mohclass
$table->add_row(fpbx_label(_('Music on Hold Class'), 
					_('Music class to play to callers while wating for an agent if different then the primary queue')),
					form_dropdown('music', $mlist, $music));

//join announce
$table->add_row(fpbx_label(_('Join Announcement'), 
					_('Announcement to play to callers upon joining the queue.')),
					form_dropdown('joinannounce_id', $rec, $joinannounce_id));

//Queue Language
$label = fpbx_label(_('Language'),
			_('Language code to set the channel. This is used in conjunction with the language sound files if other languages are installed on the system. This requires setup outside of FreePBX and will default to the installed english sound files if none are present for this language.'));
$table->add_row($label, form_input('language', $language));

//max wait time
$table->add_row(fpbx_label(_('Max Wait Time'), 
					_('Maximum wait time for a caller after which the call will exit the queue and be sent to the failover destination.')),
					form_dropdown('maxwait', $mwlist, $maxwait));

//Queue Priority
$data = array();
$data['name'] = 'priority';
$data['type'] = 'number';
$data['min'] = '0';
$data['max'] = '999';
$data['size'] = '10';
if ($priority == '') {
	$data['disabled'] = true;
}
$label = fpbx_label(_('Queue Priority'),
			_('Queue Priority to use for this virtual queue, a normal queue has 0 priority and larger numbers have higher priority.'));
$table->add_row($label, fpbx_form_input_check($data, $priority, '', '<small>' . _('Enable') . '</small>', '', true));

//Queue Position
$data = array();
$data['name'] = 'position';
$data['type'] = 'number';
$data['min'] = '0';
$data['max'] = '100';
$data['size'] = '10';
if ($position == '') {
	$data['disabled'] = true;
}
$label = fpbx_label(_('Queue Position'),
			_('When set queue will attempt to insert this caller into the designated positon within the queue'));
$table->add_row($label, fpbx_form_input_check($data, $position, '', '<small>' . _('Enable') . '</small>', '', true));

$table->add_row(array('data' => fpbx_section_header(_("Agent Related Settings")), 'colspan' => 2));

//agent announce
$table->add_row(fpbx_label(_('Agent Announcement'),
					_('Announcement to play to agent upon answering a queue call prior to bridging the caller.')),
					form_dropdown('agentannounce_id', $rec, $agentannounce_id));

//call confirm annoucement
$table->add_row(fpbx_label(_('Call Confirm Announcement'), 
					_('Annoucement to be played remote agents when answering a queue call to confirm they want to answer the call.'
					. 'This will override the queue setting as well as any follow-me announcement they have set.')),
					form_dropdown('callconfirm_id', $rec, $callconfirm_id));

//Min Penalty
$data = array();
$data['name'] = 'min_penalty';
$data['type'] = 'number';
$data['min'] = '0';
$data['max'] = '100';
$data['size'] = '10';
if ($min_penalty == '') {
	$data['disabled'] = true;
}
$label = fpbx_label(_('Initial Min Penalty'),
			_('The minimum penalty an agent must have to be included in this virtual queue. This penalty can change dynamically if a queue rule is also applied.'));
$table->add_row($label, fpbx_form_input_check($data, $min_penalty, '', '<small>' . _('Enable') . '</small>', '', true));

//Max Penalty
$data = array();
$data['name'] = 'max_penalty';
$data['type'] = 'number';
$data['min'] = '0';
$data['max'] = '100';
$data['size'] = '10';
if ($max_penalty == '') {
	$data['disabled'] = true;
}
$label = fpbx_label(_('Initial Max Penalty'),
			_('The maximum penalty an agent must have to be included in this virtual queue. This penalty can change dynamically if a queue rule is also applied.'));
$table->add_row($label, fpbx_form_input_check($data, $max_penalty, '', '<small>' . _('Enable') . '</small>', '', true));

// Penalty Rules
$table->add_row(fpbx_label(_('Queue Penalty Rules'), 
					_('Queue penalty rules, part of the generated queuerules.conf, allow the QUEUE_MIN_PENALTY.'
					. 'and QUEUE_MAX_PENALTY to change as a caller ages in a queue. Make sure to set the Initial min and max penalties above when using rules.')),
					form_dropdown('rule_id', $qrules, $rule_id));

$table->add_row(array('data' => fpbx_section_header(_("Target Queue Destinations")), 'colspan' => 2));

$label = fpbx_label(_('Caller Post Hangup Destination'),
			_('Destination to send the caller to upon the agent hanging up the call, often used to send a caller to take a post call survey.'));
$table->add_row($label, drawselects($cdest, 1, false, false, _("unchanged")));

$label = fpbx_label(_('Agent Post Hangup Destination'),
			_('Destination to send the agent to upon the caller hanging up the call.'));
$table->add_row($label, drawselects($adest, 2, false, false, _("unchanged")));


$label = fpbx_label(_('Queue Fail Over on FULL Destination'),
			_('Alternative destination to that defined in the hosting queue if the call exits the queue with QUEUESTATUS: FULL.'));
$table->add_row($label, drawselects($full_dest, 4, false, false, _("unchanged")));

$label = fpbx_label(_('Queue Fail Over on JOINEMPTY Destination'),
			_('Alternative destination to that defined in the hosting queue if the call exits the queue with QUEUESTATUS: JOINEMPTY.'));
$table->add_row($label, drawselects($joinempty_dest, 5, false, false, _("unchanged")));

$label = fpbx_label(_('Queue Fail Over on LEAVEEMPTY Destination'),
			_('Alternative destination to that defined in the hosting queue if the call exits the queue with QUEUESTATUS: LEAVEEMPTY.'));
$table->add_row($label, drawselects($leaveempty_dest, 6, false, false, _("unchanged")));

$label = fpbx_label(_('Queue Fail Over on JOINUNAVAIL Destination'),
			_('Alternative destination to that defined in the hosting queue if the call exits the queue with QUEUESTATUS: JOINUNAVAIL.'));
$table->add_row($label, drawselects($joinunavail_dest, 7, false, false, _("unchanged")));

$label = fpbx_label(_('Queue Fail Over on LEAVEUNAVAIL Destination'),
			_('Alternative destination to that defined in the hosting queue if the call exits the queue with QUEUESTATUS: LEAVEUNAVAIL.'));
$table->add_row($label, drawselects($leaveunavail_dest, 8, false, false, _("unchanged")));

$label = fpbx_label(_('Queue Default Fail Over Destination'),
			_('Alternative destination to that defined in the hosting queue if the call exits the queue and proceeds to the fail over destination.'));
$table->add_row($label, drawselects($dest, 0, false, false, _("unchanged")));


$table->add_row(array('data' => fpbx_section_header(_("Destination")), 'colspan' => 2));

$label = fpbx_label(_('Destination'),
			_('Destination to link this virtual queue setup instance, usually points to an actual queue.'));
$table->add_row($label, drawselects($gotodest, 3, false, false,'',true));

$html .= $table->generate();
$html .= $hooks . br(2);

$html .= form_submit('Submit', _('Submit'));
if ($id) {
	$html .= form_submit('Submit', _('Delete'));
}
echo $html;
