<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed');}

if (zend_loader_file_encoded()) {
	$webcallback_lic_info	= zend_loader_file_licensed();
	$webcallback_lic_exp        = isset($webcallback_lic_info['webcallback_exp'])?preg_replace('/-/','',$webcallback_lic_info['webcallback_exp']):'00000000';
	if ($webcallback_lic_exp > date('Ymd')) {
		$webcallback_licensed = true;
	} else {
		$webcallback_licensed = false;
	}
} else {
	$webcallback_licensed = true;
}

function webcallback_call($p, $id) {
	global $astman, $webcallback_licensed;

	//license check!
	if (!$webcallback_licensed) {
		$ret['Response'] = 'Error';
		$ret['Message'] = 'License Expired';

		echo json_encode($ret);
		return;
	}

	$i = webcallback_get($id);
	if(!$i['dest']) {
		//crash and burn
		$ret['Response'] = 'Error';
		$ret['Message'] = 'Configuration error (1)';
	} else {
		$p =  preg_replace('/[^0-9]/', '', $p);
		$dest = explode(',', $i['dest']);
		$cid = '"' . $i['cidprepend'] . '" <' . $p . '>';
		$ret = $astman->Originate('Local/' . $p
				. '@webcallback-' . $id, $dest[1], $dest[0],
				$dest[2], '', $cid, '', '', '', '');
	}

	echo json_encode($ret);
}

function webcallback_delete($id = '') {
	global $db;
	$sql = 'DELETE FROM webcallback WHERE id = ?';
	$q = $db->query($sql, array($id));
	if($db->IsError($q)) {
		die_freepbx($q->getMessage());
	}
}

function webcallback_get_config($engine) {
	global $ext, $amp_conf, $webcallback_licensed;

	//dont run if were not licensed!!
	if (!$webcallback_licensed) {
		return false;
	}
	switch($engine) {
		case "asterisk":
			global $astman;
			$wcb = webcallback_get();
			foreach ($wcb as $w) {
				$c = 'webcallback-' . $w['id'];
				//$ext->addInclude($c, 'from-internal-additional');
				/*caller/ account code
				$ext->add($c, '', '', new ext_setvar('__NODEST', '${EXTEN}'));
				$ext->add($c, '', '', new ext_setvar('__NODEST', '${EXTEN}'));
				*/
				$dp = explode(' ', str_replace(array("\n", "\r", "\r\n"), ' ', $w['patterns']));

				//default to match any amount of digits (but at least one)
				//if no dialplan is set
				if (!$dp || count($dp) == 1 && !$dp[0]) {
					$dp[] = 'x.';
				}
				foreach ($dp as $d) {
					if (!$d) { //skip blank lines!
						continue;
					}
					$dial = '_' . $d;
					$ext->add($c, $dial, '', new ext_noop('WEBCALLBACK call from ${FROM}'));
					//$ext->add($c, $dial, '', new ext_macro('prepend-cid', $w['cidprepend']));
					$ext->add($c, $dial, '',
						new ext_dial('Local/' . $w['numprepend'] . '${EXTEN}@from-internal,'));
				}

			}
			break;
	}
}

function webcallback_get($id = '') {
	global $db;
	$sql = 'SELECT * FROM webcallback';
	if ($id) {
		$sql .= ' WHERE id = ?';
		$get = $db->getAll($sql, array($id), DB_FETCHMODE_ASSOC);
		$ret = isset($get[0]) ? $get[0] : false;
	} else {
		$get = $db->getAll($sql, DB_FETCHMODE_ASSOC);
		$ret = $get;
	}

	return $ret ? $ret : false;
}

function webcallback_iframe($id) {
	global $webcallback_licensed;
	$var				= webcallback_get($id);

	if ($var && $webcallback_licensed) {
		$var['i']			= $id;
		$base_url			= ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == "on") ? "https" : "http");
		$base_url			.= "://".$_SERVER['HTTP_HOST'];
		$base_url			.= $_SERVER['SCRIPT_NAME'];
		$var['dest']		= $base_url;
		$var['valid_msg']	= $var['valid_msg'];
		$var['invalid_msg']	= $var['invalid_msg'];
		dbug('parring $var', $var);
		echo load_view(dirname(__FILE__) . '/../views/iframe.php', $var);
	} else {
		return false;
	}

}

function webcallback_save($var) {
	global $db, $amp_conf;
	$sql = 'REPLACE INTO webcallback (id, name, dest, cidprepend,
			numprepend, accountcode, button_attr, dialpad_attr, patterns, error_msg, valid_msg, invalid_msg, icon)
			VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)';

	$q = $db->query($sql, array(
			$var['id'],
			$var['name'],
			$var['dest'],
			$var['cidprepend'],
			$var['numprepend'],
			$var['accountcode'],
			$var['button_attr'],
			$var['dialpad_attr'],
			$var['patterns'],
			$var['error_msg'],
			$var['valid_msg'],
			$var['invalid_msg'],
			$var['icon'])
	);
	if($db->IsError($q)) {
		die_freepbx($q->getMessage());
	}
	$var['id'] = $amp_conf["AMPDBENGINE"] == "sqlite3"
				? sqlite_last_insert_rowid($db->connection)
				: mysql_insert_id($db->connection);

	needreload();

	return $var['id'];
}

function webcallback_sysadmin_getinfo() {
    return array(
        "name" => "Web Call Back", // Required. Descriptive name.
        "expires" => true,         // Optional. Defaults to false (never expires)
        "keyname" => "webcallback_exp", // Optional. Only checked if 'expires' is true
    );
}
