<?php

function xmpp_generate_xmpp_conf($args) {
	global $amp_conf;
	$c = '';
	$c .= defined('WARNING_BANNER') ? str_replace(';', '--', WARNING_BANNER) : '';
	
	//modules
	$c .= 'modules_enabled = {
				"admin_adhoc";
				"admin_telnet";
				"bosh";
				"console";
				"dialback";
				"disco";
				"groups";
				"legacyauth";
				"pep";
				"ping";
				"posix";
				"private";
				"roster";
				"saslauth";
				"tls";
		};' . PHP_EOL;
	
	//settings
	$c .= 'data_path = "/usr/com/prosody"' . PHP_EOL;
	$c .= 'authentication = "internal_plain"' . PHP_EOL;
	$c .= 'storage = "sql"' . PHP_EOL;
	$c .= 'log = "/var/log/prosody/prosody.log"' . PHP_EOL;
	$c .= 'pidfile = "/var/run/prosody/prosody.pid";' . PHP_EOL;
	
	//TLS http://prosody.im/doc/advanced_ssl_tls#certificates
	/*$c .= 'ssl = {
	  key = "/path/to/prosody.' . $args['domain'] . '.key";
	  certificate = "/path/to/prosody.' . $args['domain'] . '.cert";
	 }';*/
	
	switch ($amp_conf['AMPDBENGINE']) {
		case 'mysql':
			$driver = 'MySQL';//case sensitive, weird lua thing and prosody doesnt attempt to 'clean it up'
			break;
		default:
			break;
	}
	//virtual host
	$c .= 'sql = { '
		. 'driver = "' . $driver 
		. '", database = "' . $amp_conf['AMPDBNAME'] 
		. '", username = "' . $amp_conf['AMPDBUSER'] 
		. '", password = "' . $amp_conf['AMPDBPASS']
		. '", host = "' . $amp_conf['AMPDBHOST'] 
		. '" }' . PHP_EOL;
	$c .= 'VirtualHost "' . $args['domain'] . '"' . PHP_EOL;
	$c .= 'groups_file = "/etc/asterisk/prosody_groups.txt"' . PHP_EOL;
	$c .= 'Component "conf.' . $args['domain'] . '" "muc"' . PHP_EOL;
	$c .= 'Component "asterisk.' . $args['domain'] . '"' . PHP_EOL;
	$c .= '  component_secret = "asterisk"' . PHP_EOL;
	$c .= '  validate_from_addresses = "false"' . PHP_EOL;

	
	return $c;
}
?>
